<?php
/**
 * UTF8
 * stanislav.elbl, 27.02.2017
 */

namespace RonPortal\Admin;

use Ron\StringUtils;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\MVC\BaseViewObject;
use Ron\MVC\DownloadFileOutputObject;
use Ron\MVC\HttpController;
use RonPortal\NastaveniUzivatele;


class NovinkyPortaluView extends BaseViewObject
{
    /** @var NovinkaPortalu[] */
    protected $data;

    /**
     * NovinkyPortaluView constructor.
     * @param NovinkaPortalu[] $data
     */
    public function __construct($data)
    {
        parent::__construct('view/novinkyview.php');
        $this ->data = $data;
    }


}


class NovinkyPortaluController extends HttpController
{
    /** @var Database */
    private $database;

    /**
     * NovinkyPortaluController constructor.
     * @param Database $database
     */
    public function __construct(Database $database)
    {
        $this->database = $database;
    }


    public function handleAction($action)
    {
        if (isset($_GET['action'])) {
            switch ($_GET['action']) {
                case 'allnews' :
                    return new DownloadFileOutputObject('doc', 'ronportal_4_news.txt', null, 'windows-1250');
            }
        }

        $data = NovinkaPortalu::loadNovinky();

        if ($data) {
            $datum = $data[0] ->datum;
            if ($datum > time()) $datum = DateUtils::startOfTheDay(time());
            NastaveniUzivatele::setUserSettingsItem($this ->database, 'novinky_zobrazeny_do', StringUtils::format('date', $datum));
        }

        return new NovinkyPortaluView($data);
    }
}

return new NovinkyPortaluController($this ->database);
