<?php
/**
 * UTF8
 * pavel.rudol, 2.10.2018
 */

namespace RonPortal;

use Exception;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\MVC\MessageManagerViewObject;
use Ron\MVC\Model;
use Ron\MVC\Redirect;
use Ron\MVC\TextViewObject;
use Ron\MVC\HttpController;
use Ron\MVC\ViewObject;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Common\PersonalPasswordForm;
use function Ron\ronText;


class PersonalPasswordController extends HttpController
{
    /** @var Database */
    private $database;


    /**
     * @param Database $database
     */
    public function __construct($database)
    {
        Prava::nastavObdobiProPrava(DateUtils::today());
        $this->database = $database;
    }

//    private function jeNastaveneHeslo()
//    {
//        $params = $this->database->createParameters();
//
//        $sql =
//            "SELECT OsobniHeslo FROM Osoba WHERE RC = " . $params->addParameter(User::getRC());
//
//        $cursor = $this->database->getSqlResult($sql, $params);
//
//        $row = $cursor->fetch();
//
//        if (is_null($row[0]))
//            return false;
//
//        return true;
//    }


//    /**
//     * @param $heslo
//     * @return string
//     * @throws Exception
//     */
//    private function zakodujHeslo($heslo)
//    {
//        $agentResult = AgentManager::executePersonAgent("100 -vstup:$heslo ", false); //-nolog
//
//        if (is_null($agentResult)) {
//            throw new Exception(TextManager::_('Heslo_nezakodovano'));
//        }
//
//        return $agentResult->resultParams['heslo'];
//    }

//    /**
//     * @param $heslo
//     * @throws Exception
//     */
//    private function overHeslo($heslo)
//    {
//        if (is_null($heslo)) {
//            throw new Exception( ronText('Spatne_puvodni_heslo') );
//        }
//
//        $heslo = $this->zakodujHeslo($heslo);
//
//        $params = $this->database->createParameters();
//
//        $sql =
//            "SELECT OsobniHeslo FROM Osoba WHERE RC = " . $params->addParameter(User::getRC()); // . " AND OsobniHeslo = " . $params->addParameter($this ->database ->getBlobParam($heslo, 'OsobniHeslo'));
//        $cursor = $this->database->getSqlResult($sql, $params);
//        $row = $cursor->fetch();
//        $cursor ->close();
//
//        if (!$row) {
//            // nemelo by nastat
//            throw new Exception('Chyba pri overovani puvodniho hesla - zaznam v databazi nebyl nalezen');
//        }
//
//        if ($heslo != $row[0]) {
//            throw new Exception( ronText('Spatne_puvodni_heslo') );
//        }
//    }

//    /**
//     * @param string $newpass1
//     * @param string $newpass2
//     * @param string|null $oldpass
//     * @param string|null $osoba
//     * @return bool
//     * @throws Exception
//     */
//    function setPassword($newpass1, $newpass2, $oldpass = null, $osoba = null)
//    {
//        if ($newpass1 != $newpass2) {
//            throw new Exception( ronText('Hesla_se_neshoduji') );
//        }
//
//        if ($this->prava->prava == 1) {
//            if ($this->jeNastaveneHeslo())
//                $this->overHeslo($oldpass);
//            $osobaRC = User::getRC();
//        } else {
//            $pracPomer = new PracovniPomer();
//            $pracPomer->nactiPPPodleId($this->database, $osoba);
//
//            if (!$this->prava->lzeZobrazitRC($pracPomer->rc)) {
//                throw new NeniPravoException();
//            }
//            $osobaRC = $pracPomer->rc;
//        }
//
//        $newpass1 = $this->zakodujHeslo($newpass1);
//
//        $params = $this ->database ->createParameters();
//
//        $this ->database ->sql(
//                'UPDATE Osoba SET OsobniHeslo = ' . $params->addParameter($this->database->getBlobParam($newpass1, 'OsobniHeslo')) .
//                ' WHERE RC = ' . $params->addParameter($osobaRC), $params);
//
//        return true;
//    }


    /**
     * @return ViewObject
     */
    function handleChangePassword()
    {
//        if (isset($_POST['setpassword'])  &&  $_POST['setpassword']) {
//            try {
//                $this ->setPassword($_POST['newpass1'], $_POST['newpass2'], $_POST['oldpass'], isset($_POST['osoba']) ? $_POST['osoba'] : null);
//                return new Redirect(null, '?menuid=personalpassword&set=1');
//            } catch (Exception $e) {
//                MessageManager::addErrorMessage($e ->getMessage());
//                // pokracuje dale (zobrazi znovu dialog)
//            }
//        } else {
//            if (isset($_GET['set'])  &&  $_GET['set']) {
//                return new TextViewObject(
//                    ronText('Heslo_zmeneno') .
//                    '<br/><br/>' .
//                    "<a href='?menuid=vyplatnilistky'>" . ronText('Pokracovat') . "</a>\n"
//                );
//            }
//        }

        $f = new PersonalPasswordForm($this ->database);
        if ($f ->handleAction()) {
            // nadpis
            Model::addViewObject(new TextViewObject(TextManager::_('Nastaveni_osobniho_hesla'), '', 'h1'));

            Model::addViewObject(new MessageManagerViewObject());

            $backAction = ($_GET['backaction'] ?? false)
                ? StringUtils::secureString($_GET['backaction'])
                : 'vyplatnilistky';

            return new TextViewObject(
                "<a href='?menuid=$backAction'>" . ronText('Pokracovat') . "</a>\n",
                'margin-top-4'
            );
        }

        return $f;

//        if ($this->prava->prava != 1) {
//            $combo = new ComboBoxOsoba();
//            $combo->loadDataPP($this->database, DateUtils::today(), DateUtils::today(), $this->prava, null, null);
//
//            Model::addData('osoba', $combo);
//        } else {
//            Model::addData('vyzadovatpuvodni', $this->jeNastaveneHeslo());
//        }
//
//        return new BaseViewObject('view/personal_password.php');
    }


    /**
     * @param string $action
     * @return string|Redirect|ViewObject
     * @throws Exception
     */
    public function handleAction($action)
    {

        if (!Prava::jsouNejakePrava('osobni_heslo')) {
            throw new NeniPravoException();
        }

        TextManager::getInstance() ->loadStrings('users.ini');

        return $this ->handleChangePassword();
    }


}

return new PersonalPasswordController($this->database);
