<?php
/**
 * UTF8
 * stanislav.elbl, 23.01.2017
 */

namespace RonPortal\Editace;


use Ron\DB\DBUtils;
use Ron\Http\HtmlHeaders;
use Ron\MVC\HttpController;
use Ron\MVC\Model;
use Ron\MVC\TextViewObject;
use Ron\TextManager;
use RonPortal\Controls\FilterFormFilterObdobi;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;


class PrehledZpracovaneController extends HttpController
{
    public $database;

    /**
     * PrehledZpracovaneController constructor.
     * @param $database
     */
    public function __construct($database)
    {
        $this->database = $database;
    }


    /**
     * @return PrehledZpracovaneDochazky
     * @throws \Exception
     */
    function prehledZpracovaneDochazky()
    {
        Model::addViewObject(new TextViewObject('<h1>' . \Ron\ronText('Prehled_zpracovane_dochazky') . '</h1>'));
        HtmlHeaders::getInstance() ->setTitle( \Ron\ronText('RON_Portal') . ' - ' . \Ron\ronText('Prehled_zpracovane_dochazky'));

        $filterForm = new RonPortalFilterForm($this ->database, 'prehledzpracovane', true);
//        $filterForm ->nastavObdobi(true, 'ADS', false);
        $filterForm ->addFilterObdobi();

        $prava = Prava::vratPrava('prohlizeni');

        if ($prava ->zobrazitVyberRozdeleni()) { // napr. pro "pouze vlastni" se vyber nezobrazuje
            $filterForm ->addFilterRozdeleni1(null, $prava);
            $filterForm ->addFilterRozdeleni2(null, $prava);
        }

        $filterForm ->loadData();

        Model::addViewObject($filterForm);

        $prehled = new PrehledZpracovaneDochazky($this ->database);

        // nacte nastaveni
        $settingsXml = RonPortalSettings::getBvarSettings($this ->database,
            'RonPortal_Prehled_zpracovane',
            RonPortalSettings::getMultilineValue('prehledzpracovane'));

        $prehled ->nactiNastaveni($settingsXml);
        $prehled ->load($filterForm);

        return $prehled;
    }


    /**
     * @param string $action
     * @return \Ron\MVC\InternalRedirect|\Ron\MVC\OutputObject|\Ron\MVC\Redirect|\Ron\MVC\ViewObject|PrehledZpracovaneDochazky|string
     * @throws \Exception
     */
    public function handleAction($action)
    {
//    if (isset($_GET['action'])  &&  $_GET['action'] == 'report') {
//        return $this ->report();
//    }

        TextManager::getInstance() ->loadStrings('dochazka.ini');
        HtmlHeaders::getInstance() ->addScript('script/dochazka.js');
        HtmlHeaders::getInstance() ->addCss('css/dochazka.css');

//        if (isset($_POST['rozdelenidv']) && $_POST['rozdelenidv']) {
//            return $this ->rozdeleniDV();
//        }

        return $this ->prehledZpracovaneDochazky();
    }
}


return new PrehledZpracovaneController($this ->database);
