<?php
/**
 * stanislav.elbl, 06.11.2015
 */
namespace RonPortal\Mzdy;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;

$filterForm = Model::getInstance() ->getData('filterForm');
/** @var Dovolena $dovolena */
$dovolena = Model::getInstance() ->getData('dovolena');
$vyplaceniMzdy = Model::getInstance() ->getData('vyplaceniMzdy');
$cisloUctu = Model::getInstance() ->getData('cisloUctu');

?>
<h1><?= \Ron\ronText('Mzdove_udaje') ?></h1>

<?php $filterForm ->render(); ?>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form small-form" id="mzdove_udaje">
    <div class="form-content">
        <?php if ($dovolena->obdobi > 0) { ?>
            <div class="row">
                <div class="col col-5 caption"><strong><?= \Ron\ronText('Dovolena') ?></strong></div>
                <div class="col col-7"><?= \Ron\ronText('Dny') . ($dovolena->prepocetNaHodiny ? ' / ' . \Ron\ronText('Hodiny') : '') ?></div>
            </div>

            <div class="row">
                <div class="col col-5 caption"><?= \Ron\ronText('Dovolena_narok') ?></div>
                <div class="col col-7"><?= StringUtils::format('number_1', $dovolena->narokDnu) ?>
                    <?php if ($dovolena->prepocetNaHodiny) { ?>
                        / <?= StringUtils::format('number_2', $dovolena->narokHodin) ?>
                    <?php } ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-5 caption"><?= \Ron\ronText('Dovolena_cerpano') ?></div>
                <div class="col col-7"><?= StringUtils::format('number_1', $dovolena->cerpanoDnu) ?>
                    <?php if ($dovolena->prepocetNaHodiny) { ?>
                        / <?= StringUtils::format('number_2', $dovolena->cerpanoHodin) ?>
                    <?php } ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-5 caption"><?= \Ron\ronText('Dovolena_zustatek') ?></div>
                <div class="col col-7"><?= StringUtils::format('number_1', $dovolena->zustatekDnu) ?>
                    <?php if ($dovolena->prepocetNaHodiny) { ?>
                        / <?= StringUtils::format('number_2', $dovolena->zustatekHodin) ?>
                    <?php } ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-5 caption"><?= \Ron\ronText('Dovolena_obdobi') ?></div>
                <div class="col col-7"><?= StringUtils::format('date', \Ron\DateUtils::lastDayOfMonth($dovolena->obdobi)) ?></div>
            </div>

            <div class="row">
                <div class="col col-5 caption"><?= \Ron\ronText('Dovolena_typ') ?></div>
                <div class="col col-7"><?= $dovolena->typDovolene ?></div>
            </div>

            <div class="row form-gap">
            </div>
        <?php } ?>

        <?php if ($vyplaceniMzdy) { ?>
            <div class="row">
                <div class="col col-5 caption"><strong><?= \Ron\ronText('Vyplaceni_mzdy') ?></strong></div>
                <div class="col col-7"><?= StringUtils::htmlTextConvert($vyplaceniMzdy[1]) ?></div>
            </div>

            <?php if ($vyplaceniMzdy[0] == 1) { ?>
                <!-- Na ucet -->
                <div class="row">
                    <div class="col col-5 caption"></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert($cisloUctu) ?></div>
                </div>
            <?php } else if ($vyplaceniMzdy[0] == 2) { ?>
                <!-- Slozenkou -->
                <div class="row"> <!-- adresat -->
                    <div class="col col-5 caption"></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert($vyplaceniMzdy[8]) ?></div>
                </div>

                <div class="row"> <!-- ulice, PSC, mesto -->
                    <div class="col col-5 caption"></div>
                    <div class="col col-7"><?= StringUtils::htmlTextConvert("{$vyplaceniMzdy[9]}, {$vyplaceniMzdy[11]}, {$vyplaceniMzdy[10]}") ?></div>
                </div>
            <?php } ?>

        <?php } ?>
    </div>

</div>