<?php
/**
 * stanislav.elbl, 07.03.2016
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;
use RonPortal\RonPortalSettings;

$vyrobaDisabled = !RonPortalSettings::getIntValue('vyroba');

$result = [
    'caption' => 'nastaveni_editace',
    'category' => 'nastaveni_sekce_dochazka',
    'name'  => 'editace',
    'index' => 210,
    'storage' => 'nastaveni',
    'strings' => 'preferences_dochazka.ini',

    'items' =>
        [
            [
                'name'  => 'mesicnivezpracovane',       'type'  => Preference::CHECKBOX,    'title' => 'dochazka_zobrazit_prehled_mesicnich',
                'infoText' => 'dochazka_zobrazit_prehled_mesicnich_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'skrytzapoctenycas',         'type'  => Preference::CHECKBOX,    'title' => 'dochazka_skryt_zapocteny_cas',
                'infoText' => 'dochazka_skryt_zapocteny_cas_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'editaceschvalenedochazky',  'type'  => Preference::CHECKBOX,    'title' => 'dochazka_editace_schvalene',
                'infoText' => 'dochazka_editace_schvalene_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'editaceprepisovat',         'type'  => Preference::CHECKBOX,    'title' => 'dochazka_prepisovat_zaznamy',
                'defaultValue' => 0
            ],
            [
                'name'  => 'editacevkladatprestavky',   'type'  => Preference::CHECKBOX,    'title' => 'dochazka_vkladat_prestavky',
                'defaultValue' => 0
            ],
            [
                'name'  => 'vkladanizpracovane_dnu',    'type'  => Preference::TEXT,        'title' => 'editace_pocet_dnu_pro_vkladani',
                'infoText' => 'editace_pocet_dnu_pro_vkladani_info',
                'defaultValue' => '0'
            ],

            [
                'name'  => 'parametryagentapredschvalenim',    'type'  => Preference::TEXT,        'title' => 'dochazka_parametry_agenta_pred_schvalenim',
                'defaultValue' => '',
                'infoText' => 'dochazka_parametry_agenta_pred_schvalenim_info'
            ],

            // rozdeleni zaznamu dochazky
            [
                'type'  => Preference::CATEGORY,    'title' => 'rozdeleni_zaznamu_dochazky'

            ],
            [
                'name'  => 'typrozdelenieditace',   'type'  => Preference::SQL_COMBOBOX,    'title' => 'dochazka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni ORDER BY Kod',
                'defaultValue' => ''
            ],
            [
                'name'  => 'rozdelenieditacepovinne',   'type'  => Preference::CHECKBOX,    'title' => 'dochazka_rozdeleni_povinne',
                'defaultValue' => 0
            ],
            [
                'name'  => 'nadpisrozdelenieditace',    'type'  => Preference::TEXT,        'title' => 'dochazka_nadpis_rozdeleni',
                'defaultValue' => '',
                'infoText' => 'dochazka_nadpis_rozdeleni_info'
            ],

            // rozdeleni dennich vysledku
            [
                'type'  => Preference::CATEGORY,    'title' => 'rozdeleni_dennich_vysledku'

            ],
            [
                'name'  => 'dv_typrozdeleni',       'type'  => Preference::SQL_COMBOBOX,    'title' => 'dv_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni ORDER BY Kod',
                'defaultValue' => ''
            ],
            [
                'name'  => 'dv_pouzevlastnir',      'type'  => Preference::COMBOBOX,        'title' => 'dv_vyber_rozdeleni',
                'options' => [
                    0 => 'dv_rozdeleni_vsechna', 1 => 'dv_rozdeleni_pouze_vlastni',  2 => 'dv_rozdeleni_vlastni_a_podrizena', 3 => 'dv_rozdeleni_pouze_podrizena'
                ],
                'defaultValue' => '0'
            ],
            [
                'name'  => 'dv_povolitprirazenir',  'type'  => Preference::CHECKBOX,        'title' => 'dv_povolit_vyber_rozdeleni',
                'defaultValue' => 0
            ],
            [
                'name'  => 'dv_casoveslozky',       'type'  => Preference::TEXT,            'title' => 'dv_casove_slozky',
                'infoText' => 'dv_casove_slozky_info',
                'defaultValue' => ''
            ],
            [
                'name'  => 'dv_casovaslozkasoucet', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'dv_casova_slozka_soucet',
                'sql'   => 'SELECT Kod, Popis FROM TypCasoveSlozkyMzdy ORDER BY Kod',
                'defaultValue' => '',
                'infoText' => 'dv_casova_slozka_soucet_info'
            ],
            [
                'name'  => 'dv_minimalnicas',       'type'  => Preference::TEXT,            'title' => 'dv_minimalni_vykazany_cas',
                'defaultValue' => ''
            ],

            [
                'name'  => 'dv_noverozdeleni',  'type'  => Preference::CHECKBOX,            'title' => 'dv_nove_zobrazeni',
                'defaultValue' => 1,
                'infoText' => 'dv_nove_zobrazeni_info',
            ],
            [
                'name'  => 'dv_formatzobrazeni',    'type'  => Preference::TEXT,            'title' => 'dv_format_zobrazeni',
                'defaultValue' => '',
                'infoText' => 'dv_format_zobrazeni_info'
            ],
            [
                'name'  => 'dv_casovaslozka2',      'type'  => Preference::SQL_COMBOBOX,    'title' => 'dv_casova_slozka2',
                'sql'   => 'SELECT Kod, Popis FROM TypCasoveSlozkyMzdy ORDER BY Kod',
                'defaultValue' => '',
                'infoText' => 'dv_casova_slozka2_info'
            ],

            // mesicni vysledky
            [
                'type'  => Preference::CATEGORY,   'title' => 'mesicni_vysledky',
            ],
            [
                'name'  => 'zobrazovatnastavenemv',     'type'  => Preference::COMBOBOX,    'title' => 'mv_zobrazit',
                'options' => [
                    0 => 'mv_zobrazit_vsechny', 1 => 'mv_zobrazit_vybrane',  2 => 'mv_zobrazit_vybrane_a_vzorce'
                ],
                'defaultValue' => 0,
            ],
            [
                'name'  => 'radkymesicnichvysledku',    'type'  => Preference::TEXT,        'title' => 'radky_mesicnich_vysledku',
                'defaultValue' => ''
            ],
            [
                'name'  => 'skrytnulovemesicni',        'type'  => Preference::CHECKBOX,    'title' => 'mv_skryt_nulove_radky',
                'defaultValue' => 0,
            ],

            // rozdeleni vyroby
            [
                'type'  => Preference::CATEGORY,   'title' => 'rozdeleni_vyroby',      'disabled' => $vyrobaDisabled
            ],
            [
                'name'  => 'vyrobaveditaci',       'type'  => Preference::CHECKBOX,    'disabled' => $vyrobaDisabled,
                'defaultValue' => 0,
                'title' => 'editace_rozdeleni_vyroby'
            ],
            // priznak, jestli zamestnanec muze vybirat jen zakazky prirazene pres "CinnostVyrobniZakazky" a "PracovnikCinnostiZakazky"
            [
                'name'  => 'jenprirazenezakazky',  'type'  => Preference::CHECKBOX,    'disabled' => $vyrobaDisabled,
                'defaultValue' => 0,
                'title' => 'jen_prirazene_zakazky'
            ],
            [
                'name'  => 'jenprirazenecinnosti',  'type'  => Preference::CHECKBOX,    'disabled' => $vyrobaDisabled,  'title' => 'jen_prirazene_cinnosti',
                'defaultValue' => 0,
                'infoText' => 'jen_prirazene_cinnosti_info'
            ],
            [
                'name'  => 'editovathodinyvyroby',  'type'  => Preference::CHECKBOX,    'disabled' => $vyrobaDisabled,  'title' => 'editovat_hodiny_vyroby',
                'defaultValue' => 1
            ],
            [
                'name'  => 'editovatcasyvyroby',  'type'  => Preference::CHECKBOX,      'disabled' => $vyrobaDisabled,  'title' => 'editovat_casy_vyroby',
                'defaultValue' => 0
            ],
            [
                'name'  => 'editovatvyrobek',  'type'  => Preference::CHECKBOX,         'disabled' => $vyrobaDisabled,  'title' => 'editovat_vyrobek',
                'defaultValue' => 0
            ],
            [
                'name'  => 'editovatrozdelenivyroby',   'type'  => Preference::SQL_COMBOBOX,    'title' => 'editovat_rozdeleni_vyroby_typ',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni ORDER BY Kod',
                'defaultValue' => ''
            ],

            [
                'name'  => 'zakazatduplicityvyroby', 'type'  => Preference::CHECKBOX,    'disabled' => $vyrobaDisabled, 'title' => 'zakazat_duplicity_vyroby',
                'defaultValue' => 0,
            ],
            [
                'name'  => 'vyroba_casovaslozkasoucet', 'type'  => Preference::SQL_COMBOBOX,    'disabled' => $vyrobaDisabled,  'title' => 'vyroba_casova_slozka_soucet',
                'defaultValue' => '',
                'sql'   => 'SELECT Kod, Popis FROM TypCasoveSlozkyMzdy ORDER BY Kod'
            ],
            [
                'name'  => 'vyroba_cinnost_sloupce',  'type'  => Preference::COMBOBOX,    'title' => 'vyroba_cinnost_sloupce',
                'options' => [
                    0 => 'vyroba_cinnost_sloupce_nic', 1 => 'vyroba_cinnost_sloupce_status',  2 => 'vyroba_cinnost_sloupce_typ',
                ],
                'defaultValue' => 0,
                'infoText' => 'vyroba_cinnost_sloupce_info'
            ],

            // hodne stare nastavevni rozdeleni - presunuto do spolecnych
            [
                'name'  => 'typrozdeleni',          'type'  => Preference::DELETE
            ],

        ]
];


return $result;
