<?php
/**
 * Created by PhpStorm.
 * User: pavel.rudol
 * Date: 4.5.2020
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_sklad',
    'category' => 'nastaveni_sekce_dalsi_agendy',
    'name'  => 'sklad',
    'index' => 710,
    'storage' => 'nastaveni',
    'strings' => 'sklad.ini',

    'items' =>
        [
            // uzivatelska pole
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nadpisy_uzivatelska_pole_firmy'
            ],
            [
                'name'  => 'firma_uzivatelska1',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_1',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska2',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_2',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska3',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_3',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska4',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_4',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska5',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_5',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska6',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_6',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska7',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_7',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska8',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_8',
                'defaultValue' => ''
            ],
            [
                'name'  => 'firma_uzivatelska9',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_9',
                'defaultValue' => ''
            ],
            [
                'name'  => 'dodavatele_filtrovat_dle_uzivatelska',  'type'  => Preference::TEXT,        'title' => 'dodavatele_filtrovat_dle_uzivatelska',
                'infoText' => 'dodavatele_filtrovat_dle_uzivatelska_info', 'defaultValue' => '',
            ],
            // uzivatelska pole
            [
                'type'  => Preference::CATEGORY,    'title' => 'Nadpisy_uzivatelska_pole_VO'
            ],
            [
                'name'  => 'vydanaobjednavka_uzivatelska1',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_1',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_uzivatelska2',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_2',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_uzivatelska3',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_3',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_uzivatelska4',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_4',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_uzivatelska5',  'type'  => Preference::TEXT,        'title' => 'Uzivatelske_pole_5',
                'defaultValue' => ''
            ],
            //nastaveni pro vyber rozdeleni 1 na objednavce
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana_typ_rozdeleni_1'
            ],
            [
                'name'  => 'ObjednavkaVydana_TypRozdeleni1',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'storage' => 'sys_var_global', 'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_typrozdeleni1_prava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prava',
                'sql'   => "SELECT Kod, Popis FROM TypPravaProIntraweb WHERE kod LIKE 'objednavka_vydana%' ORDER BY Kod",
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni1_zadani_povinne',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_povinne_zadani',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_povinne_zadani_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni1_nejnizsi_uroven',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni1_filtr_stredisko',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_filtr_stredisko',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_filtr_stredisko_info'
            ],
            //nastaveni pro vyber rozdeleni 2 na objednavce
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana_typ_rozdeleni_2'
            ],
            [
                'name'  => 'ObjednavkaVydana_TypRozdeleni2',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'storage' => 'sys_var_global', 'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_typrozdeleni2_prava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prava',
                'sql'   => "SELECT Kod, Popis FROM TypPravaProIntraweb WHERE kod LIKE 'objednavka_vydana%' ORDER BY Kod",
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni2_zadani_povinne',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_povinne_zadani',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_povinne_zadani_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni2_nejnizsi_uroven',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni2_filtr_stredisko',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_filtr_stredisko',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_filtr_stredisko_info'
            ],
            //nastaveni pro vyber rozdeleni 3 na objednavce
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana_typ_rozdeleni_3'
            ],
            [
                'name'  => 'ObjednavkaVydana_TypRozdeleni3',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'storage' => 'sys_var_global', 'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_typrozdeleni3_prava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prava',
                'sql'   => "SELECT Kod, Popis FROM TypPravaProIntraweb WHERE kod LIKE 'objednavka_vydana%' ORDER BY Kod",
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni3_zadani_povinne',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_povinne_zadani',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_povinne_zadani_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni3_nejnizsi_uroven',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni3_filtr_stredisko',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_filtr_stredisko',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_filtr_stredisko_info'
            ],
            //nastaveni pro vyber rozdeleni 4 na objednavce
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana_typ_rozdeleni_4'
            ],
            [
                'name'  => 'ObjednavkaVydana_TypRozdeleni4',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'storage' => 'sys_var_global', 'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_typrozdeleni4_prava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prava',
                'sql'   => "SELECT Kod, Popis FROM TypPravaProIntraweb WHERE kod LIKE 'objednavka_vydana%' ORDER BY Kod",
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni4_zadani_povinne',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_povinne_zadani',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_povinne_zadani_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni4_nejnizsi_uroven',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni4_filtr_stredisko',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_filtr_stredisko',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_filtr_stredisko_info'
            ],
            //nastaveni pro vyber rozdeleni 5 na objednavce
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana_typ_rozdeleni_5'
            ],
            [
                'name'  => 'ObjednavkaVydana_TypRozdeleni5',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'storage' => 'sys_var_global', 'defaultValue' => ''
            ],
            [
                'name'  => 'vydanaobjednavka_typrozdeleni5_prava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prava',
                'sql'   => "SELECT Kod, Popis FROM TypPravaProIntraweb WHERE kod LIKE 'objednavka_vydana%' ORDER BY Kod",
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni5_zadani_povinne',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_povinne_zadani',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_povinne_zadani_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni5_nejnizsi_uroven',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_nejnizsi_uroven_info'
            ],
            [
                'name'  => 'vydanaobjednavka_rozdeleni5_filtr_stredisko',    'type'  => Preference::CHECKBOX,    'title' => 'vydana_objednavka_rozdeleni_filtr_stredisko',
                'defaultValue' => 0,
                'infoText' => 'vydana_objednavka_rozdeleni_filtr_stredisko_info'
            ],
            //obecna nastaveni vydane objednavky
            [
                'type'  => Preference::CATEGORY,    'title' => 'Objednavka_vydana'
            ],
            [
                'name'  => 'vydanaobjednavka_filtrovat_stredisko_tr',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Typ_rozdeleni_filtr_stredisek',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 ORDER BY Kod',
                'infoText' => 'Typ_rozdeleni_filtr_stredisek_info'
            ],
            [
                'name'  => 'vydanaobjednavka_dodavatel_dle_rozdeleni',  'type'  => Preference::COMBOBOX, 'title' => 'Vydana_objednavka_dodavatel_dle_rozdeleni',
                'options'   => [0 => '', 1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5],
                'defaultValue' => 0,
            ],
            [
                'name'  => 'vydanaobjednavka_schvaleni_procento_prekroceni', 'type'  => Preference::TEXT,    'title' => 'Procento_prekroceni_castky',
                'defaultValue' => 0,
                'infoText' => 'Procento_prekroceni_castky_info'
            ],
            [
                'name'  => 'vydanaobjednavka_domaci_mena', 'type'  => Preference::SQL_COMBOBOX,    'title' => 'Domaci_mena',
                'sql' => "-- noinspection SqlResolve
                            SELECT KodMeny_ISO, KodMeny_ISO {fn_concat()} ' - ' {fn_concat()} PopisMeny FROM Mena WHERE Aktivni = 1 ORDER BY poradi",
                'infoText' => 'Domaci_mena_info'
            ],
            [
                'type'  => Preference::CATEGORY,    'title' => 'Vydana_objednavka_email'
            ],
            // odesilatel
            [
                'name'  => 'vydanaobjednavka_odesilatel',   'type'  => Preference::TEXT,    'title' => 'Vydana_objednavka_odesilatel',
                'defaultValue' => '',
                'infoText' => 'Vydana_objednavka_odesilatel_info'
            ],
            // prijemce
            [
                'name'  => 'vydanaobjednavka_prijemce_typ_rozdeleni',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_rozdeleni_prijemce',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni WHERE Aktivni = 1 AND PouzitProRozdeleniFirmy = 1 ORDER BY Kod',
                'defaultValue' => '',
                'infoText' => 'Vydana_objednavka_typ_rozdeleni_prijemce_info'
            ],
            [
                'name'  => 'vydanaobjednavka_prijemce_uzivatelske_pole',  'type'  => Preference::COMBOBOX, 'title' => 'Vydana_objednavka_prijemce_uzivatelske_pole',
                'options'   => [0 => '', 1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5],
                'defaultValue' => 0,
                'infoText' => 'Vydana_objednavka_prijemce_uzivatelske_pole_info'
            ],
            [
                'name'  => 'vydanaobjednavka_prijemce_pole_firmy',  'type'  => Preference::TEXT, 'title' => 'Vydana_objednavka_prijemce_pole_firmy',
                'defaultValue' => '',
                'infoText' => 'Vydana_objednavka_prijemce_pole_firmy_info'
            ],
            // obsah
            [
                'name'  => 'vydanaobjednavka_predmet',  'type'  => Preference::TEXT,    'title' => 'vydana_objednavka_predmet',
                'defaultValue' => '',
            ],
            [
                'name'  => 'vydanaobjednavka_text',     'type'  => Preference::MEMO,    'title' => 'vydana_objednavka_text',
                'defaultValue' => '', 'storage' => 'sys_bvar_global',
                'infoText' => 'vydana_objednavka_text_info'
            ],
            [
                'name'  => 'vydanaobjednavka_sestava',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_sestava',
                'sql'   => "SELECT Kod, nazev FROM SestavyProIntraweb ORDER BY nazev",
                'infoText' => 'Vydana_objednavka_sestava_info'
            ],
            [
                'name'  => 'vydanaobjednavka_typdokumentu_log_zapsat',    'type'  => Preference::CHECKBOX,    'title' => 'Vydana_objednavka_zapisovat_dokument',
                'defaultValue' => 0,
                'infoText' => 'Vydana_objednavka_zapisovat_dokument_info'
            ],
            [
                'name'  => 'vydanaobjednavka_typdokumentu_log',  'type'  => Preference::SQL_COMBOBOX, 'title' => 'Vydana_objednavka_typ_dokumentu',
                'sql'   => "SELECT Kod, popis FROM TypDokumentu ORDER BY popis", 'defaultValue' => '0',
            ],
        ]
];