<?php
/**
 * stanislav.elbl, 30.10.2015
 */

namespace RonPortal\Settings;

use Ron\Controls\Preference;

return [
    'caption' => 'nastaveni_vkladani',
    'category' => 'nastaveni_sekce_dochazka',
    'name'  => 'vkladani',
    'index' => 200,
    'storage' => 'nastaveni',
    'strings' => 'preferences_dochazka.ini',

    'items' =>
        [
            // kontrolovat schvaleni pri vkladani
            [
                'name'  => 'kontrolavkladani',  'type'  => Preference::COMBOBOX,    'title' => 'vkladani_kontrola_schvaleni',
                'options' => [
                    0 => 'vkladani_schvaleni_nekontrolovat', 1 => 'vkladani_schvaleni_3',  2 => 'vkladani_schvaleni_2', 3 => 'vkladani_schvaleni_1'
                ],
                'infoText' => 'vkladani_kontrola_schvaleni_info',
                'defaultValue' => '0'
            ],
            // zpetne vkladani
            [
                'name'  => 'pocetdnuzpetnevkladani',    'type'  => Preference::TEXT,        'title' => 'pocet_dnu_zpetne_vkladani',
                'defaultValue' => '',
                'infoText' => 'pocet_dnu_zpetne_vkladani_info'
            ],
            // vyber casu podle historie
            [
                'name'  => 'vkladani_casypodlehistorie',    'type'  => Preference::CHECKBOX,    'title' => 'vkladani_podle_historie',
                'infoText' => 'vkladani_podle_historie_info',
                'defaultValue' => 0
            ],

            // nastaveni terminalu pro vkladani
            [
                'type'  => Preference::CATEGORY,    'title' => 'vkladani_nastaveni_terminalu'

            ],
            [
                'name'  => 'vkladani_povolit_terminal',  'type'  => Preference::CHECKBOX,    'title' => 'vkladani_povolit_terminal',
                'infoText' => 'vkladani_povolit_terminal_info',
                'defaultValue' => 1
            ],
            [
                'name'  => 'vkladani_potvrdit',  'type'  => Preference::CHECKBOX,    'title' => 'vkladani_potvrdit_vlozeni',
                'infoText' => 'vkladani_potvrdit_vlozeni_info',
                'defaultValue' => 0
            ],
            [
                'name'  => 'vkladani_obarvit_tlacitka',  'type'  => Preference::CHECKBOX,    'title' => 'vkladani_obarvit_tlacitka',
                'defaultValue' => 0
            ],
            [
                'name'  => 'vkladani_razeni_tlacitek',   'type'  => Preference::COMBOBOX,    'title' => 'vkladani_razeni_tlacitek',
                'options' => [
                    'Kod' => 'Kod', 'Popis' => 'Popis', 'PopisProDochazku' => 'PopisProDochazku', 'PopisTlacitkaTerminalu' => 'PopisTlacitkaTerminalu', 'ZkratkaProPlanovani' => 'ZkratkaProPlanovani'
                ],
                'defaultValue' => 'Kod'
            ],

            // nastaveni terminalu v zaznamu puvodni dochazky
            [
                'type'  => Preference::CATEGORY,    'title' => 'Vkladani_nastaveni_zaznamu'

            ],
            // do pole karta doplnit ...
            [
                'name'  => 'vkladani_karta',    'type'  => Preference::COMBOBOX,    'title' => 'vkladani_pole_karta',
                'options' => [
                    0 => 'vkladani_karta_nic', 1 => 'vkladani_karta_nazev_pocitace',  2 => 'vkladani_karta_ip'
                ],
                'defaultValue' => '1'
            ],
            [
                'name'  => 'vkladani_zpusob_terminal',         'type'  => Preference::COMBOBOX,    'title' => 'vkladani_urceni_terminalu',
                'options' => [
                    0 => 'vkladani_terminal_nevkladat', 1 => 'vkladani_terminal_vybrany',  2 => 'vkladani_terminal_podle_url', 3 => 'vkladani_terminal_user_utils', 4 => 'vkladani_terminal_rucne'
                ],
                'defaultValue' => '0'
            ],
            [
                'name'  => 'vkladani_terminal',         'type'  => Preference::SQL_COMBOBOX,    'title' => 'vkladani_terminal',
                'sql'   => 'SELECT Kod, Popis FROM Terminal ORDER BY Kod',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vkladani_povinnyterminal',  'type'  => Preference::CHECKBOX,    'title' => 'vkladani_povinny_terminal',
                'infoText' => 'vkladani_povinny_terminal_info',
                'defaultValue' => 0
            ],

            // typ rozdeleni
            [
                'type'  => Preference::CATEGORY,    'title' => 'vkladani_nastaveni_rozdeleni'

            ],
            [
                'name'  => 'vkladani_rozdeleni',         'type'  => Preference::SQL_COMBOBOX,    'title' => 'vkladani_typ_rozdeleni',
                'sql'   => 'SELECT Kod, Popis FROM TypRozdeleni ORDER BY Popis',
                'defaultValue' => ''
            ],
            [
                'name'  => 'vkladani_povinnerozdeleni',  'type'  => Preference::CHECKBOX,    'title' => 'vkladani_povinne_rozdeleni',
                'defaultValue' => 0
            ],

      ]
];