<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\DB;

class DBRecordIterator implements \Iterator
{
    /** @var DBRecord */
    var $dbRecord;
    var $index = 0;

    /**
     * DBRecordIterator constructor.
     * @param DBRecord $dbRecord
     */
    public function __construct(DBRecord $dbRecord)
    {
        $this->dbRecord = $dbRecord;
    }

    #[\ReturnTypeWillChange]    // kvuli podpore PHP 7 nelze nastavit typ
    public function current()
    {
        return $this ->dbRecord ->fields[$this ->index] ->value;
    }

    public function next():void
    {
        ++ $this ->index;
    }

    #[\ReturnTypeWillChange]    // kvuli podpore PHP 7 nelze nastavit typ
    public function key()
    {
        return $this ->dbRecord ->fields[$this ->index] ->fieldName;
    }

    public function valid(): bool
    {
        return $this ->index >= 0  &&  $this ->index < count($this ->dbRecord ->fields);
    }

    public function rewind(): void
    {
        $this ->index = 0;
    }
}
