<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\DB;

/**
 * Pojmenovane parametry - tj. do SQL dotazu se vklada :p<index>
 */
class NamedParameters extends Parameters
{
    static $lastIndex = 1;

    /** @var int Jedinecny index pro kazdy objekt parametru - umoznuje spojovani parametru pomoci appendParams */
    var $index;
    var $data = [];

    /**
     * NamedParameters constructor.
     * @param Database $database
     */
    public function __construct($database)
    {
        parent::__construct($database);
        $this ->index = self::$lastIndex ++;
    }


    public function addParameter($value)
    {
        $index = count($this ->data) + 1;
        $name = "p{$this->index}_$index";
        $this ->data[$name] = $value;

        return ":$name";
    }

    public function getSqlParameters()
    {
        return $this ->data;
    }

    /**
     * @param NamedParameters $params
     * @return $this
     */
    public function appendParameters($params)
    {
        if ($params) {
            foreach ($params ->data as $name => $param) {
                $this ->data[$name] = $param;
            }
        }
        return $this;
    }


    public function newInstance()
    {
        return new self($this ->database);
    }


    public function getLogText()
    {
        return '';
    }
}
