<?php
/**
 * stanislav.elbl, 02.11.2015
 */

namespace Ron;

/**
 * Priloha emailu.
 */
class EMailAttachment
{
    /** @var string     Jmeno prilohy - tj. zadany obsah $content se pripoji jako soubor s timto jmenem. */
    public $fileName;
    /** @var string     Obsah prilohy. */
    public $content;

    /**
     * eMailAttachment constructor.
     * @param string $fileName  Jmeno prilohy
     * @param string $content   Obsah prilohy
     */
    public function __construct($fileName, $content)
    {
        $this->fileName = $fileName;
        $this->content = $content;
    }
}


/**
 * Reprezentuje email, ktery se bude odesilat
 */
class EMail
{
    /** @var string     Emailova adresa odesilatele */
    var $from;
    /** @var ?string    Jmeno odesilatele */
    var $fromName;

    /** @var string     Emailova adresa prijemce. Muze obsahovat vice adres oddelenych strednikem (pokud to podporuje pouzity MailManager). */
    var $to;
    /** @var string     Emailova adresa prijemce kopie. Muze obsahovat vice adres oddelenych strednikem  (pokud to podporuje pouzity MailManager). */
    var $copyTo;
    /** @var string     Emailova adresa prijemce slepe kopie. Muze obsahovat vice adres oddelenych strednikem  (pokud to podporuje pouzity MailManager). */
    var $blindCopyTo;
    /** @var string     Emailova adresa pro odpoved. */
    var $replyTo;

    /** @var string     Predmet emailu */
    var $subject;
    /** @var string     Obsah emailu */
    var $text;

    /** @var EMailAttachment[] $attachments     Prilohy emailu */
    var $attachments = [];

    /** @var bool|null  Urcuje, jestli se ma email odeslat jako HTML. Pokud je null, pouzije se vychozi nastaveni MailManagera */
    var $sendHtml = null; // podle nastaveni maileru


    function addAttachment($fileName, $content)
    {
        $this ->attachments[] = new EMailAttachment($fileName, $content);
    }

    function __toString()
    {
        return
            "Od:  $this->from 
            Jmeno odesilatele: $this->fromName 
            Komu: $this->to 
            Kopie: $this->copyTo 
            Skryta kopie: $this->blindCopyTo
            Odpoved: $this->replyTo
            Predmet: $this->subject
            Text: $this->text";
    }

    function convertToUTF8()
    {
        $this ->subject = StringUtils::toUTF8($this ->subject);
        $this ->text = StringUtils::toUTF8($this ->text);
        $this ->fromName = StringUtils::toUTF8($this ->fromName);
    }

    function getSubject()
    {
        global $mailer_subject_prefix;
        return ($mailer_subject_prefix ?: '') . $this->subject;
    }

}
