<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

use Ron\DB\DBException;
use Ron\DB\SQLUtils;
use Ron\Http\App;
use RonPortal\Log;

abstract class JsonController extends HttpController
{

    /**
     * @param string $action
     * @param JsonOutputObject $output
     * @throws \Exception
     */
    abstract function handleJsonAction($action, $output);

    public function handleAction($action)
    {
        $result = new JsonOutputObject();

        try {
            if (!App::getDebugMode()) {
                ini_set('display_errors', 0);
            };

            $this->handleJsonAction($action, $result);
//        } catch (RonException $e) {
//            $result ->addError($e ->getMessage(), $e ->getFieldName(), $e ->getErrorDescription());
        } catch (DBException $e) {
            // zaloguje chybu
            if ($e ->database) {
                try {
                    Log::addRecordToDBLog($e ->database,
                        SQLUtils::getTableNameFromSQL($e ->sql), 'ERROR', $this,
                        $e ->getMessage() . "\n" . $e ->dbMessage . "\n\nSQL:\n" . $e ->sql);

                    error_log($e ->dbMessage . "\n" . $e ->getTraceAsString());
                } catch (\Exception $e) {
                    // ted uz radsi nedela nic
                }
            }

            $result ->addError($e);
        } catch (\Exception $e) {
            $result ->addError($e);
        }

        return $result;
    }
}

