<?php
/**
 * stanislav.elbl, 19.02.2021
 */

namespace Ron\MVC;

use Ron\Http\App;
use Ron\Http\HttpHeaders;
use Ron\Http\HttpResponse;
use Ron\TextManager;


class TranslationsOutputObject implements OutputObject
{
    public function output()
    {
        if (!App::getDebugMode()) {
            ini_set('display_errors', 0);
        };

        HttpResponse::getInstance() ->getHeaders()
            ->addHeadersForContent('translations.js')
            ->setHeader(HttpHeaders::CACHE_CONTROL, 'private, max-age=3600')
            ->setHeader(HttpHeaders::PRAGMA, 'private')
            ->setHeader(HttpHeaders::EXPIRES, date('D, d M Y H:i:s', time() + 86400) . ' GMT');

        HttpResponse::renderHeaders();

        echo TextManager::getInstance() ->javascript();
    }
}
