<?php
/** UTF-8
 * roman.szablatura, 10.10.2016
 */

namespace RonPortal\Common;

use Exception;
use Ron\Controls\BrowserField;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\SqlStatement;
use RonPortal\Controls\FilterFormFilter;
use RonPortal\Controls\FilterFormFilterDatumOdDo;
use RonPortal\Controls\FilterFormFilterItem;
use RonPortal\Controls\FilterFormFilterSwitchLinks;
use function Ron\ronText;
use Ron\TextManager;
use RonPortal\Controls\JmenoPrijmeniBrowserField;
use RonPortal\Controls\RonPortalBrowser;
use RonPortal\Controls\RonPortalFilterForm;
use RonPortal\Prava;
use RonPortal\RozdeleniUtils;
use RonPortal\User;





/**
 * Class UkolFilterForm
 */
class UkolFilterForm extends RonPortalFilterForm
{
    private $ukoluKeSplneni = 0;
    private $ukoluKHodnoceni = 0;
    private $ukoluKeSchvaleni = 0;

//    // stavy ukolu
//    public $stavVse = true; // nastavi se automaticky, pokud neni zapnuty zadny z dalsich filtru
//    public $stavNesplnene = false;
//    public $stavPoTerminu = false;
//    public $stavSplnene = false;
//    public $stavMamHodnotit = false;
//    public $stavMamSchvalit = false;

//    public $typUkolu = null;
//    public $filtrResitele = 'mojeukoly'; // mojeukoly/ukolyvsech

    /**
     * UkolFilterForm constructor.
     * @param Database $database
     * @param $splnit
     * @param $hodnot
     * @param $schval
     */
    function __construct(Database $database)
    {
        parent::__construct($database, 'ukoly', true);

        //$this->f_formaction = '?menuid=ukoly';
        //$this->f_classname = 'filtercontainer leftcaptions';
        $prava = Prava::vratPrava('ukoly'); // prava na prohlizeni a "splneni"

        $filtrResitele = $prava->pouzeSebe()
            ? 'mojeukoly'
            : ($_GET['filtrresiteleukolu'] ?? $_SESSION['filterform_filtrresiteleukolu'] ?? 'mojeukoly');


        if (!$prava->pouzeSebe()) {
            // prepinani moje / vsechny
            $this ->addFilter(
                (new FilterFormFilter('filtrresiteleukolu'))
                    ->addItem(
                        (new FilterFormFilterItem('mojeukoly', ronText('Moje_ukoly')))
                            ->setUrl('?menuid=ukoly&filtrresiteleukolu=mojeukoly')
                    )
                    ->addItem(
                        (new FilterFormFilterItem('ukolyvsech', ronText('Vsechny_ukoly')))
                            ->setUrl('?menuid=ukoly&filtrresiteleukolu=ukolyvsech')
                    )
                    ->setDefaultValue('mojeukoly')
                    ,
                true
            );
        }

        $this ->addFilter(
            (new FilterFormFilterDatumOdDo($this))
                ->setCaption(ronText('Termin_ukolu') . ' ' . ronText('Od')),
            true
        );

        if ($filtrResitele === 'ukolyvsech') {
            $this ->addFilterRozdeleni1();
            $this ->addFilterRozdeleni2();

            $this ->addFilterPP(true, $prava)
                ->setDatumOd(time())
                ->setDatumDo(time())
                ->setDefaultValue('');
        }

        $this ->addFilter(
            (new FilterFormFilter('typukolu', FilterFormFilter::TYPE_OPTIONS))
                ->setCaption(TextManager::_('Typ_ukolu'))
                ->addItem('', TextManager::_('_vse_'))
                ->setOptionsSql(
                    'SELECT Kod, Popis FROM KategorieUkolu WHERE %FILTER% ORDER BY %ORDER%',
                    '1 = 1', 'Popis'
                )
                ->setSqlFilter('KategorieUkolu.kod = ')
        );

        $this ->addFilter(
            (new FilterFormFilterSwitchLinks('stavukolu'))
                ->addItem('', TextManager::_('Vse'))
                ->addItem('nesplnene', TextManager::_('Nesplnene'))
                ->addItem('poterminu', TextManager::_('Po_terminu_nesplnene'))
                ->addItem('splnene', TextManager::_('Splnene'))
                ->addItem('mamhodnotit', TextManager::_('Mam_hodnotit'))
                ->addItem('mamschvalit', TextManager::_('Mam_schvalit'))
        );

        $this ->addFilter(
            (new FilterFormFilter('cekajici', FilterFormFilter::TYPE_TEXT))
                ->setDefaultValue(TextManager::_('ukoly_cekajici'))
                ->setUrl('?menuid=ukoly&stavukolu_nesplnene=1&stavukolu_mamhodnotit=1&stavukolu_mamschvalit=1')
        );
    }



//    function renderStavUkolu()
//    {
//        echo
//            '<div class="text_link padding-top-2 padding-bottom-2">' .
//            '<input type="hidden" name="vse"       id="stav_ukolu_vse" value=""/>' . // hodnota se nastavi, jen kdyz uzivatel klikne na tento odkaz
//            '<input type="hidden" name="nesplnene" id="stav_ukolu_nesplnene" value="' . ($this ->stavNesplnene ? '1' : '0') . '"/>' .
//            '<input type="hidden" name="poterminu" id="stav_ukolu_poterminu" value="' . ($this ->stavPoTerminu ? '1' : '0') . '"/>' .
//            '<input type="hidden" name="splnene"   id="stav_ukolu_splnene" value="' . ($this ->stavSplnene ? '1' : '0') . '"/>' .
//            '<input type="hidden" name="mamhodnotit" id="stav_ukolu_mamhodnotit" value="' . ($this ->stavMamHodnotit ? '1' : '0') . '"/>' .
//            '<input type="hidden" name="mamschvalit" id="stav_ukolu_mamschvalit" value="' . ($this ->stavMamSchvalit ? '1' : '0') . '"/>' .
//            '<ul class="linkslist">' .
//            // vse
//            '  <li' . ($this ->stavVse ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_vse" data-value="1">' . TextManager::_('Vse') . '</a>' .
//              '</li>' .
//            // nesplnene
//            '  <li' . ($this ->stavNesplnene ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_nesplnene" data-value="' . ($this ->stavNesplnene ? '0' : '1') . '">' . TextManager::_('Nesplnene') . '</a>' .
//              '</li>' .
//            // nesplnene
//            '  <li' . ($this ->stavPoTerminu ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_poterminu" data-value="' . ($this ->stavPoTerminu ? '0' : '1') . '">' . TextManager::_('Po_terminu_nesplnene') . '</a>' .
//              '</li>' .
//            // splnene
//            '  <li' . ($this ->stavSplnene ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_splnene" data-value="' . ($this ->stavSplnene ? '0' : '1') . '">' . TextManager::_('Splnene') . '</a>' .
//              '</li>' .
//            // mam hodnotit
//            '  <li' . ($this ->stavMamHodnotit ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_mamhodnotit" data-value="' . ($this ->stavMamHodnotit ? '0' : '1') . '">' . TextManager::_('Mam_hodnotit') . '</a>' .
//              '</li>' .
//            // mam schvalit
//            '  <li' . ($this ->stavMamSchvalit ? ' class="selectedlink"' : '') . '>' .
//              '<a href="#" data-submit="1" class="setValue" data-selector="#stav_ukolu_mamschvalit" data-value="' . ($this ->stavMamSchvalit ? '0' : '1') . '">' . TextManager::_('Mam_schvalit') . '</a>' .
//              '</li>' .
//            '</ul>' .
//            '</div>';
//    }

//    function renderInfoNovinky()
//    {
//        if ($this->ukoluKeSplneni == 0  && $this->ukoluKHodnoceni == 0 && $this->ukoluKeSchvaleni == 0) {
//            // nic
//        } else {
//            $url = '?menuid=ukoly';
//
//            if($this->ukoluKeSplneni != 0) {
//                $url .= '&nesplnene=1';
//            }
//
//            if($this->ukoluKHodnoceni != 0) {
//                $url .= '&mam_hodnotit=1';
//            }
//
//            if($this->ukoluKeSchvaleni != 0) {
//                $url .= '&mam_schvalit=1';
//            }
//
//            echo
//                '<div class="font-weight-bold ukoly_cekaji" title="' . $this->vytvoreniTitleNovinek() . '">' .
//                "<a href='$url'>" . ronText('ukoly_cekajici') . '</a>' .
//                '</div>';
//        }
//    }
//
//    function vytvoreniTitleNovinek()
//    {
//        $result = '';
//        if ($this->ukoluKeSplneni != 0) {
//            $result .= ronText('ukolu_ke_splneni'). ": " . $this->ukoluKeSplneni . '&#010';
//        }
//        if ($this->ukoluKHodnoceni != 0) {
//            $result .= ronText('ukolu_k_hodnoceni'). ": " .  $this->ukoluKHodnoceni . '&#010';
//        }
//        if ($this->ukoluKeSchvaleni != 0) {
//            $result .= ronText('ukolu_ke_schvaleni'). ": " . $this->ukoluKeSchvaleni;
//        }
//        return $result;
//    }


//    /**
//     * @throws DBException
//     */
//    function najdiUkolyVyzadujiciPozornost()
//    {
//        $this->ukoluKeSplneni = 0;
//        $this->ukoluKHodnoceni = 0;
//        $this->ukoluKeSchvaleni = 0;
//
//        $params = $this ->database->createParameters();
//
//        // nacte ukoly zgrupovane podle RC zamestnancu a stavu (at nemusi nacitat kazdy zvlast)
//        $sql =
//            'SELECT RC_Osoby, UkolOsoby.StavUkolu, UkolOsoby.RC_Hodnotitele_Def, UkolOsoby.Hodnoceno,' . // 0 - 3
//            ' UkolOsoby.RC_Schvalovatele1_Def, UkolOsoby.Schvaleno1, UkolOsoby.RC_Schvalovatele2_Def, UkolOsoby.Schvaleno2,' . // 4 - 7
//            ' COUNT(*)' .   // 8
//            ' FROM UkolOsoby' .
//            ' WHERE StavUkolu <> -1' .
//            ' AND (UkolOsoby.RC_Osoby = ' . $params ->addParameter(User::getRC()) .
//            '  OR UkolOsoby.RC_Hodnotitele_Def = ' . $params ->addParameter(User::getRC()) .
//            '  OR UkolOsoby.RC_Schvalovatele1_Def = ' . $params ->addParameter(User::getRC()) .
//            '  OR UkolOsoby.RC_Schvalovatele2_Def = ' . $params ->addParameter(User::getRC()) .
//            ' )' .
//            ' GROUP BY RC_Osoby, UkolOsoby.StavUkolu, UkolOsoby.RC_Hodnotitele_Def, UkolOsoby.Hodnoceno,' .
//            '  UkolOsoby.RC_Schvalovatele1_Def, UkolOsoby.Schvaleno1, UkolOsoby.RC_Schvalovatele2_Def, UkolOsoby.Schvaleno2';
//
//        $cursor = $this ->database->getSqlResult($sql, $params);
//
//        while ($row = $cursor->fetch()){
//            // Ukoly ke splneni
//            if ($row[0]  &&  User::hasRC($row[0]) && !$row[1]) {
//                $this->ukoluKeSplneni += $row[8];
//            }
//
//            // Ukoly pripravene k hodnoceni
//            if ($row[2]  &&  User::hasRC($row[2]) && !$row[3] && $row[1] == 1) {
//                $this->ukoluKHodnoceni += $row[8];
//            }
//
//            // Ukoly pripravene ke schvaleni 1
//            if ($row[4]  &&  User::hasRC($row[4]) && $row[1] == 1 && $row[3] == 1 && $row[5] == 0) {
//                $this->ukoluKeSchvaleni += $row[8];
//            }
//
//            // Ukoly pripravene ke schvaleni 2
//            if ($row[6]  &&  User::hasRC($row[6]) && $row[1] == 1 && $row[5] == 1 && $row[7] == 0) {
//                $this->ukoluKeSchvaleni += $row[8];
//            }
//        }
//
//        $cursor ->close();
//    }

//    private function loadStavyUkolu()
//    {
//        $value = [];
//
//        if (isset($_GET['vse']) && (int)$_GET['vse']) {
//            // vypne vsechny stavove filtry a zapne vse ...
//            $this ->stavVse = true;
//        } else {
//            // nesplnene
//            if (isset($_GET['nesplnene'])) {
//                $this->stavNesplnene = (int)$_GET['nesplnene'];
//                if ($this ->stavNesplnene) {
//                    $value['nesplnene'] = 1;
//                }
//            } else {
//                $this->stavNesplnene = $_SESSION['filtr_stav_ukolu']['nesplnene'] ?? false;
//            }
//
//            // po terminu
//            if (isset($_GET['poterminu'])) {
//                $this->stavPoTerminu = (int)$_GET['poterminu'];
//                if ($this ->stavPoTerminu) {
//                    $value['poterminu'] = 1;
//                }
//            } else {
//                $this->stavPoTerminu = $_SESSION['filtr_stav_ukolu']['poterminu'] ?? false;
//            }
//
//            // splnene
//            if (isset($_GET['splnene'])) {
//                $this->stavSplnene = (int)$_GET['splnene'];
//                if ($this ->stavSplnene) {
//                    $value['splnene'] = 1;
//                }
//            } else {
//                $this->stavSplnene = $_SESSION['filtr_stav_ukolu']['splnene'] ?? false;
//            }
//
//            // mam hodnotit
//            if (isset($_GET['mamhodnotit'])) {
//                $this->stavMamHodnotit = (int)$_GET['mamhodnotit'];
//                if ($this ->stavMamHodnotit) {
//                    $value['mamhodnotit'] = 1;
//                }
//            } else {
//                $this->stavMamHodnotit = $_SESSION['filtr_stav_ukolu']['mamhodnotit'] ?? false;
//            }
//
//            // mam schvalit
//            if (isset($_GET['mamschvalit'])) {
//                $this->stavMamSchvalit = (int)$_GET['mamschvalit'];
//                if ($this ->stavMamSchvalit) {
//                    $value['mamschvalit'] = 1;
//                }
//            } else {
//                $this->stavMamSchvalit = $_SESSION['filtr_stav_ukolu']['mamschvalit'] ?? false;
//            }
//        }
//
//        if (!$value) {
//            $this ->stavVse = true;
//            unset($_SESSION['filtr_stav_ukolu']);
//        } else {
//            $this ->stavVse = false;
//            $_SESSION['filtr_stav_ukolu'] = $value;
//        }
//    }


//    private function loadTypUkolu()
//    {
//        if (isset($_GET['typukolu'])) {
//            $this ->typUkolu = trim($_GET['typukolu']);
//            if ($this ->typUkolu === '') {
//                $this ->typUkolu = null;
//            }
//            $_SESSION['ukoly_filtrtyp'] = $this ->typUkolu;
//        } else {
//            $this ->typUkolu = $_SESSION['ukoly_filtrtyp'] ?? null;
//        }
//    }


//    function renderVlastnikUkolu()
//    {
//        // vlastnik ukolu - moje / vsechny
//        if (!$this->prava->pouzeSebe()) {
//            LinksList::renderLinks(
//                [
//                    'mojeukoly' => ronText('Moje_ukoly'),
//                    'ukolyvsech' => ronText('Vsechny_ukoly')
//                ],
//                $this ->filtrResitele,
//                'filtrresiteleukolu', '', '',//'?menuid=ukoly&filtrresiteleukolu=');
//                true // hidden field = true
//            );
//        }
//    }

//    function loadData()
//    {
//        $this->loadVlastnikUkolu();
//        $this->loadNesplnene();
//        $this->loadPoterminu();
//        $this->loadSplnene();
//        $this->loadMamHodnotit();
//        $this->loadMamSchvalit();
//        $this->loadTypUkolu();
//        $this ->loadStavyUkolu();
//        parent::loadData();
//        $this ->najdiUkolyVyzadujiciPozornost();
//    }

//    /**
//     * @throws Exception
//     */
//    function renderFilters()
//    {
//        parent::renderFilters();
//        $this->renderTypUkolu();
//        $this->renderStavUkolu();
//        $this->renderVlastnikUkolu();
//        $this->renderInfoNovinky();
//    }
}


class PrekazkaBrowserField extends BrowserField
{
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        // pokud neni v ukolu nastaveno "Prekazka", tak nezobrazuje nic (bud prekazka neni zadana, nebo jiz byla odstranena)
        if (!$rowData['col-prekazka']) {
            return '';
        }

        return parent::getViewText($value, $rowNumber, $recordId, $rowData);
    }
}



/**
 * Class StavUkoluBrowserField
 */
class StavUkoluBrowserField extends BrowserField
{
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        if ($value == 1) {  // UkolOsoby.StavUkolu = splnen
            return ronText('Str_Yes');
        }

        if (!$value) {  // probiha
            return ($rowData['col-prekazka'] == 1)  // UkolOsoby.Prekazka
                ? ronText('Prekazka_ukolu')
                : ronText('Str_No');
        }

        // -1 = zruseno - nezobrazuji se
        return '';
    }
}



class OsobaUkoluField extends JmenoPrijmeniBrowserField
{
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = parent::getViewText($value, $rowNumber, $recordId, $rowData);

        if ($value  &&  User::hasRC($value)) {
            return '<strong>' . $result . '</strong>';
        }

        return $result;
    }
}



/**
 * Class Ukol_TerminField
 */
class Ukol_TerminField extends BrowserField
{
    function getViewText($value, $rowNumber, $recordId, $rowData)
    {
        $result = parent::getViewText($value, $rowNumber, $recordId, $rowData);

        $class = '';
        //Pokud existuje zaznam DatumSplneni_Skutecne, pak se promenna $class naplni hodnotou 'splnene'
        if ($rowData['col-datumsplneni']) {
            $class = 'splnene';
        } else {
            //ulozeni hodnoty datumu - DatumSplneni_Narizene
            $datum = $this ->database ->stringToTimestamp($value);
            //Pokud je aktualni datum vyssi nez DatumSplneni_Narizene je pouzito k obarveni data tridy po_terminu
            if (DateUtils::endOfTheDay($datum) < time()) {
                $class = 'po_terminu';
            }
        }

        //Vysledne obarveni datumu na zaklade splneni nebo po_terminu
        if ($class) {
            return
                '<div class="' . $class . '">' . $result . '</div>';
        }

        return $result;
    }
}

/**
 * Class SeznamUkoluBrowser
 */
class UkolyBrowser extends RonPortalBrowser
{
    var $prava;    //Prava na prohlizeni a "splneni"

//    var $ukoluKeSplneni = 0;
//    var $ukoluKHodnoceni = 0;
//    var $ukoluKeSchvaleni = 0;


    /**
     * SeznamUkoluBrowser constructor.
     * @param Database $database
     * @throws Exception
     */
    function __construct($database)
    {
        parent::__construct($database, 'ukoly');

        $this->prava = Prava::vratPrava('ukoly'); // prava na prohlizeni a "splneni"

        $this->title = ronText('Seznam_ukolu');
        $this->code = 'browserukoly';

        $this->sqlSelectPart =
            ' UkolOsoby.KodSerial'; // 0
            //' Resitel.Jmeno, Resitel.Prijmeni, Resitel.Titul, UkolOsoby.RC_Osoby'; // 1..4
            //' Zadavatel.Jmeno, Zadavatel.Prijmeni, Zadavatel.Titul, UkolOsoby.RC_KdoZadal'; // 5..8
            //' UkolOsoby.DatumSplneni_Narizene, UkolOsoby.DatumSplneni_Skutecne'; // 9,10
            //$database ->castWideMemo('UkolOsoby.PodrobnyPopis'); // 11
            //', UkolOsoby.Prekazka, UkolOsoby.DatumZapisuPrekazky, ' . $database ->castWideMemo('UkolOsoby.PoznamkaKPrekazce'); // 12..14
            //', UkolOsoby.ZkracenyPopis'; // 15
            //' KategorieUkolu.Popis, UkolOsoby.DatumZadani'; // 16,17
            //" COALESCE(Hodnotitel.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(Hodnotitel.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} Hodnotitel.Titul, '')";  // 18
            //' UkolOsoby.StavUkolu, UkolOsoby.Prekazka, UkolOsoby.PP_Osoby_OsobniCislo, UkolOsoby.PP_Osoby_DatumNastupu, UkolOsoby.RC_Hodnotitele_Def';     // 19 - 23
            //" UkolOsoby.RC_OsobaUkolu, COALESCE(VazanaOsoba.Prijmeni,'') {fn_concat()} ' ' {fn_concat()} COALESCE(VazanaOsoba.Jmeno,'') {fn_concat()} COALESCE(', ' {fn_concat()} VazanaOsoba.Titul, '')";  //24 - 25
            //' KategorieUkolu.PopisVazbyNaOsobu, VazanaOsoba.Prijmeni, UkolOsoby.Hodnoceno, UkolOsoby.Schvaleno1, UkolOsoby.Schvaleno2';    //26 - 30
            //' UkolOsoby.RC_Schvalovatele1_Def, UkolOsoby.RC_Schvalovatele2_Def, UkolOsoby.PP_Hodnotitel_RC';    //31 - 33

        $this->sqlFromPart =
            '(((((UkolOsoby INNER JOIN Osoba Resitel' .
            '           ON UkolOsoby.RC_Osoby = Resitel.RC ' .
            '             )' .
            '        LEFT OUTER JOIN Osoba Zadavatel ' .
            '        ON UkolOsoby.RC_KdoZadal = Zadavatel.RC ' .
            '        )' .
            '       LEFT OUTER JOIN Osoba Hodnotitel ' .
            '       ON UkolOsoby.RC_Hodnotitele_Def = Hodnotitel.RC' .
            '       )'.
            '     LEFT OUTER JOIN Osoba VazanaOsoba ' .
            '     ON UkolOsoby.RC_OsobaUkolu = VazanaOsoba.RC' .
            '     )'.
            '    LEFT OUTER JOIN KategorieUkolu ' .
            '    ON KategorieUkolu.Kod = UkolOsoby.KodKategorieUkolu ' .
            ')';

        $this->primaryField = 0;

//        $this->najdiUkolyVyzadujiciPozornost($database);

        // termin
        $this->addField(new Ukol_TerminField($database))
            ->setSqlFieldName('UkolOsoby.DatumSplneni_Narizene') ->setHeaderText(ronText('Termin_ukolu'))
            ->setCode('col-datumsplneni_narizene')
            ->setFormat('finedate') ->setLink('?menuid=ukoly')
            ->setOrdering(true);

        $this ->defaultSort = 'col-datumsplneni_narizene';

        //Splneno - Ano/Ne/Prekazka
        $this->addField(new StavUkoluBrowserField($this->database))
            ->setSqlFieldName('UkolOsoby.StavUkolu') ->setHeaderText('Splneno')
            ->setCode('col-stavukolu') ->setOrdering(true)
            ->setLink('?menuid=ukoly');

        //Datum splneni
        $this->addField()
            ->setSqlFieldName('UkolOsoby.DatumSplneni_Skutecne') ->setHeaderText('Datum_splneni')
            ->setCode('col-datumsplneni')  // ->setVisible($this ->filterForm ->stavSplnene) - zruseno - filtr se vytvari az dodatecne
            ->setFormat('finedate') ->setOrdering(true);


        // Zadano osobe - pokud jsou vybrany vsechny osoby pak sloupec skryt
//        $resitelfield = new Ukol_OsobaField(1, ronText('Resitel'), true); // index pole v sql
//        $this->addField($resitelfield)
//            ->setCode('col-resitel') ->setVisible($this ->filterForm ->vsechnyOsoby);

        //' Resitel.Jmeno, Resitel.Prijmeni, Resitel.Titul, UkolOsoby.RC_Osoby'; // 1..4
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Resitel.Jmeno')
            ->setCode('col-resitel-jmeno');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Resitel.Prijmeni')
            ->setCode('col-resitel-prijmeni');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Resitel.Titul')
            ->setCode('col-resitel-titul');

        $this->addField(new OsobaUkoluField($this ->database, 'col-resitel-jmeno', 'col-resitel-prijmeni', null, 'col-resitel-titul'))
            ->setSqlFieldName('UkolOsoby.RC_Osoby') ->setHeaderText('Resitel')
            ->setCode('col-resitel') ->setOrdering(true)
            ->setSortSQL('Resitel.Prijmeni, Resitel.Jmeno')
            ->setSortSQLDesc('Resitel.Prijmeni DESC, Resitel.Jmeno DESC');

        // typ ukolu - v KODAMU(kategorie)
        $this->addField()
            ->setSqlFieldName('KategorieUkolu.Popis') ->setHeaderText('Typ_ukolu') ->setOrdering(true)
            ->setCode('col-kategorie');

        // popis
        $this->addField()
            ->setSqlFieldName('UkolOsoby.ZkracenyPopis') ->setHeaderText('Popis')
            ->setCode('col-popis')
            ->setLink('?menuid=ukoly') ->setOrdering(true) ->setWrap(true);

        // Datum zadani
        $this->addField()
            ->setSqlFieldName('UkolOsoby.DatumZadani') ->setHeaderText('Datum_zadani')
            ->setCode('col-datumzadani')
            ->setFormat('finedate') ->setOrdering(true);

        // Zadal
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Zadavatel.Jmeno')
            ->setCode('col-zadavatel-jmeno');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Zadavatel.Prijmeni')
            ->setCode('col-zadavatel-prijmeni');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Zadavatel.Titul')
            ->setCode('col-zadavatel-titul');

        $this ->addField(new JmenoPrijmeniBrowserField($this ->database, 'col-zadavatel-jmeno', 'col-zadavatel-prijmeni', null, 'col-zadavatel-titul'))
            ->setHeaderText('Zadavatel') ->setOrdering(true)
            ->setCode('col-zadavatel')
            ->setSortSQL('Zadavatel.Prijmeni, Zadavatel.Jmeno')
            ->setSortSQLDesc('Zadavatel.Prijmeni DESC, Zadavatel.Jmeno DESC');

        // Hodnotitel
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Hodnotitel.Jmeno')
            ->setCode('col-hodnotitel-jmeno');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Hodnotitel.Prijmeni')
            ->setCode('col-hodnotitel-prijmeni');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Hodnotitel.Titul')
            ->setCode('col-hodnotitel-titul');

        $this ->addField(new JmenoPrijmeniBrowserField($this ->database, 'col-hodnotitel-jmeno', 'col-hodnotitel-prijmeni', null, 'col-hodnotitel-titul'))
            ->setHeaderText('Hodnotitel') ->setOrdering(true)
            ->setCode('col-hodnotitel')
            ->setSortSQL('Hodnotitel.Prijmeni, Hodnotitel.Jmeno')
            ->setSortSQLDesc('Hodnotitel.Prijmeni DESC, Hodnotitel.Jmeno DESC');

        // Hodnoceno
        $this->addField(BrowserField::FIELD_TYPE_SELECT)
            ->setSqlFieldName('Hodnoceno') ->setHeaderText('Hodnoceno') ->setOrdering(true) ->setAlign('center')
            ->setCode('col-hodnoceno')
            ->setOptions([0 => TextManager::_('Str_No'), 1 => TextManager::_('Str_Yes')]);

        // zjisti, jestli existuje typ ukolu s nastavenou vazbou
        $cursor = $database ->getSqlResult('SELECT MAX(PopisVazbyNaOsobu) FROM KategorieUkolu');
        $rowVazba = $cursor ->fetch();
        $existujeVazba = $rowVazba  &&  $rowVazba[0];
        $cursor ->close();

        // Vazana osoba - popis
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN) // skryto - je v titulku sloupce, lze zobrazit pomoci xml nastaveni
            ->setSqlFieldName('KategorieUkolu.PopisVazbyNaOsobu') ->setHeaderText('Vazana_osoba_popis') ->setOrdering(true)
            ->setCode('col-popisvazby');

        // Vazana osoba - nacteni jmena atd.
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('VazanaOsoba.Jmeno') ->setVisible($existujeVazba)
            ->setCode('col-vazanaosoba-jmeno');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('VazanaOsoba.Prijmeni') ->setVisible($existujeVazba)
            ->setCode('col-vazanaosoba-prijmeni');

        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('VazanaOsoba.Titul') ->setVisible($existujeVazba)
            ->setCode('col-vazanaosoba-titul');

        $this ->addField(new JmenoPrijmeniBrowserField($this ->database, 'col-vazanaosoba-jmeno', 'col-vazanaosoba-prijmeni', null, 'col-vazanaosoba-titul'))
            ->setHeaderText('Vazana_osoba_prijmeni_jmeno') ->setOrdering(true)
            ->setCode('col-vazanaosoba') ->setVisible($existujeVazba) // jen pokud existuje nejaky typ ukolu s nastavenou vazbou
            ->setSortSQL('VazanaOsoba.Prijmeni, VazanaOsoba.Jmeno')
            ->setSortSQLDesc('VazanaOsoba.Prijmeni DESC, VazanaOsoba.Jmeno DESC')
            ->setTitleFieldIndex('col-popisvazby');

        $this ->addField(BrowserField::FIELD_TYPE_COMMENT)
            ->setSqlFieldName('UkolOsoby.PodrobnyPopis') ->setCastWideMemo(true)
            ->setCode('col-podrobnypopis')
            ->setClassName('browserpoznamka')
            ->setHeaderColSpan(-1)
            ->setHeaderText(TextManager::_('Detailni_popis') . ': ');


        // prekazka
        $this->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('UkolOsoby.Prekazka')
            ->setCode('col-prekazka');

        $this ->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('UkolOsoby.PoznamkaKPrekazce') ->setCastWideMemo(true)
            ->setCode('col-poznamkakprekazce');

        $this ->addField((new PrekazkaBrowserField($database))
            ->setType(BrowserField::FIELD_TYPE_COMMENT)
            ->setSqlFieldName('UkolOsoby.DatumZapisuPrekazky')
            ->setFormat('finedatetime')
            ->setCode('col-prekazka-info')
            ->setClassName('browserpoznamka prekazkaukolu color-red')
            ->setHeaderColSpan(-1)
            ->setHeaderText(TextManager::_('Prekazka_ukolu') . ': ')
            ->setSqlFieldIndex2('col-poznamkakprekazce')
            ->setSqlFieldIndex2Separator(' - ')
            ->setWrap(true)
        );
    }


    function setFilterForm()
    {
        $this->filterForm = new UkolFilterForm($this->database);
    }




//    /**
//     * @param array $values
//     * @return bool
//     * @throws Exception
//     */
//    function enableLine($values)
//    {
//        //Zobrazit pokud ma na radek pravo
//        return $this->prava->lzeZobrazitRC($values['col-resitel']);
//    }


    function renderLine($values, $className, $rowNumber, $edit = false)
    {
        parent::renderLine($values, $className, $rowNumber);

        $this->renderSeparator();
    }


    function getSQLFilter()
    {
        $params = $this ->database ->createParameters();
        $result = $this ->filterForm ->buildSqlFilter($params);

        $result .=
            ($result ? ' AND ' : '') .
            'StavUkolu <> -1'; // nezobrazovat zrusene

        $filtrPrava = $this ->prava ->sqlFiltr('Resitel', time(), time(), $params, false, true);
        if ($filtrPrava) {
            $result .=
                ($result ? ' AND ' : '') .
                $filtrPrava;
        }

        // Filtr na osobu, pripadne na rozdeleni
        if ($this ->filterForm ->getFilterValue('filtrresiteleukolu') !== 'ukolyvsech' || $this->prava->pouzeSebe()) {
            // jen vlastni
            $result .=
                ($result ? ' AND ' : '') .
                'UkolOsoby.RC_Osoby = ' . $params ->addParameter(User::getRC()) .
                "\n";
        } else if ($this ->filterForm ->getFilterValue('osoba')) {
            // vybrana osoba
            $result .=
                ($result ? ' AND ' : '') .
                'UkolOsoby.RC_Osoby = ' . $params ->addParameter($this ->filterForm ->getFilterValue('osoba', 'rc')) . "\n";
        } else {
            foreach ($this ->filterForm ->getRozdeleniFilters() as $rozdeleniFilter) {
                if ($rozdeleniFilter ->getValue() !== null) {
                    $filtrRozdeleni = RozdeleniUtils::sqlFilterRozdeleniPP($this->database, 'Resitel',
                        $rozdeleniFilter->getValue('typRozdeleni'),
                        $rozdeleniFilter->getValue(),
                        time(), time(),
                        $rozdeleniFilter->getValue('vcetnePodrizenych'),
                        $params,
                        true); // $jenRC = true

                    if ($filtrRozdeleni) {
                        $result .=
                            ($result ? ' AND ' : '') .
                            '(' . $filtrRozdeleni . ')' .
                            "\n";
                    }
                }
            }
        }


//        if (isset($this ->filterForm ->typUkolu)) {
//            $result .=
//                ($result ? ' AND ' : '') .
//                'KategorieUkolu.kod = ' . $params ->addParameter($this ->filterForm ->typUkolu);
//        }

        if ($this ->filterForm ->getFilterValue('datumod')) {
            $result .=
                ($result ? ' AND ' : '') .
                ' DatumSplneni_Narizene >= ' . $params ->addDateParameter($this ->filterForm ->getFilterValue('datumod')) .
                ' AND DatumSplneni_Narizene <= ' . $params ->addDateParameter($this ->filterForm ->getFilterValue('datumod', 'datumDo'));
        }

        //Filtr stav ukolu
        $filtrStavUkolu = '';
        //if ($this ->filterForm ->stavNesplnene) {
        if ($this ->filterForm ->getFilterValue('stavukolu', 'nesplnene')) {
            $filtrStavUkolu .=
                'UkolOsoby.StavUkolu = 0';
        }

//        if ($this ->filterForm ->stavPoTerminu) {
        if ($this ->filterForm ->getFilterValue('stavukolu', 'poterminu')) {
            $filtrStavUkolu .=
                ($filtrStavUkolu ? ' OR ' : '') .
                '(DatumSplneni_Skutecne IS NULL AND DatumSplneni_Narizene < ' . $params ->addDateParameter(time()) . ')';
        }

//        if ($this ->filterForm ->stavSplnene) {
        if ($this ->filterForm ->getFilterValue('stavukolu', 'splnene')) {
            $filtrStavUkolu .=
                ($filtrStavUkolu ? ' OR ' : '') .
                'DatumSplneni_Skutecne IS NOT NULL';
        }

        //Aby se vyfiltroval musi byt ukol splnen, musi byt jeste neohodnocen a musi RC_Hodnotitele_Def souhlasit s prihlasenym uzivatelem
//        if ($this ->filterForm ->stavMamHodnotit) {
        if ($this ->filterForm ->getFilterValue('stavukolu', 'mamhodnotit')) {
            $filtrStavUkolu .=
                ($filtrStavUkolu ? ' OR ' : '') .
                '(UkolOsoby.StavUkolu = 1 AND UkolOsoby.Hodnoceno = 0 AND UkolOsoby.RC_Hodnotitele_Def = ' . $params ->addParameter(User::getRC()) . ')';
        }

        //Aby se vyfiltroval musi byt ukol splnen, musi byt neschvaleny a musi RC_Schvalovatele1_Def nebo RC_Schvalovatele2_Def souhlasit s prihlasenym uzivatelem
//        if ($this ->filterForm ->stavMamSchvalit) {
        if ($this ->filterForm ->getFilterValue('stavukolu', 'mamschvalit')) {
            $filtrStavUkolu .=
                ($filtrStavUkolu ? ' OR ' : '') .
                ' ((UkolOsoby.StavUkolu = 1 AND UkolOsoby.Hodnoceno = 1) ' .
                ' AND ((UkolOsoby.Schvaleno1 = 0 AND UkolOsoby.RC_Schvalovatele1_Def = ' . $params ->addParameter(User::getRC()) . ')' .
                ' OR (UkolOsoby.Schvaleno1 = 1 AND UkolOsoby.Schvaleno2 = 0 AND UkolOsoby.RC_Schvalovatele2_Def = ' . $params ->addParameter(User::getRC()) . ')' .
                "))\n";
        }



        if ($filtrStavUkolu) {
            $result .=
                ($result ? ' AND ' : '') .
                '(' . $filtrStavUkolu . ')';
        }

        return new SqlStatement($result, $params);
    }
}
