<?php
/**
 * stanislav.elbl, 18.03.2021
 */

namespace RonPortal\Common;

use Ron\Controls\FormField;
use Ron\TextManager;
use RonPortal\Controls\RonPortalForm;

class VyjadreniFormular extends RonPortalForm
{

    function __construct($database)
    {
        parent::__construct($database, 'edit');

        $this -> htmlAction = '?menuid=vzkazy&action=vyjadreni';
        $this -> stornoAction = '?menuid=vzkazy';

        $this -> title = TextManager::_('Upravit_vyjadreni');
        $this -> sqlTableName = 'Vzkaz';

        $this ->code = 'formvyjadreni';

        $this ->addField(FormField::FIELD_TYPE_ID)
            ->setFieldName('Id') ->setPrimary(true)
            ->setCode('field-id');

        $this ->addField(FormField::FIELD_TYPE_HIDDEN)
            ->setFieldName('Zpracovano') ->setDataType('int') ->setDefaultValue(0)
            ->setCode('field-zpracovano');

        $this ->addField(FormField::FIELD_TYPE_ACTUAL_TIME)
            ->setFieldName('PosledniAktualizace') ->setReadOnly(true)
            ->setCode('field-posledniaktualizace');

        $this ->addField()
            ->setFieldName('Predmet') ->setCaption('Predmet')
            ->setMaxLength(60) ->setReadOnly(true)
            ->setCode('field-predmet');

        $this ->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('Popis') ->setReadOnly(true)
            ->setCode('field-popis'); // FORM_FIELD_CAPTION => '&nbsp;', FORM_FIELD_EDIT => false

        $this ->addField(FormField::FIELD_TYPE_MEMO)
            ->setFieldName('Vyjadreni') ->setCaption('Vyjadreni')
            ->setCode('field-vyjadreni');
    }
}
