<?php

namespace RonPortal\Controls;

use Ron\Controls\FormField;
use Ron\StringUtils;
use Ron\TextManager;

class SeznamRozdeleniFormField extends FormField
{
    /** @var string Urcuje, co ma udelat po zavreni dialogu - muze byt nastaveno na "reload" */
    public $afterCloseAction = '';


    public function __construct($fieldType = self::FIELD_TYPE_EDIT)
    {
        parent::__construct($fieldType);
        $this ->fieldCssClass = 'pills';
    }



    /**
     * @param string $afterCloseAction
     * @return SeznamRozdeleniFormField
     */
    public function setAfterCloseAction(string $afterCloseAction): SeznamRozdeleniFormField
    {
        $this->afterCloseAction = $afterCloseAction;
        return $this;
    }




    protected function showFieldContent($database, $value, $canEdit, $insert, $rowData)
    {
        if (!$this ->options) {
            $this ->loadOptions($database);
        }

        $lastTyp = null;
        foreach ($this ->options as $option) {
            if ($lastTyp !== $option ->params['typ']) {
                if ($lastTyp !== null) {
                    echo "</ul>\n";
                }

                $cssClass = $this ->getFieldCssClass();
                echo
                    "<div>" . StringUtils::htmlTextConvert($option ->params['typ']) . "</div>" .
                    "<ul class='$cssClass'>";

                $lastTyp = $option ->params['typ'];
            }

            // key, caption
            echo "<li>" . StringUtils::htmlTextConvert($option ->caption) . "</li>";
        }

        if ($lastTyp !== null) {
            echo "</ul>\n";
        }

        if ($canEdit) {
            $pomStr = $this ->afterCloseAction
                ? ' data-after-close="reload"'
                : '';
            echo '<div><a class="vyber-rozdeleni" href="#"' . $pomStr . '>' . TextManager::_('Priradit_rozdeleni') . '</a></div>';

            //                 <span class="js vyber-rozdeleni-osoby" id="rozdelenidv_vyberrozdeleni"
//                      data-url="?menuid=editace&action=rozdeleniosoby"
//                      data-idpp="..."
//                      data-select-kod="#vyberRozdeleni" data-select-popis="#vyberRozdeleniPopis">
        }
    }
}
