<?php
/**
 * stanislav.elbl, 03.11.2015
 */

namespace RonPortal\Dochazka;

use Ron\DateUtils;
use Ron\GuiUtils;
use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\PoznamkaKeDni;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;
use RonPortal\System\Report;

/** @var Absence $absence */
$absence = Model::getInstance() ->getData('absence');
/** @var Absence[] $prekryvaneAbsence */
$prekryvaneAbsence = Model::getInstance() ->getData('prekryvaneAbsence');

/** @var Report[] $reportList */
$reportList = Model::getInstance() ->getData('reportList');

$backMenuId = Model::getInstance() ->getData('backMenuId');

$pravoDoporuceni = Prava::vratPrava('absence_doporuc');
$pravoDoporucit =
    $pravoDoporuceni ->lzeZobrazitPP($absence ->f_PP ->idPP)  &&
    $pravoDoporuceni ->priznak3ObsahujeKod($absence ->operaceDochazky, true);
$pravoSchvalit = Prava::vratPrava('absence_schval', 'absence_schval_' . $absence ->operaceDochazky) ->lzeZobrazitPP($absence ->f_PP ->idPP);
$pravoPlanovat = Prava::vratPrava('absence', 'absence_' . $absence ->operaceDochazky) ->lzeZobrazitPP($absence ->f_PP ->idPP);
$pravoSmazat = Prava::vratPrava('absence_delete', 'absence_delete_' . $absence ->operaceDochazky) ->lzeZobrazitPP($absence ->f_PP ->idPP); // jestli muze zrusit schvalenou absenci i kdyz nema pravo na schvalovani

//$casoveSlozky = explode(';', RonPortalSettings::getValue(RonPortalSettings::ABSENCE_CASOVE_SLOZKY) );
//$nadpisy = explode(';', RonPortalSettings::getValue(RonPortalSettings::ABSENCE_CASOVE_SLOZKY_NADPISY));
$casoveSlozky = Model::getInstance() ->getData('casoveSlozky');

/** @var PoznamkaKeDni[] $poznamky */
$poznamky = Model::getInstance() ->getData('poznamky');

$classSchvalovani = RonPortalSettings::getIntValue(RonPortalSettings::ABSENCE_SCHVALOVANI)
    ? ''
    : 'd-none';

function cssClassProStav($stav)
{
    switch ($stav) {
        case 1 : // schvaleno
        case 5 : // zadost o zruseni zamitnuta
            return 'successmsg';

        case 2 : // zamitnuto
        case 4 : // zruseno
            return 'errormsg';

        case 3 : // zadost o zruseni
            return 'warningmsg';

        case 0 :
        default :
            return '';
    }
}

?>
<h1><?= TextManager::_('Planovani_absenci') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div id="view_absence" class="form middle-form absence-stav-<?= (int)$absence ->schvaleni ?> absence-typ-<?= $absence ->operaceDochazky ?>">
    <div class="form-content">
        <div class="row" id="row_osoba">
            <div class="col col-4 caption d-xs-none"><?= TextManager::_('Osoba') ?></div>
            <div class="col col-12 col-sm-8 font-weight-bold"><?= $absence ->f_PP ->jmenoPrijmeni ?></div>
        </div>

        <?php foreach ($casoveSlozky as $index => $data) { ?>
            <div class="row" id="row_CasovaSlozka_<?= $index ?>">
                <div class="col col-6 col-sm-4 caption"><?= $data['nadpis'] ?></div>
                <div class="col col-6 col-sm-8"><?= $data['hodnota'] ?></div>
            </div>
        <?php } ?>

        <div class="row" id="row_OperaceDochazky">
            <div class="col col-4 caption d-xs-none"><?= TextManager::_('Absence_udalost') ?></div>
            <div class="col col-12 col-sm-8 font-weight-bold"><?= StringUtils::htmlTextConvert(TextManager::_('db_operacedochazky_popis_' . $absence ->operaceDochazky,$absence ->popisAbsence)) ?></div>
        </div>

        <div class="row" id="row_Delka">
            <div class="col col-6 col-sm-4 caption"><?= TextManager::_('Delka_absence') ?></div>
            <div class="col col-6 col-sm-8">
                <?php
                    switch($absence ->delka) {
                        case 0 : echo TextManager::_('Absence_cela_smena'); break;
                        case 1 : echo TextManager::_('Absence_pulka_smeny1'); break;
                        case 2 : echo TextManager::_('Absence_pulka_smeny2'); break;
                        case 3 : echo TextManager::_('Absence_od_do'); break;
                        case 4 : echo TextManager::_('Absence_kontinualne'); break;
                    }
                ?>
            </div>
        </div>

        <div class="row" id="row_DatumCas">
            <div class="col col-4 caption d-xs-none"></div>
            <div class="col col-8"><?= $absence ->getPopisObdobiAbsence() ?></div>
        </div>

        <?php if (RonPortalSettings::getIntValue('typrozdeleniabsence')  &&  RonPortalSettings::getIntValue('typrozdeleniabsence') === $absence ->kodTypuRozdeleni) { ?>
            <div class="row" id="row_Rozdeleni">
                <div class="col col-6 col-sm-4 caption"><?= StringUtils::htmlTextConvert($absence ->popisTypuRozdeleni) ?></div>
                <div class="col col-6 col-sm-8"><?= $absence ->popisRozdeleni ?></div>
            </div>
        <?php } ?>

        <?php if (isset($poznamky)) { ?>
            <div class="row" id="row_PoznamkyKeDni">
                <div class="col col-4 caption d-xs-none"></div>
                <div class="col col-12 col-sm-8">
                    <?php foreach($poznamky as $poznamka) { ?>
                        <div class="poznamkakedni poznamkakedni_<?= $poznamka ->typ ?>" style="<?= $poznamka ->barva ? 'background-color:' . GuiUtils::getHtmlColor($poznamka ->barva) : '' ?>">
                            <span class="datum_poznamky"><?= StringUtils::format('date', $poznamka ->datumOd) . ($poznamka ->datumDo != $poznamka ->datumOd ? ' - ' . StringUtils::format('date', $poznamka ->datumDo) : '') ?></span>
                            <span class="text_poznamky"><?= StringUtils::htmlTextConvert($poznamka ->text) ?></span>
                        </div>
                    <?php } ?>
                </div>
            </div>
        <?php } ?>

        <?php if ($prekryvaneAbsence && RonPortalSettings::getIntValue('prekryvaniabsenci')) { ?>
            <div id="row_Prekryvane" class="errortext margin-bottom">
                <div><?= TextManager::_('Prekryvani_absenci') ?></div>
                <?php foreach ($prekryvaneAbsence as $prekryvana) { ?>
                    <div>
                        <?= StringUtils::htmlTextConvert($prekryvana ->getPopisObdobiAbsence()) ?>
                        <a href="?menuid=absence&action=zobrazabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= DateUtils::dateToUrlString($prekryvana ->datumOd) ?>&poradi=<?= $prekryvana ->poradi ?>">
                            <?= StringUtils::htmlTextConvert($prekryvana ->popisAbsence) ?>
                        </a>
                    </div>
                <?php } ?>
            </div>
        <?php } ?>

        <?php for ($i = 1;  $i <= 5;  $i++) { ?>
        <div class="row <?= (isset($absence ->{"uzivatelska$i"}) &&  trim($absence ->{"uzivatelska$i"}) !== '') ? '' : 'd-none' ?>" id="row_Absence_Uzivatelska<?= $i ?>">
            <div class="col col-6 col-sm-4 caption"><?= TextManager::_("Absence_uzivatelska_$i") ?></div>
            <div class="col col-6 col-sm-8">
                <?= StringUtils::htmlTextConvert($absence ->{"uzivatelska$i"}) ?>
            </div>
        </div>
        <?php } ?>

        <?php if (RonPortalSettings::getIntValue(AbsenceController::SETTINGS_DOPORUCOVANI)  &&  ($pravoDoporucit || $absence ->doporuceni)) { ?>
            <!-- doporucovani -->
            <div id="row_Doporuceni">
                <div class="row">
                    <div class="col col-12 form-section"><?= TextManager::_('Doporuceni') ?></div>
                </div>
                <div class="row">
                    <div class="col col-4 caption d-xs-none"></div>
                    <?php if ($absence ->doporuceni) { ?>
                        <div class="col col-6 col-sm-4 <?= $absence ->doporuceni == 1 ? 'absence_doporucena' : ($absence ->doporuceni == 2 ? 'absence_nedoporucena' : '') ?>">
                            <?= TextManager::_('Doporuceni_' . $absence ->doporuceni) ?> (<?= StringUtils::format('finedatetime', $absence ->datumDoporuceni) ?> <?= StringUtils::htmlTextConvert($absence ->doporucil) ?>)
                        </div>
                    <?php } ?>
                    <!-- odkazy -->
                    <?php if ($pravoDoporucit) { ?>
                        <?php if ($absence ->doporuceni != 1) { ?>
                            <div class="col col-6 col-sm-4">
                                <a href="?menuid=absence&action=doporucitabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?=
                                    Csrf::csrfUrlParameter("doporuceniabsence_1_{$absence ->f_PP ->idPP}")
                                ?>"><?= TextManager::_('doporucit') ?></a>
                            </div>
                        <?php } ?>

                        <?php if ($absence ->doporuceni != 2) { ?>
                            <div class="col col-6 col-sm-4">
                                <a href="?menuid=absence&action=nedoporucitabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?=
                                    Csrf::csrfUrlParameter("doporuceniabsence_2_{$absence ->f_PP ->idPP}")
                                ?>"><?= TextManager::_('nedoporucit') ?></a>
                            </div>
                        <?php } ?>

                    <?php } ?>
                </div>
            </div>
        <?php } ?>

        <div id="row_schvaleni">
            <!-- schvalovani -->
            <div class="row form-gap <?= $classSchvalovani ?>"></div>

            <div class="row">
                <div class="col col-12 form-section <?= $classSchvalovani ?>"><?= TextManager::_('Schvaleni') ?></div>
            </div>

            <!-- zobrazi aktualni stav schvaleni -->
            <?php if ($absence ->schvaleni) { ?>
                <div id="row_stav_absence" class="row <?= cssClassProStav($absence ->schvaleni) ?> <?= $classSchvalovani ?>">
                    <div class="col col-4 caption d-xs-none"></div>
                    <div class="col col-12 col-sm-8 font-weight-bold">
                        <?= TextManager::_('Stav_Absence_' . $absence ->schvaleni) ?>
                    </div>
                </div>
            <?php } ?>

            <?php if (RonPortalSettings::getIntValue(RonPortalSettings::ABSENCE_SCHVALOVANI)) { ?>
                <div class="row">
                    <?php if ($absence ->schvaleni == 3) { ?>
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8">
                            <!-- zazadano o zruseni -->
                            <!--
                            <span class='schvaleni_absence'><strong><?= TextManager::_('Zadost_o_zruseni') ?></strong></span>
                            <br/>
                            -->

                            <?= TextManager::_('O_zruseni_zazadal') ?>: <?= StringUtils::htmlTextConvert($absence ->schvalil) ?> (<?= StringUtils::format('finedatetime', $absence ->datumSchvaleni) ?>)
                        </div>
                    <?php } else if ($absence ->schvaleni == 5) { ?>
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8">
                            <!-- zruseni zamitnuto -->
                            <span class='schvaleni_absence'><?= TextManager::_('Zruseni_zamitnuto') ?></span>
                        </div>
                    <?php } else { ?>
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-6 col-sm-4">
                            <!-- text Schvaleno, odkaz Schvalit -->
                            <?php if ($absence ->schvaleni == 1) { ?>
                                <span class='schvaleni_absence d-none'><?= TextManager::_('Schvaleno') ?></span>
                            <?php } else if ($pravoSchvalit) { ?>
                                <span class='schvaleni_absence'>
                                    <a href="?menuid=absence&action=schvalitabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= Csrf::csrfUrlParameter("schvaleniabsence_1_{$absence ->f_PP ->idPP}") ?>"
                                        <?php if ($absence ->schvaleni == 2) { ?> class="confirmQuestion" data-ron-confirm-text="<?= StringUtils::htmlTextConvert(TextManager::_('Opravdu_schvalit_zamitnutou_absenci')) ?>" <?php } ?>
                                        <?php if ($absence ->schvaleni == 4) { ?> class="confirmQuestion" data-ron-confirm-text="<?= StringUtils::htmlTextConvert(TextManager::_('Opravdu_schvalit_zrusenou_absenci')) ?>" <?php } ?>
                                        ><?= TextManager::_('Schvalit') ?></a>
                                </span>
                            <?php } ?>
                        </div>
                        <div class="col col-6 col-sm-4">
                            <!-- zamitnuto/zamitnout -->
                            <?php if ($absence ->schvaleni == 2) { ?>
                                <span class='schvaleni_absence d-none'><?= TextManager::_('Zamitnuto') ?></span>
                            <?php } else if ($pravoSchvalit) { ?>
                                <span class='schvaleni_absence'>
                                    <a href="?menuid=absence&action=zamitnoutabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= Csrf::csrfUrlParameter("schvaleniabsence_2_{$absence ->f_PP ->idPP}") ?>"
                                       <?php if ($absence ->schvaleni == 1) { ?> class="confirmQuestion" data-ron-confirm-text="<?= StringUtils::htmlTextConvert(TextManager::_('Opravdu_zamitnout_schvalenou_absenci')) ?>" <?php } ?>
                                        ><?= TextManager::_('Zamitnout') ?></a>
                                </span>
                            <?php } ?>
                        </div>
                    <?php } ?>
                </div>

                <div class="row form-gap"></div>
                <div class="row" id="row_zruseni">
                    <!-- zruseno/zrusit - zrusit muze i kdyz nema pravo schvalovat a jeste neni schvalena -->
                    <?php if ($absence ->schvaleni == 4) { ?>
                        <!-- zruseno -->
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8" class='schvaleni_absence'><?= TextManager::_('Zruseno') ?></div>
                    <?php } else if ($absence ->schvaleni == 3 && $pravoSchvalit) { ?>
                        <!-- zazadano o zruseni - odkazy "zrusit" a "zamitnout" -->
                        <div class="col col-4 caption d-xs-none"></div>
                        <div>
                            <span class='schvaleni_absence'>
                                <a href="?menuid=absence&action=zrusitabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= Csrf::csrfUrlParameter("schvaleniabsence_4_{$absence ->f_PP ->idPP}") ?>"><?= TextManager::_('Zrusit') ?></a>
                            </span>
                            <span class='schvaleni_absence'>
                                <a href="?menuid=absence&action=zamitnoutzruseni&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= Csrf::csrfUrlParameter("schvaleniabsence_5_{$absence ->f_PP ->idPP}") ?>"><?= TextManager::_('Zamitnout_zruseni') ?></a>
                            </span>
                        </div>
                    <?php } else if ( $pravoSchvalit  ||  $pravoSmazat  ||  (!$absence ->schvaleni  &&  $pravoPlanovat)  ||  $absence->absence_LzeZrusit ) { ?>
                        <!-- muze schvalovat nebo jeste neni schvalena a muze planovat = lze zrusit -->
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8 schvaleni_absence">
                            <a class="confirmQuestion"
                               data-ron-confirm-text="<?= TextManager::_('Opravdu_zrusit_absenci') ?>"
                               href="?menuid=absence&action=zrusitabsenci&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= Csrf::csrfUrlParameter("schvaleniabsence_4_{$absence ->f_PP ->idPP}") ?>"><?= TextManager::_('Zrusit') ?></a>
                        </div>
                    <?php } ?>
                </div>

                <div class="row form-gap"></div>
                <div class="row" id="row_schvaleni_info">
                    <?php
                        // info, kdo schvalil/zamitnul/...
                        $pomstr = '';
                        switch ($absence ->schvaleni) {
                            case 0 : // bez urceni
                                break;

                            case 1 : // schvaleno
                                $pomstr = TextManager::_('Schvalil');
                                break;

                            case 2 : // zamitnuto
                                $pomstr = TextManager::_('Zamitnul');
                                break;

                            case 3 : // zadost o zruseni - jiz je zobrazeno
                                break;

                            case 4 : // zruseno
                                $pomstr = TextManager::_('Zrusil');
                                break;

                            case 5 : // zruseni zamitnuto
                                $pomstr = TextManager::_('Zruseni_zamitnul');
                                break;
                        }
                    ?>
                    <?php if ($pomstr) { ?>
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8 schvaleni_absence">
                            <?= $pomstr ?>: <?= StringUtils::htmlTextConvert($absence ->schvalil) ?> (<?= StringUtils::format('finedatetime', $absence ->datumSchvaleni) ?>)
                        </div>
                    <?php } ?>
                </div>


                <?php if ($absence ->schvaleni == 1 && !$pravoSchvalit  &&  !$pravoSmazat  &&  !$absence ->absence_LzeZrusit) { ?>
                    <!-- zadost o zruseni -->
                    <div class="row" id="absence_zazadat_o_zruseni">
                        <div class="col col-4 caption d-xs-none"></div>
                        <div class="col col-12 col-sm-8 schvaleni_absence">
                            <a href="?menuid=absence&action=zadostozruseni&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?>"><?= TextManager::_('Zazadat_o_zruseni') ?></a>
                        </div>
                    </div>
                <?php } ?>

                <div class="row form-gap"></div>
            <?php } ?>
        </div>

        <div class="row" id="row_HistorieSchvalovani">
            <div class="col col-4 caption d-xs-none"></div>
            <div class="col col-12 col-sm-8 poznamka">
                <?= StringUtils::longTextToHtml($absence ->historieSchvaleni, true) ?>
            </div>
        </div>

        <div class="row" id="row_Poznamka">
            <div class="col col-12 form-section"><?= TextManager::_('Poznamka') ?></div>
            <div class="col col-12 poznamka">
                <?= StringUtils::longTextToHtml($absence ->poznamka, true) ?>
            </div>
        </div>
    </div>

    <div class="buttons">
        <?php if ( $pravoPlanovat  &&  $absence ->schvaleni != 4  &&  ($pravoSchvalit  || ($absence ->schvaleni != 1  &&  $absence ->schvaleni != 3)) ) { ?>
            <div class="row" id="row_editovat">
                <div class="col col-4 d-xs-none"></div>
                <div class="col col-12 col-sm-8">
                    <?php $backstr = $backMenuId ? '&backaction=' . $backMenuId : ''; ?>
                    <a href="?menuid=absence&formaction=edit&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi ?><?= $backstr ?>"><?= TextManager::_('Editovat_absenci') ?: TextManager::_('Edit') ?></a>
                </div>
            </div>
        <?php } ?>

        <div class="row" id="row_ical">
            <div class="col col-12 align-right">
                <a href="?menuid=absence&action=ical&idpp=<?= $absence ->f_PP ->idPP ?>&datum=<?= date('j.n.Y', $absence ->datumOd) ?>&poradi=<?= $absence ->poradi?>"><?= TextManager::_('Stahnout_do_kalendare') ?></a>
            </div>
        </div>

    </div>
</div>

<?php
    FormReportsListView::renderReportList($reportList,
        '?menuid=absence&action=report&idpp=' . $absence ->f_PP ->idPP . '&poradi=' . $absence ->poradi . '&datum=' . date('j.n.Y', $absence ->datumOd));
?>

<div class="text_link">
    <a href="?menuid=<?= $backMenuId ?>"><?= TextManager::_('Back_to_list') ?></a>
</div>
