<?php
/**
 * pavel.rudol, 02.11.2022 13:18
 */

namespace RonPortal\Dovednosti;

use Ron\DB\Database;
use Ron\DB\SqlStatement;
use RonPortal\Dokumenty\DokumentyBrowser;

class DokumentyDovednosti extends DokumentyBrowser
{

    /**
     * @param Database $database
     * @param int    $idPP
     */
    function __construct($database, $idPP)
    {
        parent::__construct($database, "?menuid=dovednosti&action=download&dovednostosoby=".  $idPP);
        $this->updateFields = 'dovednost;dovednosturoven';

        $this->showMessages = false;

        $this->sqlFromPart =
            ' Dokument INNER JOIN TypDokumentu ON TypDokumentu.Kod = Dokument.Typ ' .
            ' INNER JOIN DokumentyOsoby ON Dokument.Id = DokumentyOsoby.Id ' .
            ' INNER JOIN DovednostOsoby ON DokumentyOsoby.RC = DovednostOsoby.RC AND DokumentyOsoby.Dovednost_RC = DovednostOsoby.RC AND DokumentyOsoby.Dovednost_Kod = DovednostOsoby.KodDovednosti ' .
            '     AND DokumentyOsoby.Dovednost_Uroven = DovednostOsoby.KodUrovne AND DokumentyOsoby.Dovednost_DatumZiskani = DovednostOsoby.DatumZiskani ' .
            ' INNER JOIN UrovenDovednosti ON UrovenDovednosti.KodDovednosti = DovednostOsoby.KodDovednosti AND UrovenDovednosti.KodUrovne = DovednostOsoby.KodUrovne ' .
            ' INNER JOIN Dovednost ON Dovednost.Kod = UrovenDovednosti.KodDovednosti';

        $params = $this->database->createParameters();
        $this->sqlWherePart = new SqlStatement(
            "  EXISTS(SELECT PracovniPomer.RC FROM PracovniPomer WHERE PracovniPomer.ID = " . $params->addParameter($idPP) . " AND DokumentyOsoby.RC = PracovniPomer.RC)" .
            " AND DovednostOsoby.DatumZiskani <= " . $params->addDateParameter(time()) .
            " AND (DovednostOsoby.PlatnostDo >= "  . $params->addDateParameter(time()) . " OR DovednostOsoby.PlatnostDo IS NULL) ",
            $params);

        $this->addField()
            ->setSqlFieldName('Dovednost.Popis')->setHeaderText('Dovednost')->setOrdering(true);
        $this->addField()
            ->setSqlFieldName('UrovenDovednosti.Popis')->setHeaderText('Dovednosti_uroven_dovednosti')->setOrdering(true);

    }

}