<?php
/**
 * pavel.rudol, 01.11.2022 18:08
 */

namespace RonPortal\Dovednosti;

use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\TextManager;
use RonPortal\Dokumenty\DokumentUploadForm;

class NovyDokumentDovednostiForm extends DokumentUploadForm
{
    private $idOsoby;


    /** Formular pro nahrani dokumentu do databaze.
     * @param Database $database
     * @param int $idPP id PP osoby
     */
    function __construct($database, $idPP)
    {
        parent::__construct($database, '?menuid=dovednosti&action=dokumentupload', ['data-update-browser' => '#Dokumenty']);
        $this ->idOsoby = $idPP;
        $this->kategorieDokumentu = 4; //dokumenty dovednosti
        $this ->hiddenFields = [
            'dokumentdovednosti' => '1',
            'osoba' => $this ->idOsoby,
        ];
    }

    /** Zobrazi vyber ziskanych dovednosti osoby s moznosti dokument pripojit k dosazene dovednosti.
     * @throws DBException
     */
    function dalsiRadkyKDokumentu()
    {
        echo '<div class="form-gap"></div>';

        // zobrazi vyber radku, ke kteremu se ma dokument pripojit
        echo '<div class="row" id="novydokument_dovednostrow">';

        echo '<div class="col col-12 col-sm-4 caption">' . TextManager::_('Dovednosti_pripojit_dokument') . '</div>';
        echo '<div class="col col-12 col-sm-8">';
        $combo = new DovednostOsobyCombo('Dovednost', $this ->database);
        $sql =
            'SELECT DovednostOsoby.RC, DovednostOsoby.KodDovednosti, DovednostOsoby.KodUrovne, DovednostOsoby.DatumZiskani, Dovednost.Popis, UrovenDovednosti.Popis' .
            '  FROM DovednostOsoby ' .
            '    JOIN UrovenDovednosti ON (UrovenDovednosti.KodDovednosti = DovednostOsoby.KodDovednosti AND UrovenDovednosti.KodUrovne = DovednostOsoby.KodUrovne)' .
            '    JOIN Dovednost ON (Dovednost.Kod = UrovenDovednosti.KodDovednosti)' .
            ' WHERE DovednostOsoby.DatumZiskani <= ' . $this ->database->dateToString(time()) .
            '   AND (DovednostOsoby.PlatnostDo >= ' . $this ->database->dateToString(time()) . ' OR DovednostOsoby.PlatnostDo IS NULL)' .
            '   AND EXISTS(SELECT RC FROM PracovniPomer WHERE PracovniPomer.RC = DovednostOsoby.RC AND ID = ' . (int)$this ->idOsoby . ')';

        $combo ->loadData($this ->database, $sql, null);

        $combo ->render();
        echo '</div>';

        echo '</div>';
    }
}