<?php
/**
 * stanislav.elbl, 24.02.2021
 */

namespace RonPortal\Editace;

use Ron\DB\Database;
use RonPortal\PracovniPomer;


/**
 * Zajistuje zapis do tabulky MesicniVysledek_R_E
 */
class MesicniVysledek_R_ERecord extends MesicniVysledekVypoctuRecord
{
    /**
     * @param Database $database
     * @param PracovniPomer $pp
     * @param int $mesic
     * @param string $typCasoveSlozkyMzdy
     * @param int $kodTypuRozdeleni
     * @param string $rozdeleni
     * @param string|object $logDescription
     */
    public function __construct(Database $database, PracovniPomer $pp, int $mesic, string $typCasoveSlozkyMzdy, int $kodTypuRozdeleni, string $rozdeleni, $logDescription)
    {
        parent::__construct($database, $pp, $mesic, $typCasoveSlozkyMzdy, $logDescription, 'MesicniVysledek_R_E');

        $this ->addIntField('KodTypuRozdeleni', true, $kodTypuRozdeleni);
        $this ->addStringField('Rozdeleni', true, 30, $rozdeleni);

        $params = $database ->createParameters();
        $this->setWhere(
            'RC = ' . $params ->addParameter($pp ->rc) .
            ' AND OsobniCislo = ' . $params ->addParameter($pp ->osobniCislo) .
            ' AND DatumNastupu = ' . $params ->addDateParameter($pp ->datumNastupu) .
            ' AND Mesic = ' . $params ->addDateParameter($mesic) .
            ' AND TypCasoveSlozkyMzdy = ' . $params ->addParameter($typCasoveSlozkyMzdy) .
            ' AND KodTypuRozdeleni = ' . $params ->addParameter($kodTypuRozdeleni) .
            ' AND Rozdeleni = ' . $params ->addParameter($rozdeleni),
            $params);
    }
}
