<?php
/**
 * stanislav.elbl, 26.02.2021
 */

namespace RonPortal\Editace;

use Ron\DB\Database;
use Ron\DB\DBRecordField;
use RonPortal\RonPortalDBRecord;

class RozdeleniDennichVysledkuRecord extends RonPortalDBRecord
{
    /* @var int     kod typu rozdeleni */
    var $typRozdeleni;

    /* @var DBRecordField */
    var $fRozdeleni;
    /* @var DBRecordField */
    var $fSlozka;
    /* @var DBRecordField */
    var $fHodnota;

    var $jeZmena;


    /**
     * @param Database $database
     * @param string $typRozdeleni
     * @param string $rc
     * @param $osobniCislo
     * @param $datumNastupu
     * @param $den
     * @param $logDescription
     */
    function __construct($database, $typRozdeleni, $rc, $osobniCislo, $datumNastupu, $den, $logDescription)
    {
        parent::__construct($database, 'DenniVysledek_R_E');

        $this ->logDescription = $logDescription;
        $this ->jeZmena = false;

        $this ->typRozdeleni = (int)$typRozdeleni;

        $this ->addField('RC', '', true, 15, $rc);
        $this ->addField('OsobniCislo', '', true, 15, $osobniCislo);
        $this ->addField('DatumNastupu', 'date', true, 0, $datumNastupu);

        $this ->addField('Den', 'date', true, 0, $den);

        $this ->addField('KodTypuRozdeleni', 'int', true, 0, $this ->typRozdeleni);

        $this ->fRozdeleni = $this ->addField('Rozdeleni', '', true, 30, null);

        $this ->fSlozka = $this ->addField('TypCasoveSlozkyMzdy', '', true, 10, null);

        $this ->fHodnota = $this ->addField('Hodiny', 'float', false, 0, null); // readonly=false

        $params = $this ->database ->createParameters();
        $this ->setWhere(
            'RC = ' . $params->addParameter($rc) .
            ' AND OsobniCislo = ' . $params->addParameter($osobniCislo) .
            ' AND DatumNastupu = ' . $params ->addParameter($database ->dateToParam($datumNastupu)) .
            ' AND Den = ' . $params->addParameter($database ->dateToParam($den)) .
            ' AND KodTypuRozdeleni = ' . $params ->addParameter((int)$this ->typRozdeleni),
            $params);
    }
}
