<?php
/**
 * Schvalovani rozdeleni DV pro konkretni rozdeleni (zakazku)
 * stanislav.elbl, 27.02.2015
 */

namespace RonPortal\Editace;

use Ron\DateUtils;
use Ron\MessageManager;
use Ron\StringUtils;
use RonPortal\Kalendar;

/**
 * @var PrehledRozdeleniDVFormular $this
 */

?>

<h1><?= \Ron\ronText('Rozdeleni_dennich_vysledku') ?></h1>

<form method="POST" name="rozdeleniDVform" action="?menuid=rozdelenidv&prehledrozdeleni=<?= StringUtils::htmlTextConvert($this ->rozdeleni ->kod) ?>&obdobi=<?= DateUtils::dateToUrlString($this ->obdobi ->zacatek) ?>">
    <input type="hidden" name="schvaleniRozdeleniDV" value="1" />

    <!-- hlavicka -->
    <div class="form middle-form">
        <div class="form-content">
            <input class="float-right submitbutton" type="submit" value="<?= \Ron\ronText('Zapsat') ?>" />
            <div><?= StringUtils::htmlTextConvert($this ->rozdeleni ->kod) ?> - <?= StringUtils::htmlTextConvert($this ->rozdeleni ->popis) ?></div>
            <div><?= StringUtils::htmlTextConvert($this ->obdobi ->popis) ?></div>
            <div><a href="?menuid=zpracovanadochazka"><?= \Ron\ronText('Zpet') ?></a></div>
        </div>
    </div>

    <?php MessageManager::getInstance() ->showMessages(); ?>

    <table class="browser grid keyInputMove prehledrozdeleniDV">
        <thead>
            <tr>

                <th><?= \Ron\ronText('Datum') ?></th>
                <th class="rozdeleniDVSloupecRozdeleni"><?= \Ron\ronText('Rozdeleni_DV_osoby') ?></th>

                <th class="align-center"><?= \Ron\ronText('Celkem_rozdeleno') ?></th>
                <th class="align-center"><?= \Ron\ronText('Rozdeleni_DV_schvaleni') ?></th>
            </tr>
        </thead>

        <tbody class="border-bottom">
            <?php $soucet = 0;
                foreach ($this ->dataList as $index => $den) {
//                $cssClass = Kalendar::getStyleForDate($this ->database, $den ->datum, true, $this ->kalendar);
                    $cssClass = Kalendar::getStyleForDate(null, $den ->datum, false);
                    //$cssClass = '';
                    $class_str = $cssClass ? "class='$cssClass'" : '';

                    $soucet += $den ->soucet;
            ?>

            <tr <?= $class_str ?> data-ron-datum="<?= StringUtils::jsonDate($den ->datum) ?>">

                <!-- datum -->
                <td class="browser_rowheader">
                    <span class="zkratkadne"><?= \Ron\ronText('Day_short_' . date('w', $den ->datum)) ?></span><?= date('j.n.Y', $den ->datum) ?>
                </td>

                <!-- seznam zamestnancu -->
                <td>
                <?php
//                    $prvni = true;
                    foreach ($den ->zaznamy as $item) {
//                        if (!$prvni) echo ', ';
//                        $prvni = false;
                ?>
                    <span class="zaznamrozdelenidv">
                        <span class="jmeno"><?= StringUtils::htmlTextConvert($item ->titul ?: '') ?> <?= StringUtils::htmlTextConvert($item ->jmeno) ?> <?= StringUtils::htmlTextConvert($item ->prijmeni) ?></span>
                        <span class="hodiny">(<?= StringUtils::format('minuty', round($item ->hodiny * 60)) ?>)</span>
                        <?php if (strcasecmp($item ->casovaSlozka, $this ->vychoziCS)) { ?>
                            <span class="casovaslozka" title="<?= StringUtils::htmlTextConvert($item ->popisCasoveSlozky) ?>"><?= StringUtils::htmlTextConvert($item ->casovaSlozka) ?></span>
                        <?php } ?>
                    </span>
                <?php } ?>
                </td>

                <!-- soucet -->
                <td class="align-center"><?= $den ->soucet ? StringUtils::format('minuty', round($den ->soucet * 60)) : '' ?></td>

                <td class="align-center">
                    <input type="checkbox" name="schvaleno<?= date('j', $den ->datum) ?>" <?= $den ->schvaleno ? 'checked="checked"' : '' ?> />
                </td>

            </tr>
            <?php } ?>
        </tbody>

        <tbody>
            <tr class="browserfooter">
                <td><?= \Ron\ronText('Celkem') ?></td>
                <td></td>
                <td class="align-center"><?= StringUtils::format('minuty', round($soucet * 60)) ?></td>
                <td class="align-center"></td>
            </tr>
        </tbody>
    </table>

</form>
