<?php
/**
 * stanislav.elbl, 02.03.2016
 */

namespace RonPortal\ELearning;


use Ron\DB\Database;
use RonPortal\RonPortalDBRecord;
use RonPortal\User;

class EKurzOsobyDBRecord extends RonPortalDBRecord
{
    public $fId;
    public $fIdRevize;
    public $fDruhSkoleni;
    public $fDatumVznikuPovinnosti;
    public $fStav;

    /**
     * @param Database $database
     * @param object|string $logDescription
     * @param int|null $id
     */
    public function __construct($database, $logDescription, $id = null)
    {
        parent::__construct($database, 'EKurzOsoby', $logDescription);

        // vse readonly
        $this ->fId = $this ->addIntField('Id', true);
        $this ->fIdRevize = $this ->addIntField('IdRevize', true);
        // uzivatel
        $this ->addStringField('RC', true, 15, User::getRC());
        $this ->addLogText('   ' . User::getUserName());
        // skoleni
        $this ->addStringField('RC_Skoleni', true, 15, User::getRC());
        $this ->fDruhSkoleni = $this ->addStringField('DruhSkoleni', true, 20);
        $this ->fDatumVznikuPovinnosti = $this->addTimestampField('DatumVznikuPovinnosti', true);

        // stav atd
        $this ->fStav = $this ->addField('Stav', 'int', true, 0, 1);

        $this ->addTimestampField('DatumCasZahajeni', true, time());
        $this ->addIntField('Stranka', true, 0);

        $params = $this ->database ->createParameters();
        if ( isset($id) ) {
            $this ->setWhere('Id = ' . $params ->addParameter((int)$id), $params);
        }
    }
}
