<?php
/**
 * stanislav.elbl, 07.01.2016
 */

namespace RonPortal\ELearning;

use Ron\DB\Database;
use RonPortal\NeniPravoException;
use RonPortal\User;

class ELearningUtils
{
    /**
     * Vraci id prilohy v databazi (Priloha.Id)
     * @param Database $database
     * @param int $idKurzuOsoby
     * @param int $id Id prilohy v ramci kurzu (PrilohaRevizeEKurzu.Id)
     * @return int
     * @throws NeniPravoException
     */
    static function overPravoNaPrilohuKurzu($database, $idKurzuOsoby, $id)
    {
        $params = $database ->createParameters();

        $sql =
            'SELECT EKurzOsoby.RC, EKurzOsoby.Stav, PrilohaRevizeEKurzu.IdPrilohy' .
            '  FROM EKurzOsoby, PrilohaRevizeEKurzu' .
            ' WHERE PrilohaRevizeEKurzu.IdRevizeKurzu = EKurzOsoby.IdRevize' .
            '   AND EKurzOsoby.Id = ' . $params ->addParameter($idKurzuOsoby) .
            '   AND PrilohaRevizeEKurzu.Id = ' . $params ->addParameter($id);

        $cursor = $database ->getSqlResult($sql, $params);
        if (!$row = $cursor ->fetch()) {
            // priloha neni pripojena k prislusne revizi kurzu
            throw new NeniPravoException();
        }
        $cursor ->close();

        if ($row[0] != User::getRC()) {
            // ekurzosoby nepatri aktualnimu uzivateli
            throw new NeniPravoException();
        }

        // TODO: overit stav?

        return $row[2];
    }
}
