<?php
/**
 * stanislav.elbl, 02.03.2016
 */

namespace RonPortal\ELearning;


use RonPortal\RonPortalDBRecord;

class GenerovaneSkoleniDBRecord extends RonPortalDBRecord
{
    const ABSOLVOVANO_USPESNE = 3;
    const ABSOLVOVANO_NEUSPESNE = 4;

    public $fDatumSkoleni;
    public $fPotvrzeni;

    /**
     * @param \Ron\DB\Database $database
     * @param string $rc
     * @param string $druhSkoleni
     * @param int    $datumVznikuPovinnosti
     */
    public function __construct($database, $rc, $druhSkoleni, $datumVznikuPovinnosti, $logDescription)
    {
        parent::__construct($database, 'GenerovaneSkoleni', $logDescription);

        $this ->addStringField('RC', true);
        $this ->addStringField('DruhSkoleni', true);
        $this ->addTimestampField('DatumVznikuPovinnosti', true);
        $this ->addStringField('CisloSkoleni', true);

        $this ->fDatumSkoleni = $this ->addTimestampField('DatumSkoleni', true);
        $this ->fDatumSkoleni ->updateLog = true;  // zapisuje se jen pri zmene stavu

        $this ->fPotvrzeni = $this ->addIntField('Potvrzeni', true);

        $params = $this ->database ->createParameters();
        $this ->setWhere(
            'RC = ' . $params ->addParameter($rc) .
            ' AND DruhSkoleni = ' . $params ->addParameter($druhSkoleni) .
            ' AND DatumVznikuPovinnosti = ' . $params ->addTimestampParameter($datumVznikuPovinnosti),
            $params
        );
    }


    function nastavStav($stav = self::ABSOLVOVANO_USPESNE)
    {
        $this ->fPotvrzeni ->setNewValue($stav);
        $this ->fDatumSkoleni ->setNewValue( time() );

        if ($this ->loadRecord()) {
            $this ->updateRecord();
        }
    }
}
