<?php
/**
 * UTF8
 */

namespace RonPortal\ELearning;

use Ron\Controls\Browser;
use Ron\Controls\BrowserField;
use Ron\DB\Database;
use Ron\TextManager;
use RonPortal\Prava;


class KurzBrowser extends Browser
{
    /**
     * @param Database $database
     */
    function __construct($database)
    {
        parent::__construct($database);

        $this->title = TextManager::_('Kurzy');

        $this->sqlFromPart = 'EKurz';

        $this->rowClickLink = '?menuid=kurzy&action=show';

        $this->code = 'browser_ekurzy';

        $this ->browserUrl = '?menuid=kurzy&';

        // Pole
        $this ->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('Id')
            ->setCode('col-id');

        $this->primaryField = 'col-id';

        $this->addField()
            ->setSqlFieldName('EKurz.Nazev') ->setHeaderText('Nazev') ->setLink('?menuid=kurzy&action=show')
            ->setCode('col-nazev')
            ->setOrdering(true);

        $this ->defaultSort = 'col-nazev';

        $this->addField(BrowserField::FIELD_TYPE_SELECT)
            ->setSqlFieldName('EKurz.Stav') ->setHeaderText('Stav_kurzu')
            ->setCode('col-stav')
            ->setOptions([0 => TextManager::_('Kurz_Stav_0'), 1 => TextManager::_('Kurz_Stav_1'), 2 => TextManager::_('Kurz_Stav_2')])
            ->setOrdering(true) ->setWrap(true);

        $this->addField()
            ->setSqlFieldName('EKurz.PlatnostOd') ->setHeaderText('Platnost_od') ->setFormat('finedate')
            ->setCode('col-platnostod')
            ->setOrdering(true);

        $this->addField()
            ->setSqlFieldName('EKurz.PlatnostDo') ->setHeaderText('Platnost_do') ->setFormat('finedate')
            ->setCode('col-platnostdo')
            ->setOrdering(true);

        $this ->addField(BrowserField::FIELD_TYPE_COMMENT)
            ->setSqlFieldName('Popis') ->setCastWideMemo(true)
            ->setCode('col-popis')
            ->setClassName('poznamka browserpoznamka padding-left-2');
    }



    function renderFilter()
    {
        parent::renderFilter();

        // pokud muze editovat, tak zobrazi odkaz "novy zaznam"
        if ( Prava::vratHodnotuPrava('editacekurzu') ) {
            echo "<br/><div class='normaltext'><a href='?menuid=kurzy&formaction=new'>" . TextManager::_('New_record') . "</a></div>\n";
        }
    }

}

