<?php
/**
 * stanislav.elbl, 25.11.2015
 */

namespace RonPortal\ELearning;

use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\StringUtils;
use RonPortal\Testy\Dotaznik;
use RonPortal\Testy\PripraveneTemaHodnoceniDBRecord;
use RonPortal\User;


class Test extends Dotaznik
{
    const TEST_STAV_NEABSOLVOVANO = 0;
    const TEST_STAV_PROBIHA = 1;
    const TEST_STAV_NEDOKONCENO_V_LIMITU = 2;
    const TEST_STAV_ABSOLVOVANO_USPESNE = 3;
    const TEST_STAV_ABSOLVOVANO_NEUSPESNE = 4;

    /** @var  int   Kurz Osoby (pri vyplnovani testu) */
    public $idKurzuOsoby;

    /** @var  int   Index stranky (pouziva se pri vyplnovani testu) */
    public $pageIndex;


    function getJson()
    {
        return json_encode($this ->getJsonData());
    }


    /**
     * @param Database $database
     * @param int $idPripravenehoTestu  ID zaznamu z tabulky PripraveneTemaHodnoceni
     * @return Test
     */
    private static function nactiTest(Database $database, $idPripravenehoTestu)
    {
        $test = new Test($database);
        $test ->nactiPripravenyDotaznik($idPripravenehoTestu);

        return $test;
    }


    /**
     * @param Database $database
     * @param int $druhHodnoceni
     * @param int $temaCislo
     * @param KurzOsoby $kurzOsoby
     * @param object|string $logDescription
     * @return Test
     * @throws DBException
     */
    public static function vygenerujTest(Database $database, $druhHodnoceni, $temaCislo, $kurzOsoby, $logDescription)
    {
        $rec = new PripraveneTemaHodnoceniDBRecord($database, $druhHodnoceni, $temaCislo, $logDescription);
        //$rec = new RonPortalDBRecord($database, 'PripraveneTemaHodnoceni');

        //$newId = SQLUtils::newSerialNumber($database, 'PripraveneTemaHodnoceni', 'ID');
        //$rec ->addField('ID', 'int', false, 0, $newId);
        //$rec ->addField('DruhHodnoceni', 'int', false, 0, $druhHodnoceni);
        //$rec ->addField('TemaCislo', 'int', false, 0, $temaCislo);
        //$rec ->addField('DatumHodnoceni', 'timestamp', false, 0, time());
        //$rec ->addField('Stav', 'int', false, 0, 1); // povinne pole

        // pole pro elearning
        $rec ->addField('Test_Stav', 'int', false, 0, self::TEST_STAV_PROBIHA);
        $rec ->addField('Test_datumCasPocatku', 'timestamp', false, 0, time());
        $rec ->addField('EKurzOsoby', 'int', false, 0, $kurzOsoby ->id);

        $rec ->insertRecord();

        //return self::nactiTest($database, $newId);
        return self::nactiTest($database, $rec['ID']);
    }


    /**
     * Vraci instanci testu osoby k zadanemu kurzu osoby. Pokud neexistuje, vraci null
     * @param Database $database
     * @param int $druhHodnoceni
     * @param int $temaCislo
     * @param KurzOsoby $kurzOsoby
     * @param string $filtr
     * @return Test
     */
    public static function nactiTestOsoby(Database $database, $druhHodnoceni, $temaCislo, $kurzOsoby, $filtr = null)
    {
        $params = $database ->createParameters();

        $sql =
            'SELECT ID FROM PripraveneTemaHodnoceni ' .
            ' WHERE EKurzOsoby = ' . $params ->addParameter($kurzOsoby ->id) .
            '   AND DruhHodnoceni = ' . $params ->addParameter($druhHodnoceni) .
            '   AND TemaCislo = ' . $params ->addParameter($temaCislo);

        if ($filtr) {
            $sql .= ' AND ' . $filtr;
        }

        $sql .= ' ORDER BY Test_datumCasPocatku DESC'; // aby nacetl posledni pokus

        $cursor = $database ->select($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        if (!$row) {
            return null;
        }

        return self::nactiTest($database, $row[0]);
    }

    function zobrazHlavicku()
    {
        echo
            '<h2 class="nazevtestu">' . StringUtils::htmlTextConvert($this ->popisTematu) . '</h2>' .
            '<div class="poznamka popistestu">' . StringUtils::longTextToHtml($this ->poznamkaTematu) . '</div>';
    }




//    /**
//     * Nacte dodatecne udaje z tabulky TestEKurzu (casovy limit, pocet pokusu)
//     * @param Database $database
//     * @param int $idRevize
//     */
//    public function nactiTestEKurzu($database, $idRevize)
//    {
//        $params = $database ->createParameters();
//
//        $sql =
//            'SELECT PocetPokusu, CasovyLimit FROM TestEKurzu ' .
//            ' WHERE IdRevize = ' . $params ->addParameter($idRevize) .
//            '   AND DruhHodnoceni = ' . $params ->addParameter($this ->druhHodnoceni) .
//            '   AND TemaCislo = ' . $params ->addParameter($this ->temaCislo);
//
//        $cursor = $database ->select($sql, $params);
//
//        $row = $cursor ->fetch();
//        if ($row) {
//            $this ->pocetPokusu = $row[0];
//            $this ->casovyLimit = $row[1];
//        }
//    }


//    function zobrazTlacitka($editace)
//    {
//        if ($editace) {
//            echo '<input type="submit" name="ulozit" class="button" value="' . \Ron\ronText('Ulozit_test') . '" />';
//            echo '<span style="float:right">';
//            echo '<input type="submit" name="odeslat" class="submitbutton" value="' . \Ron\ronText('Odeslat_test') . '" data-ron-confirm-id="' . \Ron\ronText('Opravdu_odeslat_test') . '" />';
//            echo '</span>';
//        }
//    }


//    function zobrazDotaznik($editace, $postValues)
//    {
//        echo "<FORM name='dotaznik' class='inputform' method='post' action='?menuid=prezentace&kurzosoby={$this->idKurzuOsoby}&pageindex={$this ->pageIndex}'>\n";
//
//        $action='uloztest';
//
//        echo "<INPUT type='hidden' name='testaction' value='$action'>\n";
//
//        if ($this->fXMLSablona) {
//            $this->zobrazDotaznikXML($editace, $postValues);
//        } else {
//            $oznacitSpravne = 0;
//
//            if (!$editace) {
//                switch ($this ->test_stav) {
//                    case 3 :
//                        $oznacitSpravne = $this->zobrazitOdpovediUspesne;
//                        break;
//
//                    case 2 :
//                    case 4 :
//                        // neuspesne nebo pozde dokonceny test
//                        $oznacitSpravne = $this ->zobrazitOdpovediNeuspesne;
//                        break;
//                }
//            }
//
//            if ($oznacitSpravne) {
//                $this ->nactiSpravneOdpovedi();
//            }
//
//            $this->zobrazObsahDotazniku($editace, $oznacitSpravne, RonPortalSettings::getIntValue('povolitHTMLvTestech', 1));
//        }
//
//        echo "</FORM>\n";
//    }


    /**
     * @param int $novyStav
     * @return bool|void
     * @throws DBException
     */
    function ulozVyplnenyTest($novyStav = 1) // 1=TEST_STAV_PROBIHA
    {
        if (!$this ->loadPost()) {
            return false;
        }

        $this ->ulozOdpovedi();

        // zapise jmeno hodnoticiho a cas
        $params = $this ->database ->createParameters();
        $sql =
            'UPDATE PripraveneTemaHodnoceni ' .
            '   SET HodnotilRC = ' . $params->addParameter(User::getRC()) . ', ' .
            '       Hodnotici = ' . $params->addParameter(User::getLoginName()) . ', ' .
            '       DatumHodnoceni = ' . $params ->addTimestampParameter(time()) . ', ' .
            '       Test_Stav = ' . $params ->addParameter($novyStav) . ', ' . // 1 = probiha
            '       Poznamka = ' . $params ->addParameter( $this ->poznamkaHodnoceni ) .
            ' WHERE Id = ' . $params ->addParameter((int)$this ->fId);

        $this ->database ->sql($sql, $params);

        return true;
    }
}
