<?php
/**
 * stanislav.elbl, 25.11.2015
 */

namespace RonPortal\ELearning;

use Ron\GuiUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;
use RonPortal\Testy\DotaznikViewObject;


class TestViewObject extends DotaznikViewObject
{
    /** @var  TestEKurzu */
    public $testEKurzu;

    /**
     * TestViewObject constructor.
     * @param TestEKurzu $testEKurzu
     * @param bool $editace
     */
    public function __construct($testEKurzu, $editace)
    {
        parent::__construct($testEKurzu ->test, $editace, false);
        $this->testEKurzu = $testEKurzu;

        $this ->setFormAction("?menuid=prezentace&kurzosoby={$this->testEKurzu->test -> idKurzuOsoby}&pageindex={$this ->testEKurzu ->test ->pageIndex}");

        $this ->oznacitSpravneOdpovedi = 0;

        if (!$this ->editace) {
            switch ($this ->dotaznik ->test_stav) {
                case 3 :
                    $this ->oznacitSpravneOdpovedi = $this->dotaznik ->zobrazitOdpovediUspesne;
                    break;

                case 2 :
                case 4 :
                    // neuspesne nebo pozde dokonceny test
                    $this ->oznacitSpravneOdpovedi = $this ->dotaznik ->zobrazitOdpovediNeuspesne;
                    break;
            }
        }

        $this ->povolitHtmlVTextech = RonPortalSettings::getIntValue('povolitHTMLvTestech', 1);
    }


    /**
     * Vraci obrazek pro zadany stav. Pokud je $stav=null, tak vraci obrazek pro aktualni stav
     * @param null $stav
     * @return string
     */
    public function getInfoImage($stav = null)
    {
        if (!$stav) {
            $stav = $this ->testEKurzu ->test ->test_stav;
        }

        switch ($stav) {
            case '3' :
                return 'fa-check';

            case '2' :
            case '4' :
                return 'fa-times';
            default :
                return '';
        }
    }


    function getHtmlAttributes()
    {
        $attrs = ['data-editace' => $this->editace ? 1 : 0];

        if ($this ->testEKurzu ->casovyLimit) {
            $attrs['data-casovy-limit'] = $this ->testEKurzu ->casovyLimit; // pocet sekund od zacatku
            $attrs['data-cas-do'] = date('j.n.Y H:i:s', $this ->testEKurzu ->test ->test_datumCasPocatku + $this ->testEKurzu ->casovyLimit);
        }

        return GuiUtils::getAttributesHtml($attrs);
    }



    public function renderHiddenFields()
    {
        $action='uloztest';

        echo "<INPUT type='hidden' name='testaction' value='$action'>\n";
    }


    protected function zobrazTlacitka()
    {
        if ($this->editace) {
            echo "<div class='buttons'>";

            echo '<input type="submit" name="ulozit" class="button" value="' . TextManager::_('Ulozit_test') . '" />';
            echo '<span style="float:right">';
            echo '<input type="submit" name="odeslat" class="submitbutton" value="' . TextManager::_('Odeslat_test') . '" data-ron-confirm-id="' . TextManager::_('Opravdu_odeslat_test') . '" />';
            echo '</span>';

            echo "</div>";
        }
    }




//    public function render()
//    {
//        echo "<FORM name='dotaznik' class='inputform' method='post' action='{$this ->formAction}'>\n";
//
//        $this ->renderHiddenFields();
//
//        if ($this->dotaznik ->fXMLSablona) {
//            $this->dotaznik ->zobrazDotaznikXML($this ->editace, $this ->postValues);
//        } else {
//            if ($this ->oznacitSpravneOdpovedi) {
//                $this ->dotaznik ->nactiSpravneOdpovedi();
//            }
//
//            $this->dotaznik ->zobrazObsahDotazniku($this ->editace, $this ->oznacitSpravneOdpovedi, $this ->povolitHtmlVTextech);
//        }
//
//        echo "</FORM>\n";
//    }




//    function getJsonPrezentace()
//    {
//        $obj = ['editace' => $this->editace ? 1 : 0];
//
//        if ($this ->testEKurzu ->casovyLimit) {
//            $obj['casovyLimit'] = $this ->testEKurzu ->casovyLimit; // pocet sekund od zacatku
//            $obj['casDo'] = date('j.n.Y H:i:s', $this ->testEKurzu ->test ->test_datumCasPocatku + $this ->testEKurzu ->casovyLimit);
//        }
//
//        return json_encode($obj);
//    }

}
