<?php

namespace RonPortal\Jidelna;

use Ron\DateUtils;
use Ron\DB\Database;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FilterFormFilter;
use RonPortal\Controls\RonPortalFilterForm;

/**
 * Ve filterformu zobrazuje aktualni stav uctu stravnika.
 */
class StavUctuFilter extends FilterFormFilter
{
    public function __construct()
    {
        parent::__construct('stavuctu', self::TYPE_TEXT);
        $this ->rowId = 'filterrow_ucetstravnika';
    }

    public function load(Database $database)
    {
        if (!$this ->filterForm ->getFilterValue('osoba')) {
            return;
        }

        // Cenova kategorie zamestnance
        $cenovaKategorie = new CenovaKategorie(
            $this->filterForm ->getFilterValue('osoba', 'rc'),
            $this->filterForm ->getFilterValue('osoba', 'osobniCislo'),
            $this->filterForm ->getFilterValue('osoba', 'datumNastupu')
        );
        $cenovaKategorie->nactiVlastnostiKDatu($database, DateUtils::today());

        // u srazkove aktualni stav v obdobi dle data
        // u zalohove nacitat stav z posledniho vypocteneho obdobi
        $stavUctuStravnika = UcetStravnika::nactiAktualniStav($database,
            $this->filterForm ->getFilterValue('osoba', 'rc'),
            $this->filterForm ->getFilterValue('osoba', 'osobniCislo'),
            $this->filterForm ->getFilterValue('osoba', 'datumNastupu'),
            DateUtils::today(),
            $cenovaKategorie->f_ZpusobUctovani == 0);

        if ($stavUctuStravnika) {
            $this->value =
                '<span class="filterformtext">' .
                TextManager::_('Jidelna_aktualni_stav') .
                StringUtils::format('kc', $stavUctuStravnika->stavUctu) .
                '</span>';
        }
    }
}
