<?php
/**
 * stanislav.elbl, 25.12.2015
 */

namespace RonPortal\Jidelna;

use Ron\DateUtils;
use Ron\Http\App;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;

/** @var JidelnicekView $this */

/** @var JidelnicekFilterForm $filterForm */
$filterForm = $this ->filterForm; // Model::getInstance() ->getData('filterForm');
$alertMessage = MessageManager::getInstance() ->findMessage(null, 'alertMessage');

$datum = $filterForm ->datumJidelnickuOd;
//$aktualniTyden = DateUtils::firstDayOfWeek( time() );
//$prevDate = DateUtils::firstDayOfWeek( DateUtils::incDay($datum, -1) );
//$nextDate = DateUtils::firstDayOfWeek( DateUtils::incDay($datum, 8) );

/** @var Jidelnicek $jidelnicek */
$jidelnicek = $this ->jidelnicek; // Model::getInstance() ->getData('jidelnicek');

$objednavani = Prava::vratHodnotuPrava('objednani') ? $filterForm ->getFilterValue('osoba') : false;

$text_objednat = TextManager::_('Objednat_jidlo_text');
$text_zrusit = TextManager::_('Zrusit_objednavku_jidla_text');
$text_prevzit_z_burzy = TextManager::_('Prevzit_z_burzy_text');
$text_predat_do_burzy = TextManager::_('Predat_do_burzy_text');

?>
<h1><?= TextManager::_('Jidelnicek') ?></h1>

<?php $this->objectConfiguration ->renderXmlForms('head'); ?>
<?= $this ->objectConfiguration ->getHtmlContent(['head', 'hlavicka']) ?>

<?php $filterForm ->render(); // vyber osoby jidelny atd. ?>

<?php $this->objectConfiguration ->renderXmlForms('top'); ?>
<?= $this ->objectConfiguration ->getHtmlContent(['top', '']) ?>

<?php
    // MessageManager::getInstance() ->showMessages() - zobrazuje se v filterformu
?>

<table class="jidelnicek" data-code="jidelnicek"
    <?= (RonPortalSettings::getIntValue('jidelnicek_povolit_hodnoceni', 1)) ? 'data-jidelnicek-povolit-hodnoceni="true"' : '' ?>
    <?= (RonPortalSettings::getIntValue('jidelnicek_zobrazit_dialog', 1)) ? 'data-zobrazit-dialog="true"' : '' ?>
    <?= $alertMessage ? "data-alert-message='" . StringUtils::htmlTextConvert($alertMessage ->text, ["\n" => '\n']) . "'" : '' ?>>
    <?php foreach ($jidelnicek ->data as $denJidelnicku) { ?>
        <tr class='denjidelnicku background-table-header color-table-header font-weight-bold'>
            <td></td>
            <td colspan="1">
                <?php if ( $denJidelnicku ->datum == DateUtils::startOfTheDay(time()) ) { ?>
                    <a id="dnes"></a>
                <?php } ?>
                <a id="<?= $denJidelnicku ->datum ?>"></a>
                <?= DateUtils::dayName($denJidelnicku ->datum) ?>
                <?= StringUtils::format('date', $denJidelnicku ->datum) ?>
            </td>
            <td class="cenajidelnicku"><?= TextManager::_('Cena_polozky_jidelnicku') ?></td>
            <td colspan="4"><?= TextManager::_('Objednano') ?></td>
            <?php if ((RonPortalSettings::getIntValue('jidelnicek_zobrazit_cas_objednani')) && ($objednavani)) { ?>
                <td class="jidelnicek_objednani_do"><?= TextManager::_('Objednani_do') ?></td>
            <?php } ?>
            <td class='alergeny'><?= TextManager::_('Alergeny') ?></td>
            <?php if ($objednavani) { // ve frame nezobrazuje ?>
                <td class='jidelnicek_hodnoceni_polozky hodnocenijidla d-xs-none'><?= TextManager::_('Hodnoceni_jidla') ?></td>
            <?php } ?>
            <?php if ($jidelnicek ->jeFotografie) { ?><td class="jidelnicek_col_foto d-xs-none"></td><?php } ?>
        </tr>

        <?php
        $oldTyp = '';
        foreach ($denJidelnicku ->polozky as $polozka) { ?>
            <?php if ($oldTyp != $polozka->f_typdennihojidla) { // Zobrazi typ denniho jidla (obed/vecere) ?>
                <?php if ($oldTyp) { ?>
                <tr class="typjidla_oddelovac">
                    <td colspan="7"></td>
                    <?php if ((RonPortalSettings::getIntValue('jidelnicek_zobrazit_cas_objednani')) && ($objednavani)) { ?>
                        <td class="jidelnicek_objednani_do"></td>
                    <?php } ?>
                    <td class="alergeny"></td>
                    <td class="jidelnicek_hodnoceni_polozky d-xs-none"></td>
                    <?php if ($jidelnicek ->jeFotografie) { ?><td class="jidelnicek_col_foto d-xs-none"></td><?php } ?>
                </tr>
                <?php } ?>

                <tr class="typjidlarow typjidla_<?= $polozka ->f_typdennihojidla ?>">
                    <!--<td></td> -->
                    <td></td>
                    <td class="typjidla" colspan="6"><?= StringUtils::htmlTextConvert($polozka->f_popistypudennihojidla) ?></td>
                    <?php if ((RonPortalSettings::getIntValue('jidelnicek_zobrazit_cas_objednani')) && ($objednavani)) { ?>
                        <td class="typjidla jidelnicek_objednani_do"></td>
                    <?php } ?>
                    <td class="typjidla alergeny"></td>
                    <td class="typjidla jidelnicek_hodnoceni_polozky d-xs-none"></td>
                    <?php if ($jidelnicek ->jeFotografie) { ?><td class="typjidla jidelnicek_col_foto d-xs-none"></td><?php } ?>
                </tr>
            <?php }
            $oldTyp = $polozka ->f_typdennihojidla;
            ?>

            <tr class="polozkajidelnicku typjidla_<?= $polozka ->f_typdennihojidla ?><?= $polozka ->f_pocetobjednavekosoby ? ' objednano' : '' ?><?= (isset($_GET['polozka']) && $_GET['polozka'] == $polozka->f_id) ? ' vybranejidlo' : '' ?> cislonabidky_<?= $polozka->f_cislonabidky ?>"
                data-jidelnicek-id="<?= $polozka ->f_id ?>"
                data-jidelnicek-den="<?= date('j.n.Y', $polozka ->f_den) ?>" <?= (count($polozka->alergeny) > 0) ? 'data-jidelnicek-maalergeny="true"' : '' ?>
                <?= $polozka->kodFotografie != 0 ? 'data-jidelnicek-mafotografii="true"' : ''  ?>
                >
                <!--<td></td> -->
                <!-- cislo nabidky popis -->
                <td class='cislonabidky align-right'><?= $polozka -> f_cislonabidky ?></td>
                <td>
                    <span class="jidelnicek_popisnabidky1"> <?= StringUtils::htmlTextConvert($polozka -> f_popisnabidky) ?></span>
                    <span class="jidelnicek_popisnabidky2"> <?= $polozka->f_popisNabidky_Jazyk2 ? '<br/>' . StringUtils::htmlTextConvert($polozka->f_popisNabidky_Jazyk2) : '' ?></span>
                </td>

                <!-- cena -->
                <td class="cenajidelnicku"><?= $polozka ->zobrazenaCena ?></td>

                <td></td>

                <td class="pocetobjednavek">
                    <!-- pocet objednavek -->
                    <?php if ($polozka->f_pocetobjednavekosoby > 0) { ?>
                        <?= $polozka->f_pocetobjednavekosoby - $polozka->pocetVBurzeMych ?>
                    <?php } ?>
                    <?php if ($polozka->pocetVBurzeMych) { ?>
                        <span class="objednavkyvburze" title="<?= TextManager::_('Pocet_mych_v_burze') ?>">
                            <?= $polozka->pocetVBurzeMych ?>
                        </span>
                    <?php } ?>
                </td>

                <td class="objednani">
                    <?php if ($objednavani) { ?>
                        <?php if ($polozka->lzeObjednat) { ?>
                            <!-- objednat -->
                            <form class="objednavaniform submitWorkingInfo sendPosition" method="POST" action="?menuid=jidelnicek#<?= $polozka->f_den ?>">
                                <input type="hidden" name="action" value="objednatjidlo" />
                                <input type="hidden" name="polozka" value="<?= $polozka->f_id ?>" />
                                <input type="hidden" name="osoba" value="<?= $filterForm ->getFilterValue('osoba') ?>" />
                                <input type="hidden" name="x" />
                                <input type="hidden" name="y" />
                                <div class="<?= $text_objednat ? 'borders padding-left padding-right border-dark' : 'fa glyph-button glyph-plus' ?> jidelnicek_objednat" title='<?= TextManager::_('Objednat_jidlo') ?>'><?= $text_objednat ?></div>
                            </form>
                        <?php } else if ($polozka->lzeVyzvednoutZBurzy) { ?>
                            <!-- burza -->
                            <form class="objednavaniform submitWorkingInfo sendPosition" method="POST" action="?menuid=jidelnicek#<?= $polozka->f_den ?>">
                                <input type='hidden' name='action' value='objednavkazburzy'>
                                <input type='hidden' name='polozka' value='<?= $polozka->f_id ?>'>
                                <input type="hidden" name="osoba" value="<?= $filterForm ->getFilterValue('osoba') ?>">
                                <input type="hidden" name="x" />
                                <input type="hidden" name="y" />
                                <div class="<?= $text_prevzit_z_burzy ? 'borders padding-left padding-right border-dark' : 'fa glyph-button glyph-plus' ?> jidelnicek_objednat jidelnicek_objednat_burza" title='<?= TextManager::_('Prevzit_z_burzy') ?>'><?= $text_prevzit_z_burzy ?></div>
                            </form>
                        <?php } else { ?>
                            <!-- nelze objednat <?= $polozka ->stavObjednavani(App::getInstance() ->getDatabase()) ?>-->
                        <?php } ?>
                    <?php } ?>
                </td>

                <td class="zruseniobjednavky">
                    <?php if ($objednavani && $polozka->f_pocetobjednavekosoby) { ?>
                        <?php if ($polozka->lzeZrusitObjednavku) { ?>
                            <form class="objednavaniform submitWorkingInfo sendPosition" method="POST" action="?menuid=jidelnicek#<?= $polozka->f_den ?>">
                                <input type="hidden" name="action" value="zrusitobjednavku">
                                <input type="hidden" name="polozka" value="<?= $polozka->f_id ?>">
                                <input type="hidden" name="osoba" value="<?= $filterForm ->getFilterValue('osoba') ?>">
                                <input type="hidden" name="x" />
                                <input type="hidden" name="y" />
                                <div class="<?= $text_zrusit ? 'borders padding-left padding-right border-dark' : 'fa glyph-button glyph-minus' ?> jidelnicek_objednat" title='<?= TextManager::_('Zrusit_objednavku_jidla') ?>'><?= $text_zrusit ?></div>
                            </form>
                        <?php } else if ($polozka->lzePredatObjednavkuDoBurzy) { ?>
                            <form class="objednavaniform submitWorkingInfo sendPosition" method="POST" action="?menuid=jidelnicek#<?= $polozka->f_den ?>">
                                <input type='hidden' name='action' value='objednavkadoburzy'>
                                <input type='hidden' name='polozka' value='<?= $polozka->f_id ?>'>
                                <input type="hidden" name="osoba" value="<?= $filterForm ->getFilterValue('osoba') ?>">
                                <input type="hidden" name="x" />
                                <input type="hidden" name="y" />
                                <div class="<?= $text_predat_do_burzy ? 'borders padding-left padding-right border-dark' : 'fa glyph-button glyph-minus' ?> jidelnicek_objednat jidelnicek_objednat_burza" title='<?= TextManager::_('Predat_do_burzy') ?>'><?= $text_predat_do_burzy ?></div>
                            </form>
                        <?php } ?>
                    <?php } ?>
                </td>

                <?php if ((RonPortalSettings::getIntValue('jidelnicek_zobrazit_cas_objednani')) && ($objednavani)) { ?>
                    <td class="jidelnicek_objednani_do">
                        <?= (($polozka->prijemObjednavekDo > 0) && ($polozka->prijemObjednavekDo > DateUtils::now())) ? StringUtils::format('finedatetime', $polozka->prijemObjednavekDo) : ''; ?>
                    </td>
                <?php } ?>

                <!-- alergeny -->
                <td class='alergeny'>
                    <?php if (count($polozka->alergeny) > 0) {
                        $first = true;
                        foreach ($polozka->alergeny as $alergen) {
                    ?>
                            <?= $first ? '' : ', ' ?>
                            <span class="alergen" title="<?= StringUtils::htmlTextConvert($alergen ->popis) ?>"><?= StringUtils::htmlTextConvert($alergen->kod) ?></span>
                    <?php
                            $first = false;
                        }
                    }
                    ?>
                </td>

                <?php if ($objednavani) { // ve frame nezobrazuje ?>
                    <td class="jidelnicek_hodnoceni_polozky fa jidelnicek_hodnoceni d-xs-none" <?= $polozka->hodnoceni > 0 ? 'data-aktualni-hodnoceni="' . $polozka->hodnoceni . '"' : '' ?>>
                        <span id="jidelnicek_hodnoceni_1_<?= $polozka->f_id ?>" data-hodnoceni-polozky="1" ></span>
                        <span id="jidelnicek_hodnoceni_2_<?= $polozka->f_id ?>" data-hodnoceni-polozky="2" ></span>
                        <span id="jidelnicek_hodnoceni_3_<?= $polozka->f_id ?>" data-hodnoceni-polozky="3" ></span>
                        <span id="jidelnicek_hodnoceni_4_<?= $polozka->f_id ?>" data-hodnoceni-polozky="4" ></span>
                        <span id="jidelnicek_hodnoceni_5_<?= $polozka->f_id ?>" data-hodnoceni-polozky="5" ></span>
                    </td>
                <?php } ?>

                <?php if ($jidelnicek ->jeFotografie) { ?>
                    <td class="jidelnicek_col_foto d-xs-none">
                        <?php if ($polozka->kodFotografie) { ?>
                            <span class="jidelnicek_foto_polozky ronInfoFoto" id="jidelnicek_foto_<?= $polozka->f_id ?>"
                                  data-foto-url="?menuid=jidelnicek&action=zobrazfoto&idpolozky=<?= $polozka->f_id ?>"
                                  data-foto-alt="<?= $polozka->f_popisnabidky ?>">
                                <i class="inline-glyph fa glyph-image"></i>
                            </span>
                        <?php } ?>
                    </td>
                <?php } ?>
            </tr>
        <?php } ?>

        <tr class="new-line">
            <td colspan="8">&nbsp;</td>
            <td class="alergeny"></td>
            <td class="jidelnicek_hodnoceni d-xs-none"></td>
            <?php if ($jidelnicek ->jeFotografie) { ?><td class="jidelnicek_col_foto d-xs-none"></td><?php } ?>
        </tr>
    <?php } ?>

</table>

<?php $filterForm ->datumJidelnickuFilter ->render(); ?>

<?php $this->objectConfiguration ->renderXmlForms('bottom'); ?>
<?= $this ->objectConfiguration ->getHtmlContent(['behind', 'bottom', 'dole']) ?>

<?php
    require('ronportal/jidelna/view_detail_polozky.php'); // formular pro hodnoceni jidel
?>

<?php if (!RonPortalSettings::getIntValue('jidelnicek_povolit_hodnoceni', 1)) { ?>
    <style>
        .jidelnicek_hodnoceni_polozky {
            display: none;
        }
    </style>
<?php } ?>
