<?php

namespace RonPortal\Kapacity;

use Ron\DB\Database;
use Ron\StringUtils;

class PlanovaniKapacit_Kalendar
{
    public $kod;
//    var $f_popis;

    /** @var PlanovaniKapacit_PlanovanaSmena[]  Seznam povolenych smen */
    public $seznamSmen;

    public function __construct()
    {
        $this->seznamSmen = [];
    }


    /**
     * @param Database $database
     * @param string $kod
     * @param bool $podleSmeny2
     * @param int  $datumOd
     * @param int  $datumDo
     * @throws \Exception
     */
    public function nactiData($database, $kod, $podleSmeny2, $datumOd, $datumDo)
    {
        $this->kod = $kod;
        //$this -> f_popis = $row[1];

        $this->seznamSmen = [];

        $params = $database ->createParameters();
        if ($podleSmeny2) {
            $sql =
                'SELECT Smena, Den ' .
                ' FROM SmenaProDenKalendare ' .
                ' WHERE Kalendar = ' . $params ->addParameter($this->kod) .
                ' AND Den >= ' . $params ->addParameter($database ->dateToParam($datumOd)) .
                ' AND Den <= ' . $params ->addParameter($database ->dateToParam($datumDo)) .
                ' ORDER BY Den';
        } else {
            $sql =
                'SELECT KodSmeny, 0 ' .  // datum se nenacita
                ' FROM PouzivaneSmeny ' .
                ' WHERE KodKalendare = ' . $params ->addParameter($this->kod) .
                ' ORDER BY Poradi';
        }

        $cursor = $database ->select($sql, $params);

        while ($row = $cursor ->fetch()) {
            $smena = new PlanovaniKapacit_PlanovanaSmena();
            $smena->kod = $row[0];

            if ($podleSmeny2) {
                $smena->datum = $database ->stringToTimestamp($row[1]);
            }
            else {
                $smena->datum = 0;
            }

            $this->seznamSmen[] = $smena;
        }

        $cursor ->close();
    }


    private function getJsonSmeny()
    {
        $result = [];

        foreach ($this->seznamSmen as $smena) {
            $obj = [
                'kod' => StringUtils::jsonText($smena ->kod)
            ];

            if ($smena ->datum) {
                $obj['datumStr'] = StringUtils::jsonDate($smena->datum);
            }

            $result[] = $obj;
        }

        return $result;
    }


    public function getJson()
    {
        return [
            'kod' => StringUtils::jsonText($this ->kod),
            // 'Popis' => ...
            'povoleneSmeny' => $this ->getJsonSmeny()
        ];
    }
}
