<?php

namespace RonPortal\Kapacity;

use Ron\DateUtils;
use Ron\DB\Database;
use Ron\StringUtils;

class PlanovaniKapacit_Suma
{
    public $kodCasoveSlozky;
    public $jednotka;  // H, D, K
    public $nadpis;

    /** @var string[] */
    public $data;

    public function __construct()
    {
        $this->data = [];
    }


    /**
     * @param Database $database
     * @param int $typRozdeleni
     * @param string $rozdeleni
     * @param int $datumOd
     * @param int $datumDo
     * @throws \Exception
     */
    public function nactiDenniCasovaSlozkaR($database, $typRozdeleni, $rozdeleni, $datumOd, $datumDo)
    {
        $datum = $datumOd;
        $this->data = [];

        if (isset($rozdeleni)) {
            $params = $database->createParameters();
            $sql =
                'SELECT Den, Hodiny, Dny, KalendarniDny' .
                ' FROM DenniCasovaSlozka_R' .
                ' WHERE Den >= ' . $params->addParameter($database->dateToParam($datumOd)) .
                '   AND Den <= ' . $params->addParameter($database->dateToParam($datumDo)) .
                '   AND KodTypuRozdeleni = ' . $params->addParameter((int)$typRozdeleni) .
                '   AND Rozdeleni = ' . $params->addParameter($rozdeleni) .
                '   AND TypCasoveSlozkyMzdy = ' . $params->addParameter($this->kodCasoveSlozky) .
                ' ORDER BY Den';

            $cursor = $database->select($sql, $params);

            while ($row = $cursor->fetch()) {
                $pomd = $database->stringToTimestamp($row[0]);

                // pro chybejici datumy doplni prazdny text
                for (; $datum < $pomd; $datum = DateUtils::incDayStart($datum, 1)) {
                    $this->data[] = '';
                }

                switch ($this->jednotka) {
                    case 'D' :
                        $text = StringUtils::format('number_2', $row[2]);
                        break;
                    case 'K' :
                        $text = StringUtils::format('number_2', $row[3]);
                        break;
                    default :
                        $text = StringUtils::format('hodiny', $row[1]);
                }

                $this->data[] = $text;

                $datum = DateUtils::incDayStart($datum, 1);
            }

            $cursor ->close();
        }

        // nakonec doplni prazdne texty pro dny, ve kterych neni zaznam
        for (; $datum <= $datumDo; $datum = DateUtils::incDayStart($datum, 1)) {
            $this->data[] = '';
        }
    }
}

