<?php
/**
 * stanislav.elbl, 25.05.2017
 * Zobrazeni seznamu planovanych kapacit - verze bez editace
 */

namespace RonPortal\Kapacity;

use Ron\Controls\Browser;
use Ron\DateUtils;
use Ron\DB\Database;
use Ron\DB\DBException;
use Ron\GuiUtils;
use Ron\Http\HtmlHeaders;
use Ron\MessageManager;
use Ron\MVC\BaseViewObject;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FilterFormFilterOsoba;
use RonPortal\Dochazka\DokumentDochazky;
use RonPortal\Dochazka\Smena;
use RonPortal\NastaveniUzivatele;
use RonPortal\Prava;
use RonPortal\RonPortalSession;
use RonPortal\RonPortalSettings;
use RonPortal\RozdeleniOsob;
use RonPortal\System\Report;


/**
 * Pro pasivni rezim se data nacitaji primo do bunek
 * Class PlanovaniKapacit_Bunka
 */
class PlanovaniKapacit_Bunka
{
    public $datum;

    /** @var PlanovaniKapacit_PlanovanaSmena */
    public $smena;
    //public $zkratka;
    //public $barva;

    //public $zkratka2; // pro rezim uprav
    //public $barva2;

    /** @var string */
    public $rozdeleni;
    /** @var int */
    public $barvaRozdeleni;

    /** @var string */
    public $rozdeleni2;
    /** @var int */
    public $barvaRozdeleni2;

    public $podrobnostiSmeny;


    public $zkratkaAbsence;
    public $skutecnaAbsence;
    public $barvaSkutecnaAbsence;
    /** @var bool   Priznak, ze je v bunce nezapocitavana absence (napr. dovolena)  */
    public $jeNezapocitavanaAbsence = false;

    public $zkratkaAbsence2; // pro rezim uprav
    public $barvaAbsence2;

    /** @var PlanovaniKapacit_PlanovanaAbsence  Jedna z planovanych absenci, ktera se zobrazi v bunce */
    public $planovanaAbsence;
    /** @var PlanovaniKapacit_PlanovanaAbsence[] */
    public $seznamAbsenci = [];
    /** @var string     Pouzije se pro title */
    public $podrobnostiAbsence;

    /** @var int    nejvyssi uroven schvaleni teto bunky - 0, 1, 2, 3 */
    public $schvaleni;

    public $link; // link pro zobrazeni absence (pokud muze uzivatel schvalovat)

    public $dalsiText; // pro denni vysledky

    /** @var DokumentDochazky[] */
    public $dokumenty = [];
    /** @var PlanovaniKapacit_SluzebniCesta[] */
    public $sluzebniCesty = [];
    /** @var VysledekKontrolyPlanovani */
    public $kontroly = [];
}




class PlanovaniKapacitView_SouctovyRadek
{
    public $nadpis;

    /** @var PodminkaPlanovaniKapacit  */
    public $slot;

    /** @var Smena */
    public $smena;

    /** @var string[] */
    public $data = [];

    /** @var string[] */
    public $classes = [];
}


class PrehledKapacitView extends BaseViewObject
{
    const REZIM_PUVODNI = 0;
    const REZIM_UPRAVENY = 1;
    const REZIM_KOMBINOVANE = 2;
    const REZIM_PODLE_SMEN = 3;
    const REZIM_SLOTY = 4;

    /** @var Database */
    public $database;

    /** @var  KapacityFilterForm */
    public $filterForm;

    /** @var  PlanovaniKapacit */
    public $data;
    /** @var  PlanovaniKapacit_Bunka[][] */
    public $dataOsob;

    /** @var PlanovaniKapacitView_SouctovyRadek[] */
    var $soucty = [];

    /** @var PodminkaPlanovaniKapacit[]    Seznam slotu pro zobrazeni */
    public $sloty = [];

    /** @var  int */
    public $rezim;
    /** @var  int   Pocet radku pro zobrazeni jedne osoby - pouziva se pro zobrazeni po slotech */
    public $pocetRadkuNaOsobu;

    public $schvaleniPoctuOK = true; // pokud je v pravech nastaveno omezeni editace pri neschvalenem poctu, tak se dodatecne zkontroluje

    public $reportList;

    /**
     * @param Database $database
     */
    public function __construct($database)
    {
        parent::__construct('ronportal/kapacity/view_prehled.php');
        $this ->database = $database;
    }


    /**
     * @param PodminkaPlanovaniKapacit $novySlot
     */
    public function pridejSlot($novySlot)
    {
        foreach ($this ->sloty as $slot) {
            if ($slot ->casOd === $novySlot ->casOd  &&  $slot ->casDo === $novySlot ->casDo) {
                // slot uz existuje
                return;
            }
        }

        $this ->sloty[] = $novySlot;
    }


    /**
     * Nacte casove sloty a priradi je k jednotlivym dnum
     */
    public function nactiSloty()
    {
        $this ->data ->nactiSloty();

        foreach ($this ->data ->sloty as $sadaPodminek) {
            $datumOd = max($sadaPodminek->datumOd, $this->data->datumOd);
            $datumDo = ($sadaPodminek ->datumDo  &&  $sadaPodminek ->datumDo < $this ->data ->datumDo) ? $sadaPodminek ->datumDo : $this ->data ->datumDo;

            $indexOd = DateUtils::daysBetween($this ->data ->datumOd, $datumOd);
            $indexDo = DateUtils::daysBetween($this ->data ->datumOd, $datumDo);

            for ($index = $indexOd;  $index <= $indexDo;  $index++) {
                if ($sadaPodminek->jePlatnaProDen($this->data->dny[$index]->datum, $this->data ->dny[$index]->typ)) {
                    if ($sadaPodminek ->prioritni  ||  !$this->data->dny[$index]->sloty) {
                        $this->data->dny[$index]->sloty = $sadaPodminek ->podminky;
                    }
                }
            }
        }

        $this ->sloty = [];

        foreach ($this ->data ->dny as $den) {
            if ($den ->sloty) {
                foreach ($den ->sloty as $slot) {
                    $this ->pridejSlot($slot);
                }
            }

//            if ($den ->sloty && count($den ->sloty) > $this ->pocetRadkuNaOsobu) {
//                $this ->pocetRadkuNaOsobu = count($den ->sloty);
//            }
        }

        usort($this ->sloty, function($slot1, $slot2) {
            return PodminkaPlanovaniKapacit::compare($slot1, $slot2);
        });

        $this ->pocetRadkuNaOsobu = count($this ->sloty);
    }


    /**
     * @param PlanovaniKapacitView_SouctovyRadek[] $soucty
     * @param PodminkaPlanovaniKapacit $slot
     * @return PlanovaniKapacitView_SouctovyRadek
     */
    public function najdiSouctovyRadekProSlot(&$soucty, $slot)
    {
        foreach ($soucty as $radek) {
            if ($radek ->slot  &&  $slot ->isSameAs($radek ->slot)) {
                return $radek;
            }
        }

        $radek = new PlanovaniKapacitView_SouctovyRadek();
        $radek ->slot = $slot;

        $radek ->data = [];
        foreach ($this ->data ->dny as $index => $den) {
            $radek ->data[$index] = '';
        }

        $radek ->nadpis = $slot ->getPopis();
        $soucty[] = $radek;

        return $radek;
    }


//    /**
//     * @param PlanovaniKapacitView_SouctovyRadek[]  $soucty
//     * @param PlanovaniKapacit_PlanovanaSmena $smena
//     * @return PlanovaniKapacitView_SouctovyRadek
//     */
//    public function najdiSouctovyRadekProSmenu(&$soucty, $smena)
//    {
//        foreach ($soucty as $radek) {
//            if ($radek ->smena ->kod  &&  $smena ->kod) {
//                return $radek;
//            }
//        }
//
//        $this ->data ->seznamSmen
//        $radek = new PlanovaniKapacitView_SouctovyRadek();
//        $radek ->smena = $smena;
//
//        $radek ->data = [];
//        foreach ($this ->data ->dny as $index => $den) {
//            $radek ->data[$index] = '';
//        }
//
//        $radek ->nadpis = $smena ->getPopis();
//        $soucty[] = $radek;
//
//        return $radek;
//    }


    public function spocitejSouctyProSloty()
    {
        $nezapocitavaneAbsence = explode(';', RonPortalSettings::getValue('kapacity_absencevesloupci'));

        $soucty = [];
        foreach ($this ->data ->dny as $indexDne => $den) {
            foreach ($den ->sloty as $slot) {
                $radek = $this ->najdiSouctovyRadekProSlot($soucty, $slot);
                $soucet = 0;

                foreach ($this ->data ->seznamOsob as $indexOsoby => $osoba) {
                    $bunka = $this ->dataOsob[$indexOsoby][$indexDne];

                    $pocitat = $bunka &&
                        ($bunka ->rozdeleni === $this ->data ->rozdeleni || (!$osoba ->cizi  &&  !$bunka ->rozdeleni));

                    // TODO: Zohlednit delku absence?
//                    if ($bunka ->jeNezapocitavanaAbsence) {
//                        $pocitat = false;
//                    }

                    foreach ($bunka ->seznamAbsenci as $absence) {
                        $jeVIntervalu = false;
                        if (!isset($absence ->kod)  ||  $absence ->kod == '') {
                            // neni absence (muze nastat v pripade, ze se pouziva rezim uprav)
                        } else if ($absence ->delka <= 2) {
                            // celodenni nebo puldenni absence
                            $jeVIntervalu = true;
                        } else if ($absence ->delka == 3) {
                            // cas od do
                            if ($absence ->casOd * 3600 < $slot ->casDo  &&  $absence ->casDo * 3600 > $slot ->casOd) {
                                $jeVIntervalu = true;
                            }
                        } else if ($absence ->delka == 4) {
                            // TODO: doresit kontinualni absenci?
                            $jeVIntervalu = true;
                        }

                        if ($jeVIntervalu) {
                            if (!in_array($absence ->kod, $nezapocitavaneAbsence, true)) {
                                // nasel absenci, ktera zasahuje do slotu a nema se pocitat do souctu
                                $pocitat = false;
                                break;
                            }
                        }
                    }

                    if ($pocitat  &&  $slot ->rozdeleni) {
                        // zjisti, jestli je osoba v danem dni v rozdeleni podle podminky
                        $pocitat = $osoba ->jeVRozdeleniOsoby($slot ->kodTypuRozdeleni, $slot ->rozdeleni, $den ->datum);
                    }
                    if ($pocitat  &&  $bunka ->smena) {
                        $casOd = $bunka ->smena ->pocatek;
                        if ($slot ->casOd > $casOd) {
                            $casOd = $slot ->casOd;
                        }

                        $casDo = $bunka ->smena ->konec;
                        if ($slot ->casDo < $casDo) {
                            $casDo = $slot ->casDo;
                        }

                        if ($casDo > $casOd) {
                            $soucet = $soucet + ($casDo - $casOd) / ($slot ->casDo - $slot ->casOd);
                            if ($bunka ->smena ->delena  &&  $bunka ->smena ->preruseniOd < $casDo  &&  $bunka ->smena ->preruseniDo > $casOd) {
                                // odecte prestavku
                                $preruseniOd = $casOd > $bunka ->smena ->preruseniOd ? $casOd : $bunka ->smena ->preruseniOd;
                                $preruseniDo = $casDo < $bunka ->smena ->preruseniDo ? $casDo : $bunka ->smena ->preruseniDo;

                                if ($preruseniDo > $preruseniOd) {
                                    $soucet -= ($preruseniDo - $preruseniOd) / ($slot ->casDo - $slot ->casOd);
                                }
                            }
                        }
                    }
                }

                $radek ->data[$indexDne] =
                    "<div class='soucet_slotu'>" .
                    "<span class='skutecny_pocet'>"  . StringUtils::format('number_1', $soucet) . "</span>" .
                    "<span class='pozadovany_pocet'>" . $slot ->pocetMin . "</span>" .
                    "</div>";
//                    StringUtils::format('number_1', $soucet) .
//                    ($slot ->pocetMin ? '<span class="pozadovany_pocet">/' . $slot ->pocetMin . '</span>' : '');

                if ($slot ->pocetMin) {
                    if ($soucet < $slot ->pocetMin) {
                        $radek ->classes[$indexDne] = 'missing';
                    }
                    else if ($soucet > $slot ->pocetMin) {
                        $radek ->classes[$indexDne] = 'raising';
                    }
                }
            }
        }

        usort($soucty, function($item1, $item2) {
            return PodminkaPlanovaniKapacit::compare($item1 ->slot, $item2 ->slot);
        });

        return $soucty;
    }



    public function spocitejSoucty()
    {
        $this ->soucty = [];

        // doplni casove slozky z DenniCasovaSlozka_R
        foreach ($this ->data ->soucty as $souctyCS) {
            $radek = new PlanovaniKapacitView_SouctovyRadek();
            $radek ->nadpis = $souctyCS ->nadpis;
            $radek ->data = $souctyCS ->data;

            $this ->soucty[] = $radek;
        }

        // doplni soucty podle slotu
        if ($this ->rezim === self::REZIM_SLOTY) {
            $souctyProSloty = $this ->spocitejSouctyProSloty();
            $this ->soucty = array_merge($this ->soucty, $souctyProSloty);
        }
    }


    /**
     * @throws DBException
     */
    public function load()
    {
        $this ->rezim = (int)NastaveniUzivatele::getUserSettingsItem($this ->database, KapacityFilterForm::REZIM_UPRAV,
            RonPortalSettings::getIntValue('kapacity_rezim'));

        $style = '';
        if ($val = RonPortalSettings::getIntValue($this ->rezim === self::REZIM_KOMBINOVANE ? 'kapacity_sirka_kombi' : 'kapacity_sirka_pasivni')) {
            $style .= ".planovani_bunka { width:{$val}px; }";
        }

        if ($val = RonPortalSettings::getIntValue($this ->rezim === self::REZIM_KOMBINOVANE ? 'kapacity_vyska_kombi' : 'kapacity_vyska_pasivni')) {
            $style .= ".planovani_datarows tr, .planovani_bunka { height: {$val}px; }";
        }

        if ($style) {
            //HtmlHeaders::getInstance()->addHeader('<style>.planovani_obsahbunky{ ' .$style . ' }</style>');
            HtmlHeaders::getInstance()->addHeader("<style>$style</style>");
        }

        $this ->filterForm = new KapacityFilterForm($this ->database, 'kapacity', true);
        $this ->filterForm ->nastavProPlanovaniObdobi();

        $this ->filterForm ->loadData();

        try {
            $this->data = new PlanovaniKapacit($this->database);

            if ($this ->filterForm ->getFilterValue('osoba')) {
                $this ->data ->idPP = $this ->filterForm ->getFilterValue('osoba');
            }

            $this->data->nactiDataProHtml(
                $this->filterForm->getOmezitObdobiOd(), $this->filterForm->getOmezitObdobiDo(),
                $this->filterForm->getFilterValue('rozdeleni'), $this->filterForm->getFilterValue('rozdeleni', 'vcetnePodrizenych'),
                $this->filterForm->getFilterValue('rozdeleni2'), $this->filterForm->getFilterValue('rozdeleni2', 'vcetnePodrizenych'),
                $this->rezim === self::REZIM_UPRAVENY || $this->rezim === self::REZIM_SLOTY);

            if ($this->rezim === self::REZIM_SLOTY) {
                $this->nactiSloty();
                $this->data->doplnSloupecProSlot();
            } else {
                $this->pocetRadkuNaOsobu = 1;
            }
        } catch (\Exception $e) {
            MessageManager::addErrorMessage($e);
            $this ->data = null;
        }

        $this->schvaleniPoctuOK = true;

        if ($this ->data) {
            $this->reportList = Report::loadFormReports($this->database, 'PrehledKapacit', 'PlanovaniKapacitP'); // Jen sestavy pro pasivni. Treti parametr z duvodu kompatibility.

            if (Prava::vratPrava('kapacity_edit')->priznak2) {
                // overi, jestli jsou schvalene sloty
                $schvaleni = SchvaleniPodminekPlanovani::nactiSchvaleni($this->database, $this->data->datumOd, KapacitySettings::typRozdeleniProVyber(), $this->data->rozdeleni);
                $this->schvaleniPoctuOK = $schvaleni->lzePlanovatDen($this->data->datumDo);
            }

            $this->zpracujData();
            $this->spocitejSoucty();
        }
    }


    public function renderFiltr()
    {
        $this->filterForm ->render();

        //$rozdeleniStr = $this ->data ->f_rozdeleni != '' ? '&rozdeleni=' . StringUtils::htmlTextConvert($this ->data ->f_rozdeleni) : '';
        $rozdeleniStr = $this ->data ->rozdeleni != ''
            ? '&rozdeleni=' . rawurlencode($this ->data ->rozdeleni)
            : '';

        if ($rozdeleniStr) {
            $rozdeleniStr .= '&vcetnepodrizenych=' . $this ->data ->rozdeleniVcetnePodrizenych;
        }

        if (RonPortalSettings::getIntValue(KapacitySettings::KAPACITY_EDITACE) && Prava::vratHodnotuPrava('kapacity_edit')) {
            if ($this ->schvaleniPoctuOK) {
                // tlacitko pro editaci
                echo '<input class="button clickHref" type="button" data-ron-href="?menuid=' . ($this->rezim === self::REZIM_SLOTY ? 'planovanislotu' : 'planovanikapacit') .
                    '&obdobi=' . DateUtils::dateToUrlString($this->data->datumOd) . $rozdeleniStr .
                    ($this ->filterForm ->getFilterValue('osoba') ? '&osoba=' . $this ->filterForm ->getFilterValue('osoba') : '') . '"' .
                    ' value="' . \Ron\ronText('Planovat') . '"' .
                    '/>';
            } else {
                echo '<div class="errortext">' . \Ron\ronText('Pocty_zamestnancu_jeste_nejsou_schvaleny') . '</div>';
            }
        }


        if (Prava::vratHodnotuPrava('kapacity_pocty') || Prava::vratHodnotuPrava('kapac_schval_poc1') || Prava::vratHodnotuPrava('kapac_schval_poc2') || Prava::vratHodnotuPrava('kapac_schval_poc3')) {
            echo '<a href="?menuid=podminkyplanovani&obdobi=' . DateUtils::dateToUrlString($this ->data ->datumOd) . $rozdeleniStr . '">' . \Ron\ronText('Zobrazit_podminky_planovani') . '</a>';
        }
    }


    /**
     * @throws \Exception
     */
    public function zobrazLegendu($filtrSmeny)
    {
        echo '<div class="planovani_html_legenda">';

        echo '<h2>' . \Ron\ronText('Legenda') . '</h2>';

        //echo '<TABLE><TR><TD>';
        echo '<span class="planovani_html_legenda_smeny">';
        $b = new PlanovaniKapacitLegenda($this ->database, false); // smeny
        $b ->load($filtrSmeny);
        $b ->render();
        echo '</span>';
        //echo '</TD><TD>';

        echo '<span class="planovani_html_legenda_absence">';
        $b = new PlanovaniKapacitLegenda($this ->database, true); // absence
        $b ->load();
        $b ->render();
        echo '</span>';

        //echo '</TD></TR></TABLE>';

        echo "</div>\n";
    }


    public function pocetZobrazenychSloupcuHlavicky($vcetneSlotu)
    {
        if ($this ->pocetRadkuNaOsobu <= 1) {
            // v neslotovem rezimu zobrazi vsechny
            return $this ->data ->sloupceHlavicky ? count($this ->data ->sloupceHlavicky) : 0;
        }

        // ve slotovem rezimu mohou byt nektere hodnoty zobrazene na druhem radku
        $result = 0;
        foreach ($this ->data ->sloupceHlavicky as $sloupec) {
            if (!$sloupec ->dalsiRadek  &&  ($vcetneSlotu || $sloupec ->kodCasoveSlozky !== 'SLOT')) {
                $result ++;
            }
        }

        return $result;
    }


    public function zapisHlavickuHTML()
    {
        $sort = RonPortalSession::getValue('kapacity_sort');

        echo
            '<tr class="last-section-row">'.
            '<th class="align-right"><a href="?menuid=kapacity&kapacity_sort=' . ($sort === 2 ? -2 : 2) . '">' . \Ron\ronText('Osobni_cislo') . '</a></th>' .
            '<th class="align-left"><a href="?menuid=kapacity&kapacity_sort=' . ($sort === 1 ? -1 : 1) . '">' . \Ron\ronText('Jmeno') . '</a></th>';

        // Souctove sloupce
        foreach ($this ->data ->sloupceHlavicky as $index => $sloupec) {
            if (!$sloupec ->dalsiRadek  ||  $this ->pocetRadkuNaOsobu <= 1) {
                $sort = 0; // 0=default, 1=jmeno, 2=osobnicislo, 3=rozdeleni, 101..120=uzivatelska, 201..220=PP.uzivatelska

                switch ($sloupec->kodCasoveSlozky) {
                    case 'R' :
                        $sort = 3;
                        break;

                    case 'U1' :
                        $sort = 101;
                        break;
                    case 'U2' :
                        $sort = 102;
                        break;
                    case 'U3' :
                        $sort = 103;
                        break;
                    case 'U4' :
                        $sort = 104;
                        break;
                    case 'U5' :
                        $sort = 105;
                        break;
                    case 'U6' :
                        $sort = 106;
                        break;
                    case 'U7' :
                        $sort = 107;
                        break;
                    case 'U8' :
                        $sort = 108;
                        break;
                    case 'U9' :
                        $sort = 109;
                        break;
                    case 'U10' :
                        $sort = 110;
                        break;
                    case 'U11' :
                        $sort = 111;
                        break;
                    case 'U12' :
                        $sort = 112;
                        break;
                    case 'U13' :
                        $sort = 113;
                        break;
                    case 'U14' :
                        $sort = 114;
                        break;
                    case 'U15' :
                        $sort = 115;
                        break;
                    case 'U16' :
                        $sort = 116;
                        break;
                    case 'U17' :
                        $sort = 117;
                        break;
                    case 'U18' :
                        $sort = 118;
                        break;
                    case 'U19' :
                        $sort = 119;
                        break;
                    case 'U20' :
                        $sort = 120;
                        break;

                    case 'P1' :
                        $sort = 201;
                        break;
                    case 'P2' :
                        $sort = 202;
                        break;
                    case 'P3' :
                        $sort = 203;
                        break;
                    case 'P4' :
                        $sort = 204;
                        break;
                    case 'P5' :
                        $sort = 205;
                        break;
                    case 'P6' :
                        $sort = 206;
                        break;
                    case 'P7' :
                        $sort = 207;
                        break;
                    case 'P8' :
                        $sort = 208;
                        break;
                    case 'P9' :
                        $sort = 209;
                        break;
                    case 'P10' :
                        $sort = 210;
                        break;
                    case 'P11' :
                        $sort = 211;
                        break;
                    case 'P12' :
                        $sort = 212;
                        break;
                    case 'P13' :
                        $sort = 213;
                        break;
                    case 'P14' :
                        $sort = 214;
                        break;
                    case 'P15' :
                        $sort = 215;
                        break;
                    case 'P16' :
                        $sort = 216;
                        break;
                    case 'P17' :
                        $sort = 217;
                        break;
                    case 'P18' :
                        $sort = 218;
                        break;
                    case 'P19' :
                        $sort = 219;
                        break;
                    case 'P20' :
                        $sort = 220;
                        break;
                }

                if ($sort === RonPortalSession::getValue('kapacity_sort')) {
                    $sort = -$sort; // prepnuti na sestupne
                }

                $className = ($index === count($this->data->sloupceHlavicky) - 1) ? ' last-section-col' : '';
                echo "<th class='align-right$className'>";

                if ($sort) {
                    echo '<a href="?menuid=kapacity&kapacity_sort=' . $sort . '">';
                }
                echo $sloupec->nadpis;
                if ($sort) {
                    echo '</a>';
                }

                echo '</th>';
            }
        }

        // Sloupce pro jednotlive dny
        foreach ($this ->data ->dny as $index => $den) {
            $className =
                $den ->getHtmlClass() .
                ' align-center' .
                (!$index ? ' firstdatacol' : '');

            $styleStr = $den ->barva
                ? 'style="background-color: ' . GuiUtils::getHtmlColor($den ->barva) . '"'
                : '';

            $titleStr = $den ->hint
                ? 'title="' . StringUtils::htmlTextConvert($den ->hint) . '"'
                : '';

            echo "<th class='$className' $styleStr $titleStr>";
            echo $den ->getHeaderHtml();
            echo '</th>';
        }

        echo "</tr>\n";
    }


    public function zapisSchvaleniRozdeleni()
    {
        if (!$this ->data ->schvaleniRozdeleni  ||  !$this ->data ->schvaleniRozdeleni ->jeSchvaleni()) {
            return;
        }

        echo
            '<tbody class="planovani_schvalenirozdeleni">' .
            '<th></th>' .
            '<th class="last-section-col" colspan=' .  (1 + $this ->pocetZobrazenychSloupcuHlavicky(true)) . '"></th>';

        foreach ($this ->data ->dny as $index => $den) {
            echo '<td class="schvaleni_rozdeleni ' . $this ->data ->schvaleniRozdeleni ->getHtmlClassKapacity($den ->datum, $this ->data ->rezimUprav) . '"></td>';
        }

        echo '</tbody>';
    }


    public static function getEditaceTarget()
    {
        global $_kapacitytarget;
        return isset($_kapacitytarget) ? $_kapacitytarget : 'zpracovanadochazkawin';
    }


    /**
     * @param PlanovaniKapacit_Bunka $bunka
     * @param PlanovaniKapacit_PlanovanaAbsence $planovanaAbsence
     * @return string
     */
    public static function getClassPodleAbsence($bunka, $planovanaAbsence)
    {
        if (!$planovanaAbsence) {
            return '';
        }

        switch ($planovanaAbsence ->delka) {
            case 1  :
                return 'planovani_absence planovani_absence1';
            case 2  :
                return 'planovani_absence planovani_absence2';
            case 3  :
                return 'planovani_absence planovani_absence3';

            case 4 : // prubezna - prvni a posledni den teckovany, ostatni plne
                if ($bunka ->datum === $planovanaAbsence ->datumOd  ||  $bunka ->datum === $planovanaAbsence ->datumDo) {
                    return 'planovani_absence planovani_absence3';
                }
        }

        return 'planovani_absence';
    }


    /**
     * @param PlanovaniKapacit_PlanovanaAbsence $absence
     * @param PlanovaniKapacit_Bunka $bunka
     * @param PodminkaPlanovaniKapacit $slot
     * @return bool
     */
    public static function absenceZasahujeDoSlotu($absence, $bunka, $slot)
    {
        if (!$slot) {
            return false;
        }

        switch ($absence ->delka) {
            case 0 :
            case 1 :
            case 2 :
                // cela smena nebo pulka smeny -> zobrazi absenci
                return true;

            case 3 :
                // cas od-do - zobrazi jen kdyz zasahuje do slotu
                // TODO: zkontrolovat cas
                //var_dump($absence); var_dump($slot);
                if ($absence ->casOd >= $slot ->casDo / 3600 ||  $absence ->casDo <= $slot ->casOd / 3600) {
                    return false;
                }
                return true;

            case 4 :
                // cas od-do kontinualne - zobrazi jen kdyz zasahuje do slotu
                if ($bunka ->datum > $absence ->datumOd  &&  $bunka ->datum < $absence ->datumDo) {
                    return true;
                }

                if ($bunka ->datum === $absence ->datumOd  &&  $absence ->casOd >= $slot ->casDo / 3600) {
                    return false;
                }
                if ($bunka ->datum === $absence ->datumDo  &&  $absence ->casDo <= $slot ->casOd / 3600) {
                    return false;
                }
                break;
        }

        return true;
    }


    /**
     * @param PlanovaniKapacit_Osoba   $osoba
     * @param PlanovaniKapacit_Bunka[] $data    Zpracovana data osoby (rodelena do bunek)
     * @param string $kodRozdeleni rozdeleni, pro ktere je planovani zobrazeno - u cizich lidi urcuje editovatelne bunky
     * @param int   $indexSlotu
     */
    public function renderDataOsoby($osoba, $data, $kodRozdeleni, $indexSlotu)
    {
        $povolitRezimUprav = RonPortalSettings::getIntValue(KapacitySettings::POVOLIT_REZIM_UPRAV);

        foreach ($data as $index => $bunka) {
            $cizi = ($bunka ->rozdeleni != $kodRozdeleni) && ($osoba ->cizi || $bunka ->rozdeleni);

            $className = $this ->data ->dny[$index] ->getHtmlClass();
            if (!$index) $className .= ($className ? ' ' : '') . 'firstdatacol';
            $classStr = $className ? " class='$className'" : '';
            echo
                "<td$classStr>" .
                '<div class="planovani_bunka' . ($cizi ? ' planovani_cizi' : '') . '">';

            $indexSlotuProDen = -1;
            if ($this ->rezim === self::REZIM_SLOTY) {
                // najde v danem dni slot pro aktualni radek (sloty mohou byt kazdy den jine)
                for ($i = 0; $i < count($this->data->dny[$index]->sloty) && $indexSlotuProDen < 0; $i++) {
                    if ($this->data->dny[$index]->sloty[$i]->casOd == $this->sloty[$indexSlotu]->casOd
                        && $this->data->dny[$index]->sloty[$i]->casDo == $this->sloty[$indexSlotu]->casDo
                    ) {
                        $indexSlotuProDen = $i;
                    }
                }
            } else {
                // neni slotovy rezim
                $indexSlotuProDen = 0;
            }

            if ($indexSlotuProDen >= 0) {
                // div obarveny podle smeny
                if ($bunka->smena && $bunka->smena->zkratka && $bunka->smena->barva) {
//                $colorStr = GuiUtils::getHtmlColor($bunka ->barva);
//                echo "<div class='planovani_smena' style='background-color: $colorStr'></div>"; // vnejsi div - natahne se pres celou bunku

                    $smenaVisible = true;
                    $positionStyle = '';

                    if ($this->rezim === self::REZIM_SLOTY) {
                        if ($indexSlotuProDen < count($this->data->dny[$index]->sloty)) {
                            $slot = $this->data->dny[$index]->sloty[$indexSlotuProDen];

                            $top = null;
                            $height = null;

                            if ($bunka->smena->delena) {
                                if ($bunka->smena->preruseniOd <= $slot->casOd &&
                                    $bunka->smena->preruseniDo >= $slot->casDo
                                ) {
                                    // cely interval slotu je uvnitr prestavky => nezobrazuje se
                                    $smenaVisible = false;
                                }
                            }

                            if ($bunka->smena->pocatek >= $slot->casDo) {
                                $smenaVisible = false;
                            } else if ($bunka->smena->konec <= $slot->casOd) {
                                $smenaVisible = false;
                            }

                            if ($bunka->smena->delena &&
                                $bunka->smena->preruseniOd <= $slot->casOd &&
                                $bunka->smena->preruseniDo >= $slot->casDo
                            ) {
                                $smenaVisible = false;
                            }

                            if ($smenaVisible) {
                                $pocatek = $bunka->smena->pocatek;
                                if ($bunka->smena->delena && $bunka->smena->preruseniOd <= $slot->casOd) {
                                    $pocatek = $bunka->smena->preruseniDo;
                                }
                                if ($pocatek > $slot->casOd) {
                                    // smena zacina pozdeji nez slot - vybarvi jen cast bunky
                                    $top = 100 * ($pocatek - $slot->casOd) / ($slot->casDo - $slot->casOd);
                                }

                                $konec = $bunka->smena->konec;
                                if ($bunka->smena->delena && $bunka->smena->preruseniDo >= $slot->casDo) {
                                    $konec = $bunka->smena->preruseniOd;
                                }
                                if ($konec < $slot->casDo) {
                                    $height = 100 - 100 * ($slot->casDo - $konec) / ($slot->casDo - $slot->casOd) - ($top ? $top : 0);
                                }

                                if ($top || $height) {
                                    if (!$top) {
                                        $top = 0;
                                    }
                                    if (!$height) {
                                        $height = 100;
                                    }

                                    $positionStyle = " top: " . ($top ? $top . "%" : "0") . "; height: " . $height . "%;";
                                }
                            }
                        } else {
                            // tento slot neni v aktualni den aktivni
                            $smenaVisible = false;
                        }
                    }

                    if ($smenaVisible) {
                        echo
                            "<div class='planovani_smena'" . (($bunka->smena && $bunka->smena->barva) ? ' style="background-color: ' . GuiUtils::getHtmlColor($bunka->smena->barva) . ';' . $positionStyle . '"' : '') . "></div>";
                    }

                }


                // div obarveny podle absence
                $planovanaAbsence = null;
                $classSchvaleniAbsence = '';

                if ($this->rezim === self::REZIM_SLOTY) {
                    if ($indexSlotuProDen < count($this->data->dny[$index]->sloty)) {
                        $slot = $this->data->dny[$index]->sloty[$indexSlotuProDen];
                        // slotove planovani - zobrazi jen absence, ktere zasahuji do slotu
                        foreach ($bunka->seznamAbsenci as $planovanaA) {
                            if (self::absenceZasahujeDoSlotu($planovanaA, $bunka, $slot)) {
                                $planovanaAbsence = $planovanaA;
                            }
                        }
                    }
                } else { // if ($bunka ->zkratkaAbsence) {
                    $planovanaAbsence = $bunka->planovanaAbsence;
                }

                if ($planovanaAbsence) {
                    $className .= ' ' . self::getClassPodleAbsence($bunka, $planovanaAbsence);
                    if ($cizi) $className .= ' planovani_absence_cizi';

                    if (RonPortalSettings::getIntValue(RonPortalSettings::ABSENCE_SCHVALOVANI) && $planovanaAbsence) {
                        switch ($planovanaAbsence->schvaleni) {
                            case 1 :
                                $classSchvaleniAbsence = 'planovani_schvalenaabsence';
                                break; // schvaleno
                            case 2 :
                                $classSchvaleniAbsence = 'planovani_zamitnutaabsence';
                                break; // zamitnuto
                            default :
                                $classSchvaleniAbsence = 'planovani_absencebezschvaleni';
                        }
                    } else {
                        // schvalovani se nepouziva => vzdy schvalena
                        $classSchvaleniAbsence = 'planovani_schvalenaabsence';
                    }

                    $className .= ' ' . $classSchvaleniAbsence;

                    $colorStr = GuiUtils::getHtmlColor($planovanaAbsence->barva);
                    echo "<div class='$className' style='background-color: $colorStr'></div>";
                }

//            if ($bunka ->zkratkaAbsence) $barva = $bunka ->barvaAbsence; // barva absence ma prednost
//            else if ($cizi) $barva = null;
//            else $barva = $bunka ->barva;
//
//            $styleStr = '';
//            if ( isset($barva) ) $styleStr .= ';background-color:' . GuiUtils::getHtmlColor($barva);
//
//            if ($styleStr) $styleStr = 'style="' . $styleStr . '"';

                $class = '';

//            if ($bunka ->zkratkaAbsence) {
//                $class .= ' ' . $osoba ->getClassPodleAbsence($bunka);
//                if ($cizi) $class .= '_cizi';
//            } else {
//                $class .= $cizi ? ' planovani_smena planovani_cizi' : ' planovani_smena';
//            }

//            echo "<DIV class='$class' $styleStr>"; // vnejsi div - natahne se pres celou bunku


                if (!$indexSlotu) {
                    // horni pruh (schvalovani kapacit) - jen v prvnim radku pro osobu
                    if ($bunka->schvaleni === 3) {
                        $title = $osoba ->schvalil3 . ' ' . StringUtils::format('finedatetime', $osoba ->casSchvaleni3);
                        echo "<div class='planovani_schvaleni schvaleni3' title='$title'></div>";
                    }
                    else if ($bunka->schvaleni === 2) {
                        $title = $osoba ->schvalil2 . ' ' . StringUtils::format('finedatetime', $osoba ->casSchvaleni2);
                        echo "<div class='planovani_schvaleni schvaleni2' title='$title'></div>";
                    }
                    else if ($bunka->schvaleni === 1) {
                        $title = $osoba ->schvalil1 . ' ' . StringUtils::format('finedatetime', $osoba ->casSchvaleni1);
                        echo "<div class='planovani_schvaleni schvaleni1' title='$title'></div>";
                    }
                }

                $rozdeleniTitle = $bunka->rozdeleni
                    ? ', ' . \Ron\ronText('Rozdeleni') . ': ' . StringUtils::htmlTextConvert($bunka->rozdeleni)
                    : '';

                if ($bunka->podrobnostiAbsence) {
                    $titleStr = "title='{$bunka ->podrobnostiAbsence}$rozdeleniTitle'";
                }
                else if ($bunka->podrobnostiSmeny) {
                    $titleStr = "title='{$bunka ->podrobnostiSmeny}$rozdeleniTitle'";
                }
                else if ($bunka->rozdeleni) {
                    $titleStr = "title='$rozdeleniTitle'";
                }
                else {
                    $titleStr = '';
                }

                // zkratka smeny nebo absence
                echo "<div class='$classSchvaleniAbsence' $titleStr>";
                $zkratka = ($bunka->smena && $bunka->smena->zkratka)
                    ? $bunka->smena->zkratka // zkratka smeny ma prednost
                    : ($planovanaAbsence->zkratka ?? '');

                if ($zkratka) {
                    echo
                        ($bunka->link ? '<a href="' . $bunka->link . '">' : '') .
                        $zkratka .
                        ($bunka->link ? '</a>' : '');
                } else {
                    echo '&nbsp;';
                }
                echo '</div>';

                // podrobnosti (variabilni) smeny
                echo '<div class="planovani_podrobnosti">' . $bunka->podrobnostiSmeny . '</div>';

                // skutecna absence podle dochazky
                if ($this ->filterForm ->getFilterValue('skutecneabsence')) {
                    echo "<div class='skutecnaabsence'>{$bunka ->skutecnaAbsence}</div>";
                }
                //if (KapacityController::getZobrazitSkuteneAbsence()) echo "<div class='skutecnaabsence'>{$bunka ->skutecnaAbsence}</div>";

                // priznak zmeny planu (sikma cara vpravo dole)
                if ($povolitRezimUprav) {
                    $upravaPlanu =
                        ($bunka->smena && ($bunka->smena->zkratka !== $bunka->smena->zkratka2)) ||
                        $bunka->zkratkaAbsence !== $bunka->zkratkaAbsence2;

                    if ($upravaPlanu) {
                        // doslo ke zmene planu => zobrazi priznak
                        echo '<div class="planovani_dodatecnauprava"></div>';
                    }
                }

                // kontroly
                if ($bunka->kontroly) {
                    echo '<div class="planovani_kontroly">';

                    foreach ($bunka->kontroly as $kontrola) {
                        echo "<span class='inline-glyph fa planovani_kontrola_priznak kontrola_{$kontrola ->kategorie}' title='" .
                            StringUtils::htmlTextConvert($kontrola->popis) . ($kontrola->poznamka ? "\n" . StringUtils::htmlTextConvert($kontrola->poznamka) : '') .
                            "'></span>";
                    }

                    echo '</div>';
                }

                // rozdeleni
                if ($bunka->rozdeleni) {
                    echo
                        '<div class="planovani_cizirozdeleni" title="' . StringUtils::htmlTextConvert($bunka->rozdeleni) . '"' .
                        ($bunka ->barvaRozdeleni ? 'style="background-color: ' . GuiUtils::getHtmlColor($bunka ->barvaRozdeleni) . '"' : '') .
                        '>' .
                        '<div class="planovani_textrozdeleni">' . StringUtils::htmlTextConvert($bunka->rozdeleni) . '</div>' .
                        '</div>';
                }

                // rozdeleni
                if ($bunka->rozdeleni2) {
                    echo
                        '<div class="planovani_rozdeleni2" title="' . StringUtils::htmlTextConvert($bunka->rozdeleni2) . '"' .
                        ($bunka ->barvaRozdeleni2 ? 'style="background-color: ' . GuiUtils::getHtmlColor($bunka ->barvaRozdeleni2) . '"' : '') .
                        '>' .
                        '<div class="planovani_textrozdeleni">' . StringUtils::htmlTextConvert($bunka->rozdeleni2) . '</div>' .
                        '</div>';
                }

                // dokumenty dochazky
                if ($bunka->dokumenty && count($bunka->dokumenty)) {
                    $titleStr = '';
                    foreach ($bunka->dokumenty as $dokument) {
                        $titleStr .= ($titleStr ? "\n" : '') . $dokument->popis . ' (' . $dokument->jmenoSouboru . ')';
                    }

                    echo '<div class="planovani_dokument" title="' . StringUtils::htmlTextConvert($titleStr) . '"></div>';
                }

                // sluzebni cesty
                if ($bunka->sluzebniCesty && count($bunka->sluzebniCesty)) {
                    $titleStr = '';
                    foreach ($bunka->sluzebniCesty as $sc) {
                        if (DateUtils::startOfTheDay($sc->datumOd) < DateUtils::startOfTheDay($sc->datumDo)) {
                            $titleStr .= StringUtils::format('date', $sc->datumOd) . ' - ' . StringUtils::format('date', $sc->datumDo) . ' ';
                        }

                        $titleStr .= $sc->popis . "\n";
                    }

                    $linkStr = "data-ron-href='?menuid=sluzebnicesty&record={$bunka ->sluzebniCesty[0] ->id}'";

                    echo '<div class="planovani_sc fa glyph-business-trip clickHref clickLink" ' . $linkStr . ' title="' . StringUtils::htmlTextConvert($titleStr) . '"></div>';
                }


                if ($povolitRezimUprav && $this->rezim === self::REZIM_KOMBINOVANE) {
                    // kombinovane zobrazeni rezim planu + uprav
                    $barva2 = null;
                    if ($bunka->zkratkaAbsence2) $barva2 = $bunka->barvaAbsence2;
                    else if ($bunka->smena && $bunka->smena->zkratka2) $barva2 = $bunka->smena->barva2;

                    $styleStr = $barva2
                        ? ' style=";background-color:' . GuiUtils::getHtmlColor($barva2) . '"'
                        : '';

                    $className = 'planovani_upravaplanu';

                    if ($bunka->zkratkaAbsence2) {
                        $className .= ' ' . self::getClassPodleAbsence($bunka, $bunka->planovanaAbsence);
                        if ($cizi) $className .= ' planovani_absence_cizi';
                    } else {
                        $className .= $cizi ? ' planovani_cizi' : ' planovani_smena';
                    }

                    $text = ($bunka->smena && $bunka->smena->zkratka2)
                        ? $bunka->smena->zkratka2
                        : $bunka->zkratkaAbsence2;

                    echo "<div class='$className'" . $styleStr . '>' . $text . '</div>';
                }

                if ($bunka->dalsiText) echo '<div class="planovani_dennivysledky">' . $bunka->dalsiText . '</div>'; // denni vysledky
            }

            echo '</div>';
            echo "</td>\n";
        }
    }


    /**
     * @param PlanovaniKapacit_Osoba $osoba
     * @param PlanovaniKapacit_Bunka[] $dataOsoby
     * @throws DBException
     */
    public function nactiSkutecneAbsence($osoba, $dataOsoby)
    {
        $params = $this ->database ->createParameters();
        $sql =
            'SELECT Dochazka.Den, Dochazka.Operace,' .
            ' OperaceDochazky.ZkratkaProPlanovani, OperaceDochazky.BarvaProVykresleni' .
            ' FROM Dochazka, OperaceDochazky' .
            ' WHERE OperaceDochazky.Kod = Dochazka.Operace' .
            '  AND OperaceDochazky.Absence = 1' .
            '  AND Dochazka.RC = ' . $params ->addParameter($osoba->rc) .
            '  AND Dochazka.OsobniCislo = ' . $params ->addParameter($osoba->osobniCislo) .
            '  AND Dochazka.DatumNastupu = ' . $params ->addParameter($this ->database ->dateToParam($osoba->datumNastupu)) .
            '  AND Dochazka.Den >= ' . $params ->addParameter($this ->database ->dateToParam($this ->data ->datumOd)) .
            '  AND Dochazka.Den <= ' . $params ->addParameter($this ->database ->dateToParam($this ->data ->datumOd)) .
            ' ORDER BY Dochazka.Den';

        $cursor = $this ->database ->getSqlResult($sql, $params);

        while ($row = $cursor ->fetch()) {
            $datum = $this ->database ->stringToTimestamp($row[0]);
            $index = date('j', $datum) - date('j', $this->data ->datumOd);

            $dataOsoby[$index] ->skutecnaAbsence = $row[2];
            $dataOsoby[$index] ->barvaSkutecnaAbsence = $row[3]; // zatim nepouzito
        }
    }


    /**
     * @param PlanovaniKapacit_Bunka[] $dataOsoby
     * @param int   $den
     * @param array $hodnoty
     */
    public function zapisDenniVysledkyProDen($dataOsoby, $den, $hodnoty)
    {
        $index = date('j', $den) - date('j', $this ->data ->datumOd);

        $dataOsoby[$index] ->dalsiText = '';

        foreach ($hodnoty as $hodnota) {
            $dataOsoby[$index] ->dalsiText .= $hodnota;
        }
    }


    /**
     * Nacteni nastavenych dennich vysledku do jednotlivych bunek
     * @param PlanovaniKapacit_Osoba $osoba
     * @param PlanovaniKapacit_Bunka[] $dataOsoby
     * @throws DBException
     */
    public function nactiDenniVysledky($osoba, $dataOsoby)
    {
        $slozkystr = RonPortalSettings::getValue(PlanovaniKapacit::SETTINGS_CASOVE_SLOZKY_D); // '100:H;#;:<B>;200:D;:</B> ;300:K';
        if (!$slozkystr) {
            return;
        }

        $slozky = explode(';', $slozkystr);

        $kody = [];
        $jednotky = [];
        $hodnoty = [];

        $params = $this ->database ->createParameters();
        $sql =
            'SELECT Den, TypCasoveSlozkyMzdy, Hodiny, Dny, KalendarniDny' .
            ' FROM DenniVysledekVypoctu ' .
            ' WHERE RC = ' . $params ->addParameter($osoba->rc) .
            ' AND OsobniCislo = ' . $params ->addParameter($osoba->osobniCislo) .
            ' AND DatumNastupu = ' . $params ->addParameter($this ->database ->dateToParam($osoba->datumNastupu)) .
            ' AND Den >= ' . $params ->addParameter($this ->database ->dateToParam($this ->data ->datumOd)) .
            ' AND Den <= ' . $params ->addParameter($this ->database ->dateToParam($this ->data ->datumDo)) .
            ' AND ( 0 = 1 '; // pokracuje dale - doplni kody vybranych casovych slozek

        foreach ($slozky as $slozka) {
            $poma = explode(':', $slozka, 2);

            switch ($poma[0]) {
                case '' :
                    $kody[] = '';
                    $jednotky[] = '';
                    $hodnoty[] = $poma[1]; // pokud zacina polozka znakem : zobrazi se cely text za :
                    break;

                case '#' : // ruzne mozne zapisy noveho radku
                case '<BR>' :
                case '<br>' :
                    $kody[] = '';
                    $jednotky[] = '';
                    $hodnoty[] = '<BR/>';
                    break;

                case ' ' :
                    $kody[] = '';
                    $jednotky[] = '';
                    $hodnoty[] = ' ';
                    break;

                default :
                    $kody[] = $poma[0];
                    $jednotky[] = isset($poma[1]) ? $poma[1] : '';
                    $sql .= '  OR  TypCasoveSlozkyMzdy = ' . $params ->addParameter($poma[0]);
                    $hodnoty[] = '';
            }
        }

        $sql .= ')  ORDER BY Den';

        $cursor = $this ->database ->getSqlResult($sql, $params);
        $den = 0;

        while ($row = $cursor ->fetch()) {
            $pomden = $this ->database ->stringToTimestamp($row[0]);
            if ($pomden != $den) {
                // dalsi zaznam uz patri do noveho dne
                if ($den) {
                    // zapise nactena data pro tento den
                    $this ->zapisDenniVysledkyProDen($dataOsoby, $den, $hodnoty);
                    // a vynuluje hodnoty
                    foreach ($kody as $i => $kod) if ($kod) $hodnoty[$i] = '';
                }

                $den = $pomden;
            }

            // nastavi hodnotu
            foreach ($kody as $i => $kod)
                if ($kod == $row[1]) {
                    switch ($jednotky[$i]) {
                        case 'D' :
                            $hodnoty[$i] = StringUtils::format('number_1', $row[3]);
                            break;
                        case 'K' :
                            $hodnoty[$i] = StringUtils::format('number_1', $row[4]);
                            break;

                        default :
                            $hodnoty[$i] = StringUtils::format('hodiny', $row[2]);
                            break;
                    }
                }
        }

        if ($den) $this ->zapisDenniVysledkyProDen($dataOsoby, $den, $hodnoty);
    }


    /**
     * Zpracovani absenci osoby pro prime generovani HTML
     * @param PlanovaniKapacit_Osoba $osoba
     * @param PlanovaniKapacit_Bunka[] $result
     * @param int $datumOd
     * @param int $datumDo
     * @throws \Exception
     */
    protected function zpracujAbsenceOsoby($osoba, $result, $datumOd, $datumDo)
    {
        $nezapocitavaneAbsence = explode(';', RonPortalSettings::getValue('kapacity_absencevesloupci'));

        foreach ($osoba ->seznamAbsenci as $absence) {
            $mindatum = $absence ->datumOd;
            if ($mindatum < $datumOd) $mindatum = $datumOd;

            $maxdatum = $absence ->datumDo;
            if ($maxdatum > $datumDo) $maxdatum = $datumDo;

            for ($datum = $mindatum; $datum <= $maxdatum; $datum = DateUtils::incDayStart($datum, 1)) {
                $index = date('j', $datum) - date('j', $datumOd);

                $result[$index] ->zkratkaAbsence = $absence ->zkratka;

                $result[$index] ->barvaAbsence2 = $absence ->barva2;
                $result[$index] ->zkratkaAbsence2 = $absence ->zkratka2;

                $result[$index] ->planovanaAbsence = $absence;  // tato absence se pouzije pro zobrazeni v bunce

                $result[$index] ->podrobnostiAbsence .=
                    ($result[$index] ->podrobnostiAbsence ? "\n" : '') .
                    $absence ->podrobnostiAbsence;

                if (!$result[$index] ->jeNezapocitavanaAbsence  &&  !in_array($absence ->kod, $nezapocitavaneAbsence)) {
                    $result[$index] ->jeNezapocitavanaAbsence = true;
                }

                $result[$index] ->seznamAbsenci[] = $absence;

                $prava = Prava::vratPrava('absence_schval', 'absence_schval_' . $absence ->kod);
                $zobrazitodkaz = $prava ->lzeZobrazitPP($osoba->idPP, $datumOd, $datumDo);

                if ($zobrazitodkaz) {
                    $result[$index] ->link =
                        '?menuid=absence&action=zobrazabsenci&idpp=' . $osoba->idPP .
                        '&datumod=' . $absence ->datumOd . '&poradi=' . $absence ->poradi .
                        '&backaction=kapacity';
                }
            }
        }
    }


    /**
     * Zpracovani dat osoby pro prime generovani HTML
     * @param PlanovaniKapacit_Osoba $osoba
     * @param int $datumOd
     * @param int $datumDo
     * @return PlanovaniKapacit_Bunka[]
     * @throws \Exception
     */
    public function zpracujDataOsoby($osoba, $datumOd, $datumDo)
    {
        /** @var PlanovaniKapacit_Bunka[] $result */
        $result = [];

        // vytvori seznam datovych bunek
        for ($datum = $datumOd; $datum <= $datumDo; $datum = DateUtils::incDayStart($datum, 1)) {
            $bunka = new PlanovaniKapacit_Bunka();
            $bunka->datum = $datum;

            if ($osoba->schvaleni3 >= $datum) {
                $bunka->schvaleni = 3;
            } else if ($osoba->schvaleni2 >= $datum) {
                $bunka->schvaleni = 2;
            } else if ($osoba->schvaleni1 >= $datum) {
                $bunka->schvaleni = 1;
            } else {
                $bunka->schvaleni = 0;
            }

            $result[] = $bunka;
        }

        foreach ($osoba->seznamSmen as $smena) {
            $index = date('j', $smena->datum) - date('j', $datumOd);

            $result[$index]->smena = $smena;

            //$result[$index] ->barva = $smena ->barva;
            //$result[$index] ->zkratka = $smena ->zkratka;
            $result[$index]->rozdeleni = $smena->rozdeleni;
            $result[$index]->barvaRozdeleni = $smena ->barvaRozdeleni;
            $result[$index]->rozdeleni2 = $smena->rozdeleni2;
            $result[$index]->barvaRozdeleni2 = $smena ->barvaRozdeleni2;

            //if (RonPortalSettings::getIntValue(RonPortalSettings::KAPACITY_POVOLIT_REZIM_UPRAV)) {
            //$result[$index] ->zkratka2 = $smena ->zkratka2;
            //$result[$index] ->barva2 = $smena ->barva2;
            //}

            $textVariabilni = '';
            if ($smena->variabilni) {
                if ($smena->pocatek || $smena->konec) {
                    $textVariabilni =
                        StringUtils::format('minuty', $smena->pocatek / 60) .
                        ' - ' .
                        StringUtils::format('minuty', $smena->konec / 60);
                }

                if ($smena->delka) {
                    $textVariabilni .= ' (' . StringUtils::format('minuty', $smena->delka / 60) . ')';
                }
            }

            $result[$index]->podrobnostiSmeny = $textVariabilni;
        }

        $this->zpracujAbsenceOsoby($osoba, $result, $datumOd, $datumDo);

        if ($osoba->dokumentyDochazky) {
            foreach ($osoba->dokumentyDochazky as $dokument) {
                $index = date('j', $dokument->datum) - date('j', $datumOd);
                $result[$index]->dokumenty[] = $dokument;
            }
        }

        if ($osoba->sluzebniCesty) {
            foreach ($osoba->sluzebniCesty as $sc) {
                $datumSCOd = $sc->datumOd < $datumOd ? $datumOd : $sc->datumOd;
                $datumSCDo = $sc->datumDo > $datumDo ? $datumDo : $sc->datumDo;

                $maxIndex = date('j', $datumSCDo) - date('j', $datumOd);
                for ($index = date('j', $datumSCOd) - date('j', $datumOd); $index <= $maxIndex; $index++) {
                    $result[$index]->sluzebniCesty[] = $sc;
                }
            }
        }

        if ($osoba->kontroly) {
            foreach ($osoba->kontroly as $kontrola) {
                $index = date('j', $kontrola->datum) - date('j', $datumOd);
                if (!$result[$index]->kontroly) {
                    $result[$index]->kontroly = [$kontrola];
                } else {
                    $result[$index]->kontroly[] = $kontrola;
                }
            }
        }


        if ($this ->filterForm ->getFilterValue('skutecneabsence')) {
            $this->nactiSkutecneAbsence($osoba, $result);
        }

        $this->nactiDenniVysledky($osoba, $result);

        return $result;
    }


    /**
     * @throws \Exception
     */
    public function zpracujData()
    {
        $this ->dataOsob = [];

        foreach ($this ->data ->seznamOsob as $index => $osoba) {
            $this ->dataOsob[$index] = $this ->zpracujDataOsoby($osoba, $this ->data ->datumOd, $this ->data ->datumDo);
        }

    }


    public function renderSloupceHlavicky($indexOsoby, $indexSlotu, $dataProDalsiRadek, $pouzeSloty = false) {
        $osoba = $this ->data ->seznamOsob[$indexOsoby];

        // souctove sloupce
        foreach ($this->data->sloupceHlavicky as $i => $sloupec) {
            if ($pouzeSloty) {
                // bunka i data se renderuji jen v pripade, ze je to slot
                $renderData = $renderTH = ($sloupec ->kodCasoveSlozky === 'SLOT');
            } else if ($dataProDalsiRadek) {
                $renderTH = false;
                $renderData = $sloupec ->dalsiRadek;
            } else {
                $renderTH = !$sloupec ->dalsiRadek  ||  $this ->pocetRadkuNaOsobu <= 1;
                $renderData = $renderTH  &&  (!$indexSlotu  ||  $sloupec->kodCasoveSlozky === 'SLOT');
            }

            if ($renderTH) {
                echo "<th class='{$sloupec ->className}'>";
            }

            if ($dataProDalsiRadek  &&  $renderData) {
                echo "<span class='{$sloupec ->className}' title='" . StringUtils::htmlTextConvert($sloupec ->nadpis) . "'>";
            }

            if ($renderData) {
                if ($sloupec->kodCasoveSlozky === 'SLOT') {
                    echo isset($this->sloty[$indexSlotu]) ? $this->sloty[$indexSlotu]->getPopis() : '';
                } else if ($sloupec->kodCasoveSlozky === 'IMG') {
                    // zobrazi sloupecek s ikonami rozdeleni
                    //if (!$indexSlotu && $osoba->ikony) {
                        echo RozdeleniOsob::getIkonyHtml($osoba->ikony);
                    //}
                } else if (isset($osoba->hodnotyHlavicky[$i])) { // !$indexSlotu &&
                    if (isset($osoba->classHlavicky[$i]) && $osoba->classHlavicky[$i]) {
                        echo "<span class='{$osoba ->classHlavicky[$i]}'>";
                    }
                    echo StringUtils::htmlTextConvert($osoba->hodnotyHlavicky[$i]);
                    if (isset($osoba->classHlavicky[$i]) && $osoba->classHlavicky[$i]) {
                        echo "</span>";
                    }
                }
            }

            if ($dataProDalsiRadek  &&  $renderData) {
                echo '</span>';
            }

            if ($renderTH) {
                echo '</th>';
            }
        }
    }


    public function renderCssStyle()
    {
        $style = '';

        foreach ($this ->data ->barvy as $kodRozdeleni => $barva) {
            if ($barva) {
                $style .=
                    ".pk_row_r_{$kodRozdeleni} th, .pk_row_r_{$kodRozdeleni} td { background-color: " . GuiUtils::getHtmlColor($barva) . "; }\n" .
                    ".pk_row_r_{$kodRozdeleni} td.planovani_vikend { background-color: " . GuiUtils::getHtmlColor($barva, 0.95) . "; }\n" // vikend tmavsi
                    ;
            }
        }

        if ($style) {
            echo "<style>\n$style</style>\n";
        }
    }


    /**
     * @throws DBException
     * @throws \Exception
     */
    public function renderData()
    {
        $pravaProhlizeni = Prava::vratPrava('prohlizeni');

        foreach ($this ->data ->seznamOsob as $indexOsoby => $osoba) {
            $dataOsoby = $this ->dataOsob[$indexOsoby];

            for ($indexSlotu = 0;  $indexSlotu < $this ->pocetRadkuNaOsobu;  $indexSlotu++) {
                //$className = $index ? '' : ' firstrow';
                $className = 'pk_row_' . $osoba ->idPP;

                if ($this ->pocetRadkuNaOsobu > 1) {
                    if ($indexSlotu === $this ->pocetRadkuNaOsobu - 1) {
                        $className .= ' last-section-row';
                    }
                } else {
                    if ($indexOsoby === count($this->data->seznamOsob) - 1) {
                        $className .= ' last-section-row';
                    } else if (!$osoba->cizi && $this->data->seznamOsob[$indexOsoby + 1]->cizi) {
                        $className .= ' last-section-row';
                    }
                }
                if ($osoba ->rowClasses) {
                    $className .= ' ' . $osoba ->rowClasses;
                }

                echo
                    "<tr data-idpp='{$osoba->idPP}' class='$className'>";

                // osobni cislo, jmeno
                if (!$indexSlotu) {
                    echo '<th class="align-right">' . StringUtils::htmlTextConvert($osoba->osobniCislo) . '</th>';
                    echo '<th class="align-left">';
                    if ($pravaProhlizeni->lzeZobrazitPP($osoba->idPP)) {
                        $targetstr = self::getEditaceTarget() ? 'target="' . self::getEditaceTarget() . '"' : '';

                        // proklik na zpracovanou dochazku
                        echo
                            '<a href="?menuid=zpracovanadochazka&osoba=' . $osoba->idPP . '&obdobi=' . $this->data->datumOd . '" ' .
                            $targetstr . '>' . StringUtils::htmlTextConvert($osoba->jmenoPrijmeni) .
                            '</a>';
                    } else {
                        echo StringUtils::htmlTextConvert($osoba->jmenoPrijmeni);
                    }
                    echo '</th>';
                } else {
                    echo '<th></th>';
                    if ($indexSlotu === 1) {
                        // data, ktera se maji zobrazit v dalsim radku
                        echo '<th colspan="' . (1 + $this ->pocetZobrazenychSloupcuHlavicky(false)) . '">';
                        $this ->renderSloupceHlavicky($indexOsoby, $indexSlotu, true);
                        echo '</th>';
                    } else {
                        echo '<th></th>';
                    }
                }

                $this ->renderSloupceHlavicky($indexOsoby, $indexSlotu, false, $indexSlotu === 1); // ve druhem radku (index 1) se zobrazi jen sloty

                // data osoby
                $this->renderDataOsoby($osoba, $dataOsoby, $this->data->rozdeleni, $indexSlotu);

                echo "</tr>\n";
            }
        }
    }

}
