<?php
/**
 * stanislav.elbl, 11.06.2015
 */

namespace RonPortal\Kapacity;

use Ron\DateUtils;
use Ron\MessageManager;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\RonPortalSettings;

global $STR_PKZpracovanoDo;     // uz jen pro kompatibilitu starych prekladu!
global $STR_PKZkontrolovanoDo;  // -||-
global $STR_PKSchvalenoDo;      // -||-

$editvisible = isset($_GET['zmenitschvaleni']);
$style = $editvisible ? '' : 'style="display:none"';

$nadpisy = [
    1 => $STR_PKZpracovanoDo ?: TextManager::_('Planovani_schvaleno_do_1') ,
    2 => $STR_PKZkontrolovanoDo ?: TextManager::_('Planovani_schvaleno_do_2'),
    3 => $STR_PKSchvalenoDo ?: TextManager::_('Planovani_schvaleno_do_3')
];

/**
 * @var $this SchvaleniKapacitForm
 */

?>
<div class="planovanikapacit_schvalovani<?= $this ->rezimUprav ? ' rezimUprav' : '' ?>">

    <a name="schvalovani"></a>

    <h2><?= TextManager::_('Schvaleni_kapacit') ?></h2>

    <?php
        MessageManager::getInstance() ->showErrors();
    ?>

    <form method="POST"  name="schvalenikapacit"  action="?menuid=kapacity#schvalovani">
        <input type="hidden" name="obdobi" value="<?= $this->data->datumOd ?>"/>
        <input type="hidden" name="rozdeleni" value="<?= $this->data->rozdeleni ?>"/>
        <input type="hidden" name="rozdeleni2" value="<?= $this->data->rozdeleni2 ?>"/>
        <input type="hidden" name="rezimUprav" value="<?= $this ->rezimUprav ? '1' : '0' ?>" />

        <div class="form large-form schvalenikapacit">
            <div class="form-content">
                <div class="row">
                    <div class="col col-2"></div>
                    <div class="col col-2"><?= TextManager::_('Aktualni_stav_schvaleni') ?></div>
                    <div class="col col-8"><?= TextManager::_('Zmena_schvaleni') ?></div>
                </div>

                <?php for ($i = 1;  $i <= 3;  $i++) {
                    if ($this ->pravaSchvaleni[$i]) {
                ?>
                    <div class="row no-wrap">
                        <div class="col col-2 caption"><?= $nadpisy[$i] ?></div>
                        <div class="col col-2">
                            <?php
                                // aktualni stav
                                $value = '';

                                if ($this ->minSchvaleni[$i] == $this ->maxSchvaleni[$i]) {
                                    if ($this ->minSchvaleni[$i]) $value = date('j.n.Y', $this ->minSchvaleni[$i]);
                                    echo $value;
                                } else {
                                    // (od) - do
                                    if ($this ->minSchvaleni[$i]) echo date('j.n.Y', $this ->minSchvaleni[$i]) . ' - ';
                                    echo date('j.n.Y', $this ->maxSchvaleni[$i]);
                                }
                            ?>
                        </div>

                        <div class="col col-3">
                            <?php
                                // edit
                                if (isset($_GET['zmenitschvaleni']) && $_GET['zmenitschvaleni'] === $i) {
                                    $editvisible = true; // bez javaskriptu
                                }
                                else if (MessageManager::getInstance() ->isError("schvaleni$i")) {
                                    $editvisible = true;
                                } else {
                                    $editvisible = false;
                                }

                                $style = $editvisible ? '' : 'style="display:none"';
                                $className = 'inputDate';
                                if (MessageManager::getInstance() ->isError("schvaleni$i")) {
                                    $className .= ' app_input_error';
                                }

                                if ($editvisible && isset($_POST["schvaleni$i"])) {
                                    $value = StringUtils::htmlTextConvert($_POST["schvaleni$i"]);
                                }
                            ?>
                                <input type='text' size='10' class='<?= $className ?>' maxlength='10' id="pk_schvaleni<?= $i ?>" name="schvaleni<?= $i ?>" <?= $style ?> value='<?= $value ?>'
                                       data-roncalendar-mindate="<?= date('j.n.Y', $this ->data ->datumOd) ?>"
                                       data-roncalendar-maxdate="<?= date('j.n.Y', $this ->data ->datumDo) ?>" />
                                <div class="showcalendar" id="pk_schvaleni_btn<?= $i ?>" data-roncalendar-inputname="schvaleni<?= $i ?>" <?= $style ?>></div>
                                <input type='hidden' id="pk_zmenitschvaleni<?= $i ?>" name='zmenitschvaleni<?= $i ?>' value='<?= $editvisible ? '1' : '0' ?>' />


                            <?php
                                if (!$editvisible) { ?>
                                    <a class="zmenitschvaleni" id="pk_linkzmenitschvaleni<?= $i ?>" data-ron-index="<?= $i ?>" name="linkzmenitschvaleni<?= $i ?>" href="?menuid=kapacity&zmenitschvaleni=<?= $i ?>"><?= TextManager::_('Zmenit') ?></a>
                            <?php } ?>
                        </div>


                        <div class="col col-2">
                            <!-- odkaz "Zrusit" -->
                            <a class="zmenitschvaleni" href="?menuid=kapacity&zrusitschvaleni=<?= $i ?>" data-ron-index="<?= $i ?>" data-ron-new-value=""><?= TextManager::_('Zrusit_schvaleni') ?></a>
                        </div>

                        <div class="col col-3">
                            <!-- odkaz "Do konce obdobi" -->
                            <a class="zmenitschvaleni" href="?menuid=kapacity&nastavitschvaleni=<?= $i ?>" data-ron-index="<?= $i ?>" data-ron-new-value="<?= date('j.n.Y', $this->data->datumDo) ?>"><?= TextManager::_('Schvalit_plan_do') . ' '  . date('j.n.Y', $this->data->datumDo) ?></a>
                        </div>
                    </div>
                <?php
                    }
                }
                ?>
            </div>

            <div class="buttons">
                <div class="row">
                    <div class="col col-4"></div>
                    <div class="col col-7">
                        <input type='submit' id="pk_ulozitschvaleni" class='submitbutton' name='ulozitschvaleni' <?= $style ?>
                               value="<?= TextManager::_('form.Store') ?>"
                               <?php if (RonPortalSettings::getIntValue(KapacitySettings::ZPUSOB_SCHVALOVANI)) { ?>data-kod-rozdeleni="<?= $this ->data ->rozdeleni ?>"
                               <?php } else { ?>data-seznam-pp="<?= $this ->getSeznamPP() ?>"<?php } ?>
                               data-params="obdobi=<?= DateUtils::dateToUrlString($this ->data ->datumOd) ?><?= $this ->data ->rezimUprav ? '&rezimUprav=1' : '' ?>"/>
                        <input type='submit' id="pk_neulozitschvaleni" class='button' name='neulozitschvaleni' <?= $style ?> value="<?= TextManager::_('Cancel') ?>" />
                    </div>
                </div>
            </div>

        </div>
    </form>
</div>

<div id="schvaleni_kapacit_progress" class="rondialog min-width-600px" title="<?= TextManager::_('Schvaleni_kapacit') ?>">
    <div id="schvaleni_progress_info"><?= TextManager::_('Schvaleni_kapacit') . ' ...' ?></div>
    <div id="schvaleni_progress_bar" class="progress"></div>

    <div class="buttons">
        <input type="button" class="button" id="schvaleni_storno" value="<?= TextManager::_('Cancel') ?>" />
    </div>

    <div id="schvaleni_errors"></div>
</div>
