<?php
/**
 * User: pavel.rudol
 * Date: 3.5.2016
 * Time: 12:22
 */

namespace RonPortal\Kapacity;

use Ron\GuiUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\System\Report;

$model = Model::getInstance();

/** @var Zastup $zastup */
$zastup = $model->getData('zastup');

/** @var Report[] $reportList */
$reportList = $model ->getData('reportList');

?>

<h1><?= TextManager::_('Zastup_detail') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div class="form middle-form form-30-70" id="hlavickazastupu">
    <div class="form-content">
        <div class="row" id="hlavickazastupu_datum">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_datum') ?></div>
            <div class="form-col2"><?= StringUtils::format('date',$zastup->datum) ?></div>
        </div>
        <div class="row" id="hlavickazastupu_casod">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_cas_od') ?></div>
            <div class="form-col2"><?= StringUtils::format('time',$zastup->casOd) ?></div>
        </div>
        <div class="row" id="hlavickazastupu_casdo">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_cas_do') ?></div>
            <div class="form-col2"><?= StringUtils::format('time',$zastup->casDo) ?></div>
        </div>
        <div class="row" id="hlavickazastupu_rozdeleni">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_rozdeleni') ?></div>
            <div class="form-col2"><strong><?= StringUtils::htmlTextConvert($zastup->rozdeleniPopis) ?></strong> (<?= StringUtils::htmlTextConvert($zastup->rozdeleni) ?>)</div>
        </div>
        <div class="row" id="hlavickazastupu_pozice">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_pozice') ?></div>
            <div class="form-col2"><?= StringUtils::htmlTextConvert($zastup->kategoriePozicePopis ?: $zastup->pozicePopis) ?></div>
        </div>

        <div class="row schvaleni_zastup">
            <div class="form-col1 caption"><span><?= TextManager::_('Zastup_schvaleni') ?></span></div>
            <div class="form-col2">
                <?php if ($zastup->typSchvaleni) { ?>
                    <?php
                        switch ($zastup->typSchvaleni) {
                            case 1 :
                                $strText = 'Zastup_schvaleni';
                                $cssClass = 'zastup_textschvaleni';
                                break;
                            case 2 :
                                $strText = 'Zastup_zamitnuti';
                                $cssClass = 'zastup_textzamitnuti';
                                break;
                            case 3 :
                                $strText = 'Zastup_zruseni';
                                $cssClass = 'zastup_textzruseni';
                                break;
                            default :
                                $strText = '';
                                $cssClass = '';
                        }
                    ?>
                    <span class="<?= $cssClass ?>">
                        <?= TextManager::_($strText); ?>
                        (<?=  StringUtils::format('date',$zastup->datumSchvaleni) . ' ' . StringUtils::htmlTextConvert($zastup->schvalil) ?>)
                    </span>
                <?php } ?>

                <?php if ($zastup->lzeSchvalit) { ?>
                    <?php if ($zastup->typSchvaleni != 1) { ?>
                        <A href='?menuid=zastup&action=schval&record=<?= $zastup->id ?>'><?= TextManager::_('Zastup_proved_schvaleni') ?></A>
                        &nbsp;&nbsp;&nbsp;
                    <?php } ?>

                    <?php if (($zastup->typSchvaleni != 2) && (!$zastup->idPP)) { ?>
                        <A href = '?menuid=zastup&action=zamitni&record=<?= $zastup->id ?>' ><?= TextManager::_('Zastup_proved_zamitnuti') ?></A>

                    <?php } ?>
                <?php } ?>

                <?php if ($zastup->lzeZrusitPlan) { ?>
                    <A href = '?menuid=zastup&action=zrusplan&record=<?= $zastup->id ?>' ><?= TextManager::_('Zastup_proved_zruseni') ?></A>
                <?php } ?>
            </div>
        </div>


        <div class="row" id="hlavickazastupu_osoba">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_osoba') ?></div>
            <div class="form-col2">
            <?php if ($zastup->idPP) { ?>
                <strong><?= StringUtils::htmlTextConvert($zastup->vratJmenoPrijmeni()) ?></strong>, <?= TextManager::_('Osobni_cislo') . ' ' . StringUtils::htmlTextConvert($zastup->osobniCislo) ?>
                    <?php if ($zastup->lzePriraditOsobu) {
                        echo GuiUtils::changeLocationQuest(TextManager::_('Zastup_priradit'),
                            sprintf(TextManager::_('Zastup_zmenit_osobu'), StringUtils::htmlTextConvert($zastup->vratJmenoPrijmeni())),
                            "?menuid=zastup&action=priradit&formaction=edit&record=" . $zastup->id);
                    } ?>
            <?php } else if ($zastup->lzePriraditOsobu) { ?>
                <a href="?menuid=zastup&action=priradit&formaction=edit&record=<?= $zastup->id ?>"><?= TextManager::_('Zastup_priradit') ?></a>
            <?php } ?>
            </div>
        </div>

        <div class="row" id="hlavickazastupu_duvod">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_duvod') ?></div>
            <div class="form-col2">
                <?= StringUtils::htmlTextConvert($zastup->duvodZadosti) ?>
            </div>
        </div>

        <div class="row" id="hlavickazastupu_poznamka">
            <div class="form-col1 caption"><?= TextManager::_('Zastup_poznamka') ?></div>
            <div class="form-col2"><?= StringUtils::htmlTextConvert($zastup->poznamka) ?></div>
        </div>

        <?php if ($zastup->specifikace) { ?>
            <div class="row" id="hlavickazastupu_specifikace">
                <div class="form-col1"></div>
                <div class="form-col2"><?= StringUtils::htmlTextConvert($zastup->specifikace) ?></div>
            </div>
        <?php } ?>
    </div>

    <?php if ($zastup->lzeEditovat) { ?>
    <div class="buttons">
        <div class="row" id="hlavickazastupu_editace">
            <div class="form-col1"></div>
            <div class="form-col2"><a href="?menuid=zastup&formaction=edit&record=<?= $zastup->id ?>"><?= TextManager::_('Edit') ?></a> </div>
        </div>
    </div>
    <?php } ?>
</div>
<?php 
    FormReportsListView::renderReportList($reportList,
        '?menuid=zastup&action=report&id=' . $zastup->id);
?>
<div>
    <a href="?menuid=zastup"><?= TextManager::_('Zpet_na_seznam') ?></a>
</div>