<?php
/**
 * pavel.rudol, 21.08.2023 13:17
 */

use Ron\Http\Csrf;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use Ron\TextManager;
use RonPortal\Controls\FormReportsListView;
use RonPortal\Mzdy\DaneController;
use RonPortal\Mzdy\VyuctovaniDaneForm;
use RonPortal\Prava;

$model = Model::getInstance();

/** @var VyuctovaniDaneForm $rocniVyuctovaniForm */
$rocniVyuctovaniForm = $model->getData('rocnivyuctovaniform');
$zmenaProhlaseni = $model->getData('zmenaProhlaseni');
$jednoduchyVzhled = $model->getData('jednoduchyVzhled');
$skrytDalsihoPoplatnika = $model->getData('skrytDalsihoPoplatnika');
$reportlist = $model->getData('reportlist');

if ($jednoduchyVzhled) {
    $classStr = 'class="dane_info_skryte"';
} else {
    $classStr = '';
}

$povolitZmenovouCast = false;
//5.10.2023 zakomentovano - zmenovy formular bude samostatne
//if ($rocniVyuctovaniForm->lzePodepsatProhlaseniElektronicky() && $rocniVyuctovaniForm->jeProhlaseniSchvaleno() && $zmenaProhlaseni) {
//    $povolitZmenovouCast = true;
//}

$rok = date('Y', $rocniVyuctovaniForm->rok->value);

MessageManager::getInstance()->showMessages();
?>

<form method="post" id="formularProhlaseni" name="formularProhlaseni" enctype="multipart/form-data" action="?menuid=dane&action=ulozitprohlaseni">
    <input type="hidden" name="osoba" value="<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>">
    <input type="hidden" name="obdobi" value="<?= $rok ?>">
    <?php if ($zmenaProhlaseni) { ?>
        <input type="hidden" name="zmenovacast" value="1">
    <?php } ?>
    <?= Csrf::csrfHiddenInput('prohlaseni_' . $rocniVyuctovaniForm->pracovniPomer->idPP)?>

    <div class='form large-form prohlaseni-poplatnika'>
        <div class="form-content">

            <div class="row">
                <div class="col col-12 col-md-12 center">
                    <h1>
                        <?= $rocniVyuctovaniForm->nadpisProhlaseni() ?>
                    </h1>

                    <?php if ($rocniVyuctovaniForm['ProhlaseniPortalStav'] == 2) { //vraceno mzdovym pracovnikem ?>
                        <div class="errortext align-center">
                            <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['PoznamkaProZamestnance'] ?? TextManager::_('Prohlaseni_vychozi_poznamka_vraceni')) ?>
                        </div>
                    <?php } ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-12 center">
                    <h3>
                        <?= TextManager::_("poplatnik_dane") ?>

                        <?= TextManager::_("zdanovaci_obdobi") ?><sup>1)</sup>&nbsp;&nbsp;

                        <label>
                            <?= $rok ?>
                        </label>
                    </h3>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-12 center">
                    <?= TextManager::_("cinim_prohlaseni") ?>

                    <?php $rocniVyuctovaniForm->renderComboProhlaseni(); ?>

                    <sup>1a)</sup>
                    <?= TextManager::_("Prohlaseni_dle_zakona_38k") ?>
                </div>
            </div>
        </div>


        <?php if ($povolitZmenovouCast) { ?>
            <div class="form-content align-right">
                <span class=""><i class="inline-glyph fa glyph-edit" id="prechod-na-zmenovou-cast"></i></span>
            </div>
        <?php } ?>

        <div class="form-content ram">
            <div class="row">
                <div class="col col-12 col-md-12 font-weight-bold">
                    <?= TextManager::_("identifikace_poplatnika") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4 ">
                    <?= TextManager::_('prijmeni') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->pracovniPomer->prijmeni) ?></span>
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_('Prohlaseni_jmeno_ditete') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->pracovniPomer->jmeno) ?></span>
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_('rodne_cislo') . ": " ?><span class="font-weight-bold font-size-1"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['RodneCislo']) ?></span>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-12 font-weight-bold">
                    <?= TextManager::_("adresa_trvaleho_bydliste") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-3">
                    <?= TextManager::_('mesto') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->mesto) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('ulice') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->ulice) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('obec') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->obecPopis) ?></span>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_('psc') . ": " ?><span class="font-weight-bold"><?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->bydliste->psc) ?></span>
                </div>
            </div>

            <br>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <span class="font-weight-bold"><?= TextManager::_("nerezident_datum_narozeni") ?></span>
                    <span><?= TextManager::_('Datum_narozeni'); ?></span>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::format('date', $rocniVyuctovaniForm['OsobniUdaj.DatumNarozeni']) : '' ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <?= TextManager::_("cislo_typ_dokladu") ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->cisloDokladuNerezidenta) ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->typDokladuNerezidenta) ?>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_("stat_nerezidenta") ?>
                </div>

                <div class="col col-12 col-md-1">
                    <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm->statDokladuNerezidenta) ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-4">
                    <?= TextManager::_("identifikace_ve_statu_danove_rezidence") ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm['CisloDanoveIdentifikace']) : '' ?>
                </div>

                <div class="col col-12 col-md-2">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->typDanovehoIdentifikatoru_popis) : '' ?>
                </div>

                <div class="col col-12 col-md-3">
                    <?= TextManager::_("stat_danoveho_rezidenta") ?>
                </div>

                <div class="col col-12 col-md-1">
                    <?= $rocniVyuctovaniForm['DanovyNerezident'] ? StringUtils::htmlTextConvert($rocniVyuctovaniForm['StatDanoveRezidence']) : '' ?>
                </div>
            </div>
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte1"></div>
        <?php } ?>

        <div id="dane_info_skryte1" <?= $classStr ?>>
            <div class="info"><sup>1)</sup>&nbsp;<?= TextManager::_("za_prve") ?></div>
            <div class="info"><sup>1a)&nbsp;</sup><?= TextManager::_("za_prve_a") ?></div>
        </div>

        <div class="dane_info_doporuceni">
            <?php if ($rocniVyuctovaniForm->pracovniPomer->lzeZobrazitPP(Prava::vratPrava('prohl_osobni'), $rocniVyuctovaniForm['rok'], $rocniVyuctovaniForm['rok'])) { ?>
                <div><a href="?menuid=osobniudaje&osoba=<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>"><?= TextManager::_('Prohlaseni_info_osobni_udaje'); ?></a></div>
            <?php } ?>
        </div>

        <div class="col col-12 col-md-12 center">
            <h3><?= TextManager::_("dle_paragrafu_35ba") ?><sup>2)</sup></h3>
        </div>


        <div class="form-content ram">
            <div class="row">
                <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                    <div class="col col-12 col-md-1 ">
                        <?= TextManager::_('aktualni_stav') ?>
                    </div>

                    <div class="col col-12 col-md-11 ">
                        <?php
                            $checked = $_POST['pozaduji_upravu_slev'] ?? false;
                            ?>
                            <?= TextManager::_('pozaduji_zmenu') ?>
                            <label for="pozaduji_upravu_slev"></label>
                            <input type="checkbox" id="pozaduji_upravu_slev" name="pozaduji_upravu_slev" class="daneToggleDisabled" data-selector=".uprava_slevy_poplatnika" <?= $checked ? 'checked' : '' ?> >

                            <?= $rocniVyuctovaniForm->odpocetNavrhDatumOd ? sprintf(TextManager::_('Prohlaseni_datum_zmeny_slev'), StringUtils::format('date', $rocniVyuctovaniForm->odpocetNavrhDatumOd)) : ''; ?>
                    </div>
                <?php } //lzeEditovat ?>
            </div>


            <div class="row">
                <div class="col col-12 col-md-1 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('zakladni_odpocet_zobrazeni', $rocniVyuctovaniForm->odpocetZakladni);
                        ?>
                    </label>
                </div>

                <!--TODO: po podepsani uzivatelem, zobrazovat navrh zadany uzivatelem do okamziku podepsani ucetni
                zmenit podminku: $hodnotyProhlaseni->datumOdOdpocetNavrhSchvaleno == "" , je nefunkcni, pokud ucetni vrati v karte zamestnance drive schvalene zmeny prohlaseni
                -->
                <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <?php
                            $rocniVyuctovaniForm->renderComboOdpocet('sleva_zakladni_nova',
                                (int)($_POST['sleva_zakladni_nova'] ?? ($rocniVyuctovaniForm->odpocetNavrhDatumOd ? $rocniVyuctovaniForm->odpocetNavrhZakladni : $rocniVyuctovaniForm->odpocetZakladni)),
                                [
                                    'class' => 'uprava_slevy_poplatnika',
                                    'data-old-value-selector' => 'zakladni_odpocet_zobrazeni'
                                ]);
                            ?>
                        </label>
                    </div>
                <?php } ?>

                <div class="col col-12 col-md-10 font-weight-bold">
                    <?= TextManager::_("zakladni_sleva_poplatnika") ?>
                </div>
            </div>

            <div class="row">

                <div class="col col-12 col-md-1 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('na_zdravotni_stav1_zobrazeni', $rocniVyuctovaniForm->odpocetZdravotniStav); //id="na_zdravotni_stav1_zobrazeni"
                        ?>
                    </label>
                </div>

                <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                    <div class="col col-12 col-md-1 ">
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 1) { ?>
                            <label>
                                <?php
                                $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_zdravotni_stav1',
                                    (int)($_POST['sleva_na_zdravotni_stav1'] ?? ($rocniVyuctovaniForm->odpocetNavrhDatumOd ? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav : $rocniVyuctovaniForm->odpocetZdravotniStav)),
                                    [
                                        'class' => 'slevaNaInvaliditu uprava_slevy_poplatnika',
                                        'data-old-value-selector' => 'na_zdravotni_stav1_zobrazeni'
                                    ]);
                                ?>
                            </label>
                        <?php } ?>
                    </div>
                <?php } ?>

                <div class="col col-12 col-md-10 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("zakladni_sleva_na_invaliditu") ?></div>
                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte2"></div>
                    <?php } ?>

                    <div id="dane_info_skryte2" <?= $classStr ?>>
                        <?= TextManager::_("zakladni_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>


            <div class="row">
                <div class="col col-12 col-md-1 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('naZdravotniStav2', $rocniVyuctovaniForm->odpocetZdravotniStav == 2 ? 1 : 0); //id="naZdravotniStav2"
                        ?>
                    </label>
                </div>

                <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                    <div class="col col-12 col-md-1 ">
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 2) { ?>
                            <label>
                                <?php
                                $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_zdravotni_stav2',
                                    (int)($_POST['sleva_na_zdravotni_stav2'] ?? ((($rocniVyuctovaniForm->odpocetNavrhDatumOd ? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav : $rocniVyuctovaniForm->odpocetZdravotniStav) == 2) ? 1 : 0)),
                                    [
                                        'class' => 'slevaNaInvaliditu uprava_slevy_poplatnika',
                                        'data-old-value-selector' => 'naZdravotniStav2'
                                    ]);
                                ?>
                            </label>
                        <?php } ?>
                    </div>
                <?php } ?>

                <div class="col col-12 col-md-10 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("rozsirenou_sleva_na_invaliditu") ?></div>
                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte3"></div>
                    <?php } ?>

                    <div id="dane_info_skryte3" <?= $classStr ?>>
                        <?= TextManager::_("rozsirenou_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>


            <div class="row">
                <div class="col col-12 col-md-1 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('ztpp', $rocniVyuctovaniForm->odpocetZTPP); //id="ztpp_zobrazeni"
                        ?>
                    </label>
                </div>

                <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { //TODO: zobrazovat needitovalny navrh ?>
                    <div class="col col-12 col-md-1 ">
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->drzitelPrukazuZTTP) { ?>
                            <label>
                                <?php
                                $rocniVyuctovaniForm->renderComboOdpocet('sleva_ztpp',
                                    (int)($_POST['sleva_ztpp'] ?? ($rocniVyuctovaniForm->odpocetNavrhDatumOd ? $rocniVyuctovaniForm->odpocetNavrhZTPP : $rocniVyuctovaniForm->odpocetZTPP)),
                                    [
                                        'class' => 'uprava_slevy_poplatnika',
                                        'data-old-value-selector' => 'ztpp'
                                    ]);
                                ?>
                            </label>
                        <?php } ?>
                    </div>
                <?php } ?>

                <div class="col col-12 col-md-10 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_ztp") ?></div>
                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte4"></div>
                    <?php } ?>

                    <div id="dane_info_skryte4" <?= $classStr ?>>
                        <?= TextManager::_("slevu_na_ztp_info") ?>
                    </div>
                </div>
            </div>

            <?php if ($rok < 2024) { //od roku 2024 se sleva na studenta neuplatnuje?>
                <div class="row">
                    <div class="col col-12 col-md-1 ">
                        <label>
                            <?php
                            $rocniVyuctovaniForm->renderComboOdpocet('odpocetNaStudenta_zobrazeni', $rocniVyuctovaniForm->odpocetStudent); //id="odpocetNaStudenta_zobrazeni"
                            ?>
                        </label>
                    </div>

                    <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                        <div class="col col-12 col-md-1 ">
                            <label>
                                <?php
                                $rocniVyuctovaniForm->renderComboOdpocet('sleva_na_studenta_nova',
                                    (int)($_POST['sleva_na_studenta_nova'] ?? ($rocniVyuctovaniForm->odpocetNavrhDatumOd ? $rocniVyuctovaniForm->odpocetNavrhStudent : $rocniVyuctovaniForm->odpocetStudent)),
                                    [
                                        'class' => 'uprava_slevy_poplatnika',
                                        'data-old-value-selector' => 'odpocetNaStudenta_zobrazeni'
                                    ]);
                                ?>
                            </label>
                        </div>
                    <?php } ?>

                    <div class="col col-12 col-md-10 info">
                        <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_studenta") ?></div>
                        <?php if ($jednoduchyVzhled) { ?>
                            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte5"></div>
                        <?php } ?>

                        <div id="dane_info_skryte5" <?= $classStr ?>>
                            <?= TextManager::_("slevu_na_studenta_info") ?>
                        </div>
                    </div>
                </div>
            <?php } ?>

        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte6"></div>
        <?php } ?>

        <div id="dane_info_skryte6" <?= $classStr ?>>
            <div class="info"><sup>2)</sup><?= TextManager::_('za_druhe') ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'odecet', $rocniVyuctovaniForm->lzeEditovatProhlaseni(),
            (($rocniVyuctovaniForm->odpocetZdravotniStav > 0) || ($rocniVyuctovaniForm->odpocetZTPP == 1) || ($rocniVyuctovaniForm->odpocetStudent == 1)));
        ?>

        <div class="col col-12 col-md-12 center">
            <h3><?= TextManager::_("dle_paragrafu_35c") ?><?= TextManager::_("dle_paragrafu_35c_dodatecne") ?><sup>5)</sup><?= TextManager::_("dle_paragrafu_35c_zvyhodneni") ?><sup>3)</sup></h3>
        </div>

        <div class="info"><?= TextManager::_("dle_paragrafu_35_na_mnou_vyzivovane_deti") ?></div>

        <div class="form-content ram">

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("Prohlaseni_jmeno_ditete") ?>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("prijmeni") ?>
                </div>

                <div class="col col-12 col-md-1 ">
                    <?= TextManager::_("rc") ?>
                </div>

                <div class="col col-12 col-md-3 ">
                    <?= TextManager::_("uplatnuji_narok") ?><sup>3)</sup>
                    <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>

                        <?php if (true) /*TODO: kdy???*/ {
                            $uplatnujeOdpocetNaDetiNavrh = false;

                            if (!is_null($rocniVyuctovaniForm->deti)) {
                                foreach ($rocniVyuctovaniForm->deti as $dite) {
                                    if ($dite->poradDiteteNavrh > 0) {
                                        $uplatnujeOdpocetNaDetiNavrh = true;
                                    }
                                }
                            }
                            $checked = (int)($_POST['pozaduji_upravu_poradi_ditete'] ?? $uplatnujeOdpocetNaDetiNavrh);
                            ?>
                            <div><?= TextManager::_('aktualni_stav') ?>
                                <label for="pozaduji_upravu_poradi_ditete">&nbsp;&nbsp;/&nbsp;&nbsp;<?= TextManager::_('pozaduji_zmenu') ?></label>
                                <input type="checkbox" id="pozaduji_upravu_poradi_ditete" name="pozaduji_upravu_poradi_ditete" class="daneToggleDisabled" data-selector=".danovezvyhodneniporadiditete" <?= $checked ? 'checked' : '' ?> ></div>
                        <?php } else { ?>
                            <div><?= TextManager::_('aktualni_stav') ?>&nbsp;&nbsp;/&nbsp;&nbsp;<?= TextManager::_('zmena_slevy_schvalena_mzdovym_pracovnikem') ?></div>
                        <?php } ?>

                    <?php } else { ?>
                        <div><?= TextManager::_('aktualni_stav') ?></div>
                    <?php } ?>
                </div>

                <div class="col col-12 col-md-1 ">
                    <?= TextManager::_("ZTP/P") ?><sup>4)</sup>
                </div>

                <div class="col col-12 col-md-1 ">
                    <?= TextManager::_("zletile_dite") ?><sup>4)</sup>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("dodatecne_za_kalendarni_mesice") ?><sup>5)</sup>
                </div>

            </div>

            <hr class="oddelovac">

            <?php
            $i = 0;
            $uplatnujeOdpocetNaDeti = false;

            if (!is_null($rocniVyuctovaniForm->deti)) {
                foreach ($rocniVyuctovaniForm->deti as $dite) {
                    if ($dite->poradDitete > 0) {
                        $uplatnujeOdpocetNaDeti = true;
                    }
                    ?>

                    <div class="row">
                        <input type="hidden" name="dite_<?= $i ?>" value="<?= $dite->id ?>">

                        <div class="col col-12 col-md-2 ">
                            <?= StringUtils::htmlTextConvert($dite->jmeno) ?>
                        </div>

                        <div class="col col-12 col-md-2 ">
                            <?= StringUtils::htmlTextConvert($dite->prijmeni) ?>
                        </div>

                        <div class="col col-12 col-md-1 ">
                            <?= StringUtils::htmlTextConvert($dite->rodneCislo) ?>
                        </div>

                        <div class="col col-12 col-md-3 ">
                            <label title="<?= TextManager::_('aktualni_stav') ?>">
                                <?php
                                $rocniVyuctovaniForm->renderComboPoradiDitete("poradi_ditete_aktualne_$i", $dite->poradDitete);
                                ?>
                            </label>

                            <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                                <div class="odsazeni_poradi"></div>

                                <label title="<?= TextManager::_('zruseni_nahlaseni_zmeny_poradi_info') ?>">
                                    <?php
                                    $rocniVyuctovaniForm->renderComboPoradiDitete("dite_poradi_navrh_$i", (int)($_POST["poradi_ditete_navrh_$i"] ?? ($dite->datumVlozeniNavrhu ? $dite->poradDiteteNavrh : $dite->poradDitete)),
                                        $uplatnujeOdpocetNaDetiNavrh, ['class' => 'danovezvyhodneniporadiditete']);
                                    ?>
                                </label>
                            <?php } ?>
                        </div>

                        <div class="col col-12 col-md-1 ">
                            <label>
                                <input type="checkbox" <?= $dite->ztpp ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                        <div class="col col-12 col-md-1">
                            <label>
                                <input type="checkbox" <?= $dite->vekNaZacatkuRoku->y >= 18 ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                        <div class="col col-12 col-md-2">
                            <label>
                                <input type="text" class="uplatnujinaditedodatecne" disabled name="<?= "ditedodatecne_$i" ?>" size="12" value="">
                            </label>
                        </div>

                    </div>

                    <?php $i++;
                }
            } ?>
            <input type="hidden" name="pocetdetipoplatnika" value="<?= $i ?>">
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte7"></div>
        <?php } ?>

        <div id="dane_info_skryte7" <?= $classStr ?>>
            <div class="info"><sup>3)</sup>&nbsp;<?= TextManager::_("za_treti") ?></div>
            <div class="info"><sup>4)</sup>&nbsp;<?= TextManager::_("za_ctvrte") ?></div>
            <div class="info"><sup>5)</sup>&nbsp;<?= TextManager::_("za_pate") ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'deti', $rocniVyuctovaniForm->lzeEditovatProhlaseni(),
            $i > 0 && $uplatnujeOdpocetNaDeti);
        ?>

        <?php if ($skrytDalsihoPoplatnika == 0) { ?>

            <div class="col col-12 col-md-12 center">
                <h3><?= TextManager::_("Prohlaseni_dle_paragrafu_38") ?></h3>
            </div>


            <div class="font-weight-bold">a)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_a") ?></span></div>
            <div class="font-weight-bold">b)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_b") ?></div>
            <div class="font-weight-bold">c)&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_c") ?>
                <label for="vyzivujeJinyPoplatnik"></label>
                <?php $rocniVyuctovaniForm->renderComboAnoNe('vyzivujeJinyPoplatnik', (int)($_POST['vyzivujeJinyPoplatnik'] ?? $rocniVyuctovaniForm['VyzivujeJinyPoplatnik']), $rocniVyuctovaniForm->lzeEditovatProhlaseni(),
                    ['class' => 'daneToggleDisabled', 'data-selector' => '.jiny-poplatnik']); ?>
                <sup class="padding-left">6)</sup><sup>6a)</sup>
            </div>

            <br>

            <div class="form-content ram">
                <div class="row">
                    <div class="col col-12 col-md-2 center">
                        <?= TextManager::_("Jmeno") ?>
                    </div>

                    <div class="col col-12 col-md-4 center">
                        <?= TextManager::_("Prijmeni") ?>
                    </div>

                    <div class="col col-12 col-md-3 center">
                        <?= TextManager::_("rodne_cislo") ?>*
                    </div>

                    <div class="col col-12 col-md-2 center">
                        <?= TextManager::_("Prohlaseni_dle_paragrafu_38_uplatnuje") ?>
                    </div>

                    <div class="col col-12 col-md-1 center">
                        <?= TextManager::_("Prohlaseni_dle_paragrafu_38_zamestnani") ?><sup>7)</sup>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row">
                    <div class="col col-12 col-md-2">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikJmenoVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikJmeno']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->jmeno) : '' ?>"
                                   name="jinyPoplatnikJmeno"
                                   readonly="readonly">
                        </label>
                    </div>

                    <div class="col col-12 col-md-4">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikPrijmeniVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikPrijmeni']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->prijmeni) : '' ?>"
                                   name="jinyPoplatnikPrijmeni"
                                   readonly="readonly">
                        </label>
                    </div>


                    <div class="col col-12 col-md-3">
                        <label>
                            <input type="text"
                                   class="pole-zadosti jiny-poplatnik"
                                   id="jinyPoplatnikRCVisible"
                                   value="<?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['JinyPoplatnikRC']) ?>"
                                   data-poplatnik-hidden="<?= isset($rocniVyuctovaniForm->partnerPoplatnika) ? StringUtils::htmlTextConvert($rocniVyuctovaniForm->partnerPoplatnika->rodneCislo) : '' ?>"
                                   name="jinyPoplatnikRC"
                                   readonly="readonly">
                        </label>
                    </div>

                    <div class="col col-12 col-md-2">

                        <label for="partner_zamestnan"></label>
                        <?php $rocniVyuctovaniForm->renderComboAnoNe('jinyPoplatnikUplatnujeZv', isset($_POST['jinyPoplatnikUplatnujeZv']) ? (int)$_POST['jinyPoplatnikUplatnujeZv'] : ($rocniVyuctovaniForm['JinyPoplatnikUplatnujeZv'] ?? 0), false,
                            ['class' => 'pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane']); ?>

                    </div>

                    <div class="col col-12 col-md-1">
                        <?php $rocniVyuctovaniForm->renderComboAnoNe('jinyPoplatnikZamestnani', isset($_POST['jinyPoplatnikZamestnani']) ? (int)$_POST['jinyPoplatnikZamestnani'] : ($rocniVyuctovaniForm['JinyPoplatnikZamestnani'] ?? 0), false,
                            ['class' => 'pole-zadosti jiny-poplatnik prohlaseni-poplatnika-dane daneToggleDisabled', 'data-selector' => '.jiny-poplatnik-zamestnavatel']); ?>
                    </div>

                </div>


                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_adresa') ?> </div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikObec') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikObec" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->obecPopis ?>"
                               value="<?= isset($_POST["jinyPoplatnikObec"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikObec"]) : $rocniVyuctovaniForm['JinyPoplatnikObec'] ?>" disabled>
                    </div>
                </div>


                <div class="row align-center">
                    <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlice" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->ulice ?>"
                               value="<?= isset($_POST["jinyPoplatnikUlice"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikUlice"]) : $rocniVyuctovaniForm['JinyPoplatnikUlice'] ?>" disabled>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-3">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik adresa-poplatnika prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSC" data-poplatnik-hidden="<?= $rocniVyuctovaniForm->bydliste->psc ?>"
                                   value="<?= isset($_POST["jinyPoplatnikPSC"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikPSC"]) : $rocniVyuctovaniForm['JinyPoplatnikPSC'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_zamestnavatel_nazev') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1">
                        <div></div>
                    </div>


                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikNazevPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikNazevPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikNazevPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikNazevPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <hr class="oddelovac">

                <div class="row align-center">
                    <div class="col col-12 col-md-3 align-left">
                        <div><?= TextManager::_('Prohlaseni_platce_dane_partner_zamestnavatel_adresa') ?> <sup>7)</sup></div>
                    </div>

                    <div class="col col-12 col-md-1 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikObec') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikObecPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikObecPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikObecPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikObecPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikUlice') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                               name="jinyPoplatnikUlicePlatce"
                               value="<?= isset($_POST["jinyPoplatnikUlicePlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikUlicePlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikUlicePlatce'] ?>" disabled>
                    </div>
                </div>

                <div class="row align-center">
                    <div class="col col-12 col-md-2">
                        <div></div>
                    </div>

                    <div class="col col-12 col-md-2 align-right">
                        <div><?= TextManager::_('Prohlaseni_jinyPoplatnikPSC') . '&nbsp;' ?> </div>
                    </div>

                    <div class="col col-12 col-md-8">
                        <label title="<?= TextManager::_('') ?>">
                            <input type="text" class="pole-zadosti jiny-poplatnik jiny-poplatnik-zamestnavatel zamestnavatel-udaje prohlaseni-poplatnika-dane"
                                   name="jinyPoplatnikPSCPlatce"
                                   value="<?= isset($_POST["jinyPoplatnikPSCPlatce"]) ? StringUtils::htmlTextConvert($_POST["jinyPoplatnikPSCPlatce"]) : $rocniVyuctovaniForm['JinyPoplatnikPSCPlatce'] ?>" disabled>
                        </label>
                    </div>
                </div>

            </div>

            <?php if ($jednoduchyVzhled) { ?>
                <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte8"></div>
            <?php } ?>

            <div id="dane_info_skryte8" <?= $classStr ?>>
                <div class="info">*<sup>)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_doplneni_partnera") ?></div>
                <div class="info"><sup>6)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_6") ?></div>
                <div class="info"><sup>6a)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_6a") ?></div>
                <div class="info"><sup>7)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_7") ?></div>

                <br>

                <div class="info"><?= TextManager::_("Prohlaseni_dle_paragrafu_38_zmena") ?></div>
                <br>
                <div class="info"><?= TextManager::_("Prohlaseni_dle_paragrafu_38_nepravdive_prohlaseni") ?></div>

            </div>

            <?php
            DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'partner', $rocniVyuctovaniForm->lzeEditovatProhlaseni(), isset($rocniVyuctovaniForm->partnerPoplatnika->id));
            ?>
        <?php } ?>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Mzdy_podpisova_cast") ?></h2>
            </div>
        </div>

        <div class="col col-12 col-md-12 center">
            <h3><?= TextManager::_("Mzdy_podpisova_cast_pravdivost") ?></h3>
        </div>


        <div class="form-content ram">
            <div class="row">
                <div class="col col-12 col-md-4 center">
                    <?= TextManager::_("") ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_prokazatelne_ucinene_prohlaseni_poplatnikem"), '<sup>8)</sup>') ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_overeni_platcem_dane"), '<sup>9)</sup>') ?>
                </div>
            </div>


            <hr class="oddelovac">


            <div class="row align-center">
                <div class="col col-12 col-md-4">
                    <div><?= TextManager::_('Mzdy_na_uvedene_zdanovaci_obdobi') ?> </div>
                </div>

                <div class="col col-12 col-md-4">

                    <div> <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['ElektronickyPodpis']) ?> </div>
                </div>

                <div class="col col-12 col-md-4">
                    <div> <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['ElektronickyPodpisUcetni']) ?>  </div>
                </div>
            </div>


            <div class="row align-center">
                <div class="col col-12 col-md-4">
                    <div><?= TextManager::_('Mzdy_dodatecne_na_uvedene_zdanovaci_obdobi') ?> </div>
                </div>

                <div class="col col-12 col-md-4">
                    <div><?php /*TODO ??? */ ?> </div>
                </div>

                <div class="col col-12 col-md-4">
                    <div><?php /*TODO ??? */ ?> </div>
                </div>
            </div>

        </div>
        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte9"></div>
        <?php } ?>

        <div id="dane_info_skryte9" <?= $classStr ?>>
            <div class="info"><sup>8)</sup>&nbsp;<?= TextManager::_("Mzdy_za_osme") ?></div>
            <div class="info"><sup>9)</sup>&nbsp;<?= TextManager::_("Mzdy_za_devate") ?></div>
        </div>

        <?php if ($povolitZmenovouCast) { ?>

    </div>

    <br>

    <div class='form large-form prohlaseni-poplatnika'>

        <div class="row zmenova-cast-scroll">
            <div class="col col-12 col-md-12 center">
                <br>
            </div>
        </div>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_podpisova_cast_zmenove_casti") ?></h2>
            </div>
        </div>

        <br>

        <?php if ($rocniVyuctovaniForm['ProhlaseniPortalStav'] == 1 && $rocniVyuctovaniForm['ProhlaseniPortalZmenaStav'] == 2) { ?>
            <div class="errortext align-center">
                <?= StringUtils::htmlTextConvert($rocniVyuctovaniForm['PoznamkaProZamestnance'] ?? TextManager::_('Prohlaseni_vychozi_poznamka_vraceni')) ?>
            </div>
            <br>
        <?php } ?>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_historie_zmen_v_prubehu_roku") ?></h2>
            </div>
        </div>

        <div class="form-content ram">

            <div class="row">
                <div class="col col-12 col-md-3 center">
                    <?= TextManager::_("Prohlaseni_druh_zmeny") ?>
                </div>

                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny") ?>
                </div>

                <div class="col col-12 col-md-3 center">
                    <?php echo sprintf(TextManager::_("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>') ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>') ?>
                </div>
            </div>

            <hr class="oddelovac">

            <?php
            if (!is_null($rocniVyuctovaniForm->zmenyOdpoctu)) {
                foreach ($rocniVyuctovaniForm->zmenyOdpoctu as $zmenaOdpoctu) { ?>
                    <div class="row align-center">
                        <div class="col col-12 col-md-3">
                            <div class="align-left">
                                <?= $zmenaOdpoctu->popis ?>
                            </div>
                        </div>

                        <div class="col col-12 col-md-2">
                            <div> <?= StringUtils::format('date', $zmenaOdpoctu->zmenaOd) ?> </div>
                        </div>

                        <div class="col col-12 col-md-3">
                            <div> <?= StringUtils::htmlTextConvert($zmenaOdpoctu->elektronickyPodpis) ?> </div>
                        </div>

                        <div class="col col-12 col-md-4">
                            <div> <?= StringUtils::htmlTextConvert($zmenaOdpoctu->elektronickyPodpisUcetni) ?>  </div>
                        </div>
                    </div>

                <?php }
            } ?>
        </div>

        <br>

        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_zmenova_cast") ?></h2>
            </div>
        </div>

        <div class="col col-12 col-md-12 center">
            <h3><?= TextManager::_("Prohlaseni_dle_paragrafu_38_odst_8") ?></h3>
        </div>

        <div class="form-content ram">
            <div class="row">

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('aktualni_stav') ?>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('pozaduji_zmenu') ?>

                    <?php
                    $pozadujeZmenyVPrubehuRoku = (isset($_POST['zmeny_odecet']) && ($_POST['zmeny_odecet'] == 1)) ? "checked" : "";
                    ?>
                    <input type="checkbox" name="zmeny_odecet" value="1" class="daneToggleDisabled" data-selector=".zmeny_odecet" <?= $pozadujeZmenyVPrubehuRoku ?> >
                </div>

                <div class="col col-12 col-md-8 ">
                    <?= TextManager::_("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                    <?php $rocniVyuctovaniForm->renderComboMesicZmeny('mesic_zmeny', $_POST['mesic_zmeny'] ?? null, true, ['class' => 'zmeny_odecet']); ?>
                </div>

            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zakladni_odecet', $rocniVyuctovaniForm->odpocetZakladni) ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">

                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zakladni_odecet_nove', $_POST['zmeny_zakladni_odecet_nove'] ?? $rocniVyuctovaniForm->odpocetNavrhZakladni,
                            [
                                'class' => 'zmeny_odecet',
                            ]);
                        ?>
                    </label>

                </div>

                <div class="col col-12 col-md-8 font-weight-bold">
                    <?= TextManager::_("zakladni_sleva_poplatnika") ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav1', $rocniVyuctovaniForm->odpocetZdravotniStav); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 1) {
                            $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav1_nove', $_POST['zmeny_zdravotni_stav1_nove'] ?? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav,
                                [
                                    'class' => 'zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("zakladni_sleva_na_invaliditu") ?></div>
                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte11"></div>
                    <?php } ?>

                    <div id="dane_info_skryte11" <?= $classStr ?>>
                        <?= TextManager::_("zakladni_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav2', $rocniVyuctovaniForm->odpocetZdravotniStav == 2 ? 1 : 0); ?>
                    </label>
                </div>

                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->stav == 2) {
                            $rocniVyuctovaniForm->renderComboOdpocet('zmeny_zdravotni_stav2_nove', $_POST['zmeny_zdravotni_stav2_nove'] ?? $rocniVyuctovaniForm->odpocetNavrhZdravotniStav == 2 ? 1 : 0,
                                [
                                    'class' => 'slevaNaInvaliditu zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>

                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("rozsirenou_sleva_na_invaliditu") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte12"></div>
                    <?php } ?>

                    <div id="dane_info_skryte12" <?= $classStr ?>>
                        <?= TextManager::_("rozsirenou_sleva_na_invaliditu_info") ?>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_ztpp', $rocniVyuctovaniForm->odpocetZTPP); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php if ($rocniVyuctovaniForm->zdravotniStav->drzitelPrukazuZTTP) {
                            $rocniVyuctovaniForm->renderComboOdpocet('zmeny_ztpp_nove', $_POST['zmeny_ztpp_nove'] ?? $rocniVyuctovaniForm->odpocetNavrhZTPP,
                                [
                                    'class' => 'zmeny_odecet',
                                ]);
                        } ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_ztp") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte13"></div>
                    <?php } ?>

                    <div id="dane_info_skryte13" <?= $classStr ?>>
                        <?= TextManager::_("slevu_na_ztp_info") ?>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php $rocniVyuctovaniForm->renderComboOdpocet('zmeny_odpocet_student', $rocniVyuctovaniForm->odpocetStudent); ?>
                    </label>
                </div>


                <div class="col col-12 col-md-2 ">
                    <label>
                        <?php
                        $rocniVyuctovaniForm->renderComboOdpocet('zmeny_odpocet_student_nove', $_POST['zmeny_odpocet_student_nove'] ?? $rocniVyuctovaniForm->odpocetNavrhStudent,
                            [
                                'class' => 'zmeny_odecet'
                            ]);
                        ?>
                    </label>
                </div>


                <div class="col col-12 col-md-8 info">
                    <div class="font-weight-bold float-left"><?= TextManager::_("slevu_na_studenta") ?></div>

                    <?php if ($jednoduchyVzhled) { ?>
                        <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte14"></div>
                    <?php } ?>

                    <div id="dane_info_skryte14" <?= $classStr ?>>
                        <?= TextManager::_("slevu_na_studenta_info") ?>
                    </div>
                </div>
            </div>
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte15"></div>
        <?php } ?>

        <div id="dane_info_skryte15" <?= $classStr ?>>
            <div class="info"><sup>10)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_10") ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'odecet', true,
            (($rocniVyuctovaniForm->zdravotniStav->stav > 0) || ($rocniVyuctovaniForm->zdravotniStav->drzitelPrukazuZTTP == 1) || ($rocniVyuctovaniForm->odpocetStudent == 1)));
        ?>

        <div class="info"><?= TextManager::_("Prohlaseni_zmenova_cast_naroku_na_deti_info") ?></div>


        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_historie_zmen_slev_na_deti") ?></h2>
            </div>
        </div>

        <div class="form-content ram">

            <div class="row">
                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_jmeno_ditete") ?>
                </div>

                <div class="col col-12 col-md-2 center">
                    <?= TextManager::_("Prohlaseni_poradi_ditete") ?>
                </div>

                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("Prohlaseni_kalendarni_mesic_rozhodnuti_zmeny") ?>
                </div>

                <div class="col col-12 col-md-3 center">
                    <?php echo sprintf(TextManager::_("Prohlaseni_podpis_poplatnika_zmeny"), '<sup>10)</sup>') ?>
                </div>

                <div class="col col-12 col-md-4 center">
                    <?php echo sprintf(TextManager::_("Mzdy_overeni_platcem_dane"), '<sup>9)</sup> <sup>10)</sup>') ?>
                </div>
            </div>

            <hr class="oddelovac">

            <?php
            if (!is_null($rocniVyuctovaniForm->zmenyPoradiDeti)) {
                foreach ($rocniVyuctovaniForm->zmenyPoradiDeti as $dite) { ?>
                    <div class="row align-center">
                        <div class="col col-12 col-md-2">
                            <div class="font-weight-bold">
                                <?= StringUtils::htmlTextConvert($dite->jmeno) ?>&nbsp;<?= StringUtils::htmlTextConvert($dite->prijmeni) ?>
                            </div>
                        </div>

                        <div class="col col-12 col-md-2">
                            <div class="">
                                <?= $dite->poradDitete ?>
                            </div>
                        </div>


                        <div class="col col-12 col-md-1">
                            <div> <?= StringUtils::format('date', $dite->zmenaOd) ?> </div>
                        </div>

                        <div class="col col-12 col-md-3">
                            <div> <?= StringUtils::htmlTextConvert($dite->elektronickyPodpis) ?> </div>
                        </div>

                        <div class="col col-12 col-md-4">
                            <div> <?= StringUtils::htmlTextConvert($dite->elektronickyPodpisUcetni) ?>  </div>
                        </div>
                    </div>

                <?php }
            } ?>
        </div>


        <br>
        <br>


        <div class="row">
            <div class="col col-12 col-md-12 center">
                <h2><?= TextManager::_("Prohlaseni_zmenova_cast_poradi_deti") ?></h2>
            </div>
        </div>


        <div class="form-content ram">


            <div class="row">
                <div class="col col-12 col-md-2 "></div>
                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_('pozaduji_zmenu') ?>

                    <input type="checkbox" name="zmeny_zmena_poradi" class="daneToggleDisabled" data-selector=".danovezvyhodneniporadiditete" value="1">
                </div>

                <div class="col col-12 col-md-4">
                    <?= TextManager::_("Prohlaseni_mesic_zmeny") . "&nbsp;" ?>
                    <?php $rocniVyuctovaniForm->renderComboMesicZmeny('mesic_zmeny_deti', $_POST['mesic_zmeny_deti'] ?? null, true, ['class' => 'danovezvyhodneniporadiditete']); ?>
                </div>

                <div class="col col-12 col-md-4 center"></div>
            </div>


            <br>


            <div class="row">
                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("Prohlaseni_jmeno_ditete") ?>
                </div>

                <div class="col col-12 col-md-2 ">
                    <?= TextManager::_("rc") ?>
                </div>

                <div class="col col-12 col-md-3 ">
                    <?= TextManager::_("uplatnuji_narok") ?><sup>11)</sup>
                </div>


                <div class="col col-12 col-md-3 center">
                    <?= TextManager::_("Prohlaseni_zmena_poradi") ?>
                </div>


                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("ZTP/P") ?><sup>4)</sup>
                </div>

                <div class="col col-12 col-md-1 center">
                    <?= TextManager::_("zletile_dite") ?><sup>4)</sup>
                </div>

            </div>

            <hr class="oddelovac">

            <?php
            $i = 0;

            if (!is_null($rocniVyuctovaniForm->deti)) {

                $uplatnujeOdpocetNaDeti = false;
                foreach ($rocniVyuctovaniForm->deti as $dite) {
                    if ($dite->poradDitete > 0) {
                        $uplatnujeOdpocetNaDeti = true;
                    }

                    ?>

                    <input type="hidden" name="zmeny_dite_<?= $i ?>" value="<?= $dite->id; ?>">

                    <div class="row">
                        <div class="col col-12 col-md-2">
                            <input type="hidden" name="zmeny_dite_<?= $i ?>" value="<?= $dite->id; ?>">
                            <?= StringUtils::htmlTextConvert($dite->jmeno) ?>&nbsp;<?= StringUtils::htmlTextConvert($dite->prijmeni) ?>
                        </div>

                        <div class="col col-12 col-md-2">
                            <?= $dite->rodneCislo ?>
                        </div>

                        <div class="col col-12 col-md-3 center">
                            <?= ($dite->poradDitete == 0) ? "N" : $dite->poradDitete ?>
                        </div>

                        <div class="col col-12 col-md-3 center">

                            <label title="<?= TextManager::_('zruseni_nahlaseni_zmeny_poradi_info') ?>">
                                <?php
                                $rocniVyuctovaniForm->renderComboPoradiDitete("zmeny_poradi_ditete_navrh_$i", $_POST["zmeny_poradi_ditete_navrh_$i"] ?? '', true,
                                    ['class' => 'danovezvyhodneniporadiditete'], true);
                                ?>
                            </label>

                        </div>

                        <div class="col col-12 col-md-1 center">
                            <label>
                                <input type="checkbox" <?= $dite->ztpp ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                        <div class="col col-12 col-md-1 center">
                            <label>
                                <input type="checkbox" <?= $dite->vekNaZacatkuRoku->y >= 18 ? 'checked' : "" ?> value="1" disabled>
                            </label>
                        </div>

                    </div>

                    <?php $i++;
                }
            } ?>
            <input type="hidden" name="pocetDetiZmenyPoradi" value="<?= $i ?>">
        </div>

        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-info dane_info" data-selector="#dane_info_skryte16"></div>
        <?php } ?>

        <div id="dane_info_skryte16" <?= $classStr ?>>
            <div class="info"><sup>11)</sup>&nbsp;<?= TextManager::_("Prohlaseni_dle_paragrafu_38_za_11") ?></div>
        </div>

        <?php
        DaneController::zobrazDokumenty($rocniVyuctovaniForm->database, $rok, $rocniVyuctovaniForm->pracovniPomer, 'deti', true, $i > 0 && $uplatnujeOdpocetNaDeti);
        ?>

        <?php } ?>
<!--TODO: podpisova cast u zmenoveho formulare -->
        <br>
        <?php if ($jednoduchyVzhled) { ?>
            <div class="fa inline-glyph glyph-warning dane_info" data-selector="#dane_info_skryte10"></div>
        <?php } ?>

        <div id="dane_info_skryte10" <?= $classStr ?>>
            <div class="info font-weight-bold"><?= TextManager::_("Prohlaseni_upozorneni_zmenova_cast_tucne") ?></div>
            <div class="info"><?= TextManager::_("Prohlaseni_upozorneni_zmenova_cast") ?></div>
        </div>

        <div class="buttons">
            <input type="button" class="button clickHref" data-ron-href="?menuid=dane&osoba=<?= $rocniVyuctovaniForm->pracovniPomer->idPP ?>" value="<?= TextManager::_('zpet') ?>">
            <?php if ($rocniVyuctovaniForm->lzeEditovatProhlaseni()) { ?>
                <button type="submit" class="button" name="ulozit" value="1"><?= TextManager::_('zadost_ulozit') ?></button>
                <button type="submit" class="button confirmQuestion" data-ron-confirm-text="<?= TextManager::_('prohlaseni_opravdu_podepsat'); ?>" name="podepsatprohlaseni"
                        value="1"><?= TextManager::_('potvrzuji_pravdivost_prohlaseni') ?></button>
            <?php } ?>

            <?php if ($povolitZmenovouCast) { ?>
                <button type="submit" class="button" id="zmenovaCastProhlaseni" name="zmenovaCastProhlaseni" value="1"><?= TextManager::_('Prohlaseni_zmenova_cast_ulozit') ?></button>
            <?php } ?>
        </div>

    </div>
</form>

<?php
FormReportsListView::renderReportList($reportlist, '?menuid=dane&action=report&typ=prohlaseni&idpp=' . $rocniVyuctovaniForm->pracovniPomer->idPP . '&rok=' . $rok);
?>
