<?php
/**
 * stanislav.elbl 10.6.2020
 */

namespace RonPortal\Pomucky;

use Ron\Controls\ComboBox;
use Ron\MessageManager;
use Ron\StringUtils;

/** @var VelikostiPomucekForm $this */

?>
<h1><?= \Ron\ronText('zmena_velikost_pomucky') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form enctype="multipart/form-data" method="post" name="zmenavelikostipomuckyform">
    <input type="hidden" name="osoba" value="<?= $this ->pp ->idPP ?>"/>

    <div class="form large-form">
        <div class="form-content">
            <div class="row">
                <div class="col col-0 col-sm-3 formtablecaption"></div>
                <div class="col col-12 col-sm-9"><strong><?= $this ->pp ->jmenoPrijmeniKratke ?></strong></div>
            </div>

            <div class="row margin-bottom-2">
                <div class="col col-5 col-sm-3 formtablecaption"><?= \Ron\ronText('osobni_cislo') ?></div>
                <div class="col col-7 col-sm-9"><?= $this ->pp->osobniCislo ?></div>
            </div>

            <?php foreach ($this ->items as $item) { ?>
                <div class="row margin-top-2">
                    <div class="col col-5 col-sm-3 formtablecaption"><?= StringUtils::htmlTextConvert($item ->popisTypuVelikosti) ?></div>
                    <div class="col col-5 col-sm-8">
                        <?php
                        $htmlName =
                            'velikost_' .
                            StringUtils::htmlTextConvert(str_replace(' ', '_', $item ->kodTypuVelikosti)) .
                            ($item ->aktualniHodnoty ? '_' . StringUtils::htmlTextConvert(str_replace(' ', '_', $item ->aktualniHodnoty[0])) : '');
                        ComboBox::renderComboBox($htmlName,
                            $item ->seznamVelikosti,
                            $item ->aktualniHodnoty ? $item ->aktualniHodnoty[0] : null); ?>
                    </div>
                    <div class="col col-2 col-sm-1">
                        <i class="inline-glyph glyph-button fa glyph-delete zrusit-velikost-pomucky comboBoxMove"
                           data-selector="select[name=<?= $htmlName ?>" data-value=""
                           title="<?= \Ron\ronText('Zrusit_nastaveni_velikosti') ?>"></i>
                        <i class="inline-glyph glyph-button fa glyph-new pridat-dalsi-velikost-pomucky toggleClass toggle_velikost_<?= str_replace(' ', '_', StringUtils::htmlTextConvert($item ->kodTypuVelikosti)) ?>"
                           data-selector=".toggle_velikost_<?= str_replace(' ', '_', StringUtils::htmlTextConvert($item ->kodTypuVelikosti)) ?>"
                           data-toggle-class="d-none"
                           title="<?= \Ron\ronText('Pridat_nastaveni_velikosti_pomucky') ?>"></i>
                    </div>
                </div>
                <?php for ($i = 1;  $i < count($item ->aktualniHodnoty);  $i++) { // kazdy typ velikosti muze mit i vice hodnot ?>
                    <div class="row">
                        <div class="col col-5 col-sm-3 formtablecaption"></div>
                        <div class="col col-5 col-sm-8">
                            <?php
                            $htmlName =
                                'velikost_' .
                                str_replace(' ', '_', StringUtils::htmlTextConvert($item ->kodTypuVelikosti . '_' . $item ->aktualniHodnoty[$i]));
                            ComboBox::renderComboBox(
                                $htmlName,
                                $item ->seznamVelikosti,
                                $item ->aktualniHodnoty[$i]); ?>
                        </div>
                        <div class="col col-2 col-sm-1">
                            <i class="inline-glyph glyph-button fa glyph-delete zrusit-velikost-pomucky comboBoxMove"
                               data-selector="select[name=<?= $htmlName ?>" data-value=""
                               title="<?= \Ron\ronText('Zrusit_nastaveni_velikosti') ?>"></i>
                        </div>
                    </div>
                <?php } ?>
                <!-- jeden radek navic pro pridani dalsi hodnoty velikosti - zobrazi se az po kliknuti na ikonku a jenom v pripade, ze prvni radek ma nejakou hodnotu -->
                <?php if ($item ->aktualniHodnoty) { ?>
                    <div class="row d-none toggle_velikost_<?= str_replace(' ', '_', StringUtils::htmlTextConvert($item ->kodTypuVelikosti)) ?>">
                        <div class="col col-5 col-sm-3 formtablecaption"></div>
                        <div class="col col-5 col-sm-8">
                            <?php
                            $htmlName = 'velikost_' . str_replace(' ', '_', StringUtils::htmlTextConvert($item ->kodTypuVelikosti));
                            ComboBox::renderComboBox($htmlName, $item ->seznamVelikosti, null); ?>
                        </div>
                        <div class="col col-2 col-sm-1">
                            <i class="inline-glyph glyph-button fa glyph-delete zrusit-velikost-pomucky comboBoxMove"
                               data-selector="select[name=<?= $htmlName ?>" data-value=""
                               title="<?= \Ron\ronText('Zrusit_nastaveni_velikosti') ?>"></i>
                        </div>
                    </div>
                <?php } ?>
            <?php } ?>
        </div>

        <div class="buttons">
            <div class="row">
                <div class="col col-0 col-sm-3"></div>
                <div class="col col-12 col-sm-9">
                    <input type="submit" name="zapsatvelikosti" class="submitbutton" value="<?= \Ron\ronText('form.Store')?>">
                    <input type="submit" name="zapsatazpet" class="submitbutton" value="<?= \Ron\ronText('ulozit_odejit')?>">
                    <input type="reset"  class="button" value="<?= \Ron\ronText('form.Original') ?>">
                    <input type="submit" name="cancel" class="button" value="<?= \Ron\ronText('Cancel') ?>">
                </div>
            </div>
        </div>
    </div>
</form>
