<?php
/**
 * pavel.rudol, 11.04.2020
 */
namespace RonPortal\Sklad;

use Ron\Controls\ComboBox;
use Ron\DateUtils;
use Ron\GuiUtils;
use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use RonPortal\Prava;
use RonPortal\RonPortalSettings;
use function Ron\ronText;

/** @var VydanaObjednavkaFormular $this */

$model = Model::getInstance();

/** @var VydanaObjednavka $objednavka */
$objednavka =  $model->getData('objednavka');

/** @var ComboBox $comboStredisko */
$comboStredisko = $model->getData('comboStredisko');
/** @var ComboBox $comboRozdeleni1 */
$comboRozdeleni1 = $model->getData('comboRozdeleni1');
/** @var ComboBox $comboRozdeleni2 */
$comboRozdeleni2 = $model->getData('comboRozdeleni2');
/** @var ComboBox $comboRozdeleni3 */
$comboRozdeleni3 = $model->getData('comboRozdeleni3');
/** @var ComboBox $comboRozdeleni4 */
$comboRozdeleni4 = $model->getData('comboRozdeleni4');
/** @var ComboBox $comboRozdeleni5 */
$comboRozdeleni5 = $model->getData('comboRozdeleni5');
/** @var ComboBox $comboMena */
$comboMena = $model->getData('comboMena');

$typRozdeleni1 = $model->getData('typRozdeleni1');
$typRozdeleni1Popis = $model->getData('typRozdeleni1Popis');
$typRozdeleni2 = $model->getData('typRozdeleni2');
$typRozdeleni2Popis = $model->getData('typRozdeleni2Popis');
$typRozdeleni3 = $model->getData('typRozdeleni3');
$typRozdeleni3Popis = $model->getData('typRozdeleni3Popis');
$typRozdeleni4 = $model->getData('typRozdeleni4');
$typRozdeleni4Popis = $model->getData('typRozdeleni4Popis');
$typRozdeleni5 = $model->getData('typRozdeleni5');
$typRozdeleni5Popis = $model->getData('typRozdeleni5Popis');

$editaceFaktury = $model->getData('editacefaktury');

/** @var string $formAction */
$formAction = $model ->getData('formAction');

$pocetNovychRadku = $objednavka->pocetNovychRadku;

$pravaFakturovat = Prava::vratPrava('objednavka_vydana_faktura');

$stornoURL = "?menuid=objednavky&action=detail&record={$objednavka->cisloObjednavky}";

if ($formAction == 'insert') {
    $stornoURL = "?menuid=objednavky";
}
?>
<h1>
    <?php
    if ($formAction == 'insert') {
        if ($objednavka->jeSablona)
            echo ronText('Objednavka_nova_sablona');
        else
            echo ronText('Objednavka_novy_zaznam');
    } else {
        if ($objednavka->jeSablona)
            echo ronText('Objednavka_sablona');
        else
            echo ronText('Objednavka_vydana');
    } ?>
</h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form enctype="multipart/form-data" name="vydanaobjednavkaform" method="post" action="?menuid=objednavky&action=formular<?= $objednavka->cisloObjednavky ? '&record=' . $objednavka->cisloObjednavky : '' ?>">
    <input type="hidden" name="cisloobjednavky" value="<?= $objednavka->cisloObjednavky ?>" />
    <input type="hidden" name="formaction" value="<?= $formAction /* save/insert */?>" />
    <input type="hidden" name="record" value="<?= $objednavka->cisloObjednavky ?>" />
    <input type="hidden" name="deleteRadek" id="objednavka_delete_row" value="" />
    <input type="hidden" name="pocetnovychradku" id="objednavka_pocet_novych_radku" value="<?= $pocetNovychRadku ?>" />
    <?php if ($objednavka->jeSablona) { ?>
        <input type="hidden" name="sablona" value="1" />
    <?php } ?>
    <?php if (!($objednavka->povolitZmenuDodavatele || (!is_null($objednavka->poleProEditaci) && $objednavka->poleProEditaci['dodavatel']))) { ?>
        <input type="hidden" name="dodavatel" value="<?= $objednavka->dodavatel ?>" />
    <?php } ?>
    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['stredisko']) { ?>
        <input type="hidden" name="stredisko" value="<?= $objednavka->stredisko ?>" />
    <?php } ?>
    <?php if ($editaceFaktury) { ?>
        <input type="hidden" name="editacefaktury" value="1" />
    <?php } ?>
    <?php if (!empty($objednavka->faktury)) { ?>
        <input type="hidden" name="pocetFaktur" id="objednavka_pocet_faktur" value="<?= count($objednavka->faktury) ?>" />
        <?php foreach ($objednavka->faktury as $i => $fakturaPrijata) { ?>
            <input type="hidden" name="faktura_cislo_<?= ($i+1) ?>" value="<?= $fakturaPrijata->cisloFaktury ?>" />
        <?php   }
    } ?>
    <?php if ($typRozdeleni1) { ?>
        <input type="hidden" name="typrozdeleni" value="<?= $typRozdeleni1 ?>" />
        <input type="hidden" name="typrozdeleni_popis" value="<?= $typRozdeleni1Popis ?>" />
        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['rozdeleni']) { ?>
            <input type="hidden" name="rozdeleni" value="<?= $objednavka->rozdeleni1->kod ?>" />
        <?php } ?>
    <?php } ?>
    <?php if ($typRozdeleni2) { ?>
        <input type="hidden" name="typrozdeleni2" value="<?= $typRozdeleni2 ?>" />
        <input type="hidden" name="typrozdeleni2_popis" value="<?= $typRozdeleni2Popis ?>" />
        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['rozdeleni2']) { ?>
            <input type="hidden" name="rozdeleni2" value="<?= $objednavka->rozdeleni2->kod ?>" />
        <?php } ?>
    <?php } ?>
    <?php if ($typRozdeleni3) { ?>
        <input type="hidden" name="typrozdeleni3" value="<?= $typRozdeleni3 ?>" />
        <input type="hidden" name="typrozdeleni3_popis" value="<?= $typRozdeleni3Popis ?>" />
        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['rozdeleni3']) { ?>
            <input type="hidden" name="rozdeleni3" value="<?= $objednavka->rozdeleni3->kod ?>" />
        <?php } ?>
    <?php } ?>
    <?php if ($typRozdeleni4) { ?>
        <input type="hidden" name="typrozdeleni4" value="<?= $typRozdeleni4 ?>" />
        <input type="hidden" name="typrozdeleni4_popis" value="<?= $typRozdeleni4Popis ?>" />
        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['rozdeleni4']) { ?>
            <input type="hidden" name="rozdeleni4" value="<?= $objednavka->rozdeleni4->kod ?>" />
        <?php } ?>
    <?php } ?>
    <?php if ($typRozdeleni5) { ?>
        <input type="hidden" name="typrozdeleni5" value="<?= $typRozdeleni5 ?>" />
        <input type="hidden" name="typrozdeleni5_popis" value="<?= $typRozdeleni5Popis ?>" />
        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['rozdeleni5']) { ?>
            <input type="hidden" name="rozdeleni5" value="<?= $objednavka->rozdeleni5->kod ?>" />
        <?php } ?>
    <?php } ?>
    <?php if (!(is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['odeslatmail'])) { ?>
        <input type="hidden" name="odeslatmail" value="<?= $objednavka->odeslatMail ?>" />
    <?php } ?>
    <?php if (!(is_null($objednavka->poleProEditaci)) && ($objednavka->poleProEditaci['radek_dodano'] !== 2)) {
        foreach ($objednavka->radky as $i => $radek) {
            if ($radek->souhlasDodaneMnozstvi) { ?>
                <input type="hidden" name="souhlas_dodano_<?= $radek->cisloRadku ?>" value="<?= $radek->souhlasDodaneMnozstvi ?>" />
            <?php }
        }
    } ?>

    <div class="form large-form form-sm" id="vydana_objednavka">
        <div class="form-content">
            <div class="row">
                <div class="col col-9 col-sm-3 caption"><?= ronText('Cislo_objednavky') ?></div>
                <div class="col col-12 col-sm-6"><?= StringUtils::htmlTextConvert($objednavka->cisloObjednavky) ?></div>
                <div class="col col-3 col-sm-3">
                    <?php GuiUtils::renderCheckbox('odeslatmail', ronText('Odeslat_mail'), $objednavka->odeslatMail,
                        (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['odeslatmail']) ? '' : 'disabled="true"'); ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-9 col-sm-3 caption required"><?= ronText('Datum_vystaveni') ?></div>
                <div class="col col-12 col-sm-6">
                    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['datum_vystaveni']) { ?>
                        <?= StringUtils::format('date', $objednavka->datumVystaveni) ?>
                    <?php } else { ?>
                        <input type='text' class='inputDate'
                               size='10' maxlength='10'
                               name='datum_vystaveni' value='<?= StringUtils::format('date', $objednavka->datumVystaveni ?: DateUtils::today()) ?>'>
                        <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='datum_vystaveni'></i>
                    <?php } ?>
                </div>

            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption<?= $objednavka->jeSablona ? '' : ' required' ?>"><?= ronText('Termin_dodani') ?></div>
                <div class="col col-12 col-sm-6">
                    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['termin_dodani']) { ?>
                        <?= StringUtils::format('date', $objednavka->terminDodani) ?>
                    <?php } else { ?>
                        <input type='text' class='inputDate <?= MessageManager::getClass('termin_dodani'); ?>'
                               size='10' maxlength='10'
                               name='termin_dodani' value='<?= StringUtils::format('date', $objednavka->terminDodani) ?>'>
                        <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='termin_dodani'></i>
                    <?php } ?>
                </div>
                <?php if (!$objednavka->jeSablona) { ?>
                    <div class="col col-3 col-sm-3">
                        <?php GuiUtils::renderCheckbox('odeslano', ronText('Odeslano'), $objednavka->odeslano, 'disabled="true"');
                        if ($objednavka->odeslano) echo "&nbsp;" . StringUtils::format('date', $objednavka->datumCasOdeslani); ?>
                    </div>
                <?php } ?>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption"><?= ronText('Vystavil') ?></div>
                <div class="col col-12 col-sm-6">
                    <?= StringUtils::htmlTextConvert($objednavka->vystavilJmenoPrijmeni) ?>
                </div>
                <?php if (!$objednavka->jeSablona) { ?>
                    <div class="col col-3 col-sm-3">
                        <?php GuiUtils::renderCheckbox('vyrizeno', ronText('Vyrizeno'), $objednavka->vyrizeno,
                            ($objednavka->schvaleno && $pravaFakturovat->lzeZobrazitRC($objednavka->vystavil)) ? '' : 'disabled="true"'); ?>
                    </div>
                <?php } ?>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption required"><?= ronText('Stredisko') ?></div>
                <div class="col col-12 col-sm-9"><?php if (is_null($comboStredisko) || (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['stredisko'])) echo StringUtils::htmlTextConvert($objednavka->strediskoPopis); else $comboStredisko->render(); ?></div>
            </div>

            <?php if ($typRozdeleni1) {  ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni1_zadani_povinne') ? ' required' : '' ?>"><?= StringUtils::htmlTextConvert($typRozdeleni1Popis) ?></div>
                    <div class="col col-12 col-sm-9"><?php
                        if (!is_null($comboRozdeleni1) && (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['rozdeleni'])) {
                            $comboRozdeleni1->render();
                        } else {
                            echo StringUtils::htmlTextConvert($objednavka->rozdeleni1->popis) . ($objednavka->rozdeleni1->kod ?  ' (' . StringUtils::htmlTextConvert($objednavka->rozdeleni1->kod) . ')' : '');
                        }
                        ?></div>
                </div>
            <?php }
            if ($typRozdeleni2) {  ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni2_zadani_povinne') ? ' required' : '' ?>"><?= StringUtils::htmlTextConvert($typRozdeleni2Popis) ?></div>
                    <div class="col col-12 col-sm-9"><?php
                        if (!is_null($comboRozdeleni2) && (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['rozdeleni2'])) {
                            $comboRozdeleni2->render();
                        } else {
                            echo StringUtils::htmlTextConvert($objednavka->rozdeleni2->popis) . ($objednavka->rozdeleni2->kod ?  ' (' . StringUtils::htmlTextConvert($objednavka->rozdeleni2->kod) . ')' : '');
                        }
                        ?></div>
                </div>
            <?php }
            if ($typRozdeleni3) {  ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni3_zadani_povinne') ? ' required' : '' ?>"><?= StringUtils::htmlTextConvert($typRozdeleni3Popis) ?></div>
                    <div class="col col-12 col-sm-9"><?php
                        if (!is_null($comboRozdeleni3) && (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['rozdeleni3'])) {
                            $comboRozdeleni3->render();
                        } else {
                            echo StringUtils::htmlTextConvert($objednavka->rozdeleni3->popis) . ($objednavka->rozdeleni3->kod ?  ' (' . StringUtils::htmlTextConvert($objednavka->rozdeleni3->kod) . ')' : '');
                        }
                        ?></div>
                </div>
            <?php }
            if ($typRozdeleni4) {  ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni4_zadani_povinne') ? ' required' : '' ?>"><?= StringUtils::htmlTextConvert($typRozdeleni4Popis) ?></div>
                    <div class="col col-12 col-sm-9"><?php
                        if (!is_null($comboRozdeleni4) && (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['rozdeleni4'])) {
                            $comboRozdeleni4->render();
                        } else {
                            echo StringUtils::htmlTextConvert($objednavka->rozdeleni4->popis) . ($objednavka->rozdeleni4->kod ?  ' (' . StringUtils::htmlTextConvert($objednavka->rozdeleni4->kod) . ')' : '');
                        }
                        ?></div>
                </div>
            <?php }
            if ($typRozdeleni5) {  ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption<?= RonPortalSettings::getIntValue('vydanaobjednavka_rozdeleni5_zadani_povinne') ? ' required' : '' ?>"><?= StringUtils::htmlTextConvert($typRozdeleni5Popis) ?></div>
                    <div class="col col-12 col-sm-9"><?php
                        if (!is_null($comboRozdeleni5) && (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['rozdeleni5'])) {
                            $comboRozdeleni5->render();
                        } else {
                            echo StringUtils::htmlTextConvert($objednavka->rozdeleni5->popis) .  ($objednavka->rozdeleni5->kod ?  ' (' . StringUtils::htmlTextConvert($objednavka->rozdeleni5->kod) . ')' : '');
                        }
                        ?></div>
                </div>
            <?php } ?>

            <?php if (!$objednavka->povolitZmenuDodavatele && ObjednavkyController::$indexUzivatelskehoFiltruDodavatele) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-3 caption required"><?= StringUtils::htmlTextConvert(ObjednavkyController::$nadpisUzivatelskehoFiltruDodavatele) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?= StringUtils::htmlTextConvert($objednavka->dodavatelUzivatelskeData); ?></div>
                </div>
            <?php } ?>

            <div class="row">
                <div class="col col-12 col-sm-3 caption required"><?= ronText('Dodavatel') . (ObjednavkyController::$indexUzivatelskehoFiltruDodavatele ? ('/' . ObjednavkyController::$nadpisUzivatelskehoFiltruDodavatele) : '') ?></div>
                <div class="col col-12 col-sm-9"><?php
                    if (($objednavka->povolitZmenuDodavatele)) {
                        $this->renderComboDodavatel();
                    } else {
                        echo StringUtils::htmlTextConvert($objednavka->dodavatelPopis);
                    }
                    ?></div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption required"><?= ronText('Popis') ?></div>
                <div class="col col-12 col-sm-9">
                    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['popis']) { ?>
                        <?= StringUtils::htmlTextConvert($objednavka->popis) ?>
                    <?php } else { ?>
                        <input class="form-input <?= MessageManager::getClass('popis') ?>" name="popis" maxlength="80" value="<?= StringUtils::htmlTextConvert($objednavka->popis) ?>" type="text">
                    <?php } ?>
                </div>
            </div>

            <div class="row objednavka_predpokladana_cena">
                <div class="col col-12 col-sm-3 caption"><?= ronText('Predpokladana_cena') ?></div>
                <div class="col col-2 col-sm-2">
                    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['cenapredpoklad']) { ?>
                        <?= StringUtils::format('number2', $objednavka->predpokladanaCena) . "&nbsp;" . StringUtils::htmlTextConvert($objednavka->mena); ?>
                    <?php } else { ?>
                        <input class="inputFloat form-input" name="cenapredpoklad" maxlength="20" value="<?= StringUtils::format('number_2', $objednavka->predpokladanaCena) ?>" type="text">
                    <?php } ?>
                </div>
            </div>

            <div class="row">
                <div class="col col-12 col-sm-3 caption required"><?= ronText('Cena') ?></div>
                <div class="col col-2 col-sm-2 vydana_objednavka_suma">
                    <?= StringUtils::format('number2', $objednavka->cenaCelkem) . (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['mena'] ? "&nbsp;" . StringUtils::htmlTextConvert($objednavka->mena) : '') ?>
                </div>
                <?php if (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['mena']) { ?>
                    <div class="col col-1 col-sm-1">
                        <?php if (!is_null($comboMena)) $comboMena->render(); else echo StringUtils::htmlTextConvert($objednavka->mena); ?>
                    </div>
                <?php } ?>
                <div class="col col-4 col-sm-3">
                    <?= ronText('Cena_info') ?>
                </div>
            </div>

            <?php if (RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA1)) { ?>
                <div class="row row_vydana_objednavka_uziv1">
                    <div class="col col-12 col-sm-3 caption align-top"><?= RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA1) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['uzivatelska1']) { ?>
                            <?= StringUtils::htmlTextConvert($objednavka->uzivatelska1) ?>
                        <?php } else { ?>
                            <input class="form-input" name="uzivatelska1" maxlength="100" value="<?= StringUtils::htmlTextConvert($objednavka->uzivatelska1) ?>" type="text">
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
            <?php if (RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA2)) { ?>
                <div class="row row_vydana_objednavka_uziv2">
                    <div class="col col-12 col-sm-3 caption align-top"><?= RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA2) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['uzivatelska2']) { ?>
                            <?= StringUtils::htmlTextConvert($objednavka->uzivatelska2) ?>
                        <?php } else { ?>
                            <input class="form-input" name="uzivatelska2" maxlength="100" value="<?= StringUtils::htmlTextConvert($objednavka->uzivatelska2) ?>" type="text">
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
            <?php if (RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA3)) { ?>
                <div class="row row_vydana_objednavka_uziv3">
                    <div class="col col-12 col-sm-3 caption align-top"><?= RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA3) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['uzivatelska3']) { ?>
                            <?= StringUtils::htmlTextConvert($objednavka->uzivatelska3) ?>
                        <?php } else { ?>
                            <input class="form-input" name="uzivatelska3" maxlength="100" value="<?= StringUtils::htmlTextConvert($objednavka->uzivatelska3) ?>" type="text">
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
            <?php if (RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA4)) { ?>
                <div class="row row_vydana_objednavka_uziv4">
                    <div class="col col-12 col-sm-3 caption align-top"><?= RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA4) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['uzivatelska4']) { ?>
                            <?= StringUtils::htmlTextConvert($objednavka->uzivatelska4) ?>
                        <?php } else { ?>
                            <input class="form-input" name="uzivatelska4" maxlength="100" value="<?= StringUtils::htmlTextConvert($objednavka->uzivatelska4) ?>" type="text">
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
            <?php if (RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA5)) { ?>
                <div class="row row_vydana_objednavka_uziv5">
                    <div class="col col-12 col-sm-3 caption align-top"><?= RonPortalSettings::getValue(VydanaObjednavka::SETTINGS_UZIVATELSKA5) ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['uzivatelska5']) { ?>
                            <?= StringUtils::htmlTextConvert($objednavka->uzivatelska5) ?>
                        <?php } else { ?>
                            <input class="form-input" name="uzivatelska5" maxlength="100" value="<?= StringUtils::htmlTextConvert($objednavka->uzivatelska5) ?>" type="text">
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>

            <div class="row">
                <div class="col col-12 col-sm-3 caption align-top"><?= ronText('Objednavka_poznamka') ?></div>
                <div class="col col-12 col-sm-9">
                    <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['poznamka']) { ?>
                        <?= StringUtils::longTextToHtml($objednavka->poznamka, true) ?>
                    <?php } else { ?>
                        <textarea name="poznamka" class="form-input" cols="60" rows="3"><?= StringUtils::longTextToHtml($objednavka->poznamka, true) ?></textarea>
                    <?php } ?>
                </div>
            </div>

            <div class="row form-gap">
            </div>

            <?php if ($objednavka->cisloObjednavky && !$objednavka->jeSablona) { ?>
                <div class="row form-section">
                    <div class="col col-12 col-sm-12 align-left"><?= ronText('Objednavka_schvaleni'); ?></div>
                </div>

                <?php if ($objednavka->prekrocenaCenaFaktury) { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-12"><?= ronText('Prekrocena_cena_objednavky') ?></div>
                    </div>
                <?php } ?>

                <div class="row vydana-objednavka-schvaleni1">
                    <div class="col col-12 col-sm-3 caption"><?= ronText('Objednavka_schvaleni_1') ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php $this->renderNastavSchvaleni(1); ?>
                    </div>
                </div>
                <div class="row vydana-objednavka-schvaleni2">
                    <div class="col col-12 col-sm-3 caption"><?= ronText('Objednavka_schvaleni_2') ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php $this->renderNastavSchvaleni(2); ?>
                    </div>
                </div>
                <div class="row vydana-objednavka-schvaleni3">
                    <div class="col col-12 col-sm-3 caption"><?= ronText('Objednavka_schvaleni_3') ?></div>
                    <div class="col col-12 col-sm-9">
                        <?php $this->renderNastavSchvaleni(3); ?>
                    </div>
                </div>
                <?php if ((($objednavka->schvaleni1Stav == 2) || ($objednavka->schvaleni2Stav == 2) || ($objednavka->schvaleni3Stav == 2)) ||
                    (($objednavka->schvaleni1Stav == 3) || ($objednavka->schvaleni2Stav == 3) || ($objednavka->schvaleni3Stav == 3))) { ?>
                    <div class="row vydana-objednavka-poznamka">
                        <div class="col col-12 col-sm-3 caption required">
                            <?php if (($objednavka->schvaleni1Stav == 2) || ($objednavka->schvaleni2Stav == 2) || ($objednavka->schvaleni3Stav == 2)) {
                                echo ronText('Poznamka_k_vraceni'); } else {
                                echo ronText('Poznamka_k_zamitnuti');
                            }
                            ?>
                        </div>
                        <div class="col col-12 col-sm-9">
                            <?= StringUtils::longTextToHtml($objednavka->poznamkaKeSchvaleni, true) ?>
                        </div>
                    </div>
                <?php } ?>
                <?php if ($objednavka->schvaleno) { ?>
                    <div class="row">
                        <div class="col col-12 col-sm-3 caption"></div>
                        <div class="col col-12 col-sm-9"><?php GuiUtils::renderCheckbox('schvaleno', ronText('Schvaleno'), $objednavka->schvaleno, 'disabled="true"'); ?></div>
                    </div>
                <?php } ?>
                <div class="row" id="objednavka_historie">
                    <div class="col col-3 d-xs-none"></div>
                    <div class="col col-12 col-sm-9">
                        <div id="historie_objednavky" class="autoExpand poznamka font-normal">
                            <?= StringUtils::longTextToHtml($objednavka->historieSchvalovani) ?>
                        </div>
                    </div>
                </div>
            <?php } ?>

            <div class="row form-section">
                <div class="col col-6 col-sm-2 align-left"><?= ronText('Zbozi') ?></div>
                <div class="col col-12 col-sm-5 align-left required"><?= ronText('Radek_vydane_objednavky_popis'); ?></div>
                <div class="col col-1 col-sm-1 align-left required"><?= ronText('Radek_vydane_objednavky_mnozstvi'); ?></div>
                <div class="col col-1 col-sm-1 align-left required"><?= ronText('Radek_vydane_objednavky_cena_za_jednotku'); ?></div>
                <div class="col col-1 col-sm-1 align-right"><?= ronText('Radek_vydane_objednavky_cena'); ?></div>
                <div class="col col-2 col-sm-2 align-right"><?= ronText('Radek_vydane_objednavky_datum_dodani'); ?></div>
            </div>

            <?php if (is_array($objednavka->radky)) {
                foreach ($objednavka->radky as $i => $radek) {
                    $rowclassname = ($i % 2) ? 'browsercolor1' : 'browsercolor2';
                    ?>
                    <div class="radekVydaneObjednavky  <?= $rowclassname ?>">
                        <div class="row">
                            <div class="col col-6 col-sm-2">
                                <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['radek_zbozi']) echo StringUtils::htmlTextConvert($radek->kodZbozi); else $this->renderComboZbozi($radek) ?>
                            </div>
                            <div class="col col-12 col-sm-5">
                                <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['radek_popis']) { ?>
                                    <?= StringUtils::htmlTextConvert($radek->popis) ?>
                                <?php } else { ?>
                                    <input class="form-input <?= MessageManager::getClass("popis_{$radek->cisloRadku}"); ?>" name="popis_<?= $radek->cisloRadku ?>" maxlength="60" value="<?= StringUtils::htmlTextConvert($radek->popis) ?>" type="text">
                                <?php } ?>
                            </div>
                            <div class="col col-1 col-sm-1">
                                <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['radek_mnozstvi']) { ?>
                                    <?= StringUtils::format('number_2', $radek->mnozstvi) ?>
                                <?php } else { ?>
                                    <input class="form-input inputFloat vydana_objednavka_prepocet vydana_objednavka_mnozstvi <?= MessageManager::getClass("mnozstvi_{$radek->cisloRadku}"); ?>"
                                           name="mnozstvi_<?= $radek->cisloRadku ?>" size="10" maxlength="10" value="<?= StringUtils::format('number_2', $radek->mnozstvi) ?>" type="text">
                                <?php } ?>
                            </div>
                            <div class="col col-1 col-sm-1">
                                <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['radek_cena']) { ?>
                                    <?= StringUtils::format('number2', $radek->cenaZaJednotku) ?>
                                <?php } else { ?>
                                    <input class="form-input inputFloat vydana_objednavka_prepocet vydana_objednavka_cena_jednotkova <?= MessageManager::getClass("cena_{$radek->cisloRadku}"); ?>"
                                           name="cena_<?= $radek->cisloRadku ?>" size="10" maxlength="10" value="<?= StringUtils::format('number_2', $radek->cenaZaJednotku) ?>" type="text">
                                <?php } ?>
                            </div>
                            <div class="col col-1 col-sm-1 align-right vydana_objednavka_cena">
                                <?= StringUtils::format('number2', $radek->cena) ?>
                            </div>
                            <div class="col col-2 col-sm-2 align-right">
                                <?php if (!is_null($objednavka->poleProEditaci) && !$objednavka->poleProEditaci['radek_datum_dodani']) { ?>
                                    <?= $radek->predpokladaneDatumDodani ? StringUtils::format('date', $radek->predpokladaneDatumDodani) : '' ?>
                                <?php } else { ?>
                                    <div class="input-group form-input">
                                        <input type='text' class='inputDate'
                                               size='10' maxlength='10'
                                               name='datum_dodani_<?= $radek->cisloRadku ?>' value='<?= $radek->predpokladaneDatumDodani ? StringUtils::format('date', $radek->predpokladaneDatumDodani) : '' ?>'>
                                        <i class='showcalendar input-group-text  glyph-button fa glyph-calendar' data-roncalendar-inputname='datum_dodani_<?= $radek->cisloRadku ?>'></i>
                                    </div>
                                <?php } ?>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col col-3 col-sm-2 font-italic">
                                <?php if (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['radek_rozsireny_popis']) { ?>
                                    <?= ronText('Rozsireny_popis'); ?>
                                <?php } ?>
                            </div>
                            <div class="col col-12 col-sm-7">
                                <?php if (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['radek_rozsireny_popis']) { ?>
                                    <textarea name="rozsireny_popis_<?= $radek->cisloRadku ?>" class="form-input" cols="60" rows="3"><?= StringUtils::htmlTextConvert($radek->rozsirenyPopis) ?></textarea>
                                <?php } else { ?>
                                    <?= StringUtils::htmlTextConvert($radek->rozsirenyPopis) ?>
                                <?php } ?>
                            </div>
                            <div class="col col-1 caption">
                                <?= isset($objednavka->poleProEditaci['radek_dodano']) ? ronText('Dodano_mnozstvi') : ''; ?>
                            </div>
                            <div class="col col-1">
                                <?php if (!is_null($objednavka->poleProEditaci) && ($objednavka->poleProEditaci['radek_dodano'] == 2)) { ?>
                                    <input class="form-input inputFloat <?= MessageManager::getClass("dodano_mnozstvi_{$radek->cisloRadku}") ?>"
                                           name="dodano_mnozstvi_<?= $radek->cisloRadku ?>" size="5" maxlength="5" value="<?= StringUtils::format('number_2', $radek->dodanoMnozstvi) ?>" type="text">
                                <?php } else { ?>
                                    <?= StringUtils::format('number_2', $radek->dodanoMnozstvi) ?>
                                <?php } ?>
                            </div>
                            <div class="col col-1 align-right">
                                <?php
                                if (!is_null($objednavka->poleProEditaci) && $objednavka->poleProEditaci['radek_dodano']) {
                                    GuiUtils::renderCheckbox("souhlas_dodano_{$radek->cisloRadku}", ronText('Objednavka_souhlas_mnozstvi'), $radek->souhlasDodaneMnozstvi,
                                        $objednavka->poleProEditaci['radek_dodano'] == 2 ? '' : 'disabled="true"');
                                }
                                if ($objednavka->lzeEditovat()) {
                                    $confirm = '';
                                    $visible = 'js-hide hidden';
                                    if (!$radek->novyRadek) {
                                        $confirm = "data-ron-confirm-text='" . ronText('Opravdu_smazat_radek_objednavky') . "'";
                                        $visible = '';
                                    }
                                    ?>
                                    <i class="inline-glyph glyph-button fa glyph-delete radek_delete <?= $visible ?>" data-cislo-radku="<?= $radek->novyRadek ? '' : $radek->cisloRadku ?>" <?= $confirm ?>></i>
                                <?php } ?>
                            </div>
                        </div>
                        <div class="row form-gap">
                        </div>
                    </div>
                <?php }
            } ?>

            <?php if (is_null($objednavka->poleProEditaci) || $objednavka->poleProEditaci['radek_zbozi']) { ?>
                <div class="row">
                    <div class="col col-12 col-sm-2">
                        <input class="button" type="button" id="novyradek" name="novyradekobjednavky" value="<?= ronText('Novy_radek') ?>" />
                    </div>
                </div>
            <?php } ?>

            <div class="row font-weight-bold font-size-relative-2 margin-top margin-bottom-2">
                <div class="col col-12 col-sm-9">
                    <?= ronText('Soucet'); ?>
                </div>
                <div class="col col-1 col-sm-1 align-right vydana_objednavka_suma" id="vydana_objednavka_suma">
                    <?= StringUtils::format('number2', $objednavka->soucetCen) ?>
                </div>
            </div>

            <?php if ($pravaFakturovat->lzeZobrazitRC($objednavka->vystavil) && !empty($objednavka->faktury) && !$objednavka->jeSablona) { ?>
                <div class="row form-section">
                    <div class="col col-12"><?= ronText('Faktura'); ?></div>
                </div>

                <?php if ($objednavka->prekrocenaCenaFaktury) { ?>
                    <div class="row">
                        <label>
                            <span class="poznamka_faktura"><strong><?= ronText('Poznamka_k_prekroceni') ?></strong><br/></span>
                            <textarea name="dotaz_zadavateli" rows="8" class="form-input"><?= Model::getInstance()->getData('dotaz') ?></textarea><br/>
                        </label>

                        <input type="submit" name="dotaz" class="submitbutton" value="<?= ronText('Odeslat_zadavateli') ?>">
                    </div>
                <?php }

                foreach ($objednavka->faktury as $n => $faktura) {
                    $rowclassname = ($n % 2) ? 'browsercolor1' : 'browsercolor2';
                    $i = $n+1;
                    ?>
                    <div class="prijataFaktura  <?= $rowclassname ?>">
                        <div class="row">
                            <div class="col col-3 col-sm-2 caption required"><?= ronText('Cislo_faktury') ?></div>
                            <div class="col col-3 col-sm-2 cislo_faktury">
                                <?= StringUtils::htmlTextConvert($faktura->cisloFaktury) ?>
                            </div>

                            <div class="col col-3 col-sm-2 caption"><?= ronText('Popis') ?></div>
                            <div class="col col-12 col-sm-6">
                                <input class="form-input" name="faktura_popis_<?= $i ?>" maxlength="80" value="<?= StringUtils::htmlTextConvert($faktura->popis) ?>" type="text">
                            </div>
                        </div>
                        <div class="row">
                            <div class="col col-3 col-sm-2 caption required"><?= ronText('Datum_vystaveni') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input type='text' class='inputDate <?= MessageManager::getClass("faktura_datum_vystaveni_$i"); ?>'
                                       size='10' maxlength='10'
                                       name='faktura_datum_vystaveni_<?= $i ?>' value='<?= $faktura->datumVystaveni ? StringUtils::format('date', $faktura->datumVystaveni) : '' ?>'>
                                <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='faktura_datum_vystaveni_<?= $i ?>'></i>
                            </div>

                            <div class="col col-3 col-sm-2 caption required"><?= ronText('Datum_splatnosti') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input type='text' class='inputDate <?= MessageManager::getClass("faktura_datum_splatnosti_$i"); ?>'
                                       size='10' maxlength='10'
                                       name='faktura_datum_splatnosti_<?= $i ?>' value='<?= $faktura->datumSplatnosti ? StringUtils::format('date', $faktura->datumSplatnosti) : '' ?>'>
                                <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='faktura_datum_splatnosti_<?= $i ?>'></i>
                            </div>

                            <div class="col col-3 col-sm-2 caption required"><?= ronText('Datum_prijeti') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input type='text' class='inputDate <?= MessageManager::getClass("faktura_datum_prijeti_$i"); ?>'
                                       size='10' maxlength='10'
                                       name='faktura_datum_prijeti_<?= $i ?>' value='<?= $faktura->datumPrijeti ? StringUtils::format('date', $faktura->datumPrijeti) : '' ?>'>
                                <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='faktura_datum_prijeti_<?= $i ?>'></i>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col col-3 col-sm-2 caption"><?= ronText('Cislo_faktury_dodavatele') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input class="form-input" name="faktura_cislofakturydodavatele_<?= $i ?>" maxlength="80" value="<?= StringUtils::htmlTextConvert($faktura->cisloFakturyDodavatele) ?>" type="text">
                            </div>

                            <div class="col col-3 col-sm-2 caption required"><?= ronText('Faktura_castka') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input class="form-input" name="faktura_castka_<?= $i ?>" maxlength="80" value="<?= StringUtils::format('number_2', $faktura->castka) ?>" type="text">
                            </div>

                            <div class="col col-3 col-sm-2 caption"><?= ronText('Datum_zaplaceni') ?></div>
                            <div class="col col-3 col-sm-2">
                                <input type='text' class='inputDate'
                                       size='10' maxlength='10'
                                       name='faktura_datum_zaplaceni_<?= $i ?>' value='<?= $faktura->datumZaplaceni ? StringUtils::format('date', $faktura->datumZaplaceni) : '' ?>'>
                                <i class='showcalendar glyph-button fa glyph-calendar' data-roncalendar-inputname='faktura_datum_zaplaceni_<?= $i ?>'></i>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col col-12 col-sm-2 caption align-top"><?= ronText('Poznamka') ?></div>
                            <div class="col col-12 col-sm-9">
                                <textarea name="faktura_poznamka_<?= $i ?>" class="form-input" cols="60" rows="3"><?= StringUtils::longTextToHtml($faktura->poznamka, true) ?></textarea>
                            </div>
                        </div>
                    </div>
                <?php } ?>
                <div class="row">
                    <div class="col col-12 col-sm-2">
                        <input class="button" type="button" id="novafaktura" name="novafaktura" value="<?= ronText('Nova_faktura') ?>" />
                    </div>
                </div>
            <?php }?>

        </div>
        <div class="buttons">
            <input type="submit" class="submitbutton" value="<?= ronText('form.Store'); ?>">
            <input type="button" data-ron-href="<?= $stornoURL ?>" class="confirmQuestion button" value="<?= ronText('Cancel') ?>" data-ron-confirm-text="<?= ronText('Opravdu_zrusit_editaci') ?>" />
        </div>
    </div>

</form>
