<?php
/**
 * stanislav.elbl, 16.11.2015, pavel.rudol, 8.11.2017
 * Hlavicka hodnoceni (obdobi, ...)
 */

namespace RonPortal\Skoleni;

use Ron\MessageManager;
use Ron\StringUtils;
use Ron\TextManager;
use function Ron\ronText;

/** @var $this HodnoceniSkoleni */

if ($_POST['backaction'] ?? null) $back = StringUtils::secureString($_POST['backaction']);
else if ($_GET['backaction'] ?? null) $back = StringUtils::secureString($_GET['backaction']);
else $back = 'skoleni';

$nadpis = '';

switch ($this->typGenerovaniHodnoceni) {
    case 1 : //ucastnik dle typu rozdeleni
    case 2 : //ucastnik zvolenou osobou
        $nadpis = ronText('Skoleni_Hodnoceni_Ucastnika');
        break;
    case 3 : //skoleni ucastnikem
        $nadpis = ronText('Skoleni_Hodnoceni');
        break;
}
?>

<h1><?= $nadpis ?></h1>

<?php MessageManager::getInstance() ->showMessages() ?>

<div class="form middle-form">
    <div class="form-content">

    <div class="row">
        <div class="col-12 col-sm-4 caption"><?= ronText('Skoleni') ?></div>
        <div class="col-12 col-sm-8"><strong><?= StringUtils::htmlTextConvert($this->nazevSkoleni) ?></strong></div>
    </div>
    <div class="row">
        <div class="col-12 col-sm-4 caption"><?= ronText('Skoleni_DatumZacatku'); ?></div>
        <div class="col-12 col-sm-8"><?= StringUtils::format('datetime', $this->zacatekSkoleni) ?></div>
    </div>
    <div class="row">
        <div class="col-12 col-sm-4 caption"><?= ronText('Skoleni_DatumUkonceni'); ?></div>
        <div class="col-12 col-sm-8"><?= StringUtils::format('datetime', $this->konecSkoleni) ?></div>
    </div>

    <?php if ($this->fHodnocenyPrijmeni || $this->fHodnocenyJmeno) { ?>
        <div class="row">
            <div class="col-12 col-sm-4 caption"><?= $this->typGenerovaniHodnoceni == 3 ? ronText('hodnotici') : ronText('Hodnoceny') ?></div>
            <div class="col-12 col-sm-8"><strong><?= StringUtils::htmlTextConvert($this->fHodnocenyJmeno .' ' . $this->fHodnocenyPrijmeni) ?></strong></div>
        </div>
    <?php } ?>

    <?php if ($this->fPocatekObdobi || $this->fKonecObdobi) { ?>
        <div class="row">
            <div class="col-12 col-sm-4 caption"><?= ronText('Hodnocene_obdobi') ?></div>
            <div class="col-12 col-sm-8"><?= StringUtils::format('date', $this->fPocatekObdobi) ?> - <?= StringUtils::format('date', $this->fKonecObdobi) ?></div>
        </div>
    <?php } ?>

    <div class="row">
        <div class="col-12 col-sm-4 caption"><?= ronText('Stav_hodnoceni') ?></div>
        <div class="col-12 col-sm-8">
            <?= TextManager::_('Stav_hodnoceni_' . $this->fStav) ?>
        </div>
    </div>

    <?php if ($this->hodnotici || $this->hodnoticiPrijmeni || $this->hodnoticiJmeno) { ?>
        <div class="row">
            <div class="col-12 col-sm-4 caption"><?= ronText('Hodnotil') ?></div>
            <div class="col-12 col-sm-8">
                <?= StringUtils::htmlTextConvert($this->hodnoticiJmeno . ' ' . $this->hodnoticiPrijmeni) ?>
                <?php if ($this->hodnotici) echo ' ('. StringUtils::htmlTextConvert($this->hodnotici) . ')'; ?>
            </div>
        </div>
    <?php } ?>

    <?php if ($this->fDatumHodnoceni) { ?>
        <div class="row">
            <div class="col-12 col-sm-4 caption"><?= ronText('Datum_hodnoceni') ?></div>
            <div class="col-12 col-sm-8"><?= StringUtils::format('datetime', $this->fDatumHodnoceni) ?></div>
        </div>
    <?php } ?>

    </div>
</div>

<div class="text_link margin-top-2">
    <a href="?menuid=<?= $back ?>"><?= ronText('Zpet_na_seznam') ?></a>
</div>

