<?php
/**
 * stanislav.elbl, 28.09.2021 22:34
 */

namespace RonPortal\SluzebniCesty;

use Ron\DB\Database;
use RonPortal\RonPortalSettings;

class RadekUctovaniSluzebniCesty
{
    public $idSluzebniCesty;

    public $cisloRadku;
    public $popis;
    public $den;

    public $typ; // => TypRUctovaniSlCesty
    // nacteno z typu
    public $popisTypu;
    public $druhPohybu; // +/-

    public $castka;
    public $castkaStr;
    public $kodMeny;
    public $zpusobPlatby;
    public $castkaDPH;
    public $castkaDPHStr;

    public $nahrada;   // priznak, ze se jedna o nahradu
    public $NVVSpotrebaVozidla;
    public $NVVPocetUjetychKm;
    public $NVVNepocitatZakladniSazbu;
    public $NVVNeprokazanaCenaPHM;
    public $NVVCenaPHM;
    public $NVVDruhPHM;
    public $NVVVozidlo; // => VozidloOsoby, Vozidlo

    public $error;     // priznak chyby

    public $novyRadek; // priznak, ze se jedna o novy radek


    function __construct($idSluzebniCesty)
    {
        $this ->idSluzebniCesty = $idSluzebniCesty;
        $this ->error = false;

        $this ->castkaDPH = 0;
    }


    function getCastkaView() {
        if ( !$this->castka ) {
            return '';
        }

        switch ($this ->druhPohybu) {
            case 1 :
            case 2 :
                if (!RonPortalSettings::getIntValue(SluzebniCesta::SETTINGS_ZNAMENKO_UCTOVANI)) {
                    // je zadan druh pohybu (+/-) - vzdy zobrazi kladne
                    return abs($this->castka);
                }
        }

        return $this ->castka;
    }


    /**
     * @param Database $database
     * @param int $idSluzebniCesty
     * @return null|string
     * @deprecated
     */
    public static function vratVychoziMenu($database, $idSluzebniCesty)
    {
        return SluzebniCestyUtils::vratVychoziMenu($database, $idSluzebniCesty);
    }
}
