<?php

namespace RonPortal\SluzebniCesty;

use Ron\DB\Database;
use Ron\DB\DBException;

class Spolucestujici
{
    public $idPP;

    public $rc;
    public $osobniCislo;
    public $datumNastupu;

    public $jmenoPrijmeni;

    /**
     * @param Database $database
     * @param int $idSluzebniCesty
     * @return Spolucestujici[]
     * @throws DBException
     */
    public static function nactiSpolucestujici($database, $idSluzebniCesty)
    {
        $result = [];

        $params = $database ->createParameters();
        $sql =
            'SELECT PracovniPomer.id, Spolucestujici.RC, Spolucestujici.OsobniCislo, Spolucestujici.DatumNastupu,' .
            ' Osoba.Jmeno, Osoba.Prijmeni, Osoba.Titul' .
            ' FROM Spolucestujici, PracovniPomer, Osoba' .
            ' WHERE Spolucestujici.SluzebniCesta_ID = ' . $params ->addParameter($idSluzebniCesty) .
            '   AND PracovniPomer.RC = Spolucestujici.RC' .
            '   AND PracovniPomer.OsobniCislo = Spolucestujici.OsobniCislo' .
            '   AND PracovniPomer.DatumNastupu = Spolucestujici.DatumNastupu' .
            '   AND PracovniPomer.RC = Osoba.RC' .
            ' ORDER BY Osoba.Prijmeni, Osoba.Jmeno, Spolucestujici.OsobniCislo';

        $cursor = $database ->getSqlResult($sql, $params, 'Chyba pri nacitani spolucestujicich!');
        while ($row = $cursor ->fetch()) {
            $spolucestujici = new Spolucestujici();
            $spolucestujici ->idPP = $row[0];
            $spolucestujici ->rc = $row[1];
            $spolucestujici ->osobniCislo = $row[2];
            $spolucestujici ->datumNastupu = $cursor ->stringToTimestamp($row[3]);
            $spolucestujici ->jmenoPrijmeni =
                ($row[6] ? $row[6] . ' ' : '') .
                $row[4] . ' ' . $row[5];

            $result[] = $spolucestujici;
        }
        $cursor ->close();

        return $result;
    }
}
