<?php
/**
 * stanislav.elbl, 14.07.2021 19:01
 */

namespace RonPortal\SluzebniCesty;


use Ron\Controls\Option;
use Ron\DB\Database;
use Ron\TextManager;
use RonPortal\Prava;

class TypRadkuUctovaniSluzebniCesty
{
    /** @var int */
    public $kod;
    /** @var string */
    public $popis;
    /** @var int    0=obecny, 1=prijem, 2=vydej */
    public $druhPohybu;
    /** @var int    Priznak, jestli se jedna o nahradu */
    public $nahrada;

    /**
     * @param Database $database
     * @param string $kod
     * @return null|TypRadkuUctovaniSluzebniCesty
     */
    public static function vratTypUctovani($database, $kod)
    {
        if (!$kod) {
            return null;
        }

        $params = $database ->createParameters();
        $sql =
            'SELECT Kod, DruhPohybu, NahradaZaVlastniVozidlo, Popis' .
            ' FROM TypRUctovaniSlCesty' .
            ' WHERE Kod = ' . $params ->addParameter((int)$kod);

        $cursor = $database ->getSqlResult($sql, $params);
        $row = $cursor ->fetch();
        $cursor ->close();

        if (!$row) {
            return null;
        }

        $result = new TypRadkuUctovaniSluzebniCesty();
        $result ->kod = (int)$row[0];
        $result ->druhPohybu = (int)$row[1];
        $result ->nahrada = (int)$row[2];
        $result ->popis = $row[3];

        return $result;
    }


    public static function typUctovaniJeNVV($database, $kod)
    {
        $typRadku = self::vratTypUctovani($database, $kod);

        if (!$typRadku) {
            return null;
        }

        return $typRadku ->nahrada == 1;
    }


    static function lzeEditovatRadekUctovani($idPP, $typRadku)
    {
        $prava = Prava::vratPrava('slcesty_ucet', 'slcesty_ucet_' . $typRadku); // TODO: umoznit i pravo pro zahranicni SC?
        return $prava ->lzeZobrazitPP($idPP);
    }


    /**
     * Nacte seznam typu uctovani, ktere muze uzivatel editovat pro zadany idPP
     * @param Database $database
     * @param int $idPP
     * @return Option[]
     */
    public static function loadOptions($database, $idPP)
    {
        $result = [new Option('', '')];

        $cursor = $database ->getSqlResult(
            'SELECT Kod, Popis FROM TypRUctovaniSlCesty WHERE (Aktivni=1) AND (NOT (Kod IN (1,2,3,4))) ORDER BY Popis');

        while ($row = $cursor ->fetch()) {
            $pravo = Prava::vratPrava('slcesty_ucet', 'slcesty_ucet_' . $row[0]);
            if ($pravo ->lzeZobrazitPP($idPP)) {
                $result[] = new Option($row[0], TextManager::_('db_typructovanislcesty_popis_' . $row[0], $row[1]));
            }
        }

        $cursor ->close();

        return $result;
    }
}
