<?php
/**
 * UTF8
 * stanislav.elbl, 09.12.2015
 * Zajistuje overeni tokenu pomoci webove sluzby Softip HR portalu
 */

/*
Priklad requestu:
POST /hhrtest/WSConnectionToRON/RonWS.asmx/AuthUser HTTP/1.1
Host: sk1sclron01.ad.heiway.sk
Content-Type: application/x-www-form-urlencoded
Content-Length: length

token=string

Priklad odpovedi:
HTTP/1.1 200 OK
Content-Type: text/xml; charset=utf-8
Content-Length: length

<?xml version="1.0" encoding="utf-8"?>
<string xmlns="http://SoftipHappyHr.sk/">string</string>
*/

namespace RonPortal;

use Ron\HttpSocket;
use Ron\MVC\Controller;
use Ron\MVC\ViewObject;
use Ron\StringUtils;



class SoftipUtils
{
    static function parseResponse($response)
    {
        $dom = new \DOMDocument();
        $dom ->loadXML($response);

        //var_dump($dom);

        return $dom ->documentElement ->nodeValue;
    }


    /**
     * Vraci osobni cislo uzivatele
     * @param string $token
     * @return string
     */
    static function tokenUserAuthentication($token)
    {
        global $softipServer;
        global $softipServerPort;
        global $softipLoginUrl;

        require_once('ron/httpsocket.php');

        $httpSocket = new HttpSocket($softipServer, $softipServerPort);
        $httpSocket ->method = HttpSocket::METHOD_POST;
        $httpSocket ->contentType = HttpSocket::CONTENT_TYPE_FORM;

        $httpSocket ->open();
        $httpSocket ->sendRequest('token=' . $token, $softipLoginUrl . '/AuthUser');

        $response = $httpSocket ->readAnswer();

        return self::parseResponse($response);
    }
}

/*
// ------------------------------------------------------------------------------------------------
// TESTOVACI KOD:
class TestSoftipController implements Controller, ViewObject
{
    var $response;

    function testToken($token) {
        $this ->response = SoftipUtils::tokenUserAuthentication($token);
    }


    public function handleAction($action)
    {
        if ($_POST['token']) {
            $this ->testToken($_POST['token']);
        }

        return $this;
    }


    public function render()
    {
        if ($this ->response) {
            echo '<PRE>' . StringUtils::longTextToHtml($this ->response, true) . '</PRE><br/><br/>';
        }
        echo '<form method="POST">';

        $token = isset($_POST['token']) ? $_POST['token'] : '';
        echo "Token: <input type='text' name='token' value='$token' /><br/>";

        echo "<input type='submit' value='Test'/>";
        echo '</form>';

        echo '<br/>-----------------------------------------<br/>';

        global $softipServer;
        global $softipServerPort;
        global $softipLoginUrl;
        $action = "http://$softipServer:$softipServerPort$softipLoginUrl/AuthUser";

        echo '<form method="POST" target="_blank" action="' . $action . '">';

        echo "Externi odkaz, token: <input type='text' name='token' value='' /><br/>";

        echo "<input type='submit' value='Test'/>";
        echo '</form>';

    }
}

return new TestSoftipController();
*/
