<?php

namespace RonPortal\Terminaly;

use Ron\Controls\BrowserField;
use RonPortal\Controls\RonPortalBrowser;

class IdMediaBrowser extends RonPortalBrowser
{
    public function __construct($database)
    {
        parent::__construct($database, 'terminaly&action=media');
        //parent::__construct($database, ['menuid' => 'terminaly', 'action' => 'media']);

        $this ->sqlFromPart =
            'Karta' .
            ' LEFT OUTER JOIN TypIDMedia ON Karta.Typ = TypIDMedia.Kod' .
            ' LEFT OUTER JOIN S_ZpusobVyrazeniKarty ON Karta.ZpusobVyrazeni = S_ZpusobVyrazeniKarty.Kod';

        $this ->defaultSort = 'col-kod';

        $this ->addField()
            ->setSqlFieldName('Karta.Kod') ->setHeader('Kod_karty')
            ->setCode('col-kod')
            ->setOrdering(true);

        $this ->addField()
            ->setSqlFieldName('Karta.Kod2') ->setHeader('Kod2')
            ->setCode('col-kod2')
            ->setOrdering(true);

        $this ->addField()
            ->setSqlFieldName('Karta.OznaceniMedia') ->setHeader('Oznaceni_media')
            ->setCode('col-oznacenimedia')
            ->setOrdering(true);

        $this ->addField()
            ->setSqlFieldName('TypIDMedia.Popis') ->setHeader('Typ')
            ->setCode('col-typ')
            ->setOrdering(true);

        $this ->addField()
            ->setSqlFieldName('Karta.DatumPorizeni') ->setHeader('Datum_porizeni')
            ->setCode('col-datumporizeni') ->setFormat('date')
            ->setOrdering(true);

        $this ->addField(BrowserField::FIELD_TYPE_HIDDEN)
            ->setSqlFieldName('S_ZpusobVyrazeniKarty.Popis') ->setHeader('Duvod_vyrazeni')
            ->setCode('col-zpusobvyrazeni')
            ->setOrdering(true);

        $this ->addField()
            ->setSqlFieldName('Karta.DatumVyrazeni') ->setHeader('Datum_vyrazeni')
            ->setCode('col-datumvyrazeni') ->setFormat('date')
            ->setOrdering(true)
            ->setSqlFieldIndex2('col-zpusobvyrazeni');

        $this ->addField()
            ->setSqlFieldName(
                '(' .
                "SELECT Osoba.Prijmeni {fn_CONCAT()} ' ' {fn_CONCAT()} Osoba.Jmeno FROM PrirazeniKarty, Osoba" .
                ' WHERE PrirazeniKarty.KodKarty = Karta.Kod' .
                ' AND PrirazeniKarty.DatumPrideleni <= {fn_GETDATE()}' .
                ' AND (PrirazeniKarty.DatumVraceni >= {fn_GETDATE()} OR PrirazeniKarty.DatumVraceni IS NULL)' .
                ' AND Osoba.RC = PrirazeniKarty.RC' .
                ') AS JmenoOsoby')
            ->setCode('col-osoba') ->setHeader('Osoba')
            ->setOrdering(true) ->setSortSQL('JmenoOsoby');
    }

}
