<?php
/**
 * stanislav.elbl, 07.12.2015
 */

namespace RonPortal\Testy;

use Ron\DB\Database;
use Ron\DB\DBRecordField;
use RonPortal\RonPortalDBRecord;


class VycetOdpovediDBRecord extends RonPortalDBRecord
{
    /** @var  DBRecordField */
    var $fHodnota;
    /** @var  DBRecordField */
    var $fPopis;
    /** @var  DBRecordField */
    var $fKoeficient;

    /**
     * @param Database $database
     * @param int $druhHodnoceni
     * @param int $temaCislo
     * @param string $kodKriteria
     * @param object|string $logDescription
     */
    public function __construct($database, $druhHodnoceni, $temaCislo, $kodKriteria, $logDescription)
    {
        parent::__construct($database, 'VycetOdpovedi', $logDescription);

        $this ->addField('DruhHodnoceni', 'int', true, 0, $druhHodnoceni);
        $this ->addField('TemaCislo', 'int', true, 0, $temaCislo);
        $this ->addField('KodKriteria', 'string', true, 10, $kodKriteria);

        $this ->fHodnota = $this ->addField('Hodnota', 'int', true);
        $this ->fPopis = $this ->addField('Popis', 'memo');
        $this ->fKoeficient = $this ->addField('Koeficient', 'float');

        $params = $database ->createParameters();
        $this ->setWhere(
            'DruhHodnoceni = ' . $params ->addParameter($druhHodnoceni) .
            ' AND TemaCislo = ' . $params ->addParameter($temaCislo) .
            ' AND KodKriteria = ' . $params->addParameter($kodKriteria),
            $params);
    }
}
