<?php
// Zobrazeni detailu uchazece
namespace RonPortal\Uchazeci;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use RonPortal\PravaNaOsoby;
use RonPortal\RonPortalSettings;
use RonPortal\User;

/* @var Uchazec $uchazec */
$uchazec = Model::getInstance()->getData('uchazec');

/* @var PravaNaOsoby $pravaKomunikace */
$pravaKomunikace = Model::getInstance()->getData('pravaKomunikace');
?>

<h1><?= \Ron\ronText('Uchazec') ?></h1>

<a href="?menuid=uchazeci&"><?= \Ron\ronText('Zpet_na_seznam') ?></a>


<?php MessageManager::getInstance() ->showMessages() ?>

<div class='form large-form' id="uchazec_view">
    <div class="form-content">
        <div class="row" id="hlavickauchazece_signatura">
            <div class="col-12 col-sm-9">
                <?= StringUtils::htmlTextConvert($uchazec ->titul) ?>
                <strong><?= StringUtils::htmlTextConvert($uchazec ->jmeno)?> <?= StringUtils::htmlTextConvert($uchazec ->prijmeni) ?></strong>
                <?= StringUtils::htmlTextConvert($uchazec ->titulza) ?>
            </div>
            <?php if ($uchazec ->idFotografie) { ?>
            <div class="col-12 col-sm-3">
                <div id="<?= $uchazec->idFotografie ? 'detailuchazece_foto' : 'detailuchazece_noFoto'?>">
                    <?php if ($uchazec->idFotografie) { ?>
                        <img class="ronFoto" src="?menuid=uchazeci&action=downloadfoto&record=<?= $uchazec->rc ?>" alt="foto_uchazec" >
                    <?php }  ?>
                </div>
            </div>
            <?php } ?>
        </div>


        <div id="detaily">
            <div class="row form-section" id="hlavickauchazece_detaily">
                <div class="col"><?= \Ron\ronText('Detaily') ?></div>
            </div>

            <div class="row" id="hlavickauchazece_email">
                <div class="col-4 caption"><?= \Ron\ronText('Email')?></div>
                <div class="col-8">
                    <a href="mailto:<?= StringUtils::htmlTextConvert($uchazec->email) ?>?subject=<?= \Ron\ronText('Zprava_od_personalisty')?>&body=<?= \Ron\ronText('Vazeny_uchazeci')?>,%0A%08%0A%0A%08%0A<?= \Ron\ronText('S_pozdravem')?>,"><?= StringUtils::htmlTextConvert($uchazec->email) ?></a>
                </div>
            </div>

            <div class="row" id="hlavickauchazece_mobil">
                <div class="col-4 caption"><?= \Ron\ronText('Mobil')?></div>
                <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->mobil) ?></div>
            </div>

            <?php if ($uchazec ->telefon1) { ?>
            <div class="row" id="hlavickauchazece_telefon1">
                <div class="col-4 caption"><?= \Ron\ronText('Telefon1')?></div>
                <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->telefon1) ?></div>
            </div>
            <?php } ?>

            <div class="row" id="hlavickauchazece_telefon2">
                <div class="col-4 caption"><?= \Ron\ronText('Telefon2')?></div>
                <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->telefon2) ?></div>
            </div>

            <div class="row" id="hlavickauchazece_poznamka">
                <div class="col-4 caption"><?= \Ron\ronText('Poznamka')?></div>
                <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->poznamka) ?></div>
            </div>
            <div class="row" id="hlavickauchazece_zdrojvzniku">
                <div class="col-4 caption"><?= \Ron\ronText('zdrojVzniku')?></div>
                <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->zdrojVzniku/* ? $uchazec->zdrojVzniku : ''*/) ?></div>
            </div>

            <?php for ($i = 1; $i <= 20; $i++) {
                if (RonPortalSettings::getValue('uchazeciuzivatelska'.$i)) { ?>
                    <div class="row" id="hlavickauchazece_uzivatelska<?= $i ?>">
                        <div class="col-4 caption"><?= RonPortalSettings::getValue('uchazeciuzivatelska'.$i)  ?></div>
                        <div class="col-8"><?= StringUtils::htmlTextConvert($uchazec->uzivatelskaPole[$i]) ?></div>
                    </div>
            <?php }} ?>
        </div>


        <?php if ($uchazec->rozdeleni) { ?>
        <div id="rozdeleni">
            <div class="row form-section" id="hlavickauchazece_detaily">
                <div class="col"><?= \Ron\ronText('Rozdeleni') ?></div>
            </div>

            <?php $typRozdeleni = null ?>
            <?php foreach ($uchazec->rozdeleni as $rozdeleniUchazece) { ?>
                <div class="row">
                    <div class="col-4 caption">
                        <?= ($typRozdeleni !== $rozdeleniUchazece->typRozdeleni)
                            ?  StringUtils::htmlTextConvert($rozdeleniUchazece->typRozdeleni)
                            : '' ?>
                    </div>
                    <div class="col-8">
                        <?= StringUtils::htmlTextConvert($rozdeleniUchazece->kodRozdeleni) ?> -
                        <?= StringUtils::htmlTextConvert($rozdeleniUchazece->popisRozdeleni) ?>
                    </div>
                </div>
                <?php $typRozdeleni = $rozdeleniUchazece->typRozdeleni;  ?>
            <?php }?>
        </div>
        <?php }?>


        <?php if ($uchazec ->vzdelani) { ?>
        <div id="vzdelani">
            <div id="hlavickauchazece_vzdelani" class="row form-section">
                <div class="col"><?= \Ron\ronText('Vzdelani') ?></div>
            </div>
            <?php foreach ($uchazec->vzdelani as $vzdelaniUchazece) { ?>
                <div class="row">
                    <div class="col-4 caption">
                        <?= StringUtils::format('year',$vzdelaniUchazece->skolaOd)?> -
                        <?= StringUtils::format('year',$vzdelaniUchazece->skolaDo)?>
                    </div>
                    <div class="col-8">
                        <?= StringUtils::htmlTextConvert($vzdelaniUchazece->popisUrovneVzdelani) ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col-4 caption"></div>
                    <div class="col-8"><?= StringUtils::htmlTextConvert($vzdelaniUchazece->oborVzdelani)  ?></div>
                </div>

                <div class="row">
                    <div class="col-4 caption"></div>
                    <div class="col-8"><?= StringUtils::htmlTextConvert($vzdelaniUchazece->nazevSkoly) ?></div>
                </div>
            <?php } ?>
        </div>
        <?php } ?>



        <?php if($uchazec->dovednosti) { ?>
            <div id="dovednosti">
                <div id="hlavickauchazece_schopnosti" class="row form-section">
                    <div class="col"><?= \Ron\ronText('Schopnosti') ?></div>
                </div>

                <?php foreach ($uchazec->dovednosti as $dovednostiUchazece) { ?>
                    <div class="row">
                        <div class="col-4 caption"><?= StringUtils::format('year',$dovednostiUchazece->datumZiskani)?></div>
                        <div class="col-8">
                            <?= StringUtils::htmlTextConvert($dovednostiUchazece->popisDovednosti) ?> -
                            <?= StringUtils::htmlTextConvert($dovednostiUchazece->urovenDovednosti)  ?>
                        </div>
                    </div>
                <?php } ?>
            </div>
        <?php } ?>


        <?php if($uchazec->dokumenty) { ?>
        <div id="dokumenty">
                <div id="hlavickauchazece_dokumenty" class="row form-section">
                    <div class="col"><?= \Ron\ronText('Dokumenty') ?></div>
                </div>

                <?php foreach ($uchazec->dokumenty as $dokumentyUchazece) { ?>
                    <div class="row">
                        <div class="col-4 caption"><?= StringUtils::format('year',$dokumentyUchazece->datumVlozeniDokumentu)?></div>
                        <div class="col-8"><?= StringUtils::htmlTextConvert($dokumentyUchazece->popisDokumentu) ?></div>
                    </div>

                    <div class="row">
                        <div class="col-4 caption"></div>
                        <div class="col-8">
                            <a target="_blank" href="?menuid=uchazeci&action=download&record=<?= $uchazec->rc ?>&dokument=<?= $dokumentyUchazece->idDokumentu ?>">
                            <?= StringUtils::htmlTextConvert($dokumentyUchazece->nazevDokumentu) ?></a>
                        </div>
                    </div>
                <?php } ?>
        </div>
        <?php } ?>

        <div id="komunikace">
            <div id="hlavickauchazece_komunikace" class="row form-section">
                <div class="col"><?= \Ron\ronText('Komunikace') ?></div>
            </div>

            <?php foreach ($uchazec->komunikace as $komunikaceUchazece) { ?>
                <div class="row">
                    <div class="col-4 caption"><strong><?= StringUtils::format('finedatetime',$komunikaceUchazece->datumACasKomunikace)?></strong></div>
                    <div class="col-6">
                        <strong><?= StringUtils::htmlTextConvert($komunikaceUchazece->personalistaJmeno) ?>
                            <?= StringUtils::htmlTextConvert($komunikaceUchazece->personalistaPrijmeni) ?></strong>
                    </div>
                    <div class="col-2 align-right">
                        <?php if ($pravaKomunikace->jsouNejakePrava() && (User::hasRC($komunikaceUchazece->personalistaRC))) { ?>
                            <a href="?menuid=uchazeci&action=komunikace&formaction=edit&record=<?= $komunikaceUchazece->idKomunikace ?>"><?= \Ron\ronText('Editace_komunikace_s_uchazecem')?></a>
                        <?php } ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col-4 caption"><?= \Ron\ronText('Druh_a_obsah_sdeleni')?></div>
                    <div class="col-8">
                        <?= $komunikaceUchazece->druhSdeleni ? StringUtils::htmlTextConvert($komunikaceUchazece->druhSdeleni) . ' - '  : '' ?>
                        <?= StringUtils::longTextToHtml($komunikaceUchazece->obsahSdeleni) ?>
                    </div>
                </div>

                <div class="row margin-bottom-2">
                    <div class="col-4 caption"><?= \Ron\ronText('Odpoved_uchazece')?></div>
                    <div class="col-8"><?= StringUtils::longTextToHtml($komunikaceUchazece->odpoved, true) ?></div>
                </div>
            <?php } ?>
            <div class="row">
                <div class="col-4 caption"></div>
                <div class="col-8">
                    <?php if ($pravaKomunikace->jsouNejakePrava()) {?>
                        <a href="?menuid=uchazeci&action=komunikace&formaction=new&uchazec=<?= StringUtils::htmlTextConvert($uchazec->rc) ?>"><?= \Ron\ronText('Zaznamenat_komunikaci_s_uchazecem')?></a>
                    <?php } ?>
                </div>
            </div>
        </div>
    </div>

</div>

<div class="margin-top-2">
    <a href="?menuid=uchazeci&"><?= \Ron\ronText('Zpet_na_seznam') ?></a>
</div>
