<?php
/**
 * stanislav.elbl, 26.06.2021 21:59
 */

namespace RonPortal\XML\Classes;
use Ron\StringUtils;
use RonPortal\XML\XMLFormElement;

/**
 * while cyklus <while condition="...">...</while>
 * Class XMLElementWhile
 */
class XMLElementWhile extends XMLFormElement
{
    var $condition;

    function loadXMLElement($xmlReader)
    {
        parent::loadXMLElement($xmlReader);

        $this->condition = StringUtils::fromUTF8($this->getAttributeValue('condition'));
    }


    /**
     * @return bool
     */
    function evaluateCondition()
    {
        if (!$this ->condition) {
            return false;
        }

        $condition = $this ->nahradPromenne( $this ->condition );
        //MessageManager::addDebugLog("XMLDebug> while - vyhodnocuji vyraz: $condition");

        global $xmlform; // kvuli vyhodnocovani vyrazu!
        $result = false;

        eval('$result = '.$condition.';');

        return $result;
    }


    function getHTMLOutput()
    {
        $result = '';

        while ($this ->evaluateCondition()) {
            $result .= $this ->getElementsHTMLOutput();
        }

        return $result;
    }


    function event()
    {
        while ($this ->evaluateCondition()) {
            parent::event();
        }
    }


    function writeXMLOutput($xmlWriter)
    {
        throw new \Exception('XMLFormElementWhile::writeXMLOutput neni implementovano!');
    }


    function process()
    {
        while ($this ->evaluateCondition()) {
            parent::process();
        }
    }
}

/*
//DOC
PAGE while
<pre>
PRE
  <while condition="PHP_podminka">
    ... obsah ...
  </while>
PREEND
</pre>

//END
*/
