<?php
/**
 * stanislav.elbl, 16.12.2021 13:02
 *
 * Seznam XML formularu, ktere se nacitaji a zobrazuji napriklad u formularu nebo u browseru
 */

namespace RonPortal\XML;


class XmlFormsListItem
{
    /** @var int */
    public $idXmlFormulare;
//    /** @var string */
//    public $popisFormulare;

    /** @var string     Kde se ma formular zobrazit (top/bottom) */
    public $umisteni = 'top'; // "top"

    /** @var string     Obsah, ktery se ma zobrazit */
    public $obsah = '';
}


class XmlFormsList
{
    /** @var XmlFormsListItem[] */
    public $items = [];

    public function loadSettings($settingsArray)
    {
        if (!$settingsArray) {
            return;
        }

        foreach ($settingsArray as $settingsXml) {
            $xml = new XmlFormsListItem();

            $xml->idXmlFormulare = (int)($settingsXml['#attr']['id'] ?: 0);
//            else if (isset($settingsXml['#attr']['popis'])) {
//                $xml->popisFormulare = $settingsXml['#attr']['popis'];
//            }

            switch ($settingsXml['#attr']['umisteni'] ?: '') {
                case 'head' :
                case 'hlavicka' :
                    $xml ->umisteni = 'head';
                    break;

                case 'bottom' :
                case 'dole' :
                    $xml->umisteni = 'bottom';
                    break;

                case 'top' :
                case '' :
                    $xml->umisteni = 'top';
                    break;

                default :
                    $xml->umisteni = $settingsXml['#attr']['umisteni'];
            }

            $this->items[] = $xml;
        }
    }


    public function processXMLForms($database, $variables)
    {
        foreach ($this->items as $xml) {
            if ($xml->idXmlFormulare) {
                $xml->obsah = RonPortalXMLForm::xmlEvent($database, $xml->idXmlFormulare, $variables, null, true, false);
            }
        }
    }


    public function renderXmlForms($umisteni)
    {
        foreach ($this ->items as $xml) {
            if ($xml ->umisteni == $umisteni) {
                echo $xml ->obsah;
            }
        }
    }
}
