<?php

namespace RonPortal\Zamestnanci;

use Ron\DB\Database;
use Ron\DB\DBException;


class BankovniUcetOsoby
{
    public $serioveCislo;
    public $rc;
    public $cisloUctu;
    public $kodBanky;
    //tabulky BankovniUcet a VyplaceniMzdy

    public $specifickySymbol;
    public $konstantniSymbol;
    public $variabilniSymbol;

    public $vyplaceniMzdyPlatnostOd;
    public $vyplaceniMzdyPlatnostDo;


    public $insert_UserName;
    public $insert_Timestamp;
    public $update_UserName;
    public $update_Timestamp;

    /**
     * @param Database $database
     * @param string $rc
     * @return BankovniUcetOsoby[]
     * @throws DBException
     */
    public static function nactiUcetOsoby($database, $rc)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT KodBanky, CisloUctu, SerioveCislo, SpecifickySymbol, KonstantniSymbol, VariabilniSymbol, VyplaceniMzdy.PlatnostOd, VyplaceniMzdy.PlatnostDo,' .    //0..7
            '  Insert_UserName, Insert_Timestamp, Update_UserName, Update_Timestamp ' .   //8..11
            ' FROM BankovniUcet JOIN VyplaceniMzdy ON (VyplaceniMzdy.SerioveCisloUctuVyplaty = BankovniUcet.SerioveCislo) ' .
            ' WHERE BankovniUcet.RC = ' . $params->addParameter($rc) .
            ' ORDER BY VyplaceniMzdy.PlatnostOd DESC';

        $cursor = $database->getSqlResult($sql, $params);

        $ucty = [];

        while ($row = $cursor->fetch()) {
            $ucet = new static();
            $ucet->rc = $rc;
            $ucet->nactiDataZRadku($row, $database);

            $ucty[$ucet->serioveCislo] = $ucet;
        }

        $cursor ->close();

        return $ucty;
    }


    /**
     *
     * @param Database $database
     * @param array $row
     */
    private function nactiDataZRadku($row, $database)
    {
        $this->kodBanky = $row[0];
        $this->cisloUctu = $row[1];
        $this->serioveCislo = $row[2];
        $this->specifickySymbol = $row[3];
        $this->konstantniSymbol = $row[4];
        $this->variabilniSymbol = $row[5];
        $this->vyplaceniMzdyPlatnostOd = $database->stringToTimestamp($row[6]);
        $this->vyplaceniMzdyPlatnostDo = $database->stringToTimestamp($row[7]);
        $this->insert_UserName = $row[8];
        $this->insert_Timestamp = $database->stringToTimestamp($row[9]);
        $this->update_UserName = $row[10];
        $this->update_Timestamp = $database->stringToTimestamp($row[11]);
    }
}
