<?php
/**
 * stanislav.elbl, 28.02.2016
 */

namespace RonPortal\Zamestnanci;

use Ron\DB\Database;


/**
 * Class VzdelaniOsoby
 * Reprezentuje zaznamy z tabulky VzdelaniOsoby nebo VzdelaniUchazece
 * @package RonPortal\Personalistika
 */
class VzdelaniOsoby
{
    public $nazevSkoly;
    public $kodSkoly;
    public $oborVzdelani;
    public $oborVzdelaniKod;
    public $datumUkonceni;
    public $ukonceniVzdelani;
    public $ukonceniVzdelaniKod;
    public $typVzdelani;
    public $typVzdelaniKod;
    public $popisUrovneVzdelani;
    public $popisTypuVzdelani;
    public $skolaOd;
    public $skolaDo;
    public $vzdelani;
    public $mistoStudia;
    public $oborVzdelaniISPV;
    public $zamereni;

    /**
     * @param Database $database
     * @param $row
     */
    private function nactiVzdelaniZRadku($database, $row)
    {
        $this->nazevSkoly = $row[0];
        $this->kodSkoly = $row[9];
        $this->oborVzdelani = $row[1];
        $this->oborVzdelaniKod = $row[7];
        $this->ukonceniVzdelani = $row[2];
        $this->ukonceniVzdelaniKod = $row[8];
        $this->popisUrovneVzdelani= $row[3];
        $this->skolaOd = $database->stringToTimestamp($row[4]);
        $this->skolaDo = $database->stringToTimestamp($row[5]);
        $this->popisTypuVzdelani = $row[6];
        $this->datumUkonceni = $database->stringToTimestamp($row[10]);
        $this->typVzdelaniKod = $row[11];
        $this->mistoStudia = $row[12];
        $this->oborVzdelaniISPV = $row[13];
        $this->zamereni = $row[14];
    }

    /**
     * @param Database $database
     * @param $rc
     * @param string $tableName      VzdelaniOsoby nebo VzdelaniUchazece
     * @return VzdelaniOsoby[]
     * @throws \Exception
     */
    public static function nactiVzdelani($database, $rc, $tableName)
    {
        $params = $database->createParameters();

        $sql =
            'SELECT Skola.Nazev, OborVzdelani.Popis, S_ZpusobUkonceniSkoly.Popis, UrovenVzdelani.Popis,' . // 0..3
            " $tableName.DatumOd, $tableName.DatumDo, TypVzdelani.Popis, OborVzdelani.Kod, S_ZpusobUkonceniSkoly.Kod," . // 4..8
            " Skola.Kod, $tableName.DatumUkonceni, TypVzdelani.Kod, $tableName.MistoStudia, $tableName.OborVzdelaniISPV," . // 9..13
            " $tableName.Zamereni" . // 14
            "\nFROM $tableName JOIN  OborVzdelani ON ($tableName.OborVzdelani = OborVzdelani.Kod)" .
            " JOIN TypVzdelani ON ($tableName.KodVzdelani = TypVzdelani.Kod)" .
            ' JOIN UrovenVzdelani ON (TypVzdelani.UrovenVzdelani = UrovenVzdelani.Uroven)' .
            " JOIN S_ZpusobUkonceniSkoly ON ($tableName.VzdelaniUkonceno = S_ZpusobUkonceniSkoly.Kod)".
            " LEFT JOIN Skola ON ($tableName.Skola = Skola.Kod)" .
            "\nWHERE  RC = " . $params->addParameter($rc) .
            "\nORDER BY $tableName.DatumOd DESC, $tableName.DatumDo DESC";

        $cursor = $database ->getSqlResult($sql,$params);

        $seznamVzdelani = [];
        while($row = $cursor->fetch()) {
            $vzdelani = new VzdelaniOsoby();
            $vzdelani ->nactiVzdelaniZRadku($database, $row);
            $seznamVzdelani[] = $vzdelani;
        }

        return $seznamVzdelani;
    }

}
