<?php
/**
 * stanislav.elbl, 25.02.2021
 */

namespace RonPortal\Zamestnanci;

use Exception;
use Ron\DB\Database;
use Ron\Http\HtmlHeaders;
use Ron\MVC\JsonController;
use Ron\MVC\JsonOutputObject;
use Ron\MVC\Redirect;
use Ron\TextManager;
use RonPortal\NeniPravoException;
use RonPortal\PracovniPomer;
use RonPortal\Prava;

class ZamestnanciController extends JsonController
{
    /** @var Database */
    protected $database;

    /**
     * ZamestnanciController constructor.
     * @param Database $database
     */
    public function __construct(Database $database)
    {
        $this->database = $database;
    }


    /**
     * @throws NeniPravoException
     * @throws Exception
     */
    private function form()
    {
        if (!Prava::jsouNejakePrava('zamest_novy')) {
            throw new NeniPravoException();
        }

        $form = new NovyZamestnanecForm($this ->database);
        $result = $form ->handleAction();

        if ($result) {
            return new Redirect(null, '?menuid=zamestnanec');
        }

        return $form;
    }


    public function handleJsonAction($action, $output)
    {
        // TODO: Implement handleJsonAction() method.
    }


    public function handleAction($action)
    {
        TextManager::getInstance() ->loadStrings('zamestnanci.ini');
        HtmlHeaders::getInstance() ->addCss('css/person.css');
        HtmlHeaders::getInstance() ->addScript('script/personscripts.js');
        return $this ->form();

        //return parent::handleAction($action);
    }
}
