<?php

namespace RonPortal\Zamestnanci;

use Ron\DB\Database;
use Ron\DB\DBException;


class ZdravotniPojisteniOsoby
{
    public $rc;
    public $kodZP;
    public $nazevZP;
    public $platnostOd;
    public $platnostDo;
    public $cisloPojistence;


    /**
     *
     * @param Database $database
     * @param string $rc
     * @param int $platnost den ke kteremu je pojistovna platna
     * @return ZdravotniPojisteniOsoby
     * @throws DBException
     */
    public static function nactiZdravotniPojistovnuOsoby($database, $rc, $platnost = 0)
    {
        if ($platnost == 0) {
            $platnost = time();
        }

        $params = $database->createParameters();

        $sql =
            "SELECT KodZdravotniPojistovny, PlatnostOd, CisloPojistence, ZdravotniPojistovna.Popis, PlatnostDo " .
            " FROM PojisteniOsobyU_ZP, ZdravotniPojistovna ".
            " WHERE ZdravotniPojistovna.Kod = PojisteniOsobyU_ZP.KodZdravotniPojistovny ".
            "  AND RC = " . $params->addParameter($rc) .
            "  AND PlatnostOd <= " . $params->addDateParameter($platnost) .
            "  AND (PlatnostDo >= " . $params->addDateParameter($platnost) . " OR PlatnostDo IS NULL)";

        $cursor = $database->getSqlResult($sql, $params);
        $row = $cursor->fetch();
        $cursor ->close();

        if ($row) {
            $zdravotniPojistovna = new static();
            $zdravotniPojistovna->rc = $rc;
            $zdravotniPojistovna->nactiDataZRadku($database, $row);
            return $zdravotniPojistovna;
        } else {
            return null;
        }
    }

    /**
     *
     * @param Database $database
     * @param array $row
     */
    private function nactiDataZRadku($database, $row)
    {
        $this->kodZP = $row[0];
        $this->platnostOd = $database->stringToTimestamp($row[1]);
        $this->platnostDo = $database->stringToTimestamp($row[4]);
        $this->cisloPojistence = $row[2];
        $this->nazevZP = $row[3];
    }


}
