(function() {
    function onRadioChange() {
        let
            $this = $(this),
            name = $this.attr("name"),
            value = $this.val(),
            $items = $('input[name="' + name + '"]');

        $items.parent().toggleClass("hodnocenichecked", false); // odznaci vsechny
        $this.parent().toggleClass("hodnocenichecked", true);   // oznaci vybrany
    }
    function onCheckboxChange() {
        let
            $this = $(this);

        $this.parent()
            .toggleClass("hodnocenichecked", $this.prop('checked'));
    }


    $(function() {
        $(".dotaznik")
            .on("change", "input:radio", onRadioChange)
            .on("change", "input:checkbox", onCheckboxChange)
        ;
    });
})();


(function() {
    function selectAll(value) {
        $("#browserseznamhodnoceni").find("input:checkbox").each(function () {
            let $checkbox = $(this);

            if (!$checkbox.disabled && $checkbox.attr("name").substring(0, 18) === 'hodnocenicheckbox_') {
                $checkbox.prop("checked", value);
            }
        });
    }
    function hromadneUzavreniHodnoceni() {
        let
            hodnoceni_prerusit = false,
            isError = false,
            checkboxes = $("#browserseznamhodnoceni").find("input:checkbox"),
            progressScreen = ron.showProgressScreen(ron._('Probiha_hromadne_schvalovani'), checkboxes.length, prerusitOdesilani);


        function prerusitOdesilani() {
            hodnoceni_prerusit = true; // nastavi priznak

            $(this)
                .val("zastavuji ...")
                .attr("disabled", true);
        }


        function zavritHodnoceni() {
            window.location = '?menuid=hodnoceni';
        }


        function konecHodnoceni() {
            if (isError) {
                progressScreen.setButton(ron._("Zavrit"), zavritHodnoceni);
                progressScreen.setInfoMessage('');
                return false;
            } else {
                zavritHodnoceni();
                return true;
            }
        }


        function uzavriDalsi(i) {
            let
                selected = -1,
                 $checkbox = null;
            while (i < checkboxes.length  &&  selected < 0) {
                $checkbox = $(checkboxes.get(i));
                if ( $checkbox.attr("name").substring(0, 18) === 'hodnocenicheckbox_') {
                    if ( !$checkbox.prop("disabled")  &&  $checkbox.prop("checked") ) {
                        selected = i;
                    }
                }
                progressScreen.setProgress(i, null, ron._("Hromadne__hodnoceni_cislo") + ' ' + $checkbox.attr("name").substring(18));

                i++;
            }
            if (hodnoceni_prerusit) {
                progressScreen.addMessage(ron._("Hromadne_hodnoceni_preruseno"));
                selected = -1;

                isError = true;
            }


            if (selected < 0) {
                return konecHodnoceni();
            }


            let id = $(checkboxes.get(selected)).attr("name").substring(18); // vypreparuje cislo dotazniku

            $.ajax( "?menuid=hodnoceni&hodnoceniaction=hromadneuzavrenidotazniku&id=" + id )
                .done( function(data) {
                    if (data.result === "OK") {
                        $(checkboxes.get(selected)).prop("disabled", true);
                    }
                    else {
                        isError = true;

                        if (data.errors) {
                            for (var i = 0; i < data.errors.length; i++) {
                                progressScreen.addMessage(data.errors[i].errorText);
                            }
                        }
                    }

                    uzavriDalsi(selected + 1);
                })
                .fail( function(jqXHR) {
                    progressScreen.addMessage(ron._("Chyba_odesilani_hodnoceni") + " (" + jqXHR.status + " - " + jqXHR.statusText + ")");
                    console.log(jqXHR.responseText);

                    uzavriDalsi(selected + 1);
                });
        }


        uzavriDalsi(0, false);
    }


    $(function() {
        $("#prehled_hodnoceni")
            .on("click", "#vyberVsechnaHodnoceni", function() { selectAll(true); } )
            .on("click", "#zrusVyberHodnoceni", function() { selectAll(false); } )
            .on("click", "#hromadne_odeslat_hodnoceni", hromadneUzavreniHodnoceni);
    });
})();




(function() {
    function expandVysledky() {
        let
            $this = $(this),
            selExpand = $this.data('expand-selector'),
            selHide = $this.data('hide-selector'),
            selector = $this.data('selector'),
            expandedSelector = $this.data('expanded-selector'),
            expanded = $this.data('expanded') || $this.hasClass('expanded');

        if (expanded === undefined) {
            expanded = false;
        }

        if (selector !== undefined) {
            selHide = selector;
            selExpand = selector;
        }

        if (expanded) {
            $(selHide)
                .removeClass($this.data('toggle-class'))
                .addClass($this.data('toggle-class'))
                .children('.hodnoceniToggle')
                .removeClass('expanded');

            if (expandedSelector !== undefined) {
                $(expandedSelector).not(this).removeClass('expanded');
                $this.html(ron._('Zobrazit_vse'));
            } else {
                $this.removeClass('expanded');
            }
        } else {
            $(selExpand).removeClass($this.data('toggle-class'));
            if (expandedSelector !== undefined) {
                $(expandedSelector).not(this).addClass('expanded');
                $this.html(ron._('Skryt_vse'));
            } else {
                $this.addClass('expanded');
            }
        }

        $this.data('expanded', !expanded);

        return false;
    }

    $(function() {
        $(document.body)
            .on('click', '.hodnoceniToggle', expandVysledky);
    });
})();


(function() {
    let
        idHodnoceni = null,
        zobrazDialogVyberHodnotitele = function() {
            idHodnoceni = $(this).data('id');

            let
                ronselect = $("#hodnocenigenerovani_hodnotitel").ronselect("instance");

            $("#hodnoceninastavenihodnotitele_dialog").dialog({
                modal : true,
                resizable: false,
                width: "auto",
                height: "auto"
            });

            ronselect.loadData("?menuid=hodnoceniosob&action=nactiosoby&idhodnoceni=" + idHodnoceni, false); // dropdown = false
        },
        priraditHodnotitele = function() {
            let
                $that = $(this);

            $that.prop("disabled", "disabled");

            $.ajax({
                    url : "?menuid=hodnoceniosob&action=nastavhodnotitele",
                    type: "POST",
                    data : {
                        idhodnoceni : idHodnoceni,
                        hodnotitel : $("#hodnocenigenerovani_hodnotitel").val()
                    }
                })
                .done( function(responseData) {
                    if ( responseData.result === "OK" ) {
                        let ronselect = $("#hodnocenigenerovani_hodnotitel").ronselect("instance");

                        $('[data-id="' + idHodnoceni + '"]')
                            .html(ronselect.text())
                            .removeClass();

                        $("#hodnoceninastavenihodnotitele_dialog")
                            .dialog("close");
                    } else {
                        ron.showError(responseData);
                    }
                }).fail( function(jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri hodnoceni doslo k chybe!");
                }).always(function() {
                    $that.prop("disabled", null);
                });
        }


    $(function() {
        $(document.body)
            .on('click', '.nastavhodnotitele', zobrazDialogVyberHodnotitele)    // odkaz "Nastav hodnotitele" v seznamu Hodnoceni osob
            .on('click', "#priradit_hodnotitele", priraditHodnotitele); // tlacitko OK v dialogu pro vyber hodnotitele
    });
})();


(function() {
    let
        idPP = null,

        onComboUcelChange = function(index, options) {
            let
                ronselect = $("#hodnocenigenerovani_ucel").ronselect("instance"),
                itemUcel = ronselect.getSelectedItem(),
                zobrazitPocet = itemUcel
                    ? itemUcel.povolit_duplicitu
                    : false;

            if (itemUcel  &&  itemUcel.povolit_duplicitu) {
                $('#hodnocenigenerovani_row_pocet').show();
            } else {
                $('#hodnocenigenerovani_row_pocet').hide();
            }
        },
        zobrazDialogGenerovani = function() {
            idPP = $(this).data('id');

            let
                ronselect = $("#hodnocenigenerovani_ucel").ronselect("instance");

            $("#hodnocenigenerovani_dialog").dialog({
                modal : true,
                resizable: false,
                width: "auto",
                height: "auto"
            });

            ronselect.loadData("?menuid=hodnoceniosob&action=nactiucely&idpp=" + idPP, false); // dropdown = false
        },
        generovat = function() {
            let
                $that = $(this),
                datumOd = $('#hodnocenigenerovani_datumod').val(),
                ucel = $("#hodnocenigenerovani_ucel").val();

            $that.prop("disabled", "disabled");

            $.ajax({
                url : "?menuid=hodnoceniosob&action=generovani",
                type: "POST",
                data : {
                    idpp : idPP,
                    ucel : ucel,
                    datumod: datumOd,
                    pocetobdobi: $('#hodnocenigenerovani_pocet_obdobi').val(),
                    pocet: $('#hodnocenigenerovani_pocet').val()
                }
            })
                .done( function(responseData) {
                    if ( responseData.result === "OK" ) {
                        window.location = "?menuid=hodnoceniosob&datumpocatku=" + datumOd + "&ucel=" + ucel;
                    } else {
                        ron.showError(responseData);
                    }
                }).fail( function(jqXHR) {
                    ron.showAjaxError(jqXHR, "Pri hodnoceni doslo k chybe!");
                }).always(function() {
                    $that.prop("disabled", null);
                });
        }


    $(function() {
        $(document.body)
            .on("click", ".generovani", zobrazDialogGenerovani)
            .on("click", "#generovat_hodnoceni", generovat) // tlacitko OK v dialogu pro generovani
            .on("change", "#hodnocenigenerovani_ucel", onComboUcelChange);
    });

})();
