

$(function() {
    console.log('Inicializace prezentace ...');

    var
        $htmlPrezentace = $("#html_prezentace"),
        editace = $htmlPrezentace.data("editace"),
        casDoStr = $htmlPrezentace.data("cas-do");

    var zobrazAbsolvovanoInfo = function() {
        $("#testAbsolvovanBack").css("display", "block");
        $("#testAbsolvovanInfo").css("display", "block");
    };

    var skryjAbsolvovanoInfo = function() {
        $("#testAbsolvovanBack").hide();
        $("#testAbsolvovanInfo").hide();
    };


    if (casDoStr) {
        var
            casDo = ron.utils.stringToDateTime(casDoStr),
            infoZobrazeno = false;

        var showRemainingTime = function() {
            var remain = Math.floor( (casDo - new Date()) / 1000 );
            if (remain < 0 ) {
                remain = 0;
                if (!infoZobrazeno) {
                    infoZobrazeno = true;
                    zobrazAbsolvovanoInfo();
                }
            }

            $("#testZbyvajiciCas").text( ron.utils.secondsToString(remain) );
        };

        var showTimeTimer = function() {
            showRemainingTime();
            setTimeout(showTimeTimer, 250);
        };

        showTimeTimer();
    }


    var loadAsset = function(callback) {
        console.log('loadAsset: ', this);
        var kod = $(this).data("ron-code");

        if (kod) {
            $.ajax("?menuid=prezentace&asset=" + kod)
                .done( function(data) {
                    if (data.result == "OK") {
                        if (data.text) callback(data.text);
                    } else {
                        console.log("Chyba pri nacitani assetu: ", data.error);
                    }
                });
        }
    };

    var onKeyPress = function($e) {

        if (editace) {
            return;
        }

        var newHRef = null;

        switch ($e.which) {
            case 39 :
                newHRef = $("#linkNextPage").attr("href"); // click();
                break;

            case 37 :
                newHRef = $("#linkPrevPage").attr("href"); // click();
                break;
        }

        if (newHRef) {
            window.location.href = newHRef;
        }
    };


    var onScroll = function($e) {
        var showFloatingControls = $("#controls").offset().top < (document.documentElement.scrollTop || document.body.scrollTop);

        $("#floatcontrolspanel").css("display", showFloatingControls ? "block" : "none");
    };

    var onResize = function() {
        $("#floatcontrols").css("left", $("#controls").offset().left);
    };

    onResize();

    $("body")
        .on("keydown", onKeyPress);

    $(window)
        .on("scroll", onScroll)
        .on("resize", onResize);

    console.log('Start prezentace ...');


    $("#testAbsolvovanBack")
        .on("click", skryjAbsolvovanoInfo);

    $("#testAbsolvovanInfo")
        .on("click", skryjAbsolvovanoInfo);


    var onCloseClick = function() {
        window.close();
    };

    $("a[href='#close']").on("click", onCloseClick);
});
