/**
 * (c) RON Software spol. s r.o.
 * stanislav.elbl, 21.12.2015.
 *
 * Rozsireni TinyMCE editoru - NENI DOKONCENO, NENI UPRAVENO PRO tinyMCE 5!
 */

ron.mce = {

};


ron.mce.AssetItem = function() {
    this.code = '';
    this.description = '';
    this.content = '';
};


ron.mce.AssetPluginOptions = function()
{
    /**
     * @type {function|Array.<ron.mce.AssetItem>}
     */
    this.items = null;
};


/**
 * Plugin pro editaci assetu (bublinovych napoved).
 * @param {ron.mce.AssetPluginOptions} options
 */
ron.mce.addAssetPlugin = function(options) {
    tinymce.PluginManager.add('asset', function(editor) {

        var showAssetDialog = function(assetList) {
            var data = {},
                selection = editor.selection,
                dom = editor.dom,
                selectedElm,
                spanElement,
                initialText;
            var win,
                onlyText,
                textListCtrl,
                value;

            //function linkListChangeHandler(e) {
            //    var textCtrl = win.find('#text');
            //
            //    if (!textCtrl.value() || (e.lastControl && textCtrl.value() == e.lastControl.text())) {
            //        textCtrl.value(e.control.text());
            //    }
            //
            //    win.find('#href').value(e.control.value());
            //}

            //function buildAnchorListControl(url) {
            //    var anchorList = [];
            //
            //    tinymce.each(editor.dom.select('a:not([href])'), function(anchor) {
            //        var id = anchor.name || anchor.id;
            //
            //        if (id) {
            //            anchorList.push({
            //                text: id,
            //                value: '#' + id,
            //                selected: url.indexOf('#' + id) != -1
            //            });
            //        }
            //    });
            //
            //    if (anchorList.length) {
            //        anchorList.unshift({text: 'None', value: ''});
            //
            //        return {
            //            name: 'anchor',
            //            type: 'listbox',
            //            label: 'Anchors',
            //            values: anchorList,
            //            onselect: linkListChangeHandler
            //        };
            //    }
            //}

            function updateText() {
                if (!initialText && data.text.length === 0 && onlyText) {
                    this.parent().parent().find('#text')[0].value(this.value());
                }
            }

            //function urlChange(e) {
            //    var meta = e.meta || {};
            //
            //    if (linkListCtrl) {
            //        linkListCtrl.value(editor.convertURL(this.value(), 'href'));
            //    }
            //
            //    tinymce.each(e.meta, function(value, key) {
            //        win.find('#' + key).value(value);
            //    });
            //
            //    if (!meta.text) {
            //        updateText.call(this);
            //    }
            //}

            function isOnlyTextSelected(anchorElm) {
                var html = selection.getContent();

                // Partial html and not a fully selected anchor element
                if (/</.test(html) && (!/^<span [^>]+>[^<]+<\/span>$/.test(html) || html.indexOf('data-ron-code=') == -1)) {
                    return false;
                }

                if (anchorElm) {
                    var nodes = anchorElm.childNodes, i;

                    if (nodes.length === 0) {
                        return false;
                    }

                    for (i = nodes.length - 1; i >= 0; i--) {
                        if (nodes[i].nodeType != 3) {
                            return false;
                        }
                    }
                }

                return true;
            }

            selectedElm = selection.getNode();
            spanElement = dom.getParent(selectedElm, 'span[class=asset]');

            onlyText = isOnlyTextSelected(spanElement);

            data.text = initialText = spanElement ? (spanElement.innerText || spanElement.textContent) : selection.getContent({format: 'text'});
            data.code = spanElement ? dom.getAttrib(spanElement, 'data-ron-code') : '';

            data.class = 'asset';
            //if ((value = dom.getAttrib(spanElement, 'class'))) {
            //    data['class'] = value;
            //}

            if ((value = dom.getAttrib(spanElement, 'title'))) {
                data.title = value;
            }

            if (onlyText) {
                textListCtrl = {
                    name: 'text',
                    type: 'textbox',
                    size: 40,
                    label: 'Text to display',
                    onchange: function() {
                        data.text = this.value();
                    }
                };
            }

            //if (linkList) {
            //    linkListCtrl = {
            //        type: 'listbox',
            //        label: 'Link list',
            //        values: buildListItems(
            //            linkList,
            //            function(item) {
            //                item.value = editor.convertURL(item.value || item.url, 'href');
            //            },
            //            [{text: 'None', value: ''}]
            //        ),
            //        onselect: linkListChangeHandler,
            //        value: editor.convertURL(data.href, 'href'),
            //        onPostRender: function() {
            //            linkListCtrl = this;
            //        }
            //    };
            //}

            //if (editor.settings.target_list !== false) {
            //    if (!editor.settings.target_list) {
            //        editor.settings.target_list = [
            //            {text: 'None', value: ''},
            //            {text: 'New window', value: '_blank'}
            //        ];
            //    }
            //
            //    targetListCtrl = {
            //        name: 'target',
            //        type: 'listbox',
            //        label: 'Target',
            //        values: buildListItems(editor.settings.target_list)
            //    };
            //}

            //if (editor.settings.rel_list) {
            //    relListCtrl = {
            //        name: 'rel',
            //        type: 'listbox',
            //        label: 'Rel',
            //        values: buildListItems(editor.settings.rel_list)
            //    };
            //}

            //if (editor.settings.link_class_list) {
            //    classListCtrl = {
            //        name: 'class',
            //        type: 'listbox',
            //        label: 'Class',
            //        values: buildListItems(
            //            editor.settings.link_class_list,
            //            function(item) {
            //                if (item.value) {
            //                    item.textStyle = function() {
            //                        return editor.formatter.getCssText({inline: 'a', classes: [item.value]});
            //                    };
            //                }
            //            }
            //        )
            //    };
            //}

            //if (editor.settings.link_title !== false) {
            //    linkTitleCtrl = {
            //        name: 'title',
            //        type: 'textbox',
            //        label: 'Title',
            //        value: data.title
            //    };
            //}

            win = editor.windowManager.open({
                title: ron.translate('Vlozit_asset'),
                data: data,
                body: [
                    //{
                    //    name: 'href',
                    //    type: 'filepicker',
                    //    filetype: 'file',
                    //    size: 40,
                    //    autofocus: true,
                    //    label: 'Url',
                    //    onchange: urlChange,
                    //    onkeyup: updateText
                    //},
                    {
                        //onPostRender : function(e) {
                        //    //console.log('jsme v onPostRender kodu ... ', this, e.control.$el);
                        //    ron.ronSelect( $(e.control.$el[0]) );
                        //},
                        name: "code",
                        id: "assetCode",
                        type: "listbox",
                        //size: 40,
                        label: ron.translate("Kod"),
                        values : assetList
                            //[
                            //{text: ' ', value: ''},
                            ////{text: 'New window', value: '_blank'}
                            //]
                        //onchange: function() {
                        //    data.code = this.value();
                        //}
                    },
                    textListCtrl,
                    //linkTitleCtrl,
                    //buildAnchorListControl(data.href),
                    //linkListCtrl,
                    //relListCtrl,
                    //targetListCtrl,
                    //classListCtrl
                ],

                //onPostRender : function() {
                //    console.log('jsme v onPostRender dialogu');
                //},

                onSubmit: function(e) {
                    data = tinymce.extend(data, e.data);
                    var code = data.code;

                    // Delay confirm since onSubmit will move focus
                    function delayedConfirm(message, callback) {
                        var rng = editor.selection.getRng();

                        window.setTimeout(function() {
                            editor.windowManager.confirm(message, function(state) {
                                editor.selection.setRng(rng);
                                callback(state);
                            });
                        }, 0);
                    }

                    function insertSpan() {
                        var spanAttrs = {
                            "data-ron-code": code,
                            //rel: data.rel ? data.rel : null,
                            //title: data.title ? data.title : null,
                            "class": "asset"
                        };

                        if (spanElement) {
                            editor.focus();

                            if (onlyText && data.text != initialText) {
                                if ("innerText" in spanElement) {
                                    spanElement.innerText = data.text;
                                } else {
                                    spanElement.textContent = data.text;
                                }
                            }

                            dom.setAttribs(spanElement, spanAttrs);

                            selection.select(spanElement);
                            editor.undoManager.add();
                        } else {
                            //if (onlyText) {
                                editor.insertContent(dom.createHTML('span', spanAttrs, dom.encode(data.text)));
                            //} else {
                            //    editor.execCommand('mceInsertLink', false, spanAttrs);
                            //}
                        }
                    }

                    //if (!href) {
                    //    editor.execCommand('unlink');
                    //    return;
                    //}

                    insertSpan();
                }
            });
        };


        var loadAssetsList = function(url) {
            $.ajax(url)
                .done( function(data) {
                    if (data.result == "OK") {
                        // odstraneno
                        showAssetDialog(data.items);
                    } else {
                        ron.showError(data);
                    }
                }).fail( function(jqXHR) {
                    ron.logAjaxError(jqXHR, "Pri nacitani seznamu assetu doslo k chybe!");
                });
        };

        var createAssetDialog = function() {
            var assetList = options ? options.items : null;

            if (!assetList) {
                console.log('Neni zadan assetList!');
                showAssetDialog( [ { text: ' ', value: ''} ]);
            } else if (typeof assetList == "string") {
                // je zadano url pro nacteni dat
                loadAssetsList(assetList);
            } else if (typeof assetList == "function") {
                // je zadana funkce pro nacteni dat
                assetList(callback);
            } else {
                // je zadan seznam polozek [ { text: , value: }, ... ]
                showAssetDialog(assetList);
            }
        };


        editor.addMenuItem('asset', {
            //icon: 'link',
            image: 'images/asset.png',
            text: ron.translate('Vlozit_asset'),
            //shortcut: 'Meta+K',
            onclick: createAssetDialog,
            //stateSelector: 'span[data-ron-asset]',
            stateSelector: 'span[className=asset]',
            context: 'insert',
            prependToContext: true
        });

        editor.addButton('asset', {
            //icon: 'link',
            image: 'images/asset.png',
            tooltip: ron.translate('Vlozit_asset'),
            //shortcut: 'Meta+K',
            onclick: createAssetDialog,
            stateSelector: 'span[class=asset]'
        });

    });
};