/**
    * (c) RON Software spol. s r.o.
    * stanislav.elbl, 26.4.2016.
    */

var ronTests = {

    OPEN_URL : 'openUrl',
    SELECTOR_EXIST : 'selectorExists',
    SET_VALUE : 'setValue',
    CLICK : 'click',
    WAIT : 'wait',

    $appContent : null,

    TestItem : function() {
        this.itemType = '';
        this.url = '';

        this.selector = '';
        this.value = null;
        this.millis = null;
    },

    Test : function() {
        /** @type {Array.<ronTests.TestItem>} */
        this.items = [];
    },

    frameLoadFinishedCallback : null,
    frameLoadFineshedCallbackTimeout : 0,

    waitForFrameLoad : function(finishedCallback, frameLoadFineshedCallbackTimeout) {
        ronTests.frameLoadFinishedCallback = finishedCallback;
        ronTests.frameLoadFineshedCallbackTimeout = frameLoadFineshedCallbackTimeout ? frameLoadFineshedCallbackTimeout : 0;
    },

    onFrameLoaded : function() {
        console.log('onFrameLoaded ...');

        setTimeout(function () {
            if (ronTests.frameLoadFinishedCallback) {
                var callback = ronTests.frameLoadFinishedCallback;
                ronTests.frameLoadFinishedCallback = null;

                callback();
            }
        }, 4000);

    },

    /**
     * Volano v testovanem frame
     */
    frameLoaded : function() {
        console.log('Frame loaded ...');
        window.parent.ronTests.onFrameLoaded();
    },


    /**
     * @param {ronTests.TestItem} testItem
     *   --@ param {function} finishedCallback
     */
    openUrl : function(testItem) { // , finishedCallback) {
        console.log('Open URL', testItem.url);
        window.open(testItem.url, "appframe");
        //ronTests.waitForFrameLoad(finishedCallback);
    },

    /**
     * @param {ronTests.TestItem} testItem
     * @param {function} finishedCallback
     */
    wait : function(testItem, finishedCallback) {
        console.log('Wait', testItem.millis);
        if (testItem.millis) {
            setTimeout(finishedCallback, testItem.millis);
        } else {
            ronTests.waitForFrameLoad(finishedCallback);
        }
    },

    /**
     * @param {ronTests.TestItem} testItem
     */
    selectorExists : function(testItem) {
        var $elements = ronTests.$appContent.find(testItem.selector);
        console.log('Selector exists test', testItem.selector, 'length=' + $elements.length);
    },


    setValue : function(testItem) {
        console.log('Set value', testItem.selector, testItem.value);
        ronTests.$appContent.find(testItem.selector).val(testItem.value);
    },

    click : function(testItem) {
        console.log('Click', testItem.selector);
        ronTests.$appContent.find(testItem.selector).click();
    },


    executeTest : function(test) {
        /**
         * @param {ronTests.TestItem} testItem
         * @param {function} finishedCallback
         */
        var executeTestItem = function(testItem, finishedCallback) {
            switch (testItem.itemType) {
                case ronTests.OPEN_URL :
                    ronTests.openUrl(testItem);
                    break;

                case ronTests.WAIT :
                    ronTests.wait(testItem, finishedCallback);
                    return; // nepokracuje dale!

                case ronTests.SELECTOR_EXIST :
                    ronTests.selectorExists(testItem);
                    break;

                case ronTests.SET_VALUE :
                    ronTests.setValue(testItem);
                    break;

                case ronTests.CLICK :
                    ronTests.click(testItem);
                    break;
            }

            setTimeout(finishedCallback, 100);
        };

        var item = null;

        var executeNextItem = function() {
            item = (item === null ? 0 : item + 1);

            ronTests.$appContent = $("#appframe").contents();

            if (item < test.items.length) {
                executeTestItem(test.items[item], executeNextItem);
            }
        };

        executeNextItem();
    }



};

