

ron.sc = { };

$(function() {
    let
        $sluzebniCestaFormular = $("#sluzebni_cesta_formular"),
        idSC = $sluzebniCestaFormular.data("id-sc"),
        $cilovyStat = $("#CilovyStat"),
        nacitatStat = !$cilovyStat.val();
    let
        nactiMaximalniStravne = function() {
            let
                cilovyStat = $cilovyStat.val(),
                datum = $("#DatumSCOd").val();

            if (!cilovyStat  ||  !datum) {
                return;
            }

            if ($("#maximalniDenniStravne").is(":hidden")) return;

            let
                vychoziStatSelect = $("#vychoziStatSC"),
                vychoziStat = vychoziStatSelect.length ? vychoziStatSelect.val() : '';

            $.ajax("?menuid=sluzebnicestyjs&action=maxstravneprostat&cilovystat=" + cilovyStat + "&vychozistat=" + vychoziStat + "&datum=" + datum).done(
                function (data) {
                    if (data.result === "OK") {
                        $("#maximalniDenniStravne").html(data.text);
                    } else {
                        ron.showError(data);
                        $("#maximalniDenniStravne").html("");
                        focusJsonErrorField(data, true);
                    }
                }
            );
        },
        nactiKapesneStatu = function () {
            let
                $scForm = $("#sluzebni_cesta_formular"),
                sazbaKapesnehoPodleStatu = $scForm.data("sazba-kapesneho-podle-statu"),
                menitSazbuKapesneho = $scForm.data("menit-sazbu-kapesneho");

            if (!sazbaKapesnehoPodleStatu || !menitSazbuKapesneho) {
                return;
            }

            let
                cilovyStat = $cilovyStat.val();
            if (!cilovyStat) {
                return;
            }

            $.ajax("?menuid=sluzebnicestyjs&action=kapesneprostat&stat=" + cilovyStat).done(
                function (data) {
                    if (data.result === "OK") {
                        if (data.text) {
                            $("#SazbaKapesneho").val(data.text);
                        }
                    } else {
                        ron.showError(data);
                    }
                }
            );
        },


        nactiStatPodleRozdeleni = function(kodRozdeleni) {
            if (!kodRozdeleni) {
                return;
            }

            let nacitatAdresu = $("#sluzebni_cesta_formular").data("nacitat-adresu-rozdeleni");
            if (!nacitatAdresu && $cilovyStat.val() && !nacitatStat) {
                return;
            }

            $.ajax("?menuid=sluzebnicestyjs&action=adresarozdeleni&kod=" + encodeURIComponent(kodRozdeleni))
                .done(function (data) {
                    if (data.result === "OK") {
                        if (data.stat) {
                            let puvodniStat = $cilovyStat.val();
                            $cilovyStat.val(data.stat);
                            if (puvodniStat !== data.stat) {
                                nactiKapesneStatu();
                            }
                        }
                        if (nacitatAdresu) {
                            let novaAdresa =
                                (data.ulice ? data.ulice : "") +
                                (data.ulice && data.mesto ? ", " : "") +
                                (data.mesto ? data.mesto : "");

                            if (novaAdresa) {
                                $("#hlavickasc_popiscile").find("input").val(novaAdresa);
                            }
                        }
                    } else {
                        ron.showError(data);
                    }
                })
                .fail(function (jqXHR) {
                    ron.showAjaxError(jqXHR);
                });
        },


        zmenaRozdeleniSC = function() {
            let kod = $(this).val();

            if (kod && $("#scZahranicni").prop("checked")) {
                nactiStatPodleRozdeleni(kod);
            }
        },


        zahranicniClick = function($e) {
            let
                checked = $(this).prop("checked");

            $($e.delegateTarget).toggleClass("zahranicniSC", checked);

            if (checked) {
                nactiStatPodleRozdeleni($("#rozdelenisc_kod").val());
            }
        },


        cilovyStatChange = function() {
            nactiMaximalniStravne();
            nactiKapesneStatu();
        },
        rozdeleniOsoby_SC = function() {
            let
                idPP = $("#Osoba").val(),
                url = "?menuid=sluzebnicestyjs&action=rozdeleniosoby";


            function aktualizujSelect(newValue) {
                ronPortal.aktualizujRozdeleniOsoby(url, idPP, [$("#rozdelenisc_kod")], [$("#rozdelenisc_popis")], newValue);
            }

            ronPortal.rozdeleniOsoby({
                url: url + (idPP ? '&idpp=' + idPP : ''),
                closeCallback: aktualizujSelect
            });
        },


        nactiDataProOsobu = function(idOsoby) {
            $.ajax("?menuid=sluzebnicestyjs&action=dataproosobu&idpp=" + idOsoby)
                .done( function(data) {
                    if (data.result === "OK") {
                        if (data.rozdeleni) {
                            $("#rozdelenisc_popis").ronselect("value", data.rozdeleni);
                        }

                        if (data.stat) {
                            $("#vychoziStatSC").val(data.stat);
                        }
                        if (data.vozidla) {
                            let $select = $("#RegistracniZnacka");
                            $select.empty();
                            ron.loadOptions($select, data.vozidla);
                        }
                    } else {
                        ron.showError(data);
                    }
                }).fail( function(jqXHR) {
                ron.showAjaxError(jqXHR, "Pri nacitani dat doslo k chybe!");
            });
        },

        osobaChange = function() {
            nactiDataProOsobu($(this).val());
        };


    $(".sluzebnicestaformular")
        .on("click", "#vybratRozdeleniSC", rozdeleniOsoby_SC)
        .on("change", "#rozdelenisc_kod,#rozdelenisc_popis", zmenaRozdeleniSC)
        .on("click", "#scZahranicni", zahranicniClick)
        .on("change", "#CilovyStat", cilovyStatChange)
        .on("blur", "#DatumSCOd", nactiMaximalniStravne)
        .on("change", "#Osoba", osobaChange)
    ;

    if ($sluzebniCestaFormular.data("nacist-data-pro-osobu")) {
        nactiDataProOsobu($("#Osoba").val());
    }
});


$(function() {

    let
        seznamOsob = null,
        seznamOsobnichCisel = null;

    function cancel() {
        $("#hlavickasc_pridatspolucestujiciho").removeClass("d-none");
        $("#vyber_spolucestujiciho").addClass("d-none");
    }

    function ok() {
        let index = $("#jmenoSpolucestujiho").ronselect("itemIndex");
        if (index === null) {
            return;
        }

        let
            idPP = seznamOsob[index].idPP,
            idSC = $("#idScSpolucestujiciho").val(),
            csrfKey = $("#spolucestujiciCsrfKey").val(),
            data = {
                idpp: idPP,
                idsc: idSC,
                csrfkey: csrfKey
            };

        $.ajax(
            {
                url: "?menuid=sluzebnicestyjs&action=pridejspolucestujiciho",
                type: "POST",
                data : data
            }
        )
            .done( function(data) {
                if (data.result === "OK") {
                    window.location.replace("?menuid=sluzebnicesty&action=zobrazslcestu&record=" + idSC); // redirect
                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.showAjaxError(jqXHR);
            });

    }


    function onOsobaChange(index, options) {
        if (index === null) {
            return;
        }

        $("#jmenoSpolucestujiho").ronselect("value", options.items[index].idPP);
        $("#osobniCisloSpolucestujiciho").ronselect("value", options.items[index].idPP);
    }


    function naplnSeznamOsob(data) {
        $("#nacitani_spolucestujicich").addClass("d-none");

        if (data.result === "OK") {
            seznamOsob = data.pp;
            seznamOsobnichCisel = ron.utils.copyArray(data.pp);
            seznamOsobnichCisel.sort( function(item1, item2) {
                return item1.osobniCislo.localeCompare(item2.osobniCislo);
            });

            $("#jmenoSpolucestujiho").ronselect({
                items: seznamOsob,
                onChange: onOsobaChange,
                columns: ["jmenoPrijmeni", "osobniCislo"],
                textColumn: "jmenoPrijmeni",
                valueColumn: "idPP"
            });

            $("#osobniCisloSpolucestujiciho").ronselect({
                items: seznamOsobnichCisel,
                onChange: onOsobaChange,
                columns: ["jmenoPrijmeni", "osobniCislo"],
                textColumn: "osobniCislo",
                valueColumn: "idPP",
                dropDownAlign: "right"
            });
        } else {
            ron.showError(data);
            $("#maximalniDenniStravne").html( "" );
            focusJsonErrorField(data, true);
        }
    }

    function nactiSeznamOsob() {
        $("#spolucestujiciCancel").on("click", cancel);
        $("#spolucestujiciOK").on("click", ok);

        $.ajax('?menuid=sluzebnicestyjs&action=vyberspolucestujicich')
            .done(naplnSeznamOsob);
    }

    function vyberSpolucestujiciho() {
        $("#hlavickasc_pridatspolucestujiciho").addClass('d-none');
        $("#vyber_spolucestujiciho").removeClass('d-none');

        if (!seznamOsob) {
            nactiSeznamOsob();
        }

        return false;
    }

    $("#hlavickasc_pridatspolucestujiciho")
        .on("click", vyberSpolucestujiciho);

});


$(function() {

    var provestSchvaleni = function() {
        let
            $rows = $(".sc_row"),
            index = null,
            cancel = false,
            isError = false,
            $progressDialog = $("#progress_dialog");


        var
            onCancel = function() {
                cancel = true;
            },


            onClose = function() {
                window.location = "?menuid=sluzebnicesty";
            },


            zpracujVysledek = function(data) {
                if (data &&  data.errors) {
                    isError = true;

                    for (let i = 0;  i < data.errors.length;  i++) {
                        $progressDialog.progressDialog("addmessage", data.errors[i].errorText, "errortext");
                    }
                }
            };
        function zpracujRadek($row) {
            let
                data = {
                    id: $row.data("id-sc")
                },
                jeZmena = false,
                $checkboxes = $row.find(".schvaleni-check");

            $checkboxes.each(function() {
                let $checkbox = $(this);

                if (!$checkbox.prop("checked") != !$checkbox.data("original-value")) {
                    jeZmena = true;
                    data["Schvaleni_" + $checkbox.data("level")] = $checkbox.prop("checked") ? 1 : 0;
                }
            });
            if ($row.data("csrfkey")) {
                data.csrfkey = $row.data("csrfkey");
            }

            if (jeZmena) {
                $.ajax( {
                    url: "?menuid=sluzebnicestyjs&action=schvalenisc",
                    type: "POST",
                    data : data
                })
                    .done( zpracujVysledek )
                    .fail( ron.ajaxErrorFunction("Pri schvaleni doslo chybe!") )
                    .always(zpracujDalsiRadek);

            } else {
                setTimeout(zpracujDalsiRadek, 0); // aby se aktualizoval progress
            }
        }


        function zpracujDalsiRadek() {
            index = (index === null) ? 0 : index + 1;

            if (cancel  ||  index >= $rows.length) {
                if (isError) {
                    $progressDialog
                        .progressDialog("setvalue", index, '')
                        .progressDialog("setbuttons", ["close"]);
                } else {
                    window.location = "?menuid=sluzebnicesty";
                }
                return;
            }

            let $radek = $($rows.get(index));
            $progressDialog.progressDialog("setvalue", index, $radek.data('info-sc'));
            zpracujRadek($radek);
        }

        $progressDialog.progressDialog({
            min: 0,
            max: $rows.length,
            onCancel: onCancel,
            onClose: onClose
        });

        zpracujDalsiRadek();

        return false;
    };
    var oznacRadekSC = function($row) {
        var
            selected = false,
            $checkboxes = $row.find(".schvaleni-check");

        $checkboxes.each(function() {
            var $checkbox = $(this);

            if (!$checkbox.prop("checked") != !$checkbox.data("original-value")) {
                selected = true;
            }
        });

        $row.toggleClass("browserselectedrow", selected);
    };


    var schvaleniCheckboxClick = function() {
        oznacRadekSC($(this).closest("tr"));
    };


    var oznacVsechnyRadky = function() {
        $(".sc_row").each(function() {
            oznacRadekSC($(this));
        });
    };
    var oznacVsechny = function(index, value) {
        var $checkboxes = $("#seznamsluzebnichcest").find(".Schvaleni_" + index);

        switch (value) {
            case -1 :
                $checkboxes.each(function() {
                    var $this = $(this);

                    $this.prop("checked", !!$this.data("original-value"));
                });
                break;

            default :
                $checkboxes.prop("checked", !!value);
                break;

        }

        oznacVsechnyRadky();
    };



    var schvaleniSCMenu = function($sender, uroven) {
        var $menu = $("#schvaleniSCMenu");

        $menu
            .off("click", "li")
            .on("click", "li", function() {
                oznacVsechny( uroven, $(this).data("ron-hodnotaschvaleni") );
            });

        $menu.ronPopupMenu( { attachToElement: $sender } );

        return false; // stop event propagation
    };


    var showSchvaleniMenu = function() {
        var $this = $(this);
        schvaleniSCMenu($this, $this.data("index"));
        return false;
    };


    var allCheckClick = function() {
        var
            $this = $(this),
            checked = $this.prop("checked"),
            index = $this.data("index");

        oznacVsechny(index, checked);
    };

    function schvalSluzebniCesty() {
        let
            index = null,
            $rows = $(".sc_row");

        function provedSchvaleniRadku($row) {
            schvalDalsiSC();
        }

        function schvalDalsiSC() {
            index = (index === null) ? 0 : index + 1;

            if (index >= $rows.size()) {
                return;
            }

            provedSchvaleniRadku($($rows.get(i)));
        }

        schvalDalsiSC();
    }


    $("#seznamsluzebnichcest.hromadne-schvalovani")
        .on("click", ".schvaleni_ALL", allCheckClick)
        .on("click", ".schvaleniSCShowMenu", showSchvaleniMenu)
        .on("click", "input", schvaleniCheckboxClick);

    $("#provestHromadneSchvaleniSC")
        .on("click", provestSchvaleni);

});
(function($) {
    let
        $element = null; // nastavi se dale
    function predvyplnStatSlCesty(index) {
        let $select = $("[name=stat_" + index + "]").eq(0);

        if (!$select.length) {
            return false;
        }
        if ($select.val()) {
            return false;
        }

        let $options = $select.children("option");
        if ($options.length === 1) {
            $select.val($options.eq(0).val());
            return true;
        }

        if ($options.length === 2 && $options.eq(0).val() === "") {
            $select.val($options.eq(1).value);
            return true;
        }
        if (index <= 1) {
            $select.val($element.data("stat-sc")).trigger("change");
            return true;
        }
        if (index === 2) {
            $select.val($element.data("cilovy-stat-sc")).trigger("change");
            return true;
        }
        let predchoziRadek = index - 1;

        while (predchoziRadek > 0) {
            let
                $pom_casinput = $("[name=casod_" + predchoziRadek + "]").eq(0),
                $pom_statinput = $("[name=stat_" + predchoziRadek + "]").eq(0);

            if ( $pom_casinput.length  &&  $pom_statinput.length  &&  $pom_casinput.val()  && $pom_statinput.val() ) {
                $select.val($pom_statinput.val()).trigger("change");
                return true;
            }
            else {
                predchoziRadek--;
            }
        }
        $select.val($element.data("cilovy-stat-sc")).trigger("change");
    }
    function vyberNasledujiciOperaci(seznam, indexRadku) {
        let
            predchoziOperace = null,
            predchoziRadek = indexRadku - 1;
        while (predchoziRadek > 0  &&  !predchoziOperace) {
            let
                pom_casinput = document.getElementsByName('casod_' + predchoziRadek)[0],
                pom_operaceinput = document.getElementsByName('operace_' + predchoziRadek)[0];

            if (pom_casinput  &&  pom_operaceinput  &&  pom_casinput.value  &&  pom_operaceinput.value) {
                predchoziOperace = pom_operaceinput.value;
            } else {
                predchoziRadek--;
            }
        }

        if (!predchoziOperace) {
            return null;
        }

        predchoziOperace = predchoziOperace.toLocaleLowerCase();

        let
            result = null,
            star = false,
            found = false;
        for (let i = 0;  i < seznam.length;  i++) {
            if (found) {
                if ( seznam[i] !== "*" ) {
                    return seznam[i];
                }
            }
            else if (star) {
                if ( seznam[i] !== "*" ) {
                    result = seznam[i];
                }
            }

            if (seznam[i].toLocaleLowerCase() === predchoziOperace) {
                found = true;
            }

            star = seznam[i] === "*";
        }

        return result;
    }


    var predvyplnOperaciSlCesty = function(index) {
        let
            operaceSluzebniCesty = $element.data('operace-sc');

        if (!operaceSluzebniCesty) {
            return;
        }

        let
            operace = operaceSluzebniCesty.split(";"),
            predchozioperace = null,
            predchozicas = null,
            predchoziradek = index - 1;

        if (!operace.length) {
            return;
        }
        while (predchoziradek > 0  &&  !predchozioperace) {
            let
                pom_casinput = document.getElementsByName('casod_' + predchoziradek)[0],
                pom_operaceinput = document.getElementsByName('operace_' + predchoziradek)[0];

            if (pom_casinput  &&  pom_operaceinput  &&  pom_casinput.value) {
                predchozioperace = pom_operaceinput;
                predchozicas = pom_casinput;
            } else {
                predchoziradek--;
            }
        }

        let operaceinput = document.getElementsByName('operace_' + index)[0];
        if (operaceinput  &&  !operaceinput.value) {
            if (predchoziradek > 0) {
                let novaoperace = vyberNasledujiciOperaci(operace, index);
                if (novaoperace) {
                    operaceinput.value = novaoperace;
                }
            }
            else {
                if (operace[0]) {
                    operaceinput.value = operace[0];
                }
            }
        }
    };
    var predvyplnNovyRadekSlCesty = function(index) {
        predvyplnOperaciSlCesty(index);
        predvyplnStatSlCesty(index);
    };
    var novyRadekChange = function() {
        var index = $(this).data("ron-index");
        if (!index) {
            return;
        }

        var $row = $("#radekSC_" + index);
        if (!$row.length) {
            return;
        }

        var zobrazit = false;

        var $cas_input = $("[name=casod_" + index + "]");
        if ($cas_input.length  &&  $cas_input.eq(0).val() != "") {
            zobrazit = true;
        }

        if (!zobrazit) {
            var snidane_checkbox = $("[name=pocetPJidel_S_" + index + "]").eq(0);
            if (snidane_checkbox.length  &&  snidane_checkbox.prop("checked")) {
                zobrazit = true;
            }
        }
        if (!zobrazit) {
            var obed_checkbox = $("[name=pocetPJidel_O_" + index + "]").eq(0);
            if (obed_checkbox.length  &&  obed_checkbox.prop("checked")) {
                zobrazit = true;
            }
        }
        if (!zobrazit) {
            var vecere_checkbox = $("[name=pocetPJidel_V_" + index + "]").eq(0);
            if (vecere_checkbox  &&  vecere_checkbox.prop("checked")) {
                zobrazit = true;
            }
        }

        if (zobrazit) {
            if ($row.hasClass("novyradekSC") ) {
                $row.removeClass("novyradekSC");
                predvyplnNovyRadekSlCesty(index);
            }
        }
        else {
            $row.addClass("novyradekSC");
        }
    };


    var predvyplnCas = function($input) {
        var index = $input.data("ron-index");

        if (!$input.val()) {
            var
                casPocatku = $element.data("cas-pocatku"),
                casStr = "";

            if (index == 1) {
                casStr = (!casPocatku || casPocatku == "0:00") ? "8:00" : casPocatku;
            } else if ($input.closest("tr").is(".prvniradekprodenSC")) {
                casStr = "8:00";
            } else {
                var $predchoziInput = $("input[name='casod_" + (index - 1) + "']");

                if ($predchoziInput.val()) {
                    var cas = ron.utils.timeStringToFloat($predchoziInput.val());
                    if (cas) {
                        casStr = ron.utils.floatToTimeString(cas + 1);
                    }
                }
            }

            if (casStr) {
                $input.val(casStr);
            }
        }
    };


    var casInputDblClick = function() {
        predvyplnCas($(this));
        novyRadekChange.call(this);
    };


    var jidloCheckboxClick = function() {
        novyRadekChange.call(this);

        predvyplnCas($("input[name='casod_" + $(this).data("ron-index") + "']"));
    };


    function nastavStatProMistoSC() {
        let $this = $(this);
        if ( !$this.val() ) {
            return;
        }

        let index = $this.data('ron-index');

        $.ajax( "?menuid=sluzebnicestyjs&action=statpromistosc&kod=" + encodeURIComponent($this.val()) )
            .done( function(data) {
                if (data.result === "OK") {
                    $("[name='stat_" + index + "']")
                        .val(data.text)
                        .trigger("change");

                } else {
                    ron.showError(data);
                }
            })
            .fail( function(jqXHR) {
                ron.showAjaxError(jqXHR);
            });
    }


    var deleteRow = function() {
        var index = $(this).data('ron-deleterow');
        if (!index) {
            return;
        }

        ron.confirm(ron._("SC_Opravdu_zrusit_radek"),
            function() {
                document.radky_sc_form.smazat_radek_sluzebky.value = index;
                document.radky_sc_form.submit();
            }
        );
    };


    var vydajeProDenClick = function() {
        var datum = $(this).data('ron-vydaje');

        if (!datum) {
            return;
        }

        this.form.zobrazitVydajeProDen.value = datum;

        ron.showWorkingInfo();
        this.form.submit();
    };


    $(function() {
        $element = $("#radky_sc_editace");

        $element
            .on("keyup", 'input[name^="casod_"]', novyRadekChange)
            .on("change", 'input[name^="casod_"]', novyRadekChange)
            .on("dblclick", 'input[name^="casod_"]', casInputDblClick)
            .on("change", 'input[name^="pocetPJidel_"]', jidloCheckboxClick)
            .on("change", '[name^="misto_"]', nastavStatProMistoSC)
            .on("click", ".glyph-delete", deleteRow)
            .on("click", '[name^="vydaje_"]', vydajeProDenClick)
        ;
    });
})(jQuery);


(function($) {
    function nastavProkazaniCenyPHM() {
        let
            $this = $(this),
            prokaze = ($this.attr("value") == "1" ? !$this.prop("checked") : $this.prop("checked"));
        $("#row_uctovani_NVV_DruhPHM").toggleClass("d-none", prokaze);
        $("#row_uctovani_NVV_CenaPHM").toggleClass("d-none", !prokaze);
    }
    function radekSlCesty_Je_NVV(kod) {
        let
            kodyStr = "" + $("#radek_uctovani_sc_dialog").data("typy-uctovani-nvv"),
            kody = kodyStr ? kodyStr.split(";") : [];

        for (let i = 0;  i < kody.length;  i ++) {
            if ( kody[i] == kod ) {
                return true;
            }
        }

        return false;
    }
    function nastavTypRadkuUctovaniSlCesty() {
        let jeNahrada = radekSlCesty_Je_NVV($(this).val());

        $("#group_podrobnosti_nvv")
            .toggleClass("d-none", !jeNahrada);

        $("#group_uctovanisc_platba")
            .toggleClass("d-none", jeNahrada);
    }


    function menaUctovaniChange() {
        $("#vlastni_kurz_kod_meny").text($(this).val());
    }
    function vozidloUctovaniSCChange() {
        let
            $this = $(this),
            $selectedOption = $this.find('option[value="' + $this.val() + '"]');

        if ($selectedOption.length) {
            let
                spotreba = $selectedOption.data("spotreba"),
                druhPHM = $selectedOption.data("druhphm"),
                $editSpotreba = $($this.data("edit-spotreba")),
                $selectPHM = $($this.data("edit-druhphm")),
                $checkJednostope = $($this.data("edit-jednostope"));
            if (spotreba) {
                $editSpotreba
                    .val(spotreba)
                    .attr("readonly", "readonly");
            } else {
                $editSpotreba
                    .attr("readonly", null);
            }
            if (druhPHM) {
                $selectPHM
                    .val(druhPHM)
                    .attr("readonly", "readonly");
            } else {
                $selectPHM
                    .attr("readonly", null);
            }

            $checkJednostope
                .prop("checked", $selectedOption.data("jednostope"))
                .toggleClass("checkbox-readonly", $selectedOption.attr("value") !== "");
        }
    }


    function nactenaDataDialogu() {
        console.log("nactenaDataDialogu", this);
    }


    $(function() {
        $("#radek_uctovani_sc_dialog")
            .on("change", ".nvv-neprokazana-cena-phm", nastavProkazaniCenyPHM)
            .on("change", "#typ_radku_uctovani_sc", nastavTypRadkuUctovaniSlCesty)
            .on("change", "#uctovani_sc_kod_meny", menaUctovaniChange)
            .on("dialogdataloaded", nactenaDataDialogu);

        $("body")
            .on("change", ".vozidlo-uctovani-sc", vozidloUctovaniSCChange);
    });
})(jQuery);

$(function() {
    var
        nastavProkazaniCenyPHM = function() {
            if ($(this).val() == "1") {
                $("#NVV_DruhPHM").removeClass("d-none");
                $("#NVV_CenaPHM").addClass("d-none");
            }
            else {
                $("#NVV_DruhPHM").addClass("d-none");
                $("#NVV_CenaPHM").removeClass("d-none");
            }
        },
        radekSlCesty_Je_NVV = function(kod)
        {
            let
                kodyStr = "" + $("#UctovaniSluzebniCestyForm").data("typy-uctovani-nvv"),
                kody = kodyStr ? kodyStr.split(";") : [];

            for (let i = 0;  i < kody.length;  i ++) {
                if ( kody[i] == kod ) {
                    return true;
                }
            }

            return false;
        },
        nastavTypRadkuUctovaniSlCesty = function() {
            let jeNahrada = radekSlCesty_Je_NVV($(this).val());

            $("#nahradyzavozidlo")
                .css("display", jeNahrada ? "inline" : "none");

            this.form.Castka.disabled = jeNahrada;
        };


    $("#UctovaniSluzebniCestyForm")
        .on("change", "input[name='NVV_NeprokazanaCenaPHM']", nastavProkazaniCenyPHM)
        .on("change", "#typRadkuUctovaniSC", nastavTypRadkuUctovaniSlCesty);
});

$(function() {

    function nastavProkazaniCenyPHM() {
        let
            $this = $(this),
            index = $this.data("index"),
            prokaze = $this.attr("value") == "1";

        $("select[name=NVV_DruhPHM_" + index + "]").css("display", prokaze ? "inline" : "none");
        $("input[name=NVV_CenaPHM_" + index + "]").css("display", prokaze ? "none" : "inline");
    }


    function deleteRadekUctovani() {
        let $that = $(this);

        ron.confirmQuestion($that, function() {
            document.radky_uctovanisc_form.smazat_radek_uctovani_sluzebky.value = $that.data("cislo-radku");
            document.radky_uctovanisc_form.submit();
        });
    }

    $("#radky_uctovanisc_editace")
        .on("click", ".glyph-delete", deleteRadekUctovani)
        .on("change", ".NVV_ProkazaniCenyPHM", nastavProkazaniCenyPHM);
});


$(function() {
    function menaUctovaniChange() {
        $("#editace_uctovani_mena").text($(this).val());
    }


    function showDokumentSCDialog() {

        ronPortal.showDokumentDialog();
        return false;
    }
    function vraceniSCClick(sender) {
        $("#vracenisluzebnicesty").show();
        $(this).hide();

        return false; // puvodni odkaz se nepouzije
    }
    var kopieProSpolucestujiciho = function() {
        var $this = $(this);

        var provedRedirect = function() {
            window.location.replace( $this.attr("href") ); // redirect
        };

        var vytvorKopii = function() {
            var
                idPP = $this.data("ron-idpp"),
                idSC = $this.data("ron-idsc");

            $.ajax("?menuid=sluzebnicestyjs&action=overspolucestujiciho&idpp=" + idPP + "&idsc=" + idSC )
                .done( function(data) {
                    if (data.result === "warning") {
                        ron.confirm(data.infoText, provedRedirect);
                        return;
                    } else if (data.result !== "OK") {
                        ron.showError(data);
                        return;
                    }

                    provedRedirect();
                });
        };

        ron.confirmQuestion( $this, vytvorKopii );
        return false;
    };



    $(document.body)
        .on("change", "#KodMeny", menaUctovaniChange)
        .on("click", "#vlozit_dokument_sc", showDokumentSCDialog)
        .on("click", ".vraceni_sluzebni_cesty_link", vraceniSCClick)
        .on("click", ".kopieProSpolucestujiciho", kopieProSpolucestujiciho);

});
