
$( function() {
    function vyrobniZakazkaChange($event) {
        let
            $form = $($event.delegateTarget),
            $this = $(this),
            index = $this.closest(".radekDenniVyrobyOsoby").data("rowindex"),
            idpp = $form.data("idpp"),
            den = $form.data("den");

        let
            $ronselect = $("#vyroba" + index + "_cinnost").ronselect("instance");

        $ronselect.loadData("?menuid=vyrobajs&action=cinnostizakazky&idpp=" + idpp + "&den=" + den + "&zakazka=" + $this.val());
    }
    function hodinyEditChange() {
        let $zbyva = $("#Vyroba_Zbyva");
        if (!$zbyva.length) {
            return;
        }

        let
            sum = ron.utils.timeStringToFloat($zbyva.data("ron-sum")),
            cnt = parseInt($("#vyroba_COUNT").val());

        $(".vyroba_hodiny").each(function () {
            let
                $edit = $(this),
                hodnota = $edit.val().trim() === ''
                    ? 0
                    : ron.utils.timeStringToFloat($edit.val().trim());

            $edit.toggleClass('error', hodnota == null);
            if (hodnota != null) {
                sum -= hodnota;
            }
        });

        sum = sum.toFixed(2);

        $zbyva
            .text(ron.utils.floatToTimeString(sum))
            .toggleClass('minus', sum < 0);
    }


    function deleteRowClick() {
        let
            $this = $(this);

        function deleteRow() {
            let $input = $("#vyroba_delete_row");
            $input.val($this.data("serial"));

            $input.closest("form").submit();
        }

        ron.confirmQuestion($this, deleteRow);
    }


    $(".rozdeleniVyrobyOsoby")
        .on("change", "select.vyrobni_zakazka.nacitat_cinnosti", vyrobniZakazkaChange)
        .on("change", ".vyroba_hodiny", hodinyEditChange)
        .on("click",  ".vyroba_delete", deleteRowClick);

});
$(function() {

    var
        activeRow = -1,
        activeCol = -1;

    var hodinyEditFocus = function() {
        var $this = $(this);

        $(".vyrobaOsoby .vyroba_hodiny").toggleClass("active", false);
        $this.toggleClass("active", true);

        activeRow = $this.closest("tr").data("rowindex");
        activeCol = $this.data("index");

        $("#vyroba_datum").text( $this.data("datum") );
        $("#vyroba_popis")
            .val( $("#popis_" + activeRow + "_" + activeCol).val() )
            .prop("readonly", $this.prop("readonly"));
        $("#vyroba_rozsirujici_popis")
            .val( $("#rozsirujiciPopis_" + activeRow + "_" + activeCol).val() )
            .prop("readonly", $this.prop("readonly"));
    };


    var popisChange = function() {
        if (activeRow < 0  ||  activeCol < 0) return;

        $("#popis_" + activeRow + "_" + activeCol).val( $("#vyroba_popis").val() );
        $("#rozsirujiciPopis_" + activeRow + "_" + activeCol).val( $("#vyroba_rozsirujici_popis").val() );
    };


    var vyrobniZakazkaChange = function ($event) {
        let
            $form = $($event.delegateTarget),
            $this = $(this),
            index = $this.closest("tr").data("rowindex"),
            idpp = $form.data("idpp"),
            den = $form.data("datum-od"),
            denDo = $form.data("datum-do");

        let
            $ronselect = $("#cinnostVyrobniZakazky_" + index).ronselect("instance");

        $ronselect.loadData("?menuid=vyrobajs&action=cinnostizakazky&idpp=" + idpp + "&den=" + den + "&denDo=" + denDo + "&zakazka=" + $this.val());
    };


    var spocitejSoucetSloupce = function(index, count) {
        let sum = 0;

        for (let row = 0;  row < count;  row++) {
            let
                $edit = $("#hodnota_" + row + "_" + index),
                hodnota = $edit.val().trim() === ''
                    ? 0
                    : ron.utils.timeStringToFloat($edit.val().trim());

            $edit.toggleClass('error', hodnota == null);
            if (hodnota != null) {
                sum += hodnota;
            }
        }

        sum = sum.toFixed(2);

        $("#rozdeleniVyrobyOsoby_sum_" + index)
            .text(ron.utils.floatToTimeString(sum))
            .toggleClass('minus', sum < 0);

        var $odpracovano = $("#rozdeleniVyrobyOsoby_rozdelit_" + index);
        if ($odpracovano.length) {
            var odpracovano = ron.utils.timeStringToFloat($odpracovano.text().trim());

            $("#rozdeleniVyrobyOsoby_zbyva_" + index)
                .text(ron.utils.floatToTimeString(odpracovano - sum))
                .toggleClass('minus', sum > odpracovano);
        }
    };
    var spocitejSoucetRadku = function($tr) {
        var
            rowIndex = parseInt($tr.data("rowindex")),
            sum = 0;

        $tr.find(".vyroba_hodiny").each( function() {
            var hodnotaStr = $(this).val().trim();
            var hodnota = hodnotaStr == '' ? 0 : ron.utils.timeStringToFloat(hodnotaStr);

            if (hodnota != null) {
                sum += hodnota;
            }
        });

        $("#celkem_" + rowIndex)
            .text(ron.utils.floatToTimeString(sum));
    };


    var hodinyEditChange = function() {
        var $this = $(this);
        var
            index = parseInt($this.data("index")),
            count = parseInt($this.closest(".vyrobaOsoby").data("count"));

        spocitejSoucetSloupce(index, count);
        spocitejSoucetRadku($this.closest("tr"));
    };

    var deleteRowClick = function() {
        var
            $this = $(this);

        var deleteRow = function() {
            var $input = $("#deleteRowIndex");
            $input.val($this.data("row-index"));

            $input.closest("form").submit();
        };

        ron.confirmQuestion($this, deleteRow);
    };

    $(".vyrobaOsoby")
        .on("focus", ".vyroba_hodiny", hodinyEditFocus)
        .on("change", ".vyrobni_zakazka", vyrobniZakazkaChange)
        .on("change", ".vyroba_hodiny", hodinyEditChange)
        .on("click", ".vyroba_delete_row", deleteRowClick)
        .on("change", "#vyroba_popis, #vyroba_rozsirujici_popis", popisChange);
});

$( function() {
    var zkopirujRadek = function () {
        var $row = $(this).closest('.vyroba_radek');

        var index = $row.data('vyroba-max-index');
        var idRadku = $row.data('vyroba-idradku');

        var $rowClone = $row.clone();
        $rowClone.find('input:not(:button)')
            .prop('value', '')
            .removeClass('error');
        var newIndex = index + 1;

        $('[name="' + idRadku + '_max_index"]').prop('value', newIndex);
        $rowClone.find('[name="' + idRadku + '_max_index"]').remove();

        $rowClone.data('vyroba-max-index', newIndex);
        $rowClone.prop('data-vyroba-max-index', newIndex);
        $rowClone.find(".vyroba_osc").empty();
        $rowClone.find(".vyroba_jmeno").empty();
        $rowClone.find(".vyroba_dv").empty();
        $rowClone.find(".vyroba_mv").empty();
        $rowClone.find(".vyroba_vysledekhod").empty();
        $rowClone.find('[name^="vyroba_pocetks_' + idRadku + '"]').prop('name', 'vyroba_pocetks_' + idRadku + '_' + newIndex);
        $rowClone.find('[name^="vyroba_hodiny_' + idRadku + '"]')
            .prop('name', 'vyroba_hodiny_' + idRadku + '_' + newIndex);
        $rowClone.find('[name^="vyroba_casod_' + idRadku + '"]')
            .prop('name', 'vyroba_casod_' + idRadku + '_' + newIndex);
        $rowClone.find('[name^="vyroba_casdo_' + idRadku + '"]')
            .prop('name', 'vyroba_casdo_' + idRadku + '_' + newIndex);
        $rowClone.find('[name^="vyroba_datumod_' + idRadku + '"]')
            .prop('name', 'vyroba_datumod_' + idRadku + '_' + newIndex);
        $rowClone.find('[name^="vyroba_datumdo_' + idRadku + '"]')
            .prop('name', 'vyroba_datumdo_' + idRadku + '_' + newIndex);


        $rowClone.find('[data-roncalendar-inputname^="vyroba_datumod_' + idRadku + '"]')
            .data('roncalendar-inputname', 'vyroba_datumod_' + idRadku + '_' + newIndex);
        $rowClone.find('[data-roncalendar-inputname^="vyroba_datumdo_' + idRadku + '"]')
            .data('roncalendar-inputname', 'vyroba_datumdo_' + idRadku + '_' + newIndex);

        $rowClone.find('[name^="vyroba_hodiny_' + idRadku + '"], [name^="vyroba_casod_' + idRadku + '"], [name^="vyroba_casdo_' + idRadku + '"], [name^="vyroba_datumod_' + idRadku + '"], [name^="vyroba_datumdo_' + idRadku + '"]')
            .data('ron-hodiny-casod', 'vyroba_casod_' + idRadku + '_' + newIndex)
            .data('ron-hodiny-datumod', 'vyroba_datumod_' + idRadku + '_' + newIndex)
            .data('ron-hodiny-casdo', 'vyroba_casdo_' + idRadku + '_' + newIndex)
            .data('ron-hodiny-datumdo', 'vyroba_datumdo_' + idRadku + '_' + newIndex)
            .data('ron-hodiny-hodiny', 'vyroba_hodiny_' + idRadku + '_' + newIndex);


        var $ronComboVyrobek = $rowClone.find('[name="vyroba_vyrobek_' + idRadku + '_view"]');
        $ronComboVyrobek
            .prop('id', 'vyroba_vyrobek_' + idRadku + '_view_' + newIndex)
            .data('code-input', 'vyroba_vyrobek_' + idRadku + '_' + newIndex);
        if ($ronComboVyrobek.data('reload-item') !== '') {
            $ronComboVyrobek.data('reload-item',  '#vyroba_zakazka_' + idRadku + '_view_' + newIndex);
        }
        $rowClone.find('[name="vyroba_vyrobek_' + idRadku + '_' + index + '"]').prop('name', 'vyroba_vyrobek_' + idRadku + '_' + newIndex);
        $ronComboVyrobek.val($ronComboVyrobek.data('default-value')).ronselect();

        var $ronComboCinnost = $rowClone.find('[name="vyroba_cinnost_' + idRadku + '_view"]');
        $ronComboCinnost
            .prop('id', 'vyroba_cinnost_' + idRadku + '_view_' + newIndex)
            .data('code-input', 'vyroba_cinnost_' + idRadku + '_' + newIndex);
        $rowClone.find('[name="vyroba_cinnost_' + idRadku + '_' + index + '"]').prop('name', 'vyroba_cinnost_' + idRadku + '_' + newIndex);
        $ronComboCinnost.val($ronComboCinnost.data('default-value')).ronselect();

        var $ronComboZakazka = $rowClone.find('[name="vyroba_zakazka_' + idRadku + '_view"]');
        $ronComboZakazka
            .prop('id', 'vyroba_zakazka_' + idRadku + '_view_' + newIndex)
            .data('code-input', 'vyroba_zakazka_' + idRadku + '_' + newIndex);
        if ($ronComboZakazka.data('reload-item') !== '') {
            $ronComboZakazka.data('reload-item',  '#vyroba_vyrobek_' + idRadku + '_view_' + newIndex);
        }
        $rowClone.find('[name="vyroba_zakazka_' + idRadku + '_' + index + '"]').prop('name', 'vyroba_zakazka_' + idRadku + '_' + newIndex);
        $ronComboZakazka.val($ronComboZakazka.data('default-value')).ronselect();

        $rowClone.removeClass('browserhighlightrow');
        $rowClone.find('.confirmQuestion').remove();

        $row.after($rowClone);
        $row.find('.vyroba_add').remove();

        var $radky = $('.vyroba_radek');
        $radky.removeClass('browsercolor1 browsercolor2');
        $radky.filter(':even').addClass('browsercolor1');
        $radky.filter(':odd').addClass('browsercolor2');

        $rowClone.find('input:first').trigger('focus');
    };


    var vypoctiHodiny = function () {
        var time1 = ron.utils.stringToTime($('[name='+$(this).data('ron-hodiny-casod')+']').val());
        if (!time1) return;

        var den = ron.utils.stringToDate($('[name=den]').val());

        var date1 = den;
        var date1Str = $('[name='+$(this).data('ron-hodiny-datumod')+']').val();
        if ((date1Str !== '') && (date1Str !== undefined)) {
            date1 = ron.utils.stringToDate(date1Str);
        }
        time1.setUTCFullYear(date1.getFullYear(), date1.getMonth(), date1.getDate());

        var time2 = ron.utils.stringToTime($('[name='+$(this).data('ron-hodiny-casdo')+']').val());
        if (!time2) return;

        var date2 = den;
        var date2Str = $('[name='+$(this).data('ron-hodiny-datumdo')+']').val();
        if ((date2Str !== '') && (date2Str !== undefined)) {
            date2 = ron.utils.stringToDate(date2Str);
        }
        time2.setUTCFullYear(date2.getFullYear(), date2.getMonth(), date2.getDate());

        var milis = time2.getTime() - time1.getTime();
        if (milis < 0) milis = milis + 24 * 3600 * 1000;

        var time = new Date();
        time.setTime(milis);

        $('[name='+$(this).data('ron-hodiny-hodiny')+']').val(ron.utils.timeToString(time, true, false)); // utc=true, seconds=false
    };

    var vyrobaItemChange = function (event, data) {
        if (!data  || !data.item) {
            return;
        }

        let $this = $(this),
            val = data.item.kod,
            hiddenInputName = $this.data('code-input'),
            $secondElem = $($this.data('reload-item')),
            url = $secondElem.data('items-url'),
            attr = $secondElem.data('url-add'),
            newUrl = url + '&' + attr + '=' + val;

        $('[name="' + hiddenInputName + '"]').val(val);
        if ($secondElem.length) {
            $secondElem.ronselect("instance").loadData(newUrl);
        }
    };

    var vyrobaLoad = function (event, data) {
        console.log(data);
        if (!data || !data.length) {
            return;
        }

        let $this = $(this),
            hiddenInputName = $this.data('code-input'),
            val = $('[name="' + hiddenInputName + '"]').val(),
            $secondElem = $($this.data('reload-item')),
            url = $secondElem.data('items-url'),
            attr = $secondElem.data('url-add'),
            newUrl = url + '&' + attr + '=' + val;

        if ($secondElem.length) {
            $secondElem.ronselect("instance").loadData(newUrl);
        }
    };

    $("body")
        .on('click', '.vyroba_add', zkopirujRadek)
        .on('change', '.ronInputHodiny', vypoctiHodiny)
        .on("itemactivate", ".vyroba_combo", vyrobaItemChange)//;
        .on("dataloaded", ".vyroba_combo[data-reload-item]", vyrobaLoad);

});


$(function() {

    var renderDataDetail = function(result) {
        $("#monv_detail_osc").text(result.osobniCislo);

        if (result.idFotografie) {
            $("#monv_detail_foto").
                append(
                    $("<div/>")
                        .addClass("fotoDochazka ronFoto")
                        .append(
                            $("<img/>")
                                .attr("src", "?menuid=monitorovaniv&action=foto&idpp=" + result.idPP)
                        )
                );

        }

        var $tbody = $("#monv_detail_data");

        if (result.puvodniVyroba) {
            for (var i = 0; i < result.puvodniVyroba.length; i++) {
                $("<tr/>")
                    .append($("<td/>").text(result.puvodniVyroba[i].cas))
                    .append($("<td/>").text(result.puvodniVyroba[i].popis))
                    .append($("<td/>").text(result.puvodniVyroba[i].terminal))
                    .appendTo($tbody);
            }
        }
    };

    var loadDataDetail = function(idpp) {
        $("#monv_detail_data").empty();
        $("#monv_detail_osc").empty();
        $("#monv_detail_foto").empty();

        $.ajax( {
            url: "?menuid=monitorovaniv&action=detaildata&idpp=" + idpp,
            type: "get",
            dataType: "json"
        }).fail( function(jqXHR) {
            ron.showError("Error " + jqXHR.status + ": " + jqXHR.statusText);
        }).done( function(resultObject) {
            if (resultObject.errors  &&  resultObject.errors.length) {
                ron.showError(resultObject);
            }

            renderDataDetail(resultObject);
        });

    };

    var radekMonitorovaniClick = function($e) {
        if ($($e.target).is("a")) {
            return;
        }

        var
            $this = $(this),
            idpp = $this.data("id-pp");

        if (!idpp) {
            return;
        }

        $("#monitorovani_vyroby_detail")
            .dialog({
                modal: true,
                width: "auto",
                dialogClass: "no-close dialog",
                title: $this.data("jmeno"),
                open: function () {
                    loadDataDetail(idpp);
                }
            });
    };


    var nastavViditelnostRadku = function($select) {
        var
            $option = $select.children("option:selected");

        $("#row_VyrobniZakazka").toggleClass("d-none", $option.data("zadavat-zakazku") == "0");
        $("#row_Vyrobek").toggleClass("d-none", $option.data("zadavat-vyrobek") == "0");
        $("#row_VyrobniCislo").toggleClass("d-none", $option.data("zadavat-vyrobni-cislo") == "0");
        $("#row_MnozstviDobre").toggleClass("d-none", $option.data("zadavat-mnozstvi-dobre") == "0");
        $("#row_MnozstviSpatne").toggleClass("d-none", $option.data("zadavat-mnozstvi-spatne") == "0");
    };


    var vlozeniVyrobyClick = function() {
        var
            $this = $(this),
            $tr = $this.closest("tr"),
            idpp = $tr.data("id-pp");

        if (!idpp) {
            return;
        }

        $("#vkladani_idpp").val(idpp);
        $("#vkladani_jmeno").text($tr.data("jmeno"));

        nastavViditelnostRadku($("#vkladani_vyrobni_cinnost"));

        $("#vlozeni_vyroby_dialog")
            .dialog({
                modal: true,
                width: "auto"
            });
        return false;
    };


    $(".monitorovani-vyroby")
        .on("click", ".vlozit-vyrobu", vlozeniVyrobyClick)
        .on("click", "tr", radekMonitorovaniClick);


    var vyrobniCinnostChange = function() {
        nastavViditelnostRadku($(this));
    };


    $("#vlozeni_vyroby_dialog")
        .on("change", "#vkladani_vyrobni_cinnost", vyrobniCinnostChange)
});
