

(function($) {
    function oznacRadekZastupu() {
        let
            $this = $(this),
            originalValue = Boolean($this.data("original-value"));

        $("#zastup_row_" + $this.data("id-zastupu"))
            .toggleClass("browserselectedrow", $this.prop("checked") !== originalValue);
    }
    function oznacVsechnyZastupy(value) {
        $(".schvaleni_zastupu_checkbox").each(function(){
            let
                $this = $(this),
                originalValue = $this.data("original-value"),
                newValue = (value === -1)
                    ? originalValue
                    : value;

            $this.prop("checked", newValue ? "checked" : null);

            $("#zastup_row_" + $this.data("id-zastupu"))
                .toggleClass("browserselectedrow", newValue != originalValue);
        });
    }

    function schvaleniZastupuMenu() {
        $("#schvaleniZastupuMenu")
            .ronPopupMenu({ attachToElement: $(this) } );

        return false; // stop event propagation
    }


    $(function() {
        $("body")
            .on("click", "#zastupy_schvaleni_ALL", function () {
                oznacVsechnyZastupy($(this).prop("checked"));
            })
            .on("click", ".schvaleni_zastupu_checkbox", oznacRadekZastupu);

        $("#schvaleniZastupuMenu_Header")
            .on("click", schvaleniZastupuMenu);

        $("#schvaleniZastupuMenu")
            .on("click", "li", function() {
                oznacVsechnyZastupy( $(this).data("hodnota-schvaleni") );
            });
    });
})(jQuery);


(function($) {
    ZastupPlanKapacit = function() {
        this.existujeplan = false;
        this.smena = '';
        this.rozdeleni = '';
    };


    function idZvoleneOsoby() {
        var idPP = 0;
        var preferovanyPP = 0;
        var vybranyPP = 0;

        var osobaCombo = $('#zastup_osoba2').find('select');
        if (!$(osobaCombo).length) {
            osobaCombo = $('#row_osoba').find('select');
        }

        var preferovanaOsobaCombo = $('#zastup_osoba1').find('select');

        if ($(preferovanaOsobaCombo).length && $(preferovanaOsobaCombo).val() !== '') {
            preferovanyPP = $(preferovanaOsobaCombo).val();
            idPP = parseInt(preferovanyPP);
        }
        else { // if ($(osobaCombo).is(':visible')) { - upraveno 2021-06 - ronselect neni nikdy visible
            vybranyPP = $(osobaCombo).val();
            idPP = parseInt(vybranyPP);
        }

        return idPP;
    }


    function overPlanovaniKapacit(event) {
        var idZvolenehoPP = idZvoleneOsoby();
        var planZamestnance = {};
        var zjistiPlan = function () {
            $.ajax(
                {
                    async: false,
                    url: "?menuid=zastup&action=kontrolaplanu",
                    type: "GET",
                    data: {
                        idpp: idZvolenehoPP,
                        datum: parseInt($('input[name=DatumZastupu]').val())
                    }
                }).done(function (responseData) {

                planZamestnance.existujeplan = responseData.existujeplan;
                planZamestnance.smena = responseData.smena;
                planZamestnance.rozdeleni = responseData.rozdeleni;
            }).fail(function (jqXHR) {
                ron.showAjaxError(jqXHR, "Pri kontrole planovani kapacit doslo k chybe!");
            });
        };
        var potvrditPrepsaniPlanu = function (data) {
            if (data.existujeplan) {
                var question = ron.translate('Zastup_existuje_plan');

                if (data.smena !== '') {
                    question += ron.translate('Zastup_existuje_smena') + data.smena;
                    if (data.rozdeleni !== '') {
                        question += ', ';
                    }
                }

                if (data.rozdeleni !== '') {
                    question += ron.translate('Zastup_existuje_rozdeleni') + data.rozdeleni;
                }

                question += ron.translate('Zastup_pokracovat');

                if (!ron.confirm(question)) {
                    return false;
                }
            }

            return true;
        };

        if (idZvolenehoPP !== 0) {
            zjistiPlan();
            return potvrditPrepsaniPlanu(planZamestnance);
        }

    }



    $(function () {
        $("#zastup_kalendar_link").on('click', function () {
            let
                $this = $(this),
                idPP = idZvoleneOsoby();

            if (idPP) {
                window.open($this.data('ronlink') + idPP, $this.attr("target"));
            }

            return false;
        });

        $('#zastup_osoba1').on('change', 'select', function () {
            $("#zastup_osoba2").toggleClass('d-none', this.value !== '');
        });

        $('form:has(input[value=ZadostOZastup])').on('click', '.submitbutton', overPlanovaniKapacit);
    });
})(jQuery);

  
