<?php
/**
 * stanislav.elbl, 09.04.2015
 */

namespace RonPortal\Admin;

use Ron\MessageManager;
use Ron\MVC\Model;
use Ron\StringUtils;
use RonPortal\RonPortalSettings;

// database
global $db_utils;

// print service
global $reporterrortext;
global $reportserver;
global $reportserverport;
global $db_connectionstring; // zobrazi jen cast, aby nebylo videt pripadne heslo
global $db_user;
global $db_name;
global $db_password;

global $simplesaml_sp;
global $simplesaml_path;

global $usephpmailer;
global $phpmailerpath;
global $phpmailer_host;

if (file_exists('_email_set.php')) {
    require_once('_email_set.php'); // nacte nastaveni odesilani emailu
}

$reportServerInfo = Model::getInstance() ->getData('reportServerInfo');

function renderReportInfoData($infoDataArray)
{
    if (isset($infoDataArray)) {
        foreach ($infoDataArray as $infoData) {
            echo
                '<div class="reportinfo packed toggleClass" data-toggle-class="packed">' .
                (isset($infoData['name']) ?  $infoData['name'] . ': ' : '') .
                StringUtils::longTextToHtml($infoData['#text'], true) .
                ((isset($infoData['xmldata'])  &&  $infoData['xmldata'])
                    ? '<i class="inline-glyph fa glyph-info"></i><pre class="infodata">' . StringUtils::longTextToHtml($infoData['xmldata'][0]['#text'], true) . '</pre>'
                    : '') .
                '</div>';
            //var_dump($infoData['xmldata']);
        }
    }
}

?>
<style>
    .admin_values {
        padding-left: 20px;
    }
    .admin_value {
        font-weight: bold;
    }

    .reportinfo.packed .infodata {
        display: none;
    }
</style>

<h1><?= StringUtils::fromUTF8('Servisní informace') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<div><?= StringUtils::fromUTF8('Způsob připojení k databázi') ?>: <span class="admin_value"><?= $db_utils ?></span></div>
<div>Connection string: <span class="admin_value"><?= substr($db_connectionstring, 0, 30) ?></span></div>
<div>db_name: <span class="admin_value"><?= $db_name ?></span></div>
<div>db_user: <span class="admin_value"><?= $db_user ?></span></div>
<div>db_password: <span class="admin_value"><?= StringUtils::fromUTF8($db_password ? 'je nastaveno, nebude vypsáno!' : 'není nastaveno') ?></span></div>

<br/>

<div>Verze PHP: <span class="admin_value"><?= phpversion() ?></span></div>

<br/>

<?php if ($simplesaml_sp) { ?>
    <div>simplesaml_sp: <?= StringUtils::htmlTextConvert($simplesaml_sp) ?></div>
    <div>simplesaml_path: <?= StringUtils::htmlTextConvert($simplesaml_path) ?></div>
    <div>simplesaml metadata: ... /www/module.php/saml/sp/metadata.php/<?= StringUtils::htmlTextConvert($simplesaml_sp) ?></div>
    <br/>
<?php } ?>

<div><?= StringUtils::fromUTF8('Spouštění agentů docházky') ?>:</div>
<div class="admin_values">
    <div>
        <?= StringUtils::fromUTF8('Vzdálené spouštění (host:port)') ?>:
        <span class="admin_value"><?= RonPortalSettings::getValue(RonPortalSettings::ADS_AGENT_HOST) ?>:<?= RonPortalSettings::getValue(RonPortalSettings::ADS_AGENT_PORT) ?></span>
    </div>
    <div>
        <?= StringUtils::fromUTF8('Cesta k docházce') ?>:
        <span class="admin_value"><?= RonPortalSettings::getValue(RonPortalSettings::ADS_AGENT_CESTA) ?></span>
    </div>
    <div>
        <?php if (RonPortalSettings::getSpousteniADS()) { ?>
            <a href="?menuid=admin&testagentads=1">otestovat ...</a>
        <?php } else { ?>
            <span class="admin_value"><?= StringUtils::fromUTF8('Spouštění agentů není povoleno') ?></span>
        <?php } ?>
    </div>
</div>

<?php if (RonPortalSettings::getValue('person_agenthost')  ||  RonPortalSettings::getValue(RonPortalSettings::AGENT_HODNOCENI)) { ?>
    <div><?= StringUtils::fromUTF8('Spouštění agentů personalistiky') ?>:</div>
    <div class="admin_values">
        <div>
            <?= StringUtils::fromUTF8('Vzdálené spouštění (host:port)') ?>:
            <span class="admin_value"><?= RonPortalSettings::getValue('person_agenthost') ?>:<?= RonPortalSettings::getValue('person_agentport') ?></span>
        </div>
        <div>
            <?= StringUtils::fromUTF8('Agent hodnocení (použije se, pokud není nastaveno vzdálené spouštění)') ?>:
            <span class="admin_value"><?= RonPortalSettings::getValue(RonPortalSettings::AGENT_HODNOCENI) ?></span>
        </div>
        <div>
            <a href="?menuid=admin&testagentperson=1">otestovat ...</a>
        </div>
    </div>

<?php } ?>

<br/>
<div><a href="?menuid=infophp"><?= StringUtils::fromUTF8('phpinfo') ?></a></div>
<div><a target="_blank" href="?menuid=admin&globalsettings=1"><?= StringUtils::fromUTF8('Globální nastavení') ?></a></div>
<div><a target="_blank" href="?menuid=download&usersettings=1"><?= StringUtils::fromUTF8('Uživatelské nastavení') ?></a></div>
<?php if (ini_get('log_errors')) { ?>
    <div>Error log PHP: <a target="_blank" href="?menuid=admin&errorlog=1"><?= StringUtils::htmlTextConvert(ini_get('error_log')) ?></a></div>
<?php } ?>

<br/>
<?php if (RonPortalSettings::getIntValue('vkladani_zpusob_terminal') == 2) { ?>
    <div><?= StringUtils::fromUTF8('Terminál pro vkládání (dle URL parametru terminalvkladani=&lt;kod&gt;)') ?>: <span class="admin_value"><?= $_SESSION['terminalprovkladani'] ?></span></div>
<?php } ?>

<div>
    <?= StringUtils::fromUTF8('Odesílání emailů') ?>: <?= ($usephpmailer || $phpmailerpath)
        ? StringUtils::fromUTF8('Použije se PHPmailer a server ') . $phpmailer_host
        : StringUtils::fromUTF8('Nepoužívá se PHPmailer') ?>
</div>
<div class="admin_values">
    <div><a href="?menuid=emailtest">otestovat ...</a></div>
</div>
<br/>

<div>
    <a href="?menuid=ldap">Test LDAP</a>
</div>
<br/>


<div>
    Report server: <span class="admin_value"><?php var_dump($reportserver) ?></span>
</div>
<?php if($reportServerInfo) { ?>
    <div>
    <?php
        if (isset($reportServerInfo['infodata'])) {
            renderReportInfoData($reportServerInfo['infodata']);
        }

        if (isset($reportServerInfo['infosection'])) {
            foreach ($reportServerInfo['infosection'] as $infoSection) {
                echo '<div class="margin-top-2">' . (isset($infoSection['name']) ? $infoSection['name'] : '') . '</div>';
                if (isset($infoSection['infodata'])) {
                    renderReportInfoData($infoSection['infodata']);
                }
            }
       }
    //var_dump($reportServerInfo['#children']);
    ?>
    </div>
<?php } ?>

<?php if($reporterrortext) { ?>
    <div class="errortext"><?= $reporterrortext ?></div>
<?php } ?>

