<?php
/**
 * stanislav.elbl, 05.02.2016
 */

namespace RonPortal;

use Ron\Http\App;
use Ron\Http\HttpResponse;
use Ron\MVC\Model;
use Ron\RonException;

global $appDate;
global $appVersion;
global $copyrightYear;

/**
 * Pouziva se napr. pro zobrazeni jidelnicku bez prihlaseni nebo pro zobrazeni XML formulare LOGIN_PAGE...
 */

?>
<!doctype html>
<html>
<head>
    <?php
    require('ron/apphead.php');
    require('view/apphead.php');

    if ( App::getDebugMode() ) {
        // generuje do console seznam http hlavicek (pro ladici ucely)
        HttpResponse::getInstance() ->getHeaders() ->renderDebugScript();
    }
    ?>
</head>
<body>
<div class="pagecontent frame">
    <!--<div class="container"> -->
        <div class="appcontent">
            <!-- obsah -->
            <?php
            if (Model::getInstance() ->getViewObjects()) {
                foreach (Model::getInstance() ->getViewObjects() as $viewObject) {
                    try {
                        $viewObject->render();
                    } catch (RonException $e) {
                        echo '<div class="errortext">' . $e ->getMessage() . '</div>';
                        echo '<div>' . $e ->getErrorDescription() . '</div>';
                    } catch (\Exception $e) {
                        echo '<div class="errortext">' . $e ->getMessage() . '</div>';
                    }
                }
            }
            ?>
        </div>
    <!-- </div> -->


    <!-- paticka -->
    <div class="footer">
        <div class="copyright">
            &copy; <span class="desktop-only">2003-<?= $copyrightYear ?>, <?= \Ron\StringUtils::fromUTF8('Všechna práva vyhrazena') ?>, </span><a href="http://www.ron.cz">RON Software</a>, s.r.o.
        </div>

        <div class='version' title='<?= $appDate ?>'><a href='verze.php' target='_blank'> <?= $appVersion ?></a></div>
    </div>
</div>

<?php Model::getInstance() ->renderResources(); ?>

</body>
</html>
