<?php
/**
 * stanislav.elbl, 30.05.2016
 * UTF8
 */

namespace Ron\RonPortal;

use Ron\MessageManager;
use Ron\StringUtils;

global $sendmailpath;
global $usephpmailer;
global $phpmailerpath;
global $additional_parameters;
global $phpmailer_host;
global $phpmailer_port;
global $phpmailer_user;
global $phpmailer_password;
global $phpmailer_html;
global $phpmailer_secure;
global $phpmailer_options;

require_once("_email_set.php"); // nacte nastaveni odesilani emailu

?>
<h1><?= StringUtils::fromUTF8('Test odeslání emailu') ?></h1>

<?php MessageManager::getInstance() ->showMessages(); ?>

<form method="post">
    <input type="hidden" name="sendtestemail" value="1" />

    <div class="form form-30-70 large-form">
        <div class="form-content">
            <div class="form-row">
                <div class="form-col form-col1 caption">PHPMailer</div>
                <div class="form-col form-col2"><?= ($usephpmailer || $phpmailerpath) ? 'ANO' . ($phpmailerpath ? ' (' . $phpmailerpath . ')' : '') : 'NE' ?></div>
            </div>

            <?php if ($usephpmailer || $phpmailerpath) { ?>
                <!-- host -->
                <div class="form-row">
                    <div class="form-col form-col1 caption">PHPMailer host</div>
                    <div class="form-col form-col2"><?= $phpmailer_host . ($phpmailer_port ? ':' . $phpmailer_port : '') . ($phpmailer_secure ? ', ' . $phpmailer_secure : '') ?></div>
                </div>
                <!-- user -->
                <div class="form-row">
                    <div class="form-col form-col1 caption">PHPMailer user</div>
                    <div class="form-col form-col2"><?= ($phpmailer_user ?: 'neni zadan') . ', ' . ($phpmailer_password ? 'heslo je nastaveno' : 'heslo neni nastaveno') ?></div>
                </div>
                <!-- html -->
                <div class="form-row">
                    <div class="form-col form-col1 caption">HTML</div>
                    <div class="form-col form-col2"><?= $phpmailer_html ? 'ANO' : 'NE' ?></div>
                </div>
                <!-- options -->
                <?php if ($phpmailer_options) { ?>
                    <div class="form-row">
                        <div class="form-col form-col1 caption">Options</div>
                        <div class="form-col form-col2"><?php var_dump($phpmailer_options); ?></div>
                    </div>
                <?php } ?>
            <?php } ?>

            <!-- formular pro testovaci odeslani -->
            <div class="form-row">
                <div class="form-col form-col1 caption required"><?= StringUtils::fromUTF8('Odesílatel') ?></div>
                <div class="form-col form-col2"><input name="odesilatel" class="form-input" value="<?= isset($_POST['odesilatel']) ? StringUtils::htmlTextConvert($_POST['odesilatel']) : '' ?>"></div>
            </div>

            <div class="form-row">
                <div class="form-col form-col1 caption required"><?= StringUtils::fromUTF8('Příjemce') ?></div>
                <div class="form-col form-col2"><input name="prijemce" class="form-input" value="<?= isset($_POST['prijemce']) ? StringUtils::htmlTextConvert($_POST['prijemce']) : '' ?>"></div>
            </div>

            <div class="form-row">
                <div class="form-col form-col1 caption required">Kopie</div>
                <div class="form-col form-col2"><input name="kopie" class="form-input" value="<?= isset($_POST['kopie']) ? StringUtils::htmlTextConvert($_POST['kopie']) : '' ?>"></div>
            </div>

            <div class="form-row">
                <div class="form-col form-col1 caption required"><?= StringUtils::fromUTF8('Předmět') ?></div>
                <div class="form-col form-col2"><input name="predmet" class="form-input" value="<?= isset($_POST['predmet']) ? StringUtils::htmlTextConvert($_POST['predmet']) : StringUtils::fromUTF8('RonPortál - test odeslání emailu') ?>"></div>
            </div>

            <div class="form-row">
                <div class="form-col form-col1 caption required">Text</div>
                <div class="form-col form-col2">
                    <textarea class="form-input" cols="60" rows="10" name="text"><?= StringUtils::htmlTextConvert( isset($_POST['text']) ? $_POST['text'] : StringUtils::fromUTF8("Obsah testovacího emailu ... <br/>\nDalší řádek ")) ?></textarea>
                </div>
            </div>
        </div>

        <div class="buttons">
            <div class="form-row">
                <div class="form-col form-col1"></div>
                <div class="form-col form-col2"><input type="submit" class="submitbutton" value="Odeslat" /></div>
            </div>
        </div>

    </div>
</form>