<?php
/**
 * stanislav.elbl, 11.12.2018
 */

namespace RonPortal\Common;

use Ron\Controls\ComboBox;
use Ron\Controls\Option;
use Ron\Http\App;
use Ron\MessageManager;
use Ron\StringUtils;
use RonPortal\NastaveniUzivatele;

/** @var ReportsFilterForm $this */

$targetBlank = !isset($_GET['test'])  ||  $_GET['test'] !== 'redirect';

$orderOptions = [];
if ($this ->report  &&  $this ->report ->orderFieldsList) {
    foreach ($this ->report ->orderFieldsList as $fieldName => $title) {
        $orderOptions[] = new Option($fieldName, $title);
    }
}


?>
<h1><?= \Ron\ronText('Sestavy') ?></h1>

<div class="d-flex no-flex-wrap">
    <div class="flex-grow-0 margin-right-2">
        <?php $this ->renderReportList(); ?>
    </div>

    <div class="flex-grow-1">
        <h2>
            <?= $this ->report
                ? StringUtils::htmlTextConvert($this ->report ->nazev)
                : \Ron\ronText('Vyberte_sestavu') ?>
        </h2>

        <?php MessageManager::getInstance() ->showMessages(); ?>

        <?php if ($this ->report) { ?>
            <?php if ($GLOBALS['development']  ||  App::getDebugMode()) { ?>
                <div class="debugmsg">DEV&gt; <?= StringUtils::htmlTextConvert($this ->report ->applicationId . '/' . $this ->report ->appCategoryName . '/' . $this ->report ->appReportName) ?></div>
            <?php } ?>
        <form method="post" <?= $targetBlank ? 'target="_blank"' : '' ?> id="reportDialogForm">
            <input type="hidden" name="reportDialog" value="1" />
            <input type="hidden" name="reportName" id="reportName" value="<?= StringUtils::htmlTextConvert($this ->report ->kod) ?>" />

            <div class="form middle-form">
                <div class="form-content">
                    <!-- obdobi -->
                    <?php if ($this ->report ->zobrazitPanelObdobi) { ?>
                        <div id="reportPanelObdobi">
                            <div class="row form-section">
                                <div class="col col-12"><?= \Ron\ronText('Obdobi') ?></div>
                            </div>

                            <div class="row" id="reportPanelObdobiMesic">
                                <!-- 0=obdobi aplikace, 1=ctvrtleti, 2=rok, 3=datum od-do, 4=variabilni -->
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Mesic') ?>
                                        <input type="radio" name="typObdobi" id="typObdobi0" value="0" <?= !ReportsFilterForm::zvolenyTypObdobi() ? 'checked="checked"' : '' ?>
                                               class="toggleClass typObdobi" data-selector="#reportInputObdobiMesic,#reportPanelObdobiMesicButtons" data-uncheck-class="d-none" />
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= !ReportsFilterForm::zvolenyTypObdobi() ? '' : 'd-none' ?>" id="reportInputObdobiMesic">
                                    <?php $this ->comboObdobi ->render(); ?>
                                </div>
                                <div id="reportPanelObdobiMesicButtons" class="col col-2 desktop-only <?= !ReportsFilterForm::zvolenyTypObdobi() ? '' : 'd-none' ?>">
                                    <i class="inline-glyph glyph-button fa glyph-left comboBoxMove" data-submit="0" data-selector="#obdobiMesic" data-trigger-change="1"></i>
                                    <i class="inline-glyph glyph-button fa glyph-right comboBoxMove" data-step="-1" data-submit="0" data-selector="#obdobiMesic" data-trigger-change="1"></i>
                                </div>
                            </div>

                            <div class="row" id="reportPanelObdobiCtvrtleti">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Ctvrtleti') ?>
                                        <input type="radio" name="typObdobi" id="typObdobi1" value="1" <?= ReportsFilterForm::zvolenyTypObdobi() == 1 ? 'checked="checked"' : '' ?>
                                               class="toggleClass typObdobi" data-selector="#reportInputObdobiCtvrtleti,#reportPanelObdobiCtvrtletiButtons" data-uncheck-class="d-none" />
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::zvolenyTypObdobi() == 1 ? '' : 'd-none' ?>" id="reportInputObdobiCtvrtleti">
                                    <?php $this ->comboCtvrtleti ->render(); ?>
                                </div>
                                <div id="reportPanelObdobiCtvrtletiButtons" class="col col-2 desktop-only <?= ReportsFilterForm::zvolenyTypObdobi() == 1 ? '' : 'd-none' ?>">
                                    <i class="inline-glyph glyph-button fa glyph-left comboBoxMove" data-submit="0" data-selector="#obdobiCtvrtleti" data-trigger-change="1"></i>
                                    <i class="inline-glyph glyph-button fa glyph-right comboBoxMove" data-step="-1" data-submit="0" data-selector="#obdobiCtvrtleti" data-trigger-change="1"></i>
                                </div>
                            </div>

                            <div class="row" id="reportPanelObdobiRok">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Rok') ?>
                                        <input type="radio" name="typObdobi" id="typObdobi2" value="2" <?= ReportsFilterForm::zvolenyTypObdobi() == 2 ? 'checked="checked"' : '' ?>
                                               class="toggleClass typObdobi" data-selector="#reportInputObdobiRok,#reportPanelObdobiRokButtons" data-uncheck-class="d-none" />
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::zvolenyTypObdobi() == 2 ? '' : 'd-none' ?>" id="reportInputObdobiRok">
                                    <?php $this ->comboRok ->render(); ?>
                                </div>
                                <div id="reportPanelObdobiRokButtons" class="col col-2 desktop-only <?= ReportsFilterForm::zvolenyTypObdobi() == 2 ? '' : 'd-none' ?>">
                                    <i class="inline-glyph glyph-button fa glyph-left comboBoxMove" data-submit="0" data-selector="#obdobiRok" data-trigger-change="1"></i>
                                    <i class="inline-glyph glyph-button fa glyph-right comboBoxMove" data-step="-1" data-submit="0" data-selector="#obdobiRok" data-trigger-change="1"></i>
                                </div>
                            </div>

                            <div class="row" id="reportPanelObdobiDatumy">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Datum od') ?>
                                        <input type="radio" name="typObdobi" id="typObdobi3" value="3" <?= ReportsFilterForm::zvolenyTypObdobi() == 3 ? 'checked="checked"' : '' ?>
                                               class="toggleClass typObdobi" data-selector="#reportInputObdobiDatumy" data-uncheck-class="d-none">
                                    </label>
                                </div>
                                <div class="col col-8 <?= ReportsFilterForm::zvolenyTypObdobi() == 3 ? '' : 'd-none' ?>" id="reportInputObdobiDatumy">
                                    <input name="obdobiOd" id="obdobiOd" class="inputDate obdobiInput" data-roncalendar-next="obdobiDo" size="10" maxlength="10" value="<?= StringUtils::htmlTextConvert(ReportsFilterForm::zvoleneObdobiOd()) ?>"/>
                                    <i class="showcalendar glyph-button inline-glyph fa glyph-calendar" data-roncalendar-inputname="obdobiOd"></i>
                                    <?= \Ron\ronText('Do') ?>
                                    <input name="obdobiDo" id="obdobiDo" class="inputDate obdobiInput" data-roncalendar-prev="obdobiOd" size="10" maxlength="10" value="<?= StringUtils::htmlTextConvert(ReportsFilterForm::zvoleneObdobiDo()) ?>"/>
                                    <i class="showcalendar glyph-button inline-glyph fa glyph-calendar" data-roncalendar-inputname="obdobiDo"></i>
                                </div>
                            </div>
                        </div>
                    <?php } ?>

                    <!-- rozdeleni 1 -->
                    <?php if ($this ->report ->zobrazitPanelRozdeleni  &&  $this ->comboRozdeleni) { ?>
                        <div id="panelRozdeleni">
                            <div class="row form-section">
                                <div class="col col-12"><?= \Ron\ronText('Rozdeleni') ?></div>
                            </div>

                            <div class="row" id="reportPanelJenRozdeleni">
                                <div class="col-10 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Jen_rozdeleni') ?>
                                        <input type="checkbox" id="jenRozdeleni" name="jenRozdeleni" <?= ReportsFilterForm::getJenRozdeleni() ? 'checked="checked"' : '' ?> class="toggleClass" data-selector="#reportControlsRozdeleni1" data-uncheck-class="d-none">
                                    </label>
                                </div>

                                <div class="col-2 col-sm-8 align-right">
                                    <i class="inline-glyph glyph-button fa glyph-spinner fa-spin d-none" id="rozdeleniLoading"></i>
                                </div>

                                <div id="reportControlsRozdeleni1" class="col-12 <?= ReportsFilterForm::getJenRozdeleni() ? '' : 'd-none' ?>">
                                    <!--
                        <div class="row" id="reportPanelRozdeleniTyp">
                            <div class="col col-12 col-sm-4 caption">
                                <?= \Ron\ronText('Typ_rozdeleni') ?>
                            </div>
                            <div class="col col-12 col-sm-8 " id="reportInputRozdeleniTyp">
                                <?php //$this ->comboTypRozdeleni ->render(); ?>
                            </div>
                        </div>
                        -->

                                    <div class="row" id="reportPanelRozdeleni">
                                        <div class="col col-4 caption d-xs-none">
                                            <?= \Ron\ronText('Rozdeleni') ?>
                                        </div>
                                        <div class="col col-12 col-sm-6 " id="reportInputRozdeleniTyp">
                                            <?php $this ->comboRozdeleni ->combo1 ->render(); ?>
                                        </div>
                                        <div class="col col-12 col-sm-2 " id="reportInputRozdeleniTyp">
                                            <?php $this ->comboRozdeleni ->combo2 ->render(); ?>
                                        </div>
                                    </div>
                                    <?php if ($this ->report ->appReportName) { ?>
                                    <div class="row" id="reportPanelRozdeleniVcetnePodrizenych">
                                        <div class="col col-4 caption d-xs-none"></div>
                                        <div class="col col-12 col-sm-8" id="reportInputRozdeleniVcetnePodrizenych">
                                            <label>
                                                <input type="checkbox" id="vcetnePodrizenych" name="vcetnePodrizenych" <?= ReportsFilterForm::getRozdeleniVcetnePodrizenych() ? 'checked="checked"' : '' ?>>
                                                <?= \Ron\ronText('Rozdeleni_vcetne_podrizenych') ?>
                                            </label>
                                        </div>
                                    </div>
                                    <?php } ?>
                                </div>
                            </div>
                        </div>
                    <?php } ?>

                    <!-- osoba -->
                    <?php if ($this ->report ->zobrazitPanelOsoba) { ?>
                        <div id="reportPanelOsoba">
                            <div class="row form-section">
                                <div class="col col-12"><?= \Ron\ronText('Osoba') ?></div>
                            </div>

                            <div class="row" id="reportPanelOsobaId">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Osoba') ?>
                                        <input type="checkbox" name="jenOsoba" <?= ReportsFilterForm::getJenZvolenaOsoba() ? 'checked="checked"' : '' ?> class="toggleClass" data-selector="#reportInputOsobaId,#reportPanelObdobiOsobaButtons" data-uncheck-class="d-none"/>
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::getJenZvolenaOsoba() ? '' : 'd-none' ?>" id="reportInputOsobaId">
                                    <?php $this ->comboOsoba ->render(); ?>
                                </div>
                                <div id="reportPanelObdobiOsobaButtons" class="col col-2 desktop-only <?= ReportsFilterForm::getJenZvolenaOsoba() ? '' : 'd-none' ?>">
                                    <i class="inline-glyph glyph-button fa glyph-left comboBoxMove" data-submit="0" data-selector="#osoba" data-trigger-change="1" data-step="-1"></i>
                                    <i class="inline-glyph glyph-button fa glyph-right comboBoxMove" data-submit="0" data-selector="#osoba" data-trigger-change="1"></i>
                                    <?php if ($this ->jePravoNaVlastni) { ?>
                                        <i class="inline-glyph glyph-button fa glyph-own-data comboBoxMove" data-submit="0" data-selector="#osoba" data-trigger-change="1" data-option-selector=".vlastni-pp" id="vybratVlastniBtn"></i>
                                    <?php } ?>
                                    <i class="inline-glyph glyph-button fa glyph-spinner fa-spin d-none" id="osobaLoading"></i>
                                </div>
                            </div>

                            <?php if ($this ->report ->appReportName) { ?>
                            <div class="row" id="reportPanelOsobaTyp">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Jen_typ_osoby') ?>
                                        <input type="checkbox" name="jenTypOsoby" <?= ReportsFilterForm::getJenTypOsoby() ? 'checked="checked"' : '' ?> class="toggleClass" data-selector="#reportInputOsobaTyp" data-uncheck-class="d-none">
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::getJenTypOsoby() ? '' : 'd-none' ?>" id="reportInputOsobaTyp">
                                    <?php $this ->comboTypOsoby ->render(); ?>
                                </div>
                            </div>
                            <div class="row" id="reportPanelTypPP">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Jen_typ_PP') ?>
                                        <input type="checkbox" name="jenTypPP" <?= ReportsFilterForm::getJenTypPP() ? 'checked="checked"' : '' ?> class="toggleClass" data-selector="#reportInputTypPP" data-uncheck-class="d-none">
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::getJenTypPP() ? '' : 'd-none' ?>" id="reportInputTypPP">
                                    <?php $this ->comboTypPP ->render(); ?>
                                </div>
                            </div>
                            <?php } ?>
                        </div>
                    <?php } ?>

                    <?php if ($this ->report ->zobrazitPanelKalendar) { ?>
                        <div id="reportPanelKalendar">
                            <div class="row form-section">
                                <div class="col col-12"><?= \Ron\ronText('Kalendar') ?></div>
                            </div>
                            <div class="row" id="reportPanelKalendarId">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Kalendar') ?>
                                        <input type="checkbox" name="jenKalendar" <?= ReportsFilterForm::getJenKalendar() ? 'checked="checked"' : '' ?> class="toggleClass" data-selector="#reportInputKalendarId" data-uncheck-class="d-none"/>
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6 <?= ReportsFilterForm::getJenKalendar() ? '' : 'd-none' ?>" id="reportInputKalendarId">
                                    <?php $this ->comboKalendar ->render(); ?>
                                </div>
                            </div>
                        </div>
                    <?php } ?>

                    <?php if ($this ->report ->zobrazitPanelRazeni  &&  $orderOptions) { ?>
                        <div id="reportPanelOrder">
                            <div class="row form-section">
                                <div class="col col-12"><?= \Ron\ronText('Razeni') ?></div>
                            </div>
                            <div class="row" id="reportPanelOrderRow">
                                <div class="col col-12 col-sm-4 caption">
                                    <label>
                                        <?= \Ron\ronText('Seradit_podle') ?>
                                    </label>
                                </div>
                                <div class="col col-12 col-sm-6" id="reportInputOrder">
                                    <?php ComboBox::renderComboBox('order', $orderOptions, NastaveniUzivatele::getUserSettingsItem($this ->database, 'reports_sort')); ?>
                                </div>
                            </div>
                        </div>
                    <?php } ?>
                </div>
                <div class="buttons">
                    <?php if ($this-> report ->nazvyFormatu && count($this-> report ->nazvyFormatu) > 1) { ?>
                        <?php foreach ($this-> report ->nazvyFormatu as $format) { ?>
                            <input type="submit" class="submitbutton" name="FORMAT_<?= $format ?>" value="<?= \Ron\ronText($format) ?>" />
                        <?php } ?>
                    <?php } else { ?>
                        <input type="submit" class="submitbutton" value="<?= \Ron\ronText('OK') ?>" />
                    <?php } ?>
                </div>
            </div>
        </form>
        <?php } ?>

    </div>
</div>

<?php if (isset($_GET['testautosubmit'])  &&  $_GET['testautosubmit']) { ?>
<script>
    setTimeout( function() { $("#reportDialogForm").submit(); }, 5000 + Math.floor(Math.random() * 20000) );
</script>
<?php } ?>
